// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   AIAnimations.java

import java.lang.reflect.Field;
import java.lang.reflect.Modifier;
import java.util.ArrayList;

public abstract class AIAnimations extends Enum
{

    public abstract void SetupAnimations(AIMotionState aimotionstate);

    public void Initialize(NewAI cOwnerMesh, String sAnimSeqFile, String sRootElementName, String sTorsoElementName)
    {
        m_OwnerMesh = cOwnerMesh;
        m_sRootElementName = sRootElementName;
        m_sTorsoElementName = sTorsoElementName;
        m_nRootElementID = cOwnerMesh.GetElementID(m_sRootElementName);
        m_nTorsoElementID = cOwnerMesh.GetElementID(m_sTorsoElementName);
        cOwnerMesh.InitAnimSeqFile(sAnimSeqFile);
        InitializeImmutableAnimations();
    }

    public final String GetNameForID(int nID)
    {
        if(m_aAnimsNames == null || nID < 0 || nID >= m_aAnimsNames.length)
            return "Unknown anim name (ID: " + nID + ")";
        else
            return getClass().getName() + "." + m_aAnimsNames[nID];
    }

    public AIAnimations(int nVal)
    {
        super(nVal);
        m_aAnims = null;
        m_aAnimsNames = null;
        m_OwnerMesh = null;
        m_sRootElementName = "";
        m_nRootElementID = -1;
        m_sTorsoElementName = "Spine";
        m_nTorsoElementID = -1;
        InitializeAnimsNames();
        m_aAnims = new int[m_aAnimsNames.length];
    }

    public final void SetFreq(int nID, float fFreq)
    {
        m_OwnerMesh.SetAnimFreq(m_aAnims[nID], fFreq);
    }

    public final void Stop(String sBoneName)
    {
        m_OwnerMesh.StopAnim(sBoneName);
    }

    public final int GetAnimationsNumber()
    {
        return m_aAnims.length;
    }

    public final void PlayLoop(int nID)
    {
        Play(nID, -1);
    }

    public abstract void InitializeImmutableAnimations();

    public final float GetLength(int nID)
    {
        return m_OwnerMesh.GetAnimLength(m_aAnims[nID]);
    }

    public final float GetFreq(int nID)
    {
        return m_OwnerMesh.GetAnimFreq(m_aAnims[nID]);
    }

    private void InitializeAnimsNames()
    {
        Field aFields[] = getClass().getFields();
        ArrayList aFieldsList = new ArrayList();
        for(int i = 0; i < aFields.length; i++)
            if(aFields[i].getName().startsWith("A_") && Modifier.isStatic(aFields[i].getModifiers()))
                aFieldsList.add(aFields[i]);

        m_aAnimsNames = new String[aFieldsList.size()];
        for(int i = 0; i < m_aAnimsNames.length; i++)
        {
            Field field = (Field)aFieldsList.get(i);
            try
            {
                m_aAnimsNames[field.getInt(this)] = field.getName();
            }
            catch(IllegalAccessException e)
            {
                GameObject.CrashLog("ERROR: IllegalAccessException during access to field " + getClass().getName() + "." + field.getName() + "\n");
            }
        }

    }

    public final void Play(int nID)
    {
        Play(nID, 1);
    }

    public final void Play(int nID, int nTimes)
    {
        if(m_aAnims[nID] > -1)
        {
            m_OwnerMesh.StartAnim("");
            m_OwnerMesh.PlayAnim(m_aAnims[nID], nTimes);
        }
    }

    protected int m_aAnims[];
    protected String m_aAnimsNames[];
    protected NewAI m_OwnerMesh;
    protected String m_sRootElementName;
    protected int m_nRootElementID;
    protected String m_sTorsoElementName;
    protected int m_nTorsoElementID;
}
