// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   AIBase.java

import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.util.Vector;

public class AIBase extends Pawn
{
    public class AIBaseState extends State
    {

        public void PlayStandAnim()
        {
            PlayAnim(Anims[AIBase.A_STAND], -1);
        }

        void OnChangeMotionType()
        {
            AIBaseOnChangeMotionType();
        }

        public void OnEnter()
        {
            sLastState = sCurrentState;
            sCurrentState = getClass().getName();
            GameObject.Log("[" + sCurrentState + ".OnEnter]\n");
            int nDolar = sCurrentState.indexOf('$');
            sCurrentState = sCurrentState.substring(nDolar + 1);
            ClearTasks();
            CallMethodOnceIn(METHOD_OnMakeDecisionEntering, 0.0F);
        }

        public void OnLeave()
        {
            GameObject.LogD("\n");
            if(bNeedTimeToLeave)
                CallMethodOnceIn("EnterNewState", 0.0F);
        }

        public boolean bNeedTimeToLeave;

        public AIBaseState()
        {
            bNeedTimeToLeave = false;
        }
    }

    public class Idle extends AIBaseState
    {

        public void PlayStandAnim()
        {
            PlayAnim(Anims[AIBase.A_STAND], -1);
        }

        public void OnAnimEnd(int i)
        {
        }

        public void OnMakeDecisionEntering()
        {
            NewTask(3);
        }

        public void OnEnter()
        {
            super.OnEnter();
            bPlaceGun = false;
            SetAnimMorphTime(fSlowAnimMorphTime);
            cMotion.iSpeed = 0;
            UpdateMotion();
        }

        public void OnMakeDecision()
        {
            if(IdleTaskAvailable())
            {
                if(CanHappen(80))
                {
                    float fCurTime = GetTime();
                    if(bCanSmoke && CanHappen(20) && fCurTime - fLastSmokeTime > fInter_SmokeDelay)
                    {
                        NewTask(10);
                        NewTask(11);
                        NewTask(12);
                        fInter_SmokeDelay = fNoSmokingTime + GameObject.RandomFloat(fRandomNoSmokingTime);
                    } else
                    if(CanHappen(40))
                        NewTask(1);
                    else
                        NewTask(2);
                } else
                {
                    NewTask(3);
                }
            } else
            if(CanHappen(30))
                NewTask(2);
            else
                NewTask(3);
        }

        public void OnLeave()
        {
            super.OnLeave();
            SetAnimMorphTime(fNormalAnimMorphTime);
            HideCigarette();
        }

        float fInter_SmokeDelay;

        public Idle()
        {
            fInter_SmokeDelay = 0.0F;
        }
    }

    public class IdleSitting extends Idle
    {

        public void PlayStandAnim()
        {
            if(bIsSittingBull)
                PlayAnim(Anims[AIBase.A_IDLE_BOX], -1);
            else
                super.PlayStandAnim();
        }

        public void GetUpDone()
        {
            SetPhysicsType(1);
            SetPhysicsActive(false);
            SetLocalSpeed(Vector.Zero);
            super.OnLeave();
        }

        public void OnAnimEnd(int i)
        {
        }

        public void OnMakeDecisionEntering()
        {
            NewTask(3);
        }

        public void OnEnter()
        {
            super.OnEnter();
            fOldAnimMorphTime = GetAnimMorphTime();
            SetAnimMorphTime(0.0F);
            PlayStandAnim();
            CallMethodIn("OnEnterDelayed", 0.0F);
        }

        public void OnMakeDecision()
        {
            float fCurTime = GetTime();
            if(bCanSmoke && CanHappen(20) && fCurTime - fLastSmokeTime > fInter_SmokeDelay)
            {
                NewTask(15);
                NewTask(16);
                NewTask(17);
                fInter_SmokeDelay = fNoSmokingTime + GameObject.RandomFloat(fRandomNoSmokingTime);
            } else
            {
                PlayStandAnim();
                NewTask(3);
            }
        }

        void OnEnterDelayed()
        {
            SetAnimMorphTime(fOldAnimMorphTime);
        }

        public void GetUp()
        {
            ClearTasks();
            bIsSittingBull = false;
            SetPhysicsType(4);
            SetPhysicsActive(true);
            SetLocalSpeed(new Vector(0.0F, fGetUpSpeedY, fGetUpSpeedZ));
            PlayAnim(Anims[AIBase.A_IDLE_BOX_END], 1);
            CallMethodOnceIn("GetUpDone", GetAnimLength(Anims[AIBase.A_IDLE_BOX_END]));
        }

        public void OnLeave()
        {
            GetUp();
        }

        float fOldAnimMorphTime;
        float fInter_SmokeDelay;

        public IdleSitting()
        {
            fOldAnimMorphTime = 0.0F;
            super.bNeedTimeToLeave = true;
            fInter_SmokeDelay = 0.0F;
        }
    }

    public class Die extends AIBaseState
    {

        public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
        {
            if(bReallyDead)
            {
                MakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
                Bleed(fDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
            }
        }

        public void OnEnter()
        {
            super.OnEnter();
            DisableVitalActivities();
            if(!bUsePhysicsToDeathFall)
                PlayAnim(Anims[AIBase.A_DIE], 1);
            CallMethodOnceIn("DeathAnimEnd", GetAnimLength(Anims[AIBase.A_DIE]));
            ((ChromeModule)GetModule()).GetDoorControler().IsNearDoorable(AIBase.this);
            if(!bReallyDead)
                PlaySound(aDieSounds[GameObject.RandomInt(aDieSounds.length)]);
        }

        void DeathAnimEnd()
        {
            bReallyDead = true;
            ClearFlag(32);
            SetEllipsoid(fEllipsoidHeight[5], 3F * fEllipsoidRadius[5], 1.5F * fEllipsoidRadius[5]);
            if(GetShadows() != 2)
                ClearFlag(256);
        }

        public Die()
        {
        }
    }

    public class Dummy extends AIBaseState
    {

        public void OnReact()
        {
        }

        public void OnHearNoise(Actor actor, float f, int i)
        {
        }

        public Dummy()
        {
        }
    }


    public void OnFrame()
    {
        if(nUpdateTrackings > 0 && fUpdateTrackingTime <= 0.0F)
            UpdateTrackings();
    }

    public boolean IsActive(ControlObject Activator)
    {
        if(!super.bIsCorpseActive)
            return bReallyDead;
        else
            return false;
    }

    void AIBaseOnChangeMotionType()
    {
        OnChangeMotionType();
    }

    public float GetAnimMorphTime()
    {
        return fCurrentMorphTime;
    }

    public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        if(Assassin != null)
            GameObject.LogD("AI was hit by <" + Assassin.GetName() + ">\n");
        boolean wasDead = super.bDead;
        MakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
        Bleed(fDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
        if(!super.bDead)
        {
            TryToScream(1);
            NewTaskExclusive(14);
        } else
        if(wasDead != super.bDead)
        {
            WeaponThrowAway();
            TryToScream(2);
            if(Assassin instanceof Pawn)
                ((Pawn)Assassin).YouKilledMe(this);
        }
    }

    void InitBodyElemIDs()
    {
        InitTorsoElemIDs();
        InitLegElemIDs();
    }

    void InitTorsoElemIDs()
    {
        byte aBoneID[] = {
            5, 4, 2, 1, 0
        };
        aTorsoElemID = new int[aBoneID.length];
        for(int i = 0; i < aBoneID.length; i++)
            aTorsoElemID[i] = GetMeshElemFromBoneID(aBoneID[i]);

    }

    void InitLegElemIDs()
    {
        byte aBoneID[] = {
            14, 15, 18, 19, 20, 21
        };
        aLegElemID = new int[aBoneID.length];
        for(int i = 0; i < aBoneID.length; i++)
            aLegElemID[i] = GetMeshElemFromBoneID(aBoneID[i]);

    }

    public void SetTorsoAnimMorphTime(float fMorphTime)
    {
        for(int i = 0; i < aTorsoElemID.length; i++)
            SetAnimMorphTime(aTorsoElemID[i], fMorphTime, false);

    }

    boolean IsFrozen()
    {
        return m_nFreezeCause != 0;
    }

    boolean IsFrozen(int nFreezeCause)
    {
        return (m_nFreezeCause & nFreezeCause) != 0;
    }

    void DefineAnimationSet()
    {
        if(fAnimSpeedUp > 0.0F)
            SetAnimFreq("", 30F * fAnimSpeedUp);
        SetAnimMorphTime(fNormalAnimMorphTime);
        nRootElementID = GetElementID(ROOT_BONE);
        nTorsoElementID = GetElementID(TORSO_BONE);
        if(bUseNewModel)
        {
            UpdateAvailableAnims();
            Anims[A_KICK] = GetAnimID(ROOT_BONE, "Rk");
            Anims[A_PUNCH] = GetAnimID(ROOT_BONE, "Rb");
            Anims[A_DIE] = GetAnimID(ROOT_BONE, "death_front");
            Anims[A_IDLE_3] = GetAnimID(ROOT_BONE, "gapi_sie_w_niebo");
            Anims[A_IDLE_SMOKE_START] = GetAnimID(ROOT_BONE, "fajka_odpala");
            Anims[A_IDLE_SMOKE_LOOP] = GetAnimID(ROOT_BONE, "fajka_loop");
            Anims[A_IDLE_SMOKE_END] = GetAnimID(ROOT_BONE, "fajka_wyrzuca");
            Anims[A_IDLE_1] = GetAnimID(ROOT_BONE, "przeciaga_sie");
            Anims[A_IDLE_2] = GetAnimID(ROOT_BONE, "majstruje_przy_zamku_loop");
            Anims[A_IDLE_KEYBOARD] = GetAnimID(ROOT_BONE, "klepie_w_klawiature_loop");
            Anims[A_IDLE_TALK] = GetAnimID(ROOT_BONE, "gadka_loop");
            Anims[A_IDLE_BOX] = GetAnimID(ROOT_BONE, "sk_rozglada_sie_loop");
            Anims[A_IDLE_BOX_SMOKE_START] = GetAnimID(ROOT_BONE, "sk_zapala");
            Anims[A_IDLE_BOX_SMOKE_LOOP] = GetAnimID(ROOT_BONE, "sk_pali_loop");
            Anims[A_IDLE_BOX_SMOKE_END] = GetAnimID(ROOT_BONE, "sk_wyrzuca");
            Anims[A_IDLE_BOX_END] = GetAnimID(ROOT_BONE, "sk_zeskakuje");
        } else
        {
            Anims[A_KICK] = GetAnimID(ROOT_BONE, "kick");
            Anims[A_PUNCH] = GetAnimID(ROOT_BONE, "punch");
            Anims[A_DIE] = GetAnimID(ROOT_BONE, "death_front");
            Anims[A_IDLE_3] = GetAnimID(ROOT_BONE, "Idle01");
            Anims[A_IDLE_SMOKE_START] = GetAnimID(ROOT_BONE, "Idle02a");
            Anims[A_IDLE_SMOKE_LOOP] = GetAnimID(ROOT_BONE, "Idle02b");
            Anims[A_IDLE_SMOKE_END] = GetAnimID(ROOT_BONE, "Idle02c");
            Anims[A_IDLE_1] = GetAnimID(ROOT_BONE, "Idle03");
            Anims[A_IDLE_2] = GetAnimID(ROOT_BONE, "Idle04");
            Anims[A_IDLE_KEYBOARD] = GetAnimID(ROOT_BONE, "Idle05");
            Anims[A_IDLE_TALK] = GetAnimID(ROOT_BONE, "Idle06");
            Anims[A_IDLE_BOX] = GetAnimID(ROOT_BONE, "Idle07");
            Anims[A_IDLE_BOX_SMOKE_START] = GetAnimID(ROOT_BONE, "Idle08a");
            Anims[A_IDLE_BOX_SMOKE_LOOP] = GetAnimID(ROOT_BONE, "Idle08b");
            Anims[A_IDLE_BOX_SMOKE_END] = GetAnimID(ROOT_BONE, "Idle08c");
            Anims[A_IDLE_BOX_END] = GetAnimID(ROOT_BONE, "Idle09");
        }
        SetAnimType((byte)5, (byte)3, false);
        SetAnimType((byte)4, (byte)3, false);
        SetAnimType((byte)1, (byte)3, false);
        SetAnimType((byte)2, (byte)3, false);
        SetAnimType((byte)0, (byte)3, false);
        int nUserID = 0;
        int nWeaponType = 0;
        for(nWeaponType = 0; nWeaponType <= 5; nWeaponType++)
            if(!bUseNewModel || (bCanUseHandsAnims || nWeaponType != 0) && (bCanUsePistolAnims || nWeaponType != 2) && (bCanUseRifleAnims || nWeaponType != 3))
            {
                String prefix = "";
                switch(nWeaponType)
                {
                case 0: // '\0'
                    prefix = "N";
                    break;

                case 1: // '\001'
                    prefix = "K";
                    break;

                case 2: // '\002'
                    prefix = "P";
                    break;

                case 3: // '\003'
                    prefix = "R";
                    break;

                case 4: // '\004'
                    prefix = "H";
                    break;

                case 5: // '\005'
                    prefix = "G";
                    break;
                }
                nUserID = BuildSeqID(nWeaponType, 0, 0, 0);
                SetUserSeqID(prefix + "b", A_BUTT_HIT + nUserID);
                SetUserSeqID(prefix + "c2d", A_CRAWL2DUCK + nUserID);
                SetUserSeqID(prefix + "c2s", A_CRAWL2STAND + nUserID);
                SetUserSeqID(prefix + "d2c", A_DUCK2CRAWL + nUserID);
                SetUserSeqID(prefix + "s2c", A_STAND2CRAWL + nUserID);
                int nSpeed = 0;
                for(nSpeed = 0; nSpeed <= 5; nSpeed++)
                {
                    String prefix1 = new String(prefix);
                    switch(nSpeed)
                    {
                    case 5: // '\005'
                        prefix1 += "r";
                        break;

                    case 4: // '\004'
                        prefix1 += "w";
                        break;

                    case 3: // '\003'
                        prefix1 += "d";
                        break;

                    case 2: // '\002'
                        prefix1 += "c";
                        break;

                    case 0: // '\0'
                        prefix1 += "w";
                        break;
                    }
                    nUserID = BuildSeqID(nWeaponType, nSpeed, 0, 0);
                    SetUserSeqID(prefix1 + "j", A_JUMP + nUserID);
                    SetUserSeqID(prefix1 + "jf", A_JUMP_FORWARD + nUserID);
                    SetUserSeqID(prefix1 + "re", A_WEA_RELOAD + nUserID);
                    SetUserSeqID(prefix1 + "g", A_WEA_GET + nUserID);
                    SetUserSeqID(prefix1 + "p", A_WEA_PUTAWAY + nUserID);
                    int nMagic = 0;
                    for(nMagic = 0; nMagic <= 1; nMagic++)
                    {
                        String prefix2 = new String(prefix1);
                        if(nMagic == 0)
                            prefix2 += "a";
                        else
                            prefix2 += "n";
                        nUserID = BuildSeqID(nWeaponType, nSpeed, nMagic, 0);
                        SetUserSeqID(prefix2 + "s", A_STAND + nUserID);
                        SetUserSeqID(prefix2 + "", A_FORWARD + nUserID);
                        SetUserSeqID(prefix2 + "b", A_BACKWARD + nUserID);
                        SetUserSeqID(prefix2 + "sl", A_STRAFE_LEFT + nUserID);
                        SetUserSeqID(prefix2 + "sr", A_STRAFE_RIGHT + nUserID);
                        SetUserSeqID(prefix2 + "rl", A_ROTATE_LEFT + nUserID);
                        SetUserSeqID(prefix2 + "rr", A_ROTATE_RIGHT + nUserID);
                        SetUserSeqID(prefix2 + "sh", A_TAKE_HIT + nUserID);
                        SetUserSeqID(prefix2 + "rlb", A_BACK_ROTATE_LEFT + nUserID);
                        SetUserSeqID(prefix2 + "rrb", A_BACK_ROTATE_RIGHT + nUserID);
                        int nPumpAction = 0;
                        for(nPumpAction = 0; nPumpAction <= 1; nPumpAction++)
                        {
                            String prefix3 = new String(prefix2);
                            if(nPumpAction == 0)
                                SetUserSeqID(prefix3 + "fS", A_WEA_FIRE + BuildSeqID(nWeaponType, nSpeed, nMagic, nPumpAction));
                            else
                                SetUserSeqID(prefix3 + "f", A_WEA_FIRE + BuildSeqID(nWeaponType, nSpeed, nMagic, nPumpAction));
                        }

                    }

                }

            }

    }

    public void EnterNewState()
    {
        bIsChanginState = false;
        super.SetState(sStateToSetName);
    }

    boolean CanHappen(int nPercentage)
    {
        return GameObject.RandomInt(100) < nPercentage;
    }

    void SetupAnims()
    {
        boolean bPumpAction = false;
        byte weaponType;
        if(super.ActiveWeapon != null)
        {
            weaponType = super.ActiveWeapon.nType;
            bPumpAction = super.ActiveWeapon.bPumpAction;
        } else
        {
            weaponType = 0;
        }
        if(bUseNewModel && (!bCanUseHandsAnims || weaponType != 0) && (!bCanUsePistolAnims || weaponType != 2) && bCanUseRifleAnims)
            if(bCanUseRifleAnims)
                weaponType = 3;
            else
            if(bCanUseHandsAnims)
                weaponType = 0;
            else
            if(bCanUsePistolAnims)
                weaponType = 2;
            else
                weaponType = 3;
        int nUserID = BuildSeqID(weaponType, 0, 0, 0);
        Anims[A_BUTT_HIT] = GetAnimID(nRootElementID, A_BUTT_HIT + nUserID);
        Anims[A_CRAWL2DUCK] = GetAnimID(nRootElementID, A_CRAWL2DUCK + nUserID);
        Anims[A_CRAWL2STAND] = GetAnimID(nRootElementID, A_CRAWL2STAND + nUserID);
        Anims[A_DUCK2CRAWL] = GetAnimID(nRootElementID, A_DUCK2CRAWL + nUserID);
        Anims[A_STAND2CRAWL] = GetAnimID(nRootElementID, A_STAND2CRAWL + nUserID);
        int nSpeed = cMotion.iSpeed;
        nUserID = BuildSeqID(weaponType, nSpeed, 0, 0);
        Anims[A_JUMP] = GetAnimID(nRootElementID, A_JUMP + nUserID);
        Anims[A_JUMP_FORWARD] = GetAnimID(nRootElementID, A_JUMP_FORWARD + nUserID);
        Anims[A_WEA_RELOAD] = GetAnimID(nTorsoElementID, A_WEA_RELOAD + nUserID);
        Anims[A_WEA_GET] = GetAnimID(nTorsoElementID, A_WEA_GET + nUserID);
        Anims[A_WEA_PUTAWAY] = GetAnimID(nTorsoElementID, A_WEA_PUTAWAY + nUserID);
        int nMagic = 0;
        if(bPlaceGun && cMotion.bAiming && cMotion.iSpeed != 2 && (cMotion.iSpeed != 5 || cMotion.iSpeed == 5 && !cMotion.IsMovingLinear()))
            nMagic = 0;
        else
            nMagic = 1;
        nUserID = BuildSeqID(weaponType, nSpeed, nMagic, 0);
        Anims[A_STAND] = GetAnimID(nRootElementID, A_STAND + nUserID);
        Anims[A_FORWARD] = GetAnimID(nRootElementID, A_FORWARD + nUserID);
        Anims[A_BACKWARD] = GetAnimID(nRootElementID, A_BACKWARD + nUserID);
        Anims[A_STRAFE_LEFT] = GetAnimID(nRootElementID, A_STRAFE_LEFT + nUserID);
        Anims[A_STRAFE_RIGHT] = GetAnimID(nRootElementID, A_STRAFE_RIGHT + nUserID);
        Anims[A_ROTATE_LEFT] = GetAnimID(nRootElementID, A_ROTATE_LEFT + nUserID);
        Anims[A_ROTATE_RIGHT] = GetAnimID(nRootElementID, A_ROTATE_RIGHT + nUserID);
        Anims[A_TAKE_HIT] = GetAnimID(nTorsoElementID, A_TAKE_HIT + nUserID);
        Anims[A_BACK_ROTATE_LEFT] = GetAnimID(nRootElementID, A_BACK_ROTATE_LEFT + nUserID);
        Anims[A_BACK_ROTATE_RIGHT] = GetAnimID(nRootElementID, A_BACK_ROTATE_RIGHT + nUserID);
        if(bPumpAction)
            Anims[A_WEA_FIRE] = GetAnimID(nTorsoElementID, A_WEA_FIRE + BuildSeqID(weaponType, nSpeed, nMagic, 0));
        else
            Anims[A_WEA_FIRE] = GetAnimID(nTorsoElementID, A_WEA_FIRE + BuildSeqID(weaponType, nSpeed, nMagic, 1));
        if(fAnimSpeedUp > 0.0F)
            SetAnimFreq("", 30F * fAnimSpeedUp);
    }

    void UpdateTrackings()
    {
        UpdateAllTrackings();
    }

    void InsertItems(String aItems[], int nItems)
    {
        for(int i = 0; i < nItems; i++)
            if(GetClassID(aItems[i]) != 0)
            {
                InvObject cObject = (InvObject)CreateObject(aItems[i]);
                cObject.AddToInventory(this);
            }

    }

    boolean IsTargetInSight(ChromeActor cTarget, boolean bQuickLook, float fRange2Modifier)
    {
        if(cTarget == null)
            return false;
        Vector vTargetPos = cTarget.GetPosition();
        if(vTargetPos == null || GetPosition() == null)
            return false;
        float fTargetDist2 = vTargetPos.Distance2(GetPosition());
        boolean bRes = false;
        float fSightSamplingTime = (fTargetDist2 / fAISightRange2) * fMaxSightSamplingTime;
        if(fSightSamplingTime < 0.0F)
            fSightSamplingTime = 0.0F;
        if(fTargetDist2 < f6thSenseRange2)
            bRes = true;
        else
        if(IsPointInSightRange(vTargetPos, fAISightRange2 * fRange2Modifier))
        {
            cTarget.SetTraceCollType(1);
            if(CheckTraceAbsolute(cTarget, GetLookFromPoint(), cTarget.GetPointToLookAt(0)))
                if(!bQuickLook && bUseSightSamplesIntegration)
                {
                    UpdateSightSamplesBuffer(fSightSamplingTime, true);
                    if(ShouldSeeEnemy(fTargetDist2))
                        bRes = true;
                } else
                {
                    UpdateSightSamplesBuffer(0.0F, false);
                    bRes = true;
                }
            cTarget.SetTraceCollType(3);
        }
        if(!bRes)
            UpdateSightSamplesBuffer(fSightSamplingTime, false);
        return bRes;
    }

    boolean IsTargetInSight(ChromeActor cTarget, boolean bQuickLook)
    {
        float fRangeModifier;
        if(cTarget instanceof Player)
            fRangeModifier = aAISightRange2Modifier[((PawnAnimated) ((Player)cTarget)).motion.iSpeed];
        else
        if(cTarget instanceof AIBase)
            fRangeModifier = aAISightRange2Modifier[((AIBase)cTarget).cMotion.iSpeed];
        else
            fRangeModifier = 1.0F;
        return IsTargetInSight(cTarget, bQuickLook, fRangeModifier);
    }

    boolean IsTargetInSight(ChromeActor cTarget)
    {
        return IsTargetInSight(cTarget, false);
    }

    void TakeAction(int nAction)
    {
        bActionInProgress = true;
        switch(nAction)
        {
        case 1: // '\001'
            PerformAnimTask(Anims[A_IDLE_1 + GameObject.RandomInt(3)], 1);
            break;

        case 10: // '\n'
            PerformAnimTask(Anims[A_IDLE_SMOKE_START], 1);
            CallMethodOnceIn("ShowCigarette", fCigaretteShowTime);
            break;

        case 11: // '\013'
            PerformAnimTaskSmoke(Anims[A_IDLE_SMOKE_LOOP], nCigaretteSmokeCount + GameObject.RandomInt(nRandomCigaretteSmokeCount));
            break;

        case 12: // '\f'
            PerformAnimTask(Anims[A_IDLE_SMOKE_END], 1);
            CallMethodOnceIn("HideCigarette", fCigaretteHideTime);
            fLastSmokeTime = GetTime();
            break;

        case 13: // '\r'
            PerformAnimTask(Anims[A_IDLE_TALK], 1);
            break;

        case 2: // '\002'
            HeadTrackingIdle();
            bHeadIdleUsesTorso = CanHappen(30);
            fHeadIdleDir = CanHappen(50) ? 1 : -1;
            CallMethodOnceIn(METHOD_EndOfIdleHead, fHeadIdleTime);
            break;

        case 3: // '\003'
            TaskFinished();
            break;

        case 4: // '\004'
            if(cMotion.iSpeed != 5 && cMotion.iSpeed != 2)
                cMotion.bAiming = true;
            ChangeMotionMode(cMotion.iSpeed);
            break;

        case 5: // '\005'
            cMotion.bAiming = false;
            ChangeMotionMode(cMotion.iSpeed);
            break;

        case 6: // '\006'
            ChangeMotionMode((byte)3);
            break;

        case 7: // '\007'
            ChangeMotionMode((byte)4);
            break;

        case 8: // '\b'
            ChangeMotionMode((byte)2);
            break;

        case 9: // '\t'
            ChangeMotionMode(cMotion.iSpeed);
            break;

        case 14: // '\016'
            fCurrentRecoverTime = fRecoverTime;
            bSavedRecoverPlaceGun = bPlaceGun;
            bPlaceGun = false;
            fSavedRecoverMorphTime = GetAnimMorphTime();
            SetAnimMorphTime(fCurrentRecoverTime);
            if(!bUseNewModel)
                PlayAnim(Anims[A_TAKE_HIT], 1);
            CallMethodOnceIn(METHOD_WaitForRecoverDone, fCurrentRecoverTime);
            break;

        case 15: // '\017'
            PerformAnimTask(Anims[A_IDLE_BOX_SMOKE_START], 1);
            CallMethodOnceIn("ShowCigarette", fCigaretteShowTime);
            break;

        case 16: // '\020'
            PerformAnimTask(Anims[A_IDLE_BOX_SMOKE_LOOP], nCigaretteSmokeCount + GameObject.RandomInt(nRandomCigaretteSmokeCount));
            break;

        case 17: // '\021'
            PerformAnimTask(Anims[A_IDLE_BOX_SMOKE_END], 1);
            CallMethodOnceIn("HideCigarette", fCigaretteHideTime);
            fLastSmokeTime = GetTime();
            break;

        default:
            GameObject.LogD("Unknown action: " + nAction + "\n");
            break;
        }
    }

    void GotMessage(int nMessageID)
    {
        switch(nMessageID)
        {
        case 1: // '\001'
        case 2: // '\002'
            ActivateAI(nMessageID == 1, _FREEZE_ADVENTURE);
            break;
        }
    }

    public void Run()
    {
        ChooseIdleState();
    }

    void InitHumanBody()
    {
        nLeftHandID = GetElementID("Left_hand");
        nRightHandID = GetElementID("Right_hand");
        InitBodyElemIDs();
        if(bCanSmoke)
        {
            cCigarette = (MeshObject)CreateObjectNoInit("MeshObject");
            cCigarette.MeshName = sCigaretteMeshName;
            cCigarette.InitObject();
            cCigarette.ClearFlag(1);
            cCigarette.SetFlag(4);
            cCigarette.SetFlag(64);
            cCigarette.SetLighting(true);
            AttachChild(cCigarette, "Bip01 L Finger2");
            cCigarette.SetDirLocal(new Vector(-1F, 0.0F, 0.0F));
            HideCigarette();
        }
    }

    Vector GetLookFromPoint()
    {
        return GetBoneJointPos((byte)5);
    }

    boolean IdleTaskAvailable()
    {
        return true;
    }

    public void SwitchOutdoorAI(boolean bEnableOutdoorAI)
    {
        if(GetParent() == null)
            if(bEnableOutdoorAI)
                ActivateAI(true, _FREEZE_PORTAL);
            else
                ActivateAI(false, _FREEZE_PORTAL);
    }

    void UpdateTrackingHeight()
    {
        if(GetPosition().fY < _DYING_LEVEL)
            Die();
    }

    void UpdateSightSamplesBuffer(float fSamplingTime, boolean bIsInSight)
    {
        int nNewSightSamples = (int)(fSamplingTime / fUpdateTime) + 1;
        if(nNewSightSamples > nMaxSightSamples)
            nNewSightSamples = nMaxSightSamples;
        if(nNewSightSamples > nSightSamples)
        {
            int nSteps = nNewSightSamples - nSightSamples;
            for(int i = 0; i < nSteps; i++)
            {
                nEndSightSample++;
                nEndSightSample %= nMaxSightSamples + 1;
                aSightSample[nEndSightSample] = false;
            }

            nSightSamples = nNewSightSamples;
        } else
        {
            int nSteps = nSightSamples - nNewSightSamples;
            for(int i = 0; i < nSteps; i++)
            {
                if(aSightSample[nStartSightSample])
                    nIsInSightSamples--;
                nStartSightSample++;
                nStartSightSample %= nMaxSightSamples + 1;
            }

            nSightSamples = nNewSightSamples;
        }
        if(aSightSample[nStartSightSample])
            nIsInSightSamples--;
        nStartSightSample++;
        nStartSightSample %= nMaxSightSamples + 1;
        nEndSightSample++;
        nEndSightSample %= nMaxSightSamples + 1;
        aSightSample[nEndSightSample] = bIsInSight;
        if(bIsInSight)
            nIsInSightSamples++;
    }

    void PerformAnimTaskSmokeDo()
    {
        if(nPerformAnimSmokeTimes-- <= 0)
        {
            DisableCallMethod(METHOD_PerformAnimTaskSmokeDo);
            AnimationTaskFinished();
        } else
        {
            PlayAnim(nPerformAnimSmokeID, 1);
            CallMethodOnceIn(METHOD_PerformAnimTaskSmokeDo, GameObject.RandomFloat(1.0F) + GetAnimLength(nPerformAnimSmokeID));
        }
    }

    void InitInventory()
    {
        super.cInventory = (InventoryAI)CreateObjectNoInit("InventoryAI");
        super.cInventory.Owner = this;
        super.cInventory.InitObject();
        CallMethodIn("FillInventory", 0.0F);
    }

    void PlayStandAnim()
    {
        if(super.CurrentState instanceof AIBaseState)
            ((AIBaseState)super.CurrentState).PlayStandAnim();
        else
            PlayAnim(Anims[A_STAND], -1);
    }

    void StopHeadTracking()
    {
        if(bTrackingHead)
        {
            bTrackingHead = false;
            RemoveTracking();
        }
        bTrackingHeadIdle = false;
        TwistBody(0.0F, 0.0F, 0);
    }

    public void SetState(String sStateName)
    {
        if(super.CurrentState != null)
        {
            if(!bIsChanginState)
            {
                ((AIBaseState)super.CurrentState).OnLeave();
                if(((AIBaseState)super.CurrentState).bNeedTimeToLeave)
                {
                    sStateToSetName = sStateName;
                    bIsChanginState = true;
                } else
                {
                    super.SetState(sStateName);
                }
            } else
            if(sStateName.compareTo("Die") == 0)
            {
                bIsChanginState = false;
                super.SetState(sStateName);
            }
        } else
        {
            super.SetState(sStateName);
        }
    }

    void HeightTracking()
    {
        if(!bTrackingHeight)
        {
            bTrackingHeight = true;
            AddTracking();
        }
    }

    public void ChooseIdleState()
    {
        if(bIsSittingBull)
            SetState("IdleSitting");
        else
            SetState("Idle");
    }

    void HideCigarette()
    {
        if(cCigarette != null)
        {
            cCigarette.DeactivateOnModuleAlways();
            cCigarette.EnableRendering(false);
        }
    }

    public void Die()
    {
        if(!super.bDead)
        {
            super.Die();
            SetState("Die");
        }
    }

    void BodyDeformStrafe(byte byDir)
    {
        if(cMotion.iSpeed >= 3 && byDeformStrafe != byDir)
        {
            BoneRotate((byte)0, new Vector(1.0F, 0.0F, 0.0F), byDir * 30);
            BoneRotate((byte)1, new Vector(1.0F, 0.0F, 0.0F), -byDir * 15);
            BoneRotate((byte)2, new Vector(1.0F, 0.0F, 0.0F), -byDir * 15);
            byDeformStrafe = byDir;
        }
    }

    void NewTaskExclusive(int nAction)
    {
        ClearTasks();
        aTaskQueue.addElement(new Integer(nAction));
        TakeAction(((Integer)aTaskQueue.elementAt(0)).intValue());
    }

    public void FreezeAI(int nFreezeCause)
    {
        if(IsFrozen(nFreezeCause))
            return;
        if(!IsFrozen())
        {
            bPhysicsActiveBeforeFreeze = GetPhysicsActive();
            FreezeCallMethods();
            SetPhysicsActive(false);
            StopAnim("");
        }
        m_nFreezeCause |= nFreezeCause;
    }

    int BuildSeqID(int nWeaponType, int iSpeed, int nMagic, int nPumpAction)
    {
        if(iSpeed == 0)
            iSpeed = 4;
        return nWeaponType << 6 | iSpeed << 9 | nMagic << 12 | nPumpAction << 13;
    }

    void SetTrackingUpdateTime(float fNewTime)
    {
        if(nUpdateTrackings > 0)
            if(fNewTime <= 0.0F)
                DisableCallMethod(METHOD_UpdateTrackings);
            else
                CallMethodEveryMinMax(METHOD_UpdateTrackings, fNewTime, 10F * fNewTime);
        fUpdateTrackingTime = fNewTime;
        fUpdateTrackingTimeMax = fNewTime * 10F;
    }

    void SuperOnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        super.OnTakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
    }

    void BodyDeformStrafeReset()
    {
        if(byDeformStrafe != 0)
        {
            BoneRotate((byte)0, new Vector(1.0F, 0.0F, 0.0F), 0.0F);
            BoneRotate((byte)1, new Vector(1.0F, 0.0F, 0.0F), 0.0F);
            BoneRotate((byte)2, new Vector(1.0F, 0.0F, 0.0F), 0.0F);
            byDeformStrafe = 0;
        }
    }

    float GetTwistHorizMin(int nTwistType)
    {
        return CalcTwistExtremum(fTwistHorizMin, nTwistType);
    }

    void UpdateTrackingHead()
    {
        float fAngleH = 0.0F;
        float fAngleV = 0.0F;
        if(bTrackingHeadIdle)
        {
            fAngleH = fHeadMaxAngle * (float)Math.sin(fHeadAngle);
            fHeadAngle += fHeadAngleSpeed;
        } else
        {
            Vector vLookTarget = null;
            if(cTrackedObject instanceof ChromeActor)
                vLookTarget = ((ChromeActor)cTrackedObject).GetPointToLookAt(0);
            else
            if(vTrackedPoint != null)
                vLookTarget = new Vector(vTrackedPoint);
            else
                return;
            Vector vDir = vLookTarget;
            vDir.Sub(GetLookFromPoint());
            fAngleH = Dir2HorizAngle(vDir);
            fAngleV = -Dir2VertAngle(vDir);
        }
        int nTwistType = bHeadIdleUsesTorso ? 2 : 1;
        float fCroppedAngleH = Crop(fAngleH, GetTwistHorizMin(nTwistType), GetTwistHorizMax(nTwistType));
        float fCroppedAngleV = Crop(fAngleV, GetTwistVertMin(nTwistType), GetTwistVertMax(nTwistType));
        TwistBody(fCroppedAngleH, fCroppedAngleV, nTwistType);
    }

    void AIBaseOnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        OnTakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
    }

    void UpdateAvailableAnims()
    {
        bCanUseHandsAnims = GetAnimID(ROOT_BONE, "Nwn") > 0;
        bCanUsePistolAnims = GetAnimID(ROOT_BONE, "Pwn") > 0;
        bCanUseRifleAnims = GetAnimID(ROOT_BONE, "Rwn") > 0;
    }

    boolean IsPointInSightRange(Vector vPoint, float fRange2)
    {
        Vector vDirection = new Vector(vPoint);
        vDirection.Sub(GetPosition());
        if(vDirection.Len2() < fRange2)
        {
            vDirection.Normalize();
            float fDotToPoint = vDirection.Dot(GetLookDirection());
            if(fDotToPoint > fAISightAngleCos)
                return true;
        }
        return false;
    }

    float GetTwistVertMax(int nTwistType)
    {
        return CalcTwistExtremum(fTwistVertMax, nTwistType);
    }

    void ShowTasks()
    {
        GameObject.CrashLog("Current tasks for " + this + ": " + aTaskQueue.toString() + "\n");
    }

    void HeadTrackingIdle()
    {
        if(!bTrackingHead)
        {
            bTrackingHead = true;
            AddTracking();
        }
        bTrackingHeadIdle = true;
        fHeadAngle = 0.0F;
    }

    void SetupAnimsOld()
    {
        boolean bPumpAction = false;
        byte weaponType;
        if(super.ActiveWeapon != null)
        {
            weaponType = super.ActiveWeapon.nType;
            bPumpAction = super.ActiveWeapon.bPumpAction;
        } else
        {
            weaponType = 0;
        }
        String prefix = "";
        switch(weaponType)
        {
        case 0: // '\0'
            prefix = "N";
            break;

        case 1: // '\001'
            prefix = "K";
            break;

        case 2: // '\002'
            prefix = "P";
            break;

        case 3: // '\003'
            prefix = "R";
            break;

        case 4: // '\004'
            prefix = "H";
            break;

        case 5: // '\005'
            prefix = "G";
            break;

        default:
            prefix = "U";
            break;
        }
        Anims[A_BUTT_HIT] = GetAnimID(ROOT_BONE, prefix + "b");
        Anims[A_CRAWL2DUCK] = GetAnimID(ROOT_BONE, prefix + "c2d");
        Anims[A_CRAWL2STAND] = GetAnimID(ROOT_BONE, prefix + "c2s");
        Anims[A_DUCK2CRAWL] = GetAnimID(ROOT_BONE, prefix + "d2c");
        Anims[A_STAND2CRAWL] = GetAnimID(ROOT_BONE, prefix + "s2c");
        switch(cMotion.iSpeed)
        {
        case 5: // '\005'
            prefix += "r";
            break;

        case 4: // '\004'
            prefix += "w";
            break;

        case 3: // '\003'
            prefix += "d";
            break;

        case 2: // '\002'
            prefix += "c";
            break;

        case 0: // '\0'
            prefix += "w";
            break;
        }
        Anims[A_JUMP] = GetAnimID(ROOT_BONE, prefix + "j");
        Anims[A_JUMP_FORWARD] = GetAnimID(ROOT_BONE, prefix + "jf");
        Anims[A_WEA_RELOAD] = GetAnimID(TORSO_BONE, prefix + "re");
        Anims[A_WEA_GET] = GetAnimID(TORSO_BONE, prefix + "g");
        Anims[A_WEA_PUTAWAY] = GetAnimID(TORSO_BONE, prefix + "p");
        if(bPlaceGun && cMotion.bAiming && cMotion.iSpeed != 2 && cMotion.iSpeed != 5)
            prefix += "a";
        else
            prefix += "n";
        if(bPumpAction)
            Anims[A_WEA_FIRE] = GetAnimID(TORSO_BONE, prefix + "fS");
        else
            Anims[A_WEA_FIRE] = GetAnimID(TORSO_BONE, prefix + "f");
        Anims[A_STAND] = GetAnimID(ROOT_BONE, prefix + "s");
        Anims[A_FORWARD] = GetAnimID(ROOT_BONE, prefix + "");
        Anims[A_BACKWARD] = GetAnimID(ROOT_BONE, prefix + "b");
        Anims[A_STRAFE_LEFT] = GetAnimID(ROOT_BONE, prefix + "sl");
        Anims[A_STRAFE_RIGHT] = GetAnimID(ROOT_BONE, prefix + "sr");
        Anims[A_ROTATE_LEFT] = GetAnimID(ROOT_BONE, prefix + "rl");
        Anims[A_ROTATE_RIGHT] = GetAnimID(ROOT_BONE, prefix + "rr");
        Anims[A_TAKE_HIT] = GetAnimID(TORSO_BONE, prefix + "sh");
        SetAnimFreq("", 30F * fAnimSpeedUp);
        Anims[A_BACK_ROTATE_LEFT] = GetAnimID(ROOT_BONE, prefix + "rlb");
        SetAnimFreq(prefix + "rlb", 50F);
        Anims[A_BACK_ROTATE_RIGHT] = GetAnimID(ROOT_BONE, prefix + "rrb");
        SetAnimFreq(prefix + "rrb", 50F);
    }

    void CallMethodOnceIn(String funcname, float seconds)
    {
        DisableCallMethod(funcname);
        CallMethodIn(funcname, seconds);
    }

    void CallMethodOnceIn(int nFuncID, float seconds)
    {
        DisableCallMethod(nFuncID);
        CallMethodIn(nFuncID, seconds);
    }

    public void DisableVitalActivities()
    {
        bActionInProgress = bCriticalActionInProgress = false;
        ClearTasks();
        SetSpeed(new Vector());
        StopAnim(ROOT_BONE);
        StopAnim(TORSO_BONE);
        StopHeadTracking();
        StopHeightTracking();
        DisableCallMethod(METHOD_OnMakeDecisionEntering);
        DisableCallMethod(METHOD_OnMakeDecision);
        DisableCallMethod(METHOD_UpdateMotion);
        DisableCallMethod(METHOD_OnChangeMotionType);
        DisableCallMethod(METHOD_EndOfIdleHead);
        DisableCallMethod(METHOD_UpdateTrackings);
        DisableCallMethod(METHOD_WaitForRecoverDone);
        DisableCallMethod(METHOD_StepDone);
        DisableCallMethod(METHOD_AnimationTaskFinished);
        DisableCallMethod(METHOD_OnReact);
        IgnoreHandler("OnHearNoise");
        IgnoreHandler("OnReact");
    }

    void UpdateMotion()
    {
        if(super.bDead)
            return;
        byte iSpeedCopy = cMotion.iSpeed;
        cMotion.iSpeed = GetReducedMotionSpeed(cMotion);
        SetupAnims();
        if(cMotion.IsMoving())
        {
            int nAnimToPlay = -1;
            if(cMotion.IsMovingLinear())
                switch(cMotion.iMoveZ)
                {
                case -1: 
                    nAnimToPlay = Anims[A_BACKWARD];
                    if(cMotion.iSpeed >= 4)
                        BodyDeformStrafe((byte)(-cMotion.iMoveX));
                    else
                        BodyDeformStrafeReset();
                    break;

                case 0: // '\0'
                    if(cMotion.iSpeed == 5)
                    {
                        nAnimToPlay = Anims[A_FORWARD];
                        BodyDeformStrafe(cMotion.iMoveX);
                    } else
                    {
                        BodyDeformStrafeReset();
                        if(cMotion.iMoveX > 0)
                            nAnimToPlay = Anims[A_STRAFE_LEFT];
                        else
                            nAnimToPlay = Anims[A_STRAFE_RIGHT];
                    }
                    break;

                case 1: // '\001'
                    nAnimToPlay = Anims[A_FORWARD];
                    if(cMotion.iSpeed >= 4)
                        BodyDeformStrafe(cMotion.iMoveX);
                    else
                        BodyDeformStrafeReset();
                    break;
                }
            else
            if(cMotion.iTurn != 0)
            {
                BodyDeformStrafeReset();
                if(cMotion.iTurn > 0)
                    PlayAnim(Anims[A_ROTATE_LEFT], -1);
                else
                    PlayAnim(Anims[A_ROTATE_RIGHT], -1);
            }
            if(nAnimToPlay != -1 && (cOldMotion.iMoveX != cMotion.iMoveX || cOldMotion.iMoveZ != cMotion.iMoveZ))
            {
                PlayAnim(nAnimToPlay, -1);
                StepDone();
                CallMethodEvery(METHOD_StepDone, GetAnimLength(nAnimToPlay) / 2.0F);
            }
        } else
        {
            BodyDeformStrafeReset();
            if(cOldMotion.iSpeed == 2 && cMotion.iSpeed != 2)
            {
                if(cMotion.iSpeed == 3)
                {
                    PlayAnim(Anims[A_CRAWL2DUCK], 1);
                    CallMethodOnceIn(METHOD_UpdateMotion, GetAnimLength(Anims[A_CRAWL2DUCK]));
                } else
                {
                    PlayAnim(Anims[A_CRAWL2STAND], 1);
                    CallMethodOnceIn(METHOD_UpdateMotion, GetAnimLength(Anims[A_CRAWL2STAND]));
                }
            } else
            if(cOldMotion.iSpeed != 2 && cMotion.iSpeed == 2)
            {
                if(cMotion.iSpeed == 3)
                {
                    PlayAnim(Anims[A_DUCK2CRAWL], 1);
                    CallMethodOnceIn(METHOD_UpdateMotion, GetAnimLength(Anims[A_DUCK2CRAWL]));
                } else
                {
                    PlayAnim(Anims[A_STAND2CRAWL], 1);
                    CallMethodOnceIn(METHOD_UpdateMotion, GetAnimLength(Anims[A_STAND2CRAWL]));
                }
            } else
            {
                PlayStandAnim();
            }
            if(cOldMotion.IsMovingLinear())
                DisableCallMethod(METHOD_StepDone);
        }
        cMotion.iSpeed = iSpeedCopy;
        cOldMotion = new MotionState(cMotion);
    }

    void InitSightRangeVisualisation()
    {
        int nNumTriangles = (int)(fAISightAngle / fTriangleMaxAngle) + 1;
        for(int i = 0; i < vSightRangeVis.size(); i++)
        {
            MeshObject cMO = (MeshObject)vSightRangeVis.elementAt(i);
            cMO.DeactivateOnModuleAlways();
            cMO.delete();
        }

        vSightRangeVis.removeAllElements();
        if(bAllowSightRangeVisualisation)
        {
            fTriangleAlpha = fAISightAngle / (float)nNumTriangles;
            float fCurAngle = -fAISightAngle / 2.0F + fTriangleAlpha;
            vTriangleScale = null;
            for(int i = 0; i < nNumTriangles; i++)
            {
                MeshObject cMO = (MeshObject)CreateObjectNoInit("MeshObject");
                cMO.MeshName = sTriangleMeshName;
                cMO.InitObject();
                cMO.ClearFlag(32);
                cMO.ClearFlag(8);
                if(vTriangleScale == null)
                {
                    if(fTriangleXSize == 0.0F || fTriangleZSize == 0.0F)
                    {
                        Vector vMin = new Vector();
                        Vector vMax = new Vector();
                        cMO.GetMeshExtents(vMin, vMax);
                        fTriangleXSize = vMax.fX - vMin.fX;
                        fTriangleZSize = vMax.fZ - vMin.fZ;
                    }
                    float fDestX = fAISightRange * (float)(2D * Math.sin((double)(fTriangleAlpha / 2.0F) * 0.017453292519943295D));
                    float fDestZ = (float)Math.sqrt(fAISightRange * fAISightRange - 0.25F * fDestX * fDestX);
                    vTriangleScale = new Vector(fDestX / fTriangleXSize, 1.0F, fDestZ / fTriangleZSize);
                }
                vSightRangeVis.addElement(cMO);
            }

            bTrianglesAreVisible = false;
            CallMethodEvery("UpdateSightRangeVis", 0.2F);
        }
    }

    void TryToScream(int nScreamType)
    {
        if(CanHappen(aScreamNoiseChance[nScreamType]))
        {
            nLastScreamType = nScreamType;
            MakeNoise(aScreamNoiseLoudness[nScreamType], 4);
        } else
        {
            nLastScreamType = 0;
        }
    }

    void Initialize()
    {
        fAISightAngleCos = (float)Math.cos(((double)(fAISightAngle * 0.5F) * 3.1415926535897931D) / 180D);
        fAISightRange2 = fAISightRange * fAISightRange;
        f6thSenseRange2 = f6thSenseRange * f6thSenseRange;
        InitSightSamplesBuffer();
        SetMaxAngSpeed(fAngSpeed);
        SetSpeed(new Vector());
        bReallyDead = false;
        bActionInProgress = bCriticalActionInProgress = false;
        SetFlag(32);
        ClearFlag(2);
        super.fHealth = fStartHealth;
        super.bDead = false;
        bIsSittingBull = bStartInSittingPose;
        SetEllipsoid(fEllipsoidRadius[5], fEllipsoidHeight[5], fEllipsoidPos[5]);
        HeightTracking();
    }

    void NewTask(int nAction)
    {
        DisableCallMethod(METHOD_OnMakeDecision);
        aTaskQueue.addElement(new Integer(nAction));
        if(aTaskQueue.size() == 1)
            TakeAction(((Integer)aTaskQueue.elementAt(0)).intValue());
    }

    void TaskFinishedQuick()
    {
        TaskFinished(true);
    }

    byte GetReducedMotionSpeed(MotionState cMotion)
    {
        byte iSpeed = cMotion.iSpeed;
        if(cMotion.iSpeed == 5 && (cMotion.bAiming || cMotion.iMoveZ == -1))
            iSpeed = 4;
        if(super.ActiveWeapon != null && super.ActiveWeapon.nType == 4 && (iSpeed == 5 || cMotion.IsMovingLinear() && (iSpeed == 3 || iSpeed == 2)))
            iSpeed = 4;
        if(iSpeed == 5 && !cMotion.IsMovingLinear())
            iSpeed = 4;
        return iSpeed;
    }

    void PerformAnimTaskSmoke(int nAnimID, int nTimes)
    {
        if(nTimes < 0)
            nTimes = 0;
        nPerformAnimSmokeID = nAnimID;
        nPerformAnimSmokeTimes = nTimes;
        PerformAnimTaskSmokeDo();
    }

    void AddTracking()
    {
        if(nUpdateTrackings == 0 && fUpdateTrackingTime > 0.0F)
            CallMethodEveryMinMax(METHOD_UpdateTrackings, fUpdateTrackingTime, fUpdateTrackingTimeMax);
        nUpdateTrackings++;
    }

    float Dir2VertAngle(Vector vDir)
    {
        Vector vDirH = new Vector(vDir);
        vDirH.fY = 0.0F;
        return (float)((Math.atan2(vDir.fY, vDirH.Len()) * 180D) / 3.1415926535897931D);
    }

    void OnChangeMotionType()
    {
    }

    void OnPostUpdate()
    {
        PlaceGun();
    }

    void ExecuteAIInventory()
    {
        if(cAIInventoryExecutor == null)
            return;
        try
        {
            PlayerHUD cPlayerHUD = (PlayerHUD)cAIInventoryExecutor;
            if(cPlayerHUD.SetAIInventory(super.cInventory))
                super.bIsCorpseActive = true;
        }
        catch(ClassCastException e)
        {
            GameObject.Log("[AIBase.Execute]: AIBase corpse can be executed only by PlayerHUD\n");
        }
        cAIInventoryExecutor = null;
    }

    void FillInventory()
    {
        String aItems[] = new String[10];
        for(StringTokenizer cItemsIter = new StringTokenizer(sItems, " ,", false); cItemsIter.hasMoreTokens(); InsertItems(aItems, 1))
        {
            String sToken = cItemsIter.nextToken();
            aItems[0] = sToken;
        }

        StringTokenizer cDefaultItemsIter = new StringTokenizer(sDefaultItems, " ,+%", true);
        int nGroupItems = 0;
        int nProbability = nDefaultItemProbability;
        while(cDefaultItemsIter.hasMoreTokens()) 
        {
            String sToken = cDefaultItemsIter.nextToken();
            if(sToken.compareTo("%") == 0)
            {
                if(cDefaultItemsIter.hasMoreTokens())
                {
                    sToken = cDefaultItemsIter.nextToken();
                    try
                    {
                        nProbability = Integer.valueOf(sToken).intValue();
                    }
                    catch(NumberFormatException e)
                    {
                        GameObject.LogD("Incorrect probability value!\n");
                        nProbability = nDefaultItemProbability;
                    }
                } else
                {
                    GameObject.LogD("Default items names parsing error!\n");
                    return;
                }
            } else
            if(sToken.compareTo(" ") != 0 && sToken.compareTo("+") != 0)
                if(sToken.compareTo(",") == 0)
                {
                    if(CanHappen(nProbability))
                        InsertItems(aItems, nGroupItems);
                    nGroupItems = 0;
                    nProbability = nDefaultItemProbability;
                } else
                {
                    aItems[nGroupItems++] = sToken;
                }
        }
        if(CanHappen(nProbability))
            InsertItems(aItems, nGroupItems);
    }

    public void UnfreezeAI(int nFreezeCause)
    {
        if(!IsFrozen(nFreezeCause))
            return;
        m_nFreezeCause &= ~nFreezeCause;
        if(!IsFrozen())
        {
            UnfreezeCallMethods();
            SetPhysicsActive(bPhysicsActiveBeforeFreeze);
            StartAnim("");
            UpdateMotion();
        }
    }

    float Crop(float fValue, float fMin, float fMax)
    {
        if(fValue <= fMin)
            return fMin;
        if(fValue >= fMax)
            return fMax;
        else
            return fValue;
    }

    void RespawnAI()
    {
        DisableVitalActivities();
        PhysicsOff();
        SetPositionWorld(vRespawnPos);
        SetDir(vRespawnDir);
        Initialize();
        OnReactStart();
        UncutBodyParts();
        CallMethodOnceIn("Run", 0.0F);
    }

    public int GetScreamType()
    {
        return nLastScreamType;
    }

    void ClearTasks()
    {
        DisableCallMethod(METHOD_OnMakeDecision);
        if(aTaskQueue.size() > 0)
        {
            CancelAction(((Integer)aTaskQueue.elementAt(0)).intValue());
            aTaskQueue.removeAllElements();
        }
    }

    Collision TraceTerrainObjectsAndTreesExcludeMe(Vector vStart, Vector vEnd)
    {
        Collision cColl = null;
        Collision cCurrColl = TraceTerrain(vStart, vEnd);
        if(cCurrColl != null)
            cColl = cCurrColl;
        cCurrColl = TraceObjectsExclude(vStart, vEnd, this);
        if(cCurrColl != null)
            cColl = cCurrColl;
        cCurrColl = TraceTrees(vStart, vEnd);
        if(cCurrColl != null)
            cColl = cCurrColl;
        return cColl;
    }

    public void SetAnimMorphTime(float fMorphTime)
    {
        super.SetAnimMorphTime(fCurrentMorphTime = fMorphTime);
    }

    public void SetLegsAnimMorphTime(float fMorphTime)
    {
        for(int i = 0; i < aLegElemID.length; i++)
            SetAnimMorphTime(aLegElemID[i], fMorphTime, false);

    }

    void TaskFinished()
    {
        TaskFinished(false);
    }

    private void TaskFinished(boolean bQuick)
    {
        if(!bActionInProgress)
        {
            String s = "No action in progress, cannot finish task !!!, object:" + this + " task:";
            if(aTaskQueue.size() > 0)
                s += ((Integer)aTaskQueue.elementAt(0)).intValue();
            else
                s += "no task";
            GameObject.CrashLog(s + "\n");
            return;
        }
        bActionInProgress = false;
        if(aTaskQueue.size() != 0)
            aTaskQueue.removeElementAt(0);
        else
            Thread.dumpStack();
        if(aTaskQueue.size() == 0)
        {
            DisableCallMethod(METHOD_OnMakeDecision);
            CallMethodInMinMax(METHOD_OnMakeDecision, bQuick ? 0.0F : fMinThinkingTime + GameObject.RandomFloat(fMaxThinkingTime - fMinThinkingTime), bQuick ? 1.0F : fMaxThinkingTime * 3F);
        } else
        {
            TakeAction(((Integer)aTaskQueue.elementAt(0)).intValue());
        }
    }

    void AnimationTaskFinished()
    {
        DisableCallMethod(METHOD_PerformAnimTaskSmokeDo);
        UpdateMotion();
        TaskFinishedQuick();
    }

    public void ActivateAI(boolean bActivate, int nFreezeCause)
    {
        if(bActivate)
        {
            UnfreezeAI(nFreezeCause);
            if(!IsFrozen() || m_nFreezeCause == _FREEZE_MOVIE)
            {
                if(m_bActivateGridIndependent)
                    ActivateOnModuleGridIndependent();
                else
                    ActivateOnModule();
                EnableRendering(true);
                if(!IsFrozen())
                    m_bAIActive = true;
            }
        } else
        {
            FreezeAI(nFreezeCause);
            EnableRendering(false);
            if(m_bActivateGridIndependent)
                DeactivateOnModuleAlways();
            else
                DeactivateOnModule();
            m_bAIActive = false;
            if(cCigarette != null)
                cCigarette.EnableRendering(false);
        }
    }

    void UpdateAllTrackings()
    {
        if(bTrackingHead)
            UpdateTrackingHead();
        if(bTrackingHeight)
            UpdateTrackingHeight();
    }

    Vector GetLookDirection()
    {
        return GetBonePerpVector((byte)5);
    }

    void CancelAction(int nAction)
    {
        if(bActionInProgress)
            switch(nAction)
            {
            case 10: // '\n'
            case 15: // '\017'
                StopAnim("");
                DisableCallMethod(METHOD_AnimationTaskFinished);
                DisableCallMethod("ShowCigarette");
                break;

            case 12: // '\f'
            case 17: // '\021'
                StopAnim("");
                DisableCallMethod(METHOD_AnimationTaskFinished);
                DisableCallMethod("HideCigarette");
                break;

            case 1: // '\001'
            case 11: // '\013'
            case 13: // '\r'
            case 16: // '\020'
                StopAnim("");
                DisableCallMethod(METHOD_PerformAnimTaskSmokeDo);
                DisableCallMethod(METHOD_AnimationTaskFinished);
                break;

            case 2: // '\002'
                StopHeadTracking();
                DisableCallMethod(METHOD_EndOfIdleHead);
                break;

            case 4: // '\004'
                DisableCallMethod(METHOD_OnChangeMotionType);
                break;

            case 5: // '\005'
                DisableCallMethod(METHOD_OnChangeMotionType);
                break;

            case 6: // '\006'
                DisableCallMethod(METHOD_OnChangeMotionType);
                break;

            case 7: // '\007'
                DisableCallMethod(METHOD_OnChangeMotionType);
                break;

            case 8: // '\b'
                DisableCallMethod(METHOD_OnChangeMotionType);
                break;

            case 9: // '\t'
                DisableCallMethod(METHOD_OnChangeMotionType);
                break;

            case 14: // '\016'
                bPlaceGun = bSavedRecoverPlaceGun;
                SetAnimMorphTime(fSavedRecoverMorphTime);
                DisableCallMethod(METHOD_WaitForRecoverDone);
                break;

            default:
                GameObject.LogD("Unknown action: " + nAction + "\n");
                break;

            case 3: // '\003'
                break;
            }
        bActionInProgress = false;
    }

    float GetTwistVertMin(int nTwistType)
    {
        return CalcTwistExtremum(fTwistVertMin, nTwistType);
    }

    void TwistBody(float fHorizAngle, float fVertAngle, int nTwistType)
    {
        switch(nTwistType)
        {
        case 0: // '\0'
            BoneRotate((byte)5, vAlongXAxis, 0.0F);
            BoneRotate((byte)4, vAlongYAxis, 0.0F);
            BoneRotate((byte)1, vAlongXAxis, 0.0F);
            BoneRotate((byte)2, vAlongXAxis, 0.0F);
            break;

        case 1: // '\001'
            BoneRotate((byte)5, vAlongYAxis, fVertAngle);
            BoneRotate((byte)5, vAlongXAxis, fHorizAngle, true);
            break;

        case 2: // '\002'
            BoneRotate((byte)5, vAlongXAxis, fHorizAngle * 0.4F);
            BoneRotate((byte)1, vAlongXAxis, fHorizAngle * 0.3F);
            BoneRotate((byte)2, vAlongXAxis, fHorizAngle * 0.3F);
            BoneRotate((byte)5, vAlongYAxis, fVertAngle * 0.3F, true);
            BoneRotate((byte)4, vAlongYAxis, fVertAngle * 0.3F);
            BoneRotate((byte)1, vAlongYAxis, fVertAngle * 0.2F, true);
            BoneRotate((byte)2, vAlongYAxis, fVertAngle * 0.2F, true);
            break;

        case 3: // '\003'
            if(nLastTwistType == 1 || nLastTwistType == 2)
            {
                BoneRotate((byte)5, vAlongXAxis, 0.0F);
                BoneRotate((byte)4, vAlongYAxis, 0.0F);
            }
            BoneRotate((byte)1, vAlongXAxis, fHorizAngle * 0.5F);
            BoneRotate((byte)2, vAlongXAxis, fHorizAngle * 0.5F);
            BoneRotate((byte)1, vAlongYAxis, fVertAngle * 0.5F, true);
            BoneRotate((byte)2, vAlongYAxis, fVertAngle * 0.5F, true);
            break;

        default:
            GameObject.LogD("Incorrent twist type value!\n");
            break;
        }
        nLastTwistType = nTwistType;
    }

    void EndOfIdleHead()
    {
        StopHeadTracking();
        TaskFinished();
    }

    void PerformAnimTask(int nAnimID, int nTimes)
    {
        if(nTimes < 0)
            nTimes = 0;
        PlayAnim(nAnimID, nTimes);
        CallMethodOnceIn(METHOD_AnimationTaskFinished, (float)nTimes * GetAnimLength(nAnimID));
    }

    AIBase()
    {
        m_nFreezeCause = 0;
        bUseNewModel = true;
        fStartHealth = 100F;
        sDefaultItems = "%2 Radio, %70 DrugHealthex, %60 WeaponGrenade, %60 WeaponGrenade";
        nDefaultItemProbability = 50;
        sItems = "Ammo8mmLong, Ammo8mmLong";
        fMinThinkingTime = 0.05F;
        fMaxThinkingTime = 0.3F;
        fAngSpeed = 180F;
        fUpdateTime = 0.3F;
        fAISightAngle = 110F;
        fAISightRange = 8000F;
        bAllowSightRangeVisualisation = false;
        bSightRangeVisualization = false;
        bUseSightSamplesIntegration = false;
        fMaxSightSamplingTime = 3F;
        fInSightNecessaryRatio = 0.5F;
        aSightSample = null;
        nStartSightSample = 0;
        nEndSightSample = 0;
        nSightSamples = 0;
        nMaxSightSamples = 0;
        nIsInSightSamples = 0;
        f6thSenseRange = 200F;
        bSniperMode = false;
        nLastScreamType = 0;
        fThinkingTime = 0.0F;
        fRecoverTime = 0.1F;
        fCurrentRecoverTime = 0.0F;
        cMotion = new MotionState();
        cOldMotion = new MotionState();
        sCurrentState = "";
        sLastState = "";
        fChanginModeInterval = 0.3F;
        fChanginModeShortInterval = 0.25F;
        fChanginModeLongInterval = 0.7F;
        nLeftHandID = -1;
        nRightHandID = -1;
        fTwistHorizMin = -60F;
        fTwistHorizMax = 60F;
        fTwistVertMin = -30F;
        fTwistVertMax = 30F;
        fHeadTwistFactor = 1.5F;
        fDuckTorsoTwistFactor = 0.5F;
        fOldAnimMorphTime = 0.0F;
        METHOD_OnMakeDecisionEntering = 0;
        METHOD_OnMakeDecision = 0;
        METHOD_UpdateMotion = 0;
        METHOD_OnChangeMotionType = 0;
        METHOD_EndOfIdleHead = 0;
        METHOD_UpdateTrackings = 0;
        METHOD_WaitForRecoverDone = 0;
        METHOD_StepDone = 0;
        METHOD_OnReact = 0;
        METHOD_AnimationTaskFinished = 0;
        METHOD_PerformAnimTaskSmokeDo = 0;
        ROOT_BONE = "Bip01";
        TORSO_BONE = "Bip01 Spine";
        nRootElementID = 0;
        nTorsoElementID = 0;
        Anims = new int[36];
        bCanUseHandsAnims = false;
        bCanUsePistolAnims = false;
        bCanUseRifleAnims = false;
        fFastAnimMorphTime = 0.05F;
        fNormalAnimMorphTime = 0.15F;
        fSlowAnimMorphTime = 0.55F;
        bCanSmoke = true;
        nCigaretteSmokeCount = 3;
        nRandomCigaretteSmokeCount = 10;
        fNoSmokingTime = 5F;
        fRandomNoSmokingTime = 30F;
        fCigaretteShowTime = 0.4F;
        fCigaretteHideTime = 1.0F;
        sCigaretteMeshName = "Data/Meshes/Equipment/Fajka.3da";
        fLastSmokeTime = 0.0F;
        cCigarette = null;
        bStartInSittingPose = false;
        bTrackingHeight = false;
        m_bAIActive = true;
        m_bActivateGridIndependent = false;
        m_bAIAfterRestoreActive = false;
        bPhysicsActiveBeforeFreeze = false;
        fAnimSpeedUp = 1.2F;
        byDeformStrafe = 0;
        bIsChanginState = false;
        sStateToSetName = null;
        bPlaceGun = false;
        fUpdateTrackingTime = 0.2F;
        fUpdateTrackingTimeMax = 2.0F;
        nUpdateTrackings = 0;
        nLastTwistType = 0;
        bTrackingHead = false;
        bTrackingHeadIdle = false;
        cTrackedObject = null;
        vTrackedPoint = null;
        fOldLookAngle = 0.0F;
        fHeadAngle = 0.0F;
        fHeadAngleSpeed = 0.2F;
        fHeadMaxAngle = 65F;
        fHeadIdleTime = 7F;
        fHeadIdleDir = 1.0F;
        bHeadIdleUsesTorso = false;
        cAIInventoryExecutor = null;
        nThisInstanceNumber = 0;
        sTriangleMeshName = "Data/Interface/triangle.3da";
        fTriangleMaxAngle = 10F;
        vTriangleScale = null;
        fTriangleAlpha = 0.0F;
        fTriangleXSize = 0.0F;
        fTriangleZSize = 0.0F;
        vSightRangeVis = new Vector();
        bTrianglesAreVisible = true;
        bSavedRecoverPlaceGun = false;
        cObstacle = null;
        aTaskQueue = new Vector(10);
        bActionInProgress = false;
        bCriticalActionInProgress = false;
        nPerformAnimSmokeTimes = 0;
        nPerformAnimSmokeID = 0;
        bReallyDead = false;
        fCurrentMorphTime = fNormalAnimMorphTime;
        aLegElemID = null;
        aTorsoElemID = null;
        fGetUpSpeedZ = 150F;
        fGetUpSpeedY = 300F;
        super.ActiveElement = "Bip01 Spine1";
    }

    void WaitForRecoverDone()
    {
        SetAnimMorphTime(fSavedRecoverMorphTime);
        bPlaceGun = bSavedRecoverPlaceGun;
        UpdateMotion();
        TaskFinishedQuick();
    }

    void ChangeMotionMode(byte nMotionMode)
    {
        float fEndTime = fChanginModeInterval;
        cMotion.iSpeed = nMotionMode;
        if(nMotionMode == cOldMotion.iSpeed)
            fEndTime = fChanginModeShortInterval;
        else
        if(nMotionMode == 2 && cOldMotion.iSpeed != 3 || nMotionMode != 3 && cOldMotion.iSpeed == 2)
            fEndTime = fChanginModeLongInterval;
        UpdateMotion();
        CallMethodOnceIn(METHOD_OnChangeMotionType, fEndTime);
    }

    void UncutBodyParts()
    {
        if(HasBodyCuttedParts())
        {
            for(int i = 0; i < GetElementsNumber(); i++)
                if(IsBodyPartCutted(GetBoneIDFromMeshElem(i)))
                    UnCutBodyPart(GetBoneIDFromMeshElem(i), true);

        }
    }

    void StepDone()
    {
        if(!SoundEmitter.bListenerInsideBuilding)
            PlayStepSound(cMotion, 0);
    }

    void PlaceGun()
    {
        if(nLeftHandID == -1 || nRightHandID == -1)
            return;
        if(super.ActiveWeapon == null)
            return;
        if(bUseNewModel)
        {
            super.ActiveWeapon.FromUpForwardPos(GetElementUpVector(nRightHandID), GetElementForwardVector(nRightHandID), GetElementPos(nRightHandID));
        } else
        {
            Vector vUp = GetElementForwardVector(nRightHandID);
            vUp.Mul(-1F);
            Vector vGunAxis = GetElementRightVector(nRightHandID);
            super.ActiveWeapon.FromUpForwardPos(vUp, vGunAxis, GetElementPos(nRightHandID));
        }
    }

    float CalcTwistExtremum(float fInExtremumValue, int nTwistType)
    {
        float fMotionTwistFactor;
        if(cMotion.iSpeed == 2)
            fMotionTwistFactor = 0.0F;
        else
        if(cMotion.iSpeed == 3)
            fMotionTwistFactor = fDuckTorsoTwistFactor;
        else
            fMotionTwistFactor = 1.0F;
        switch(nTwistType)
        {
        case 0: // '\0'
            return 0.0F;

        case 1: // '\001'
            return fInExtremumValue;

        case 3: // '\003'
            return fInExtremumValue * fMotionTwistFactor;

        case 2: // '\002'
            return fInExtremumValue * fHeadTwistFactor * fMotionTwistFactor;
        }
        GameObject.LogD("Incorrent twist type value!\n");
        return 0.0F;
    }

    void RemoveTracking()
    {
        if(nUpdateTrackings > 0 && --nUpdateTrackings == 0)
            DisableCallMethod(METHOD_UpdateTrackings);
    }

    void HeadTracking(ControlObject cObj)
    {
        if(!bTrackingHead)
        {
            bTrackingHead = true;
            AddTracking();
        }
        cTrackedObject = cObj;
    }

    void StopHeightTracking()
    {
        if(bTrackingHeight)
        {
            bTrackingHeight = false;
            RemoveTracking();
        }
    }

    void SaveImportantMembers(PrintWriter output)
    {
        output.println("\n----- SESSION START -----\n");
        output.println("[AIBase]");
        output.println("fAISightAngle = " + fAISightAngle);
        output.println("fAISightRange = " + fAISightRange);
    }

    void InitSightSamplesBuffer()
    {
        nMaxSightSamples = (int)(fMaxSightSamplingTime / fUpdateTime);
        aSightSample = new boolean[nMaxSightSamples + 1];
        for(int i = 0; i < nMaxSightSamples; i++)
            aSightSample[i] = false;

        nStartSightSample = 0;
        nEndSightSample = 0;
        nSightSamples = 0;
        nIsInSightSamples = 0;
    }

    void UpdateSightRangeVis()
    {
        if(bSightRangeVisualization && !super.bDead)
        {
            if(!bTrianglesAreVisible)
            {
                for(int i = 0; i < vSightRangeVis.size(); i++)
                {
                    MeshObject cMO = (MeshObject)vSightRangeVis.elementAt(i);
                    cMO.ActivateOnModule();
                    cMO.EnableRendering(true);
                }

                bTrianglesAreVisible = true;
            }
            Vector vUp = new Vector(1.0F, 0.0F, 0.0F);
            float fCurAngle = -fAISightAngle / 2.0F + fTriangleAlpha;
            Vector vFwdHd = GetBonePerpVector((byte)5);
            vFwdHd.fY = 0.0F;
            Vector vPos = GetPosition();
            vPos.fY += 70F;
            for(int i = 0; i < vSightRangeVis.size(); i++)
            {
                MeshObject cMO = (MeshObject)vSightRangeVis.elementAt(i);
                cMO.SetPositionWorld(vPos);
                cMO.SetDir(RotateVector(vFwdHd, fCurAngle, Vector.Up));
                fCurAngle += fTriangleAlpha;
                cMO.SetScale(vTriangleScale);
            }

        } else
        {
            if(bTrianglesAreVisible)
            {
                for(int i = 0; i < vSightRangeVis.size(); i++)
                {
                    MeshObject cMO = (MeshObject)vSightRangeVis.elementAt(i);
                    cMO.DeactivateOnModuleAlways();
                    cMO.EnableRendering(false);
                }

                bTrianglesAreVisible = false;
            }
            if(super.bDead)
                DisableCallMethod("UpdateSightRangeRes");
        }
    }

    AIBase This()
    {
        return this;
    }

    void Execute(Actor cExecutor)
    {
        super.Execute(cExecutor);
        cAIInventoryExecutor = cExecutor;
        CallMethodIn("ExecuteAIInventory", 0.0F);
    }

    public void OnCreate()
    {
        super.OnCreate();
        super.bIsActiveTarget = true;
        super.bForceWholeObjectCollision = true;
        METHOD_OnMakeDecisionEntering = RegisterCallMethod("OnMakeDecisionEntering");
        METHOD_OnMakeDecision = RegisterCallMethod("OnMakeDecision");
        METHOD_UpdateMotion = RegisterCallMethod("UpdateMotion");
        METHOD_OnChangeMotionType = RegisterCallMethod("OnChangeMotionType");
        METHOD_EndOfIdleHead = RegisterCallMethod("EndOfIdleHead");
        METHOD_UpdateTrackings = RegisterCallMethod("UpdateTrackings");
        METHOD_WaitForRecoverDone = RegisterCallMethod("WaitForRecoverDone");
        METHOD_StepDone = RegisterCallMethod("StepDone");
        METHOD_OnReact = RegisterCallMethod("OnReact");
        METHOD_AnimationTaskFinished = RegisterCallMethod("AnimationTaskFinished");
        METHOD_PerformAnimTaskSmokeDo = RegisterCallMethod("PerformAnimTaskSmokeDo");
        Initialize();
        InitHumanBody();
        DefineAnimationSet();
        SetCollType(0);
        SetCollAction(16);
        SetCollHandler(768);
        SetTraceCollType(3);
        ClearFlag(4);
        SetFlag(256);
        if(GetParent() == null)
            SetFlag(2048);
        SetFlag(8);
        UpdatePathMap(true);
        SetPhysicsType(1);
        SetPhysicsActive(false);
        Vector vPos = GetPosition();
        if(vPos.fY >= TerrainHeight(vPos.fX, vPos.fZ))
            SetFlag(32768);
        PhysicsCreate(100F);
        SetLODCoeff(0.1F);
        SetLighting(true);
        RegisterKeyRequest();
        nThisInstanceNumber = nInstances;
        nInstances++;
        if(nThisInstanceNumber != 0);
        SetFlag(16);
        m_TeamsManager.AddTeamMember(this);
        OnReactStart();
        vRespawnPos = GetPosition();
        vRespawnDir = GetForwardVector();
        InitSightRangeVisualisation();
        CallMethodIn("Run", 0.0F);
    }

    void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
        if(!Game._bDbg)
            return;
        if(nKeyCode == 71)
            if(!bKeyState);
        if(nKeyCode == 77 && bKeyState)
            PlayAnim(Anims[A_DIE], 1);
        if(nKeyCode == 72 && bKeyState)
            RespawnAI();
        if(nKeyCode == 73)
            if(bKeyState)
                NewTask(6);
            else
                NewTask(7);
    }

    void ShowCigarette()
    {
        if(cCigarette != null)
        {
            cCigarette.ActivateOnModule();
            cCigarette.EnableRendering(true);
        }
    }

    boolean ShouldSeeEnemy(float fDistance2)
    {
        if(nSightSamples > 0)
        {
            float fDistance2Ratio = fDistance2 / fAISightRange2;
            if(fDistance2Ratio > 1.0F)
                fDistance2Ratio = 1.0F;
            return (float)nIsInSightSamples / (float)nSightSamples > fInSightNecessaryRatio * fDistance2Ratio;
        } else
        {
            return true;
        }
    }

    float GetTwistHorizMax(int nTwistType)
    {
        return CalcTwistExtremum(fTwistHorizMax, nTwistType);
    }

    void OnReactStart()
    {
        CallMethodEveryMinMax(METHOD_OnReact, fUpdateTime, fUpdateTime * 5F, (fUpdateTime * (float)nThisInstanceNumber) / (float)nInstances);
    }

    float Dir2HorizAngle(Vector vDir)
    {
        Vector vDirH = new Vector(vDir);
        vDirH.fY = 0.0F;
        vDirH.Normalize();
        float vDot = Crop(vDirH.Dot(GetForwardVector()), -1F, 1.0F);
        float fAngle = (float)((Math.acos(vDot) * 180D) / 3.1415926535897931D);
        if(vDirH.Dot(GetRightVector()) < 0.0F)
            return -fAngle;
        else
            return fAngle;
    }

    static int _FREEZE_MOVIE = 1;
    static int _FREEZE_PORTAL = 2;
    static int _FREEZE_ADVENTURE = 4;
    int m_nFreezeCause;
    static TeamsManager m_TeamsManager = new TeamsManager();
    static float _TIME_TO_SEND_MESSAGE = 1.0F;
    static float _DYING_LEVEL = -3200F;
    public boolean bUseNewModel;
    float fEllipsoidPos[] = {
        0, 20F, 20F, 65F, 84.972F, 84.972F
    };
    float fEllipsoidHeight[] = {
        0, 40F, 40F, 130F, 169.944F, 169.944F
    };
    float fEllipsoidRadius[] = {
        0, 39.7F, 39.7F, 39.7F, 39.7F, 39.7F
    };
    public float fStartHealth;
    public String sDefaultItems;
    public int nDefaultItemProbability;
    public String sItems;
    public float fMinThinkingTime;
    public float fMaxThinkingTime;
    public float fAngSpeed;
    public float fUpdateTime;
    public float fAISightAngle;
    float fAISightAngleCos;
    public float fAISightRange;
    float fAISightRange2;
    float aAISightRange2Modifier[] = {
        1.0F, 0.5F, 0.5F, 0.7F, 1.0F, 1.0F, 0.5F
    };
    boolean bAllowSightRangeVisualisation;
    boolean bSightRangeVisualization;
    public boolean bUseSightSamplesIntegration;
    public float fMaxSightSamplingTime;
    public float fInSightNecessaryRatio;
    boolean aSightSample[];
    int nStartSightSample;
    int nEndSightSample;
    int nSightSamples;
    int nMaxSightSamples;
    int nIsInSightSamples;
    public float f6thSenseRange;
    public float f6thSenseRange2;
    String aDieSounds[] = {
        "Data/Sounds/Ai/krzyk 01", "Data/Sounds/Ai/krzyk 04", "Data/Sounds/Ai/krzyk 05", "Data/Sounds/Ai/krzyk 07", "Data/Sounds/Ai/krzyk 08", "Data/Sounds/Ai/krzyk 09"
    };
    boolean bSniperMode;
    static final int _SCREAMTYPE_UNKNOWN = 0;
    static final int _SCREAMTYPE_PAIN = 1;
    static final int _SCREAMTYPE_DEATH = 2;
    static final int _SCREAMTYPE_BACKUP_CALL = 3;
    static final int _SCREAMTYPE_ONRICOCHETNOISE = 4;
    public float aScreamNoiseLoudness[] = {
        0, 10000F, 5000F, 10000F, 2500F
    };
    public int aScreamNoiseChance[] = {
        0, 30, 100, 100, 100
    };
    int nLastScreamType;
    float fThinkingTime;
    public float fRecoverTime;
    float fCurrentRecoverTime;
    public MotionState cMotion;
    MotionState cOldMotion;
    String sCurrentState;
    String sLastState;
    float fChanginModeInterval;
    float fChanginModeShortInterval;
    float fChanginModeLongInterval;
    int nLeftHandID;
    int nRightHandID;
    static final int _TWIST_TYPE_NONE = 0;
    static final int _TWIST_TYPE_HEAD_ONLY = 1;
    static final int _TWIST_TYPE_HEAD_USE_TORSO = 2;
    static final int _TWIST_TYPE_TORSO = 3;
    public float fTwistHorizMin;
    public float fTwistHorizMax;
    public float fTwistVertMin;
    public float fTwistVertMax;
    public float fHeadTwistFactor;
    public float fDuckTorsoTwistFactor;
    static final Vector vAlongXAxis = new Vector(1.0F, 0.0F, 0.0F);
    static final Vector vAlongYAxis = new Vector(0.0F, 1.0F, 0.0F);
    protected float fOldAnimMorphTime;
    static final int _ACTION_IDLE_ANIM = 1;
    static final int _ACTION_IDLE_HEAD = 2;
    static final int _ACTION_THINK = 3;
    static final int _ACTION_AIMING_ON = 4;
    static final int _ACTION_AIMING_OFF = 5;
    static final int _ACTION_GET_DUCKED = 6;
    static final int _ACTION_GET_WALKED = 7;
    static final int _ACTION_GET_CRAWLED = 8;
    static final int _ACTION_CHANGE_MOTION = 9;
    static final int _ACTION_IDLE_SMOKE_START = 10;
    static final int _ACTION_IDLE_SMOKE_LOOP = 11;
    static final int _ACTION_IDLE_SMOKE_END = 12;
    static final int _ACTION_IDLE_TALK = 13;
    static final int _ACTION_WAIT_FOR_RECOVER = 14;
    static final int _ACTION_BOX_SMOKE_START = 15;
    static final int _ACTION_BOX_SMOKE_LOOP = 16;
    static final int _ACTION_BOX_SMOKE_END = 17;
    static final int _ACTION_BOX_LEAVE = 18;
    int METHOD_OnMakeDecisionEntering;
    int METHOD_OnMakeDecision;
    int METHOD_UpdateMotion;
    int METHOD_OnChangeMotionType;
    int METHOD_EndOfIdleHead;
    int METHOD_UpdateTrackings;
    int METHOD_WaitForRecoverDone;
    int METHOD_StepDone;
    int METHOD_OnReact;
    int METHOD_AnimationTaskFinished;
    int METHOD_PerformAnimTaskSmokeDo;
    String ROOT_BONE;
    String TORSO_BONE;
    int nRootElementID;
    int nTorsoElementID;
    Vector vRespawnPos;
    Vector vRespawnDir;
    static byte A_STAND = 0;
    static byte A_FORWARD = 1;
    static byte A_BACKWARD = 2;
    static byte A_STRAFE_LEFT = 4;
    static byte A_STRAFE_RIGHT = 5;
    static byte A_JUMP = 6;
    static byte A_JUMP_FORWARD = 7;
    static byte A_BUTT_HIT = 8;
    static byte A_CRAWL2DUCK = 9;
    static byte A_CRAWL2STAND = 10;
    static byte A_DUCK2CRAWL = 11;
    static byte A_STAND2CRAWL = 12;
    static byte A_DIE = 13;
    static byte A_KICK = 14;
    static byte A_PUNCH = 15;
    static byte A_WEA_FIRE = 10;
    static byte A_WEA_RELOAD = 11;
    static byte A_WEA_GET = 16;
    static byte A_WEA_PUTAWAY = 17;
    static byte A_TAKE_HIT = 18;
    static byte A_IDLE_SMOKE_START = 19;
    static byte A_IDLE_SMOKE_LOOP = 20;
    static byte A_IDLE_SMOKE_END = 21;
    static byte A_IDLE_1 = 22;
    static byte A_IDLE_2 = 23;
    static byte A_IDLE_3 = 24;
    static byte A_IDLE_KEYBOARD = 25;
    static byte A_IDLE_TALK = 26;
    static byte A_IDLE_BOX = 27;
    static byte A_IDLE_BOX_SMOKE_START = 28;
    static byte A_IDLE_BOX_SMOKE_LOOP = 29;
    static byte A_IDLE_BOX_SMOKE_END = 30;
    static byte A_IDLE_BOX_END = 31;
    static byte A_ROTATE_LEFT = 32;
    static byte A_ROTATE_RIGHT = 33;
    static byte A_BACK_ROTATE_LEFT = 34;
    static byte A_BACK_ROTATE_RIGHT = 35;
    public int Anims[];
    boolean bCanUseHandsAnims;
    boolean bCanUsePistolAnims;
    boolean bCanUseRifleAnims;
    public float fFastAnimMorphTime;
    public float fNormalAnimMorphTime;
    public float fSlowAnimMorphTime;
    boolean bCanSmoke;
    int nCigaretteSmokeCount;
    int nRandomCigaretteSmokeCount;
    float fNoSmokingTime;
    float fRandomNoSmokingTime;
    float fCigaretteShowTime;
    float fCigaretteHideTime;
    String sCigaretteMeshName;
    float fLastSmokeTime;
    MeshObject cCigarette;
    public boolean bStartInSittingPose;
    boolean bIsSittingBull;
    boolean bTrackingHeight;
    boolean m_bAIActive;
    boolean m_bActivateGridIndependent;
    boolean m_bAIAfterRestoreActive;
    boolean bPhysicsActiveBeforeFreeze;
    float fAnimSpeedUp;
    byte byDeformStrafe;
    boolean bIsChanginState;
    String sStateToSetName;
    boolean bPlaceGun;
    float fUpdateTrackingTime;
    float fUpdateTrackingTimeMax;
    int nUpdateTrackings;
    int nLastTwistType;
    boolean bTrackingHead;
    boolean bTrackingHeadIdle;
    ControlObject cTrackedObject;
    Vector vTrackedPoint;
    float fOldLookAngle;
    float fHeadAngle;
    float fHeadAngleSpeed;
    float fHeadMaxAngle;
    float fHeadIdleTime;
    float fHeadIdleDir;
    boolean bHeadIdleUsesTorso;
    Actor cAIInventoryExecutor;
    static int nInstances = 0;
    int nThisInstanceNumber;
    String sTriangleMeshName;
    float fTriangleMaxAngle;
    Vector vTriangleScale;
    float fTriangleAlpha;
    float fTriangleXSize;
    float fTriangleZSize;
    Vector vSightRangeVis;
    boolean bTrianglesAreVisible;
    boolean bSavedRecoverPlaceGun;
    float fSavedRecoverMorphTime;
    MeshObject cObstacle;
    Vector aTaskQueue;
    boolean bActionInProgress;
    boolean bCriticalActionInProgress;
    int nPerformAnimSmokeTimes;
    int nPerformAnimSmokeID;
    boolean bReallyDead;
    private float fCurrentMorphTime;
    int aLegElemID[];
    int aTorsoElemID[];
    float fGetUpSpeedZ;
    float fGetUpSpeedY;

}
