// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   AIController.java

import java.lang.reflect.Field;
import java.util.*;

public abstract class AIController extends GameObject
    implements IFreezable
{

    boolean IsNearToActiveEnemy()
    {
        return GetMesh().GetDistanceTo(m_cActiveEnemy) < 1500F;
    }

    void SetActiveEnemy(ChromeActor cEnemy)
    {
        DisableCallMethod("SetLowAlarmLevel");
        if(cEnemy == null)
        {
            m_fEnemyLostTime = GetTime();
            if(GetAlarmLevel() >= 2)
                SetAlarmLevel(1);
        } else
        {
            SetAlarmLevel(2);
        }
        m_cActiveEnemy = cEnemy;
    }

    public boolean LastHeardEnemyShot()
    {
        return GetTime() - m_fLastHeardEnemyShotTime < _VERY_LONG_SOUND_IMPORTANCE_TIME;
    }

    public boolean JustHeardFriendShot()
    {
        return GetTime() - m_fLastHeardFriendShotTime < _LONG_SOUND_IMPORTANCE_TIME;
    }

    public boolean CanThrowGrenade()
    {
        return false;
    }

    boolean ActiveEnemyVisibilityLostMoreThanLong()
    {
        if(GetActiveEnemy() == null)
        {
            return false;
        } else
        {
            EnemyInfo enemyInfo = (EnemyInfo)m_aEnemies.get(GetActiveEnemy());
            return TimePassed(enemyInfo.m_fLastTraceVisibilityTime, _ENEMY_NOTICED_LONG_TIME, GetTime());
        }
    }

    void ClearGlobalTime()
    {
        DisableCallMethod("OnGlobalTimePassed");
    }

    void StartTaskTime(float fTime)
    {
        CallMethodIn(METHOD_OnTaskTimePassed, fTime);
    }

    float AngleCosToObj(ControlObject obj)
    {
        Vector vObjDir = obj.GetPosition();
        vObjDir.Sub(GetMesh().GetPosition());
        Vector vLookDir = m_MeshAI.GetLookDir();
        return MathUtils.dot2D(vLookDir, vObjDir);
    }

    public void ObjectsListMsg(ControlObject aObjs[])
    {
        RedistributeObjects(aObjs);
    }

    public void PainMsg(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        m_fLastDamageTaken = fDamage;
        if(!IsDead() && (Assassin instanceof ChromeActor))
        {
            ChromeActor actor = (ChromeActor)Assassin;
            if(!m_MeshAI.IsEnemy(actor))
            {
                GameObject.Log("Przestan do mnie strzelac, idioto !!!\n");
            } else
            {
                EnemyInfo info = AddEnemy(actor);
                if(info == null)
                    return;
                MarkAsRecognized(info);
                GotShotFromEnemy(info, fDamage);
            }
        }
    }

    void RequestEvent(int nEvent)
    {
        RequestEvent(nEvent, false);
    }

    void RequestEvent(int nEvent, boolean bForceRegenerate)
    {
        GetMesh().ProfileBegin(NewAI.PROFILE_RequestEvent);
        DebugUtils.CrashLog(m_MeshAI, "DBG: RequestEvent: " + AIEvents.GetEventName(nEvent) + "\n");
        if(IsDead())
            return;
        if(!bForceRegenerate && FilterEvent(nEvent))
            return;
        RecalcState();
        BitVector bv = RecalcGenerators();
        ServiceEvent(nEvent);
        if(!bForceRegenerate && nEvent != 8 && m_nCurrScenario != -1 && bv.IsBitSet(m_nCurrScenario))
            return;
        int nSelectedScenario = GetTheBestScenario(bv);
        if(nSelectedScenario < 0)
        {
            DebugUtils.CrashLog(m_MeshAI, "SELECTED SCENARIOS N o N e\n");
            nSelectedScenario = WaitForEnemyAction._ID;
        }
        BreakScenario(false);
        m_nLastEvent = nEvent;
        m_nCurrScenario = nSelectedScenario;
        Scenario cScenario = GetScenario(nSelectedScenario);
        DebugUtils.CrashLog(m_MeshAI, " SELECTED SCENARIO " + nSelectedScenario + " " + cScenario + " \n");
        cScenario.PrepareScenario(this);
        m_nLastPreparedScenario = nSelectedScenario;
        if(m_CurrentTask == null)
            PerformNextTask();
        GetMesh().ProfileEnd(NewAI.PROFILE_RequestEvent);
    }

    void CheckObjectSenseEvent()
    {
        CheckEnemiesEvent();
        TryToReduceAlarmLevel();
    }

    float GetHealth()
    {
        return ((Actor) (m_MeshAI)).fHealth;
    }

    void Debug(boolean bEnable)
    {
        DebugUtils.m_bDebug = bEnable;
    }

    boolean ActiveEnemyReallyVisible()
    {
        if(GetActiveEnemy() != null)
            return EnemyReallyVisible(GetActiveEnemy(), GetTime());
        else
            return false;
    }

    public void ComputeAccuracy()
    {
    }

    public final ExecutionInfo GetCurrentExecutionInfo()
    {
        return m_CurrentExecutionInfo;
    }

    public void Respawn()
    {
        m_bDead = false;
        if(m_HearingSense != null)
            ((Sense)m_HearingSense).Respawn();
        if(m_PainSense != null)
            ((Sense)m_PainSense).Respawn();
        if(m_ObjectsSense != null)
            m_ObjectsSense.Respawn();
    }

    void SetObjectToFollow(ChromeActor object)
    {
        m_ObjectToFollow = object;
    }

    public void ServeNextWaypointActivity()
    {
        if(m_CurrActivity != null)
            m_CurrActivity.StopActivity(this);
        m_bPerformCurrActivity = false;
        if(GetCurrWaypoint() == null)
        {
            GetMesh().SetWaypoint(GetMesh().cFirstWaypoint);
            m_bActivityInWaypoint = false;
            m_iCurrWaypointBehavior = 0;
            if(GetCurrWaypoint() != null)
            {
                if(GetCurrWaypoint().cMotion == null)
                    GetCurrWaypoint().cMotion = new mt_Move();
                m_CurrActivity = (IAIActivity)GetCurrWaypoint().cMotion;
                m_CurrCondition = GetCurrWaypoint().cEnterCondition;
            }
        } else
        {
            boolean bHasBehaviors = GetCurrWaypoint().aBehaviors != null && GetCurrWaypoint().aBehaviors.length > 0;
            if(!m_bActivityInWaypoint && bHasBehaviors || m_bActivityInWaypoint && m_iCurrWaypointBehavior > 0 && m_iCurrWaypointBehavior < GetCurrWaypoint().aBehaviors.length)
            {
                m_bActivityInWaypoint = true;
                m_CurrActivity = (IAIActivity)GetCurrWaypoint().aBehaviors[m_iCurrWaypointBehavior];
                if(m_CurrActivity != null)
                    m_CurrCondition = GetCurrWaypoint().aBehaviors[m_iCurrWaypointBehavior].cCondition;
                if(m_iCurrWaypointBehavior == 0)
                    GameObject.InvokeActionChain(GetCurrWaypoint().aActions);
                m_iCurrWaypointBehavior++;
            } else
            {
                if(!bHasBehaviors)
                {
                    Waypoint actionChainWaypoint = GetCurrWaypoint();
                    GameObject.InvokeActionChain(actionChainWaypoint.aActions);
                    if(actionChainWaypoint != GetCurrWaypoint())
                        return;
                }
                GetMesh().SetWaypoint(GetMesh().GetNextWaypoint());
                if(GetCurrWaypoint() != null)
                {
                    m_bActivityInWaypoint = false;
                    m_iCurrWaypointBehavior = 0;
                    if(GetCurrWaypoint().cMotion == null)
                        GetCurrWaypoint().cMotion = new mt_Move();
                    m_CurrActivity = (IAIActivity)GetCurrWaypoint().cMotion;
                    m_CurrCondition = GetCurrWaypoint().cEnterCondition;
                } else
                {
                    m_bPerformCurrActivity = false;
                    m_CurrActivity = null;
                    m_CurrCondition = null;
                }
            }
        }
        CallMethodEvery(METHOD_CheckCurrWaypointCnd, 0.1F, 0.1F * GetMesh().GetTimeDeviation());
        CheckCurrWaypointCnd();
    }

    public abstract void GotOut();

    void ChangeAlarmLevel(int iValueToAdd)
    {
        m_iCurrAlarmLevel += iValueToAdd;
        if(m_iCurrAlarmLevel < 0)
            m_iCurrAlarmLevel = 0;
        if(m_iCurrAlarmLevel > 2)
            m_iCurrAlarmLevel = 2;
    }

    public final NewAI GetMesh()
    {
        return m_MeshAI;
    }

    String TaskListtoString()
    {
        return "<curr: " + m_CurrentTask + "> " + m_TaskList;
    }

    public abstract boolean IsHidingBehindHideout();

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[AIController.SGSaveChunk]\n");
        FileChunk cFC = GameObject.NewChunk(1400, cFCParent);
        super.SGSaveChunk(cFC);
        cFC.SaveObjectRef(m_TaskList);
        cFC.SaveObjectRef(m_CurrentTask);
        cFC.SaveBool(m_bPerformNextTaskOnUnfreeze);
        cFC.SaveObject((ISaveGame)m_HearingSense);
        cFC.SaveObject((ISaveGame)m_PainSense);
        cFC.SaveObject(m_ObjectsSense);
        cFC.SaveInt(m_nCurrScenario);
        cFC.SaveInt(m_nLastPreparedScenario);
        cFC.SaveInt(m_nHelperScenariosInt);
        cFC.SaveInt(m_nLastEvent);
        cFC.SaveInt(m_aAllies.size());
        Collection alliesCollection = m_aAllies.values();
        for(Iterator alliesIterator = alliesCollection.iterator(); alliesIterator.hasNext(); cFC.SaveObjectRef((FriendInfo)alliesIterator.next()));
        cFC.SaveInt(m_aEnemies.size());
        Collection enemiesCollection = m_aEnemies.values();
        for(Iterator enemiesIterator = enemiesCollection.iterator(); enemiesIterator.hasNext(); cFC.SaveObjectRef((EnemyInfo)enemiesIterator.next()));
        if(m_RecognitionListNonPlayer == null)
            GameObject.CrashLog("[AIController.SGSaveChunk] SG-ERROR!!! m_RecognitionListNonPlayer = null\n");
        cFC.SaveInt(m_RecognitionListNonPlayer.size());
        for(int i = 0; i < m_RecognitionListNonPlayer.size(); i++)
        {
            if(m_RecognitionListNonPlayer == null)
                GameObject.CrashLog("[AIController.SGSaveChunk] SG-ERROR!!! m_RecognitionListNonPlayer = null\n");
            cFC.SaveObjectRef((ChromeActor)m_RecognitionListNonPlayer.get(i));
        }

        if(m_RecognitionListPlayer == null)
            GameObject.CrashLog("[AIController.SGSaveChunk] SG-ERROR!!! m_RecognitionListPlayer = null\n");
        cFC.SaveInt(m_RecognitionListPlayer.size());
        for(int i = 0; i < m_RecognitionListPlayer.size(); i++)
        {
            if(m_RecognitionListPlayer == null)
                GameObject.CrashLog("[AIController.SGSaveChunk] SG-ERROR!!! m_RecognitionListPlayer = null\n");
            cFC.SaveObjectRef((ChromeActor)m_RecognitionListPlayer.get(i));
        }

        cFC.SaveBool(m_bCanFire);
        cFC.SaveBool(m_bCanAim);
        cFC.SaveFloat(m_fCurrAccuracy);
        cFC.SaveObjectRef(m_cActiveEnemy);
        cFC.SaveObjectRef(m_cSuspectInfo);
        cFC.SaveFloat(m_fLastHeardEnemyShotAcceptTime);
        cFC.SaveFloat(m_fLastHeardFriendShotAcceptTime);
        cFC.SaveFloat(m_fLastHeardBulletAcceptTime);
        cFC.SaveFloat(m_fLastHeardExplosionAcceptTime);
        cFC.SaveFloat(m_fLastHeardEnemyStepsAcceptTime);
        cFC.SaveFloat(m_fLastHeardScreamAcceptTime);
        cFC.SaveFloat(m_fLastHeardDangerousAcceptTime);
        cFC.SaveFloat(m_fLastDyingCheckTime);
        cFC.SaveObjectRef(m_LastBodySpotted);
        cFC.SaveFloat(m_fLastHeardEnemyShotTime);
        cFC.SaveFloat(m_fLastHeardFriendShotTime);
        cFC.SaveFloat(m_fLastHeardRicochetTime);
        cFC.SaveFloat(m_fLastHeardExplosionTime);
        cFC.SaveFloat(m_fLastHeardDObjectTime);
        cFC.SaveFloat(m_fLastHeardEnemyStepsTime);
        cFC.SaveVector(m_vLastHeardEnemyStepsPos);
        cFC.SaveFloat(m_fLastHeardScreamTime);
        cFC.SaveFloat(m_fLastGotShotTime);
        cFC.SaveVector(m_vLastHeardEnemyShotPos);
        cFC.SaveFloat(m_fLastEnemyShotDist);
        cFC.SaveVector(m_vLastHeardFriendShotPos);
        cFC.SaveVector(m_vLastFriendsTargetPos);
        cFC.SaveObjectRef(m_LastDyingAISpotted);
        cFC.SaveObjectRef(m_LastDangerousObject);
        cFC.SaveFloat(m_fMorale);
        cFC.SaveInt(m_iCurrAlarmLevel);
        cFC.SaveFloat(m_fLastAlarmedTime);
        cFC.SaveObjectRef(m_ObjectToFollow);
        cFC.SaveFloat(m_fAttackByManyEnemiesCheckTime);
        cFC.SaveInt(m_iAttackingEnemies);
        cFC.SaveBool(m_bIsFrozen);
        cFC.SaveInt(m_NonPlayerListInfo.m_iListNdx);
        cFC.SaveInt(m_PlayerListInfo.m_iListNdx);
        cFC.SaveBool(m_bEnemyPresenceStated);
        cFC.SaveFloat(m_fLastTraceFromGunTimeCheck);
        cFC.SaveFloat(m_fLastFromGunVisibilityChangeTime);
        cFC.SaveBool(m_bActiveEnemyTraceFromGun);
        cFC.SaveVector(m_vLastHeardRicochetMakerPos);
        cFC.SaveVector(m_vLastHeardExplosionMakerPos);
        cFC.SaveFloat(m_fLastRicochetDist);
        cFC.SaveFloat(m_fLastExplosionDist);
        cFC.SaveFloat(m_fEnemyLostTime);
        cFC.SaveFloat(m_fLastImpulseTime);
        cFC.SaveFloat(m_fLastPassageNoiseTime);
        cFC.SaveFloat(m_fLastPassageEnemyNoiseTime);
        cFC.SaveVector(m_vLastPassageEnemyNoisePos);
        cFC.SaveObjectRef((ISaveGame)m_CurrActivity);
        cFC.SaveObjectRef(m_CurrCondition);
        cFC.SaveInt(m_iCurrWaypointBehavior);
        cFC.SaveBool(m_bPerformCurrActivity);
        cFC.SaveBool(m_bActivityInWaypoint);
        cFC.SaveObjectRef(m_CurrFightPoint);
        cFC.SaveFloat(m_fFightPointLeaveTime);
        cFC.SaveFloat(m_fLastEnemySpottedTime);
        cFC.SaveFloat(m_fLastEnemySpottedReactionTime);
        cFC.SaveFloat(m_fLastEnemySpottedScreamHeardTime);
        cFC.SaveFloat(m_fLastHearNoiseTraceCheckTime);
        cFC.SaveBool(m_bDead);
        cFC.SaveObjectRef(m_CurrentTriggerObject);
        cFC.SaveObjectRef(m_CurrentExecutionInfo);
        cFC.SaveFloat(m_fLastDamageTaken);
        cFC.SaveBool(m_bSitsInVehicleOnSeat);
        cFC.delete();
    }

    public Vector GetLastRicochetMakerPos()
    {
        return m_vLastHeardRicochetMakerPos;
    }

    public Vector GetLastExplosionMakerPos()
    {
        return m_vLastHeardExplosionMakerPos;
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[AIController.SGLoadChunk]\n");
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        if(cFC.GetID() == 1400)
        {
            super.SGLoadChunk(cFC);
            m_TaskList = (TasksList)cFC.LoadObjectRef();
            m_CurrentTask = (Task)cFC.LoadObjectRef();
            m_bPerformNextTaskOnUnfreeze = cFC.LoadBool();
            m_HearingSense = (IAIHearingSense)cFC.LoadObject((ISaveGame)m_HearingSense, this);
            m_PainSense = (IAIPainSense)cFC.LoadObject((ISaveGame)m_PainSense, this);
            m_ObjectsSense = (ObjectsSense)cFC.LoadObject(m_ObjectsSense, this);
            m_nCurrScenario = cFC.LoadInt();
            m_nLastPreparedScenario = cFC.LoadInt();
            m_nHelperScenariosInt = cFC.LoadInt();
            m_nLastEvent = cFC.LoadInt();
            m_aAllies.clear();
            int size = cFC.LoadInt();
            for(int i = 0; i < size; i++)
            {
                FriendInfo friendInfo = (FriendInfo)cFC.LoadObjectRef();
                m_aAllies.put(friendInfo.m_Reference, friendInfo);
            }

            m_aEnemies.clear();
            size = cFC.LoadInt();
            for(int i = 0; i < size; i++)
            {
                EnemyInfo enemyInfo = (EnemyInfo)cFC.LoadObjectRef();
                m_aEnemies.put(enemyInfo.m_Reference, enemyInfo);
            }

            m_RecognitionListNonPlayer.clear();
            size = cFC.LoadInt();
            for(int i = 0; i < size; i++)
            {
                ChromeActor actor = (ChromeActor)cFC.LoadObjectRef();
                m_RecognitionListNonPlayer.add(actor);
            }

            m_RecognitionListPlayer.clear();
            size = cFC.LoadInt();
            for(int i = 0; i < size; i++)
            {
                ChromeActor actor = (ChromeActor)cFC.LoadObjectRef();
                m_RecognitionListPlayer.add(actor);
            }

            m_bCanFire = cFC.LoadBool();
            m_bCanAim = cFC.LoadBool();
            m_fCurrAccuracy = cFC.LoadFloat();
            m_cActiveEnemy = (ChromeActor)cFC.LoadObjectRef();
            m_cSuspectInfo = (EnemyInfo)cFC.LoadObjectRef();
            m_fLastHeardEnemyShotAcceptTime = cFC.LoadFloat();
            m_fLastHeardFriendShotAcceptTime = cFC.LoadFloat();
            m_fLastHeardBulletAcceptTime = cFC.LoadFloat();
            m_fLastHeardExplosionAcceptTime = cFC.LoadFloat();
            m_fLastHeardEnemyStepsAcceptTime = cFC.LoadFloat();
            m_fLastHeardScreamAcceptTime = cFC.LoadFloat();
            m_fLastHeardDangerousAcceptTime = cFC.LoadFloat();
            m_fLastDyingCheckTime = cFC.LoadFloat();
            m_LastBodySpotted = (ChromeActor)cFC.LoadObjectRef();
            m_fLastHeardEnemyShotTime = cFC.LoadFloat();
            m_fLastHeardFriendShotTime = cFC.LoadFloat();
            m_fLastHeardRicochetTime = cFC.LoadFloat();
            m_fLastHeardExplosionTime = cFC.LoadFloat();
            m_fLastHeardDObjectTime = cFC.LoadFloat();
            m_fLastHeardEnemyStepsTime = cFC.LoadFloat();
            m_vLastHeardEnemyStepsPos = cFC.LoadVector();
            m_fLastHeardScreamTime = cFC.LoadFloat();
            m_fLastGotShotTime = cFC.LoadFloat();
            m_vLastHeardEnemyShotPos = cFC.LoadVector();
            m_fLastEnemyShotDist = cFC.LoadFloat();
            m_vLastHeardFriendShotPos = cFC.LoadVector();
            m_vLastFriendsTargetPos = cFC.LoadVector();
            m_LastDyingAISpotted = (ChromeActor)cFC.LoadObjectRef();
            m_LastDangerousObject = (ChromeActor)cFC.LoadObjectRef();
            m_fMorale = cFC.LoadFloat();
            m_iCurrAlarmLevel = cFC.LoadInt();
            m_fLastAlarmedTime = cFC.LoadFloat();
            m_ObjectToFollow = (ChromeActor)cFC.LoadObjectRef();
            m_fAttackByManyEnemiesCheckTime = cFC.LoadFloat();
            m_iAttackingEnemies = cFC.LoadInt();
            m_bIsFrozen = cFC.LoadBool();
            m_NonPlayerListInfo.m_iListNdx = cFC.LoadInt();
            m_PlayerListInfo.m_iListNdx = cFC.LoadInt();
            m_bEnemyPresenceStated = cFC.LoadBool();
            m_fLastTraceFromGunTimeCheck = cFC.LoadFloat();
            m_fLastFromGunVisibilityChangeTime = cFC.LoadFloat();
            m_bActiveEnemyTraceFromGun = cFC.LoadBool();
            m_vLastHeardRicochetMakerPos = cFC.LoadVector();
            m_vLastHeardExplosionMakerPos = cFC.LoadVector();
            m_fLastRicochetDist = cFC.LoadFloat();
            m_fLastExplosionDist = cFC.LoadFloat();
            m_fEnemyLostTime = cFC.LoadFloat();
            m_fLastImpulseTime = cFC.LoadFloat();
            m_fLastPassageNoiseTime = cFC.LoadFloat();
            m_fLastPassageEnemyNoiseTime = cFC.LoadFloat();
            m_vLastPassageEnemyNoisePos = cFC.LoadVector();
            m_CurrActivity = (IAIActivity)cFC.LoadObjectRef();
            m_CurrCondition = (Condition)cFC.LoadObjectRef();
            m_iCurrWaypointBehavior = cFC.LoadInt();
            m_bPerformCurrActivity = cFC.LoadBool();
            m_bActivityInWaypoint = cFC.LoadBool();
            m_CurrFightPoint = (FightPoint)cFC.LoadObjectRef();
            m_fFightPointLeaveTime = cFC.LoadFloat();
            m_fLastEnemySpottedTime = cFC.LoadFloat();
            m_fLastEnemySpottedReactionTime = cFC.LoadFloat();
            m_fLastEnemySpottedScreamHeardTime = cFC.LoadFloat();
            m_fLastHearNoiseTraceCheckTime = cFC.LoadFloat();
            m_bDead = cFC.LoadBool();
            m_CurrentTriggerObject = (TriggerObject)cFC.LoadObjectRef();
            m_CurrentExecutionInfo = (ExecutionInfo)cFC.LoadObjectRef();
            m_fLastDamageTaken = cFC.LoadFloat();
            m_bSitsInVehicleOnSeat = cFC.LoadBool();
        }
        cFC.delete();
    }

    public int GetValidFiringPositions()
    {
        return 0;
    }

    void RedistributeObjects(ControlObject acontrolobject[])
    {
    }

    public boolean JustSpottedEnemyOnce()
    {
        float fTime = GetTime();
        boolean bRet = false;
        if(m_fLastEnemySpottedTime > -100F)
        {
            bRet = fTime - m_fLastEnemySpottedTime < 1.0F && fTime - m_fLastEnemySpottedReactionTime > 60F;
            if(bRet)
                m_fLastEnemySpottedReactionTime = fTime;
        }
        return bRet;
    }

    public void BreakScenario(boolean bFast)
    {
        if(m_CurrentTask != null && !m_CurrentTask.IsScenarioCleaning())
        {
            m_CurrentTask.Cancel(bFast);
            m_CurrentTask = null;
        }
        for(int nId = 0; nId < m_TaskList.GetTasksNum();)
        {
            Task cTask = m_TaskList.GetTask(nId);
            if(cTask instanceof TaskTerminator)
            {
                m_TaskList.RemoveTask(nId);
                break;
            }
            if(cTask.IsScenarioCleaning())
                nId++;
            else
                m_TaskList.RemoveTask(nId);
        }

    }

    boolean AICheckTraceAbsolute(ControlObject cTarget, Vector vStart, Vector vEnd)
    {
        l_vEnd.Set(vEnd);
        m_aTraceExcludeObjects[0] = cTarget;
        m_aTraceExcludeObjects[1] = m_MeshAI;
        return m_MeshAI.AITrace(vStart, l_vEnd, NewAI._AITRACE_IGNORE_GLASS, m_aTraceExcludeObjects) == null;
    }

    boolean IsSuspectValid()
    {
        return m_cSuspectInfo != null && (m_cSuspectInfo.m_fRecognitionStartTime > 0.0F || m_cSuspectInfo.m_fRecognitionStopTime < 0.0F || !TimePassed(m_cSuspectInfo.m_fRecognitionStopTime, 5F, GetTime()));
    }

    public void ReactOnDeath(ChromeActor body, boolean bDestroyEnemy)
    {
        m_fLastHeardScreamTime = GetTime();
        m_fLastImpulseTime = m_fLastHeardScreamTime;
        m_LastDyingAISpotted = body;
        if(m_LastDyingAISpotted instanceof NewAI)
        {
            NewAI killed = (NewAI)m_LastDyingAISpotted;
            if(killed.m_Killer != null && GetMesh().IsEnemy(killed.m_Killer))
            {
                EnemyInfo info = AddEnemy(killed.m_Killer);
                if(info != null && killed.m_Killer.IsActiveOnModule() && bDestroyEnemy)
                {
                    MarkAsRecognized(info);
                    info.m_vLastKnownPos = info.m_Reference.GetPosition();
                    info.m_fLastKnownPosTime = m_fLastHeardScreamTime;
                }
            }
        }
    }

    public void Die()
    {
        if(!IsDead())
        {
            if(m_HearingSense != null)
                ((Sense)m_HearingSense).Die();
            if(m_PainSense != null)
                ((Sense)m_PainSense).Die();
            if(m_ObjectsSense != null)
                m_ObjectsSense.Die();
            DisableCallMethod("StartEvent");
            DisableCallMethod(METHOD_WaitingForAppear);
            DisableCallMethod(METHOD_CheckCurrWaypointCnd);
            DisableCallMethod("ServeNextWaypointActivity");
            DisableCallMethod("OnGlobalTimePassed");
            DisableCallMethod(METHOD_OnTaskTimePassed);
            DisableCallMethod(METHOD_OnTaskUpdate);
            DisableCallMethod("SetLowAlarmLevel");
            DisableCallMethod("CheckForAnyDying");
            DisableCallMethod("UpdateNpcEnemiesRecognition");
            DisableCallMethod("UpdatePlayerEnemiesRecognition");
            m_bDead = true;
        }
    }

    void StartTaskUpdate(float fTime)
    {
        CallMethodEvery(METHOD_OnTaskUpdate, fTime, fTime * GetMesh().GetTimeDeviation());
    }

    public void SGUpdate()
    {
        FileChunk.Log("[AIController.SGUpdate]\n");
        super.SGUpdate();
        if(m_HearingSense != null)
        {
            m_HearingSense.Init(this);
            ((ISaveGame)m_HearingSense).SGUpdate();
        }
        if(m_PainSense != null)
        {
            m_PainSense.Init(this);
            ((ISaveGame)m_PainSense).SGUpdate();
        }
        if(m_ObjectsSense != null)
        {
            m_ObjectsSense.Init(this);
            m_ObjectsSense.SGUpdate();
        }
        if(m_TaskList != null)
            m_TaskList.SetAIControllerInTasks(this);
        if(m_CurrentTask != null)
            m_CurrentTask.SetAIController(this);
        m_Player = ((ChromeModuleSingle)GetModule()).MainPlayer;
        if(m_aScenarios != null)
        {
            for(int i = 0; i < m_aScenarios.length; i++)
                if(m_aScenarios[i] != null)
                    m_aScenarios[i].Initialize();

        }
        RecalculateEnemiesVector();
        m_fLastPerformTaskTime = 0.0F;
        m_nTasksPerCurrFrame = 0;
    }

    public void InitScenarios()
    {
        if(m_MeshAI.m_nInstanceNumber == 0)
        {
            GameObject.LogLine(" I will create Scenarios " + Scenario._NUM_OF_SCENARIOS);
            Class aScenariosClasses[] = GameObject.GetClassesFromClass("Scenario");
            m_aScenarios = new Scenario[Scenario._NUM_OF_SCENARIOS];
            for(int i = 0; i < aScenariosClasses.length; i++)
                if(aScenariosClasses[i] != (Scenario.class))
                    try
                    {
                        Field fieldId = aScenariosClasses[i].getDeclaredField("_ID");
                        int id = fieldId.getInt(null);
                        if(m_aScenarios[id] == null)
                        {
                            m_aScenarios[id] = (Scenario)aScenariosClasses[i].newInstance();
                            m_aScenarios[id].Initialize();
                        } else
                        {
                            GameObject.CrashLog("ERROR: Duplicated _ID field value in: " + aScenariosClasses[i].getName() + " and " + m_aScenarios[id].getClass().getName() + "!!!\n");
                        }
                    }
                    catch(Exception e)
                    {
                        GameObject.CrashLog("ERROR accessing field _ID in scenario " + aScenariosClasses[i].getName() + "\n");
                    }

        }
    }

    public float GetLastRicochetMakerDist()
    {
        return m_fLastRicochetDist;
    }

    public float GetLastExplosionMakerDist()
    {
        return m_fLastExplosionDist;
    }

    public boolean IsDead()
    {
        return m_bDead;
    }

    void LogScenarioVector(String sHeader, BitVector scenarios)
    {
        DebugUtils.AddLog(m_MeshAI, StringUtils.FillSpacesAtEnd(sHeader, 27));
        m_LSVFilter.Set(m_DebugScenariosFilter);
        if(!m_MeshAI.bLogEditorScenarios)
            m_LSVFilter.CalcIntersectionWithComplement(Scenario._EDITOR_SCENARIOS);
        for(int j = 0; j < Scenario._NUM_OF_SCENARIOS; j++)
            if(m_LSVFilter.IsBitSet(j))
                if(scenarios.IsBitSet(j))
                    DebugUtils.AddLog(m_MeshAI, StringUtils.FillSpacesAtEnd(m_aScenarios[j].toString(), 5));
                else
                    DebugUtils.AddLog(m_MeshAI, StringUtils.FillSpacesAtEnd("----", 5));

        DebugUtils.AddLog(m_MeshAI, "\n");
    }

    public void OnGlobalTimePassed()
    {
        Notify(104);
    }

    boolean CanPlayCalmIdleAnims()
    {
        if(m_fLastAlarmedTime == -100F)
            return true;
        return GetTime() - m_fLastAlarmedTime > _TIME_TO_PLAY_CALM_IDLE_ANIM;
    }

    public float GetLastEnemyShotMakerDist()
    {
        return m_fLastEnemyShotDist;
    }

    void CallMethodOnceIn(int iMethodID, float fTime)
    {
        DisableCallMethod(iMethodID);
        CallMethodIn(iMethodID, fTime);
    }

    abstract void SetObjectToGetIn(ISeatVehicle iseatvehicle, EnumGetInType enumgetintype);

    void ShowEnemies()
    {
        if(m_aPriorityEnemies == null)
            return;
        GameObject.LogLine(" Show enemies: ");
        for(int i = 0; i < m_aPriorityEnemies.size(); i++)
        {
            EnemyInfo cInfo = (EnemyInfo)m_aPriorityEnemies.get(i);
            GameObject.LogLine("   enem " + cInfo.m_Reference + " vis " + ObjInSightAngle(cInfo.m_Reference));
        }

    }

    public boolean JustHeardExplosion()
    {
        return !TimePassed(m_fLastHeardExplosionTime, _LONG_SOUND_IMPORTANCE_TIME, GetTime());
    }

    public boolean JustHeardDangerousObject()
    {
        return GetTime() - m_fLastHeardDObjectTime < _SHORT_SOUND_IMPORTANCE_TIME;
    }

    boolean ActiveEnemyLostMoreThanLong()
    {
        if(GetActiveEnemy() == null)
            return false;
        EnemyInfo enemyInfo = (EnemyInfo)m_aEnemies.get(GetActiveEnemy());
        return TimePassed(enemyInfo.m_fLastKnownPosTime, _ENEMY_NOTICED_LONG_TIME, GetTime());
    }

    public void NotifyMeshActivation(boolean bActivate)
    {
        if(bActivate)
            DisableCallMethod(METHOD_WaitingForAppear);
        else
            StartWaitingForAppear();
    }

    public boolean IsValidFiringPosition(int nFiringPos)
    {
        return false;
    }

    public void InitController(NewAI ai)
    {
        m_MeshAI = ai;
        SetName("Controller of " + ai.GetName());
        AddGenerators();
        InitScenarios();
        CallMethodIn("StartEvent", 1.0F);
        _SHARP_ANGLE_TO_TARGET_COS = (float)Math.cos(((double)_SHARP_ANGLE_TO_TARGET * 3.1415926535897931D) / 180D);
        if(m_MeshAI.m_nInstanceNumber == 0)
            m_fVehicleNoiseConeDot = (float)Math.cos(((double)m_fVehicleNoiseConeAngle * 3.1415926535897931D) / 180D);
    }

    public void UpdateNpcEnemiesRecognition()
    {
        UpdateEnemiesRecognition(m_NonPlayerListInfo);
    }

    public void UpdatePlayerEnemiesRecognition()
    {
        UpdateEnemiesRecognition(m_PlayerListInfo);
    }

    void UpdateEnemiesRecognition(RecognitionListInfo listInfo)
    {
        GetMesh().ProfileBegin(NewAI.PROFILE_Recognition);
        ObjectsSense senseObjects = m_ObjectsSense;
        if(senseObjects == null)
            return;
        int iListSize = listInfo.m_List.size();
        if(iListSize == 0)
            return;
        float fTime = GetTime();
        float fTimeBtwTraceCheck = GetTimeBtwTraceCheck();
        if(listInfo.m_iListNdx >= iListSize)
            listInfo.m_iListNdx = 0;
        int iLastNdx = listInfo.m_iListNdx;
        do
        {
            EnemyInfo info = GetEnemy((ChromeActor)listInfo.m_List.get(listInfo.m_iListNdx));
            if(!((Actor) (info.m_Reference)).bDead && info.m_Reference.IsActiveOnModule() && fTime - info.m_fLastTraceTimeCheck > fTimeBtwTraceCheck && !info.m_bRecognized)
            {
                boolean bRecognized = false;
                if(info.m_Reference == m_Player)
                {
                    if(CanRecognize(info, senseObjects._AI_RECOGNIZE_RANGE))
                        bRecognized = true;
                    else
                    if(CanRecognize(info, senseObjects._AI_SIGHT_RANGE))
                    {
                        m_cSuspectInfo = info;
                        if(info.m_fRecognitionStartTime > 0.0F)
                        {
                            float fMaxTime = GetAlarmLevel() > 0 ? fMaxEnemyRecognitionTimeAlarmed : fMaxEnemyRecognitionTime;
                            float fRecognitionTime = fMaxTime * Tools.InterpLinear(senseObjects._AI_RECOGNIZE_RANGE2, senseObjects._AI_SIGHT_RANGE2, info.m_Reference.GetDistance2To(GetMesh()));
                            if(TimePassed(info.m_fRecognitionStartTime, fRecognitionTime, fTime))
                                bRecognized = true;
                        } else
                        {
                            info.m_fRecognitionStartTime = fTime;
                            info.m_fRecognitionStopTime = fTime;
                            CallMethodIn("CallRequestEvent", 0.0F);
                        }
                    } else
                    if(info.m_fRecognitionStartTime > 0.0F)
                    {
                        info.m_fRecognitionStartTime = -1F;
                        info.m_fRecognitionStopTime = fTime;
                        CallMethodIn("CallRequestEvent", 0.0F);
                    }
                } else
                if(CanRecognize(info, senseObjects._AI_SIGHT_RANGE))
                    bRecognized = true;
                if(bRecognized)
                {
                    MarkAsRecognized(info);
                    m_fLastEnemySpottedTime = fTime;
                    EnemyPresenceStated();
                }
                listInfo.m_iListNdx++;
                break;
            }
            if(++listInfo.m_iListNdx >= iListSize)
                listInfo.m_iListNdx = 0;
        } while(listInfo.m_iListNdx != iLastNdx);
        GetMesh().ProfileEnd(NewAI.PROFILE_Recognition);
    }

    public float GetAimingDeviation()
    {
        return 1.0F - m_fCurrAccuracy;
    }

    public void TriggerObjectNotification(TriggerObject trigger, ExecutionInfo currentExecutionInfo)
    {
        m_CurrentTriggerObject = trigger;
        m_CurrentExecutionInfo = currentExecutionInfo;
        Notify(108);
    }

    Task GetCurrTask()
    {
        return m_CurrentTask;
    }

    void AddCleaningTask(Task cTask)
    {
        cTask.SetAIController(this);
        m_TaskList.AddTask(cTask, true);
    }

    public ChromeActor GetLastDeadBodySpotted()
    {
        return m_LastBodySpotted;
    }

    public int GetTheBestScenario(BitVector bv)
    {
        int n = bv.GetFirstBitSet();
        if(n == -1)
            return -1;
        float fMaxPriority = -1F;
        BitVector bestScenarios = new BitVector();
        int iMaxPriorityScenarios = 0;
        float fProbabSum = 0.0F;
        for(; n != -1; n = bv.GetNextBitSet(n + 1))
        {
            if(fMaxPriority < m_aScenarios[n].m_fPriority)
            {
                fMaxPriority = m_aScenarios[n].m_fPriority;
                bestScenarios.ClearAllBits();
                iMaxPriorityScenarios = 0;
                fProbabSum = 0.0F;
            }
            if(m_aScenarios[n].m_fPriority == fMaxPriority)
            {
                bestScenarios.SetBit(n);
                iMaxPriorityScenarios++;
                fProbabSum += GetScenario(n).GetProbability();
            }
        }

        int nBestScenario = -1;
        float fChoice = GameObject.RandomFloat(fProbabSum);
        int nSize = iMaxPriorityScenarios;
        float fChoiceSum = 0.0F;
        n = bestScenarios.GetFirstBitSet();
        fChoiceSum += GetScenario(n).GetProbability();
        if(fChoice < fChoiceSum)
        {
            DebugUtils.CrashLog(m_MeshAI, " Selected n " + n + " \n");
            return n;
        }
        for(int i = 0; i < nSize; i++)
        {
            n = bestScenarios.GetNextBitSet(n + 1);
            fChoiceSum += GetScenario(n).GetProbability();
            if(fChoice < fChoiceSum)
            {
                DebugUtils.CrashLog(m_MeshAI, " Selected n " + n + " \n");
                return n;
            }
        }

        DebugUtils.CrashLog(m_MeshAI, " Selected -1 \n");
        return -1;
    }

    Scenario GetCurrScenario()
    {
        if(m_nCurrScenario >= 0 && m_nCurrScenario < Scenario._NUM_OF_SCENARIOS)
            return m_aScenarios[m_nCurrScenario];
        else
            return null;
    }

    void SetAlarmLevel(int iAlarmLevel)
    {
        if(m_iCurrAlarmLevel != 0 && iAlarmLevel == 0)
            m_fLastAlarmedTime = GetTime();
        if(iAlarmLevel == 0)
            m_bEnemyPresenceStated = false;
        if(iAlarmLevel >= 0 && iAlarmLevel <= 2)
            m_iCurrAlarmLevel = iAlarmLevel;
    }

    public void EditorActivityEnded()
    {
        ServeNextWaypointActivity();
    }

    boolean ActiveEnemyLostMoreThanShort()
    {
        if(GetActiveEnemy() == null)
            return false;
        EnemyInfo enemyInfo = (EnemyInfo)m_aEnemies.get(GetActiveEnemy());
        return TimePassed(enemyInfo.m_fLastKnownPosTime, GetEnemyNoticedShortTime(), GetTime());
    }

    void ResetCanFire()
    {
        m_bCanFire = false;
        ResetCanAim();
    }

    void ResetCanAim()
    {
        m_bCanAim = false;
    }

    public Vector GetLastDeadBodySpottedPos()
    {
        if(m_LastBodySpotted == null)
            return null;
        else
            return m_LastBodySpotted.GetPosition();
    }

    void TryToChangeEnemy()
    {
        EnemyInfo cInfo = GetBestEnemy();
        if(cInfo != null && m_cActiveEnemy != cInfo.m_Reference)
        {
            SetActiveEnemy(cInfo.m_Reference);
            RequestEvent(4);
            return;
        }
        if(cInfo == null && m_cActiveEnemy != null && GetMesh().bCanForgetAboutEnemy)
        {
            SetActiveEnemy(null);
            RequestEvent(7);
            return;
        } else
        {
            return;
        }
    }

    boolean IsFarAwayFromActiveEnemy()
    {
        return GetMesh().GetDistanceTo(m_cActiveEnemy) > 4000F;
    }

    void WaitingForAppear()
    {
        if(IsFrozen())
        {
            MotionType mt;
            if(m_Player == null && GetCurrWaypoint() == null && GetMesh().cFirstWaypoint != null && ((mt = GetMesh().cFirstWaypoint.cMotion) instanceof mt_Appear) && ((mt_Appear)mt).bAppear)
                ServeNextWaypointActivity();
            else
            if(GetCurrWaypoint() != null && ((mt = GetCurrWaypoint().cMotion) instanceof mt_Appear) && ((mt_Appear)mt).bAppear)
                CheckCurrWaypointCnd();
            else
                return;
            if(!m_bPerformCurrActivity)
                return;
        }
        DisableCallMethod(METHOD_WaitingForAppear);
    }

    boolean IsVeryCloseToActiveEnemy()
    {
        return GetMesh().GetDistanceTo(m_cActiveEnemy) < 800F;
    }

    Weapon GetActiveWeapon()
    {
        return ((Pawn) (m_MeshAI)).ActiveWeapon;
    }

    void MessageWeapon(int i)
    {
    }

    boolean ActiveEnemyVisibleFromGun()
    {
        if(GetActiveEnemy() == null)
            return false;
        float fTime = GetTime();
        if(TimePassed(m_fLastTraceFromGunTimeCheck, GetTimeBtwGunTraceCheck(), fTime))
        {
            m_fLastTraceFromGunTimeCheck = fTime;
            boolean bLastVisibility = m_bActiveEnemyTraceFromGun;
            m_bActiveEnemyTraceFromGun = AICheckTraceAbsoluteVehicleCheck(GetActiveEnemy(), GetActiveEnemy().GetPointToLookAt(0), GetMesh().GetVisibilityCheckFireOrigin());
            if(m_bActiveEnemyTraceFromGun != bLastVisibility)
                m_fLastFromGunVisibilityChangeTime = fTime;
        }
        return m_bActiveEnemyTraceFromGun;
    }

    void RecalcState()
    {
    }

    public void CheckCurrWaypointCnd()
    {
        if(GetCurrWaypoint() == null)
        {
            DebugUtils.CrashLog(m_MeshAI, "CheckCurrWaypointCnd: GetCurrWaypoint() == null !!!\n");
            DisableCallMethod(METHOD_CheckCurrWaypointCnd);
            return;
        }
        if(!m_bPerformCurrActivity && (m_CurrCondition == null || m_CurrCondition.Evaluate()))
        {
            m_bPerformCurrActivity = true;
            SetInCannon(false);
            m_CurrActivity.StartActivity(this);
            RequestEvent(17);
            DisableCallMethod(METHOD_CheckCurrWaypointCnd);
        }
    }

    public boolean HeardScreamLately()
    {
        if(m_fLastEnemySpottedScreamHeardTime > -100F)
            return !TimePassed(m_fLastEnemySpottedScreamHeardTime, 60F, GetTime());
        else
            return false;
    }

    void RecalculateEnemiesVector()
    {
        m_aPriorityEnemies.clear();
        m_aPriorityEnemies.addAll(m_aEnemies.values());
        RecalcEnemiesPriority();
        Collections.sort(m_aPriorityEnemies);
    }

    public boolean IsMoraleLow()
    {
        return m_fMorale < 0.4F;
    }

    float GetEnemyNoticedShortTime()
    {
        if(GetActiveEnemy() != null)
        {
            ObjectsSense senseObjects = m_ObjectsSense;
            return Tools.InterpLinear(0.0F, senseObjects._AI_SIGHT_RANGE2, GetActiveEnemyDistance2()) * (_ENEMY_NOTICED_SHORT_TIME_MAX - _ENEMY_NOTICED_SHORT_TIME_MIN) + _ENEMY_NOTICED_SHORT_TIME_MIN;
        } else
        {
            return _ENEMY_NOTICED_SHORT_TIME_DEFAULT;
        }
    }

    void AddToProperList(ChromeActor actor, float fTime)
    {
        if(m_MeshAI.IsFriend(actor) || m_MeshAI.IsNeutral(actor))
        {
            FriendInfo info = (FriendInfo)m_aAllies.get(actor);
            if(info == null)
            {
                info = new FriendInfo(actor);
                m_aAllies.put(actor, info);
            }
            RemoveEnemy(actor);
        } else
        {
            AddEnemy(actor);
            m_aAllies.remove(actor);
        }
    }

    public boolean JustHeardEnemyShot()
    {
        return GetTime() - m_fLastHeardEnemyShotTime < _LONG_SOUND_IMPORTANCE_TIME;
    }

    Vector GetOppositeDir(ControlObject cObject)
    {
        Vector vDir = GetMesh().GetPosition();
        vDir.Sub(cObject.GetPositionVectorVolatile());
        vDir.Normalize();
        return vDir;
    }

    public void OnTaskTimePassed()
    {
        Notify(105);
    }

    int GetActiveWeaponAmmo()
    {
        if(GetActiveWeapon() == null)
            return 0;
        else
            return GetActiveWeapon().nAmmo;
    }

    protected float CalcVisibilityRangeForObject(float fBaseSightRange, ChromeActor cTarget)
    {
        ChromeModuleSingle module = (ChromeModuleSingle)GetModule();
        float fMaxDistanceLvl = Math.min(fBaseSightRange * module.GetVisibilityRangeFactor(), module.GetVisibilityRangeThreshold());
        float fMaxDistanceTgt = Math.min(fBaseSightRange * cTarget.GetVisibilityRangeFactor(GetMesh()), cTarget.GetVisibilityRangeThreshold(GetMesh()));
        float fMaxDistance = Math.min(fMaxDistanceLvl, fMaxDistanceTgt);
        return fMaxDistance;
    }

    public void ActiveWeaponChanged()
    {
        ComputeAccuracy();
    }

    public void CallRequestEvent()
    {
        RequestEvent(0, false);
    }

    void ServiceEvent(int i)
    {
    }

    public AIController()
    {
        m_MeshAI = null;
        m_aTraceExcludeObjects = new ControlObject[3];
        m_TaskList = new TasksList();
        m_CurrentTask = null;
        m_bPerformNextTaskOnUnfreeze = false;
        m_HearingSense = null;
        m_PainSense = null;
        m_ObjectsSense = null;
        m_nCurrScenario = -1;
        m_nLastPreparedScenario = -1;
        m_nHelperScenariosInt = 0;
        m_nLastEvent = -1;
        m_aGenerators = null;
        m_DebugScenariosFilter = new BitVector();
        m_aAllies = new HashMap(7);
        m_aAlliesList = new ArrayList();
        m_aEnemies = new HashMap(3);
        m_aPriorityEnemies = new ArrayList();
        m_RecognitionListNonPlayer = new ArrayList();
        m_RecognitionListPlayer = new ArrayList();
        m_bCanFire = false;
        m_bCanAim = false;
        m_fCurrAccuracy = 1.0F;
        m_cActiveEnemy = null;
        m_cSuspectInfo = null;
        fMaxEnemyRecognitionTime = 3F;
        fMaxEnemyRecognitionTimeAlarmed = 0.0F;
        m_fLastHeardEnemyShotAcceptTime = -100F;
        m_fLastHeardFriendShotAcceptTime = -100F;
        m_fLastHeardBulletAcceptTime = -100F;
        m_fLastHeardExplosionAcceptTime = -100F;
        m_fLastHeardEnemyStepsAcceptTime = -100F;
        m_fLastHeardScreamAcceptTime = -100F;
        m_fLastHeardDangerousAcceptTime = -100F;
        m_fLastDyingCheckTime = -100F;
        m_LastBodySpotted = null;
        m_fLastHeardEnemyShotTime = -100F;
        m_fLastHeardFriendShotTime = -100F;
        m_fLastHeardRicochetTime = -100F;
        m_fLastHeardExplosionTime = -100F;
        m_fLastHeardDObjectTime = -100F;
        m_fLastHeardEnemyStepsTime = -100F;
        m_vLastHeardEnemyStepsPos = null;
        m_fLastHeardScreamTime = -100F;
        m_fLastGotShotTime = -100F;
        m_vLastHeardEnemyShotPos = null;
        m_fLastEnemyShotDist = 0.0F;
        m_vLastHeardFriendShotPos = null;
        m_vLastFriendsTargetPos = null;
        m_LastDyingAISpotted = null;
        m_LastDangerousObject = null;
        m_fMorale = 1.0F;
        m_iCurrAlarmLevel = 0;
        m_fLastAlarmedTime = -100F;
        m_ObjectToFollow = null;
        m_fAttackByManyEnemiesCheckTime = 0.0F;
        m_iAttackingEnemies = 0;
        m_bIsFrozen = false;
        m_NonPlayerListInfo = new RecognitionListInfo(m_RecognitionListNonPlayer);
        m_PlayerListInfo = new RecognitionListInfo(m_RecognitionListPlayer);
        m_Player = null;
        m_bEnemyPresenceStated = false;
        m_fLastTraceFromGunTimeCheck = 0.0F;
        m_fLastFromGunVisibilityChangeTime = 0.0F;
        m_bActiveEnemyTraceFromGun = false;
        m_vLastHeardRicochetMakerPos = null;
        m_vLastHeardExplosionMakerPos = null;
        m_fLastRicochetDist = 0.0F;
        m_fLastExplosionDist = 0.0F;
        _MANY_ATTACKING_ENEMIES = 2;
        m_fEnemyLostTime = -100F;
        m_fLastImpulseTime = -100F;
        _PASSAGE_NOISE_UPDATE_TIME = 0.5F;
        _PASSAGE_ENEMY_ACCEPT_TIME = 1.0F;
        m_fLastPassageNoiseTime = -100F;
        m_fLastPassageEnemyNoiseTime = -100F;
        m_vLastPassageEnemyNoisePos = null;
        m_CurrActivity = null;
        m_CurrCondition = null;
        m_iCurrWaypointBehavior = 0;
        m_bPerformCurrActivity = false;
        m_bActivityInWaypoint = false;
        m_CurrFightPoint = null;
        m_fFightPointLeaveTime = 0.0F;
        m_fLastEnemySpottedTime = -100F;
        m_fLastEnemySpottedReactionTime = -100F;
        m_fLastEnemySpottedScreamHeardTime = -100F;
        m_fLastHearNoiseTraceCheckTime = -100F;
        m_fLastDamageTaken = 0.0F;
        METHOD_CheckCurrWaypointCnd = 0;
        METHOD_WaitingForAppear = 0;
        METHOD_OnTaskUpdate = 0;
        METHOD_OnTaskTimePassed = 0;
        m_bSitsInVehicleOnSeat = false;
        m_bDead = false;
        m_bv = new BitVector();
        m_LSVFilter = new BitVector();
        _MAX_ALLOWED_TASKS_PER_FRAME = 20;
        m_fLastPerformTaskTime = 0.0F;
        m_nTasksPerCurrFrame = 0;
        _NOISE_EXT_ADD = 200F;
        m_CurrentTriggerObject = null;
        m_CurrentExecutionInfo = null;
    }

    public boolean JustHeardScream()
    {
        return GetTime() - m_fLastHeardScreamTime < _LONG_SOUND_IMPORTANCE_TIME;
    }

    boolean EnemyReallyVisible(ChromeActor actor, float fTime)
    {
        EnemyInfo info = (EnemyInfo)m_aEnemies.get(actor);
        if(info == null)
            return false;
        else
            return EnemyReallyVisible(info, fTime);
    }

    boolean EnemyReallyVisible(EnemyInfo info, float fTime)
    {
        if(info == null)
            return false;
        if(!info.m_Reference.IsActiveOnModule())
            return false;
        if(!EnemyVisible(info))
            return false;
        if(EnemyCanBeTraced(info))
        {
            info.m_fLastReallyVisibleTime = fTime;
            info.m_fLastKnownPosTime = fTime;
            info.m_vLastKnownPos = info.m_Reference.GetPosition();
            return true;
        } else
        {
            return false;
        }
    }

    public IAIActivity GetCurrActivity()
    {
        return m_CurrActivity;
    }

    public abstract boolean IsBehindHideout();

    public boolean IsFighting()
    {
        return GetActiveEnemy() != null;
    }

    public boolean IsValidLastHeardFriendShotPos()
    {
        return GetTime() - m_fLastHeardFriendShotTime < 30F;
    }

    public Vector GetLastEnemyKnownPos()
    {
        if(GetActiveEnemy() == null)
        {
            return null;
        } else
        {
            EnemyInfo info = (EnemyInfo)m_aEnemies.get(GetActiveEnemy());
            return info.m_vLastKnownPos;
        }
    }

    public abstract Vector GetDestHideoutPos();

    public void Unfreeze()
    {
        if(IsFrozen())
        {
            if(m_HearingSense != null)
                ((Sense)m_HearingSense).Unfreeze();
            if(m_PainSense != null)
                ((Sense)m_PainSense).Unfreeze();
            if(m_ObjectsSense != null)
                m_ObjectsSense.Unfreeze();
            UnfreezeCallMethods();
            m_bIsFrozen = false;
            if(m_bPerformNextTaskOnUnfreeze)
                PerformNextTask();
        }
    }

    public boolean ShouldPerformEditorActivity()
    {
        return GetCurrWaypoint() != null && m_bPerformCurrActivity && (m_CurrActivity.IsCritical() || GetActiveEnemy() == null && TimeFromImpulsePassed());
    }

    void StartWaitingForAppear()
    {
        CallMethodEvery(METHOD_WaitingForAppear, 0.1F, 0.1F * GetMesh().GetTimeDeviation());
        UnfreezeCallMethod(METHOD_WaitingForAppear);
    }

    boolean CanRecognize(EnemyInfo info, float fRecognitionDistance)
    {
        if(info.m_bRecognized)
            return true;
        ChromeActor target = info.m_Reference;
        float fDistance2 = m_MeshAI.GetDistance2To(target);
        float fVisRange = CalcVisibilityRangeForObject(fRecognitionDistance, target);
        return fDistance2 < fVisRange * fVisRange && EnemyVisible(info) && EnemyCanBeTracedToRecognize(info);
    }

    Scenario GetScenario(int nId)
    {
        if(nId < 0 || nId > Scenario._NUM_OF_SCENARIOS)
            return null;
        else
            return m_aScenarios[nId];
    }

    boolean EnemyCanBeTracedToRecognize(EnemyInfo info)
    {
        float fTime = GetTime();
        if(TimePassed(info.m_fLastTraceTimeCheck, GetTimeBtwRecognize(), fTime))
        {
            info.m_fLastTraceTimeCheck = fTime;
            if(AICheckTraceAbsoluteVehicleCheck(info.m_Reference, info.m_Reference.GetPointToLookAt(0), GetMesh().GetLookFromPoint()))
            {
                info.m_fLastTraceVisibilityTime = fTime;
                info.m_bTraceVisible = true;
            } else
            {
                info.m_bTraceVisible = false;
            }
        }
        return info.m_bTraceVisible;
    }

    public void OnCreate()
    {
        super.bSG = false;
        METHOD_CheckCurrWaypointCnd = RegisterCallMethod("CheckCurrWaypointCnd");
        METHOD_WaitingForAppear = RegisterCallMethod("WaitingForAppear");
        METHOD_OnTaskUpdate = RegisterCallMethod("OnTaskUpdate");
        METHOD_OnTaskTimePassed = RegisterCallMethod("OnTaskTimePassed");
        if(m_NoiseManager == null || m_NoiseManager.GetModule() != GetModule())
        {
            m_NoiseManager = (NoiseManager)CreateObject("NoiseManager");
            m_NoiseManager.ActivateOnModule();
            m_NoiseManager.SetTimePeriod(1.0F);
        }
        CallMethodEveryMinMax("UpdateNpcEnemiesRecognition", _MIN_TIME_BTW_NPC_ENEMY_RECOGNITION_CALL, _MAX_TIME_BTW_NPC_ENEMY_RECOGNITION_CALL);
        CallMethodEveryMinMax("UpdatePlayerEnemiesRecognition", _MIN_TIME_BTW_PLAYER_ENEMY_RECOGNITION_CALL, _MAX_TIME_BTW_PLAYER_ENEMY_RECOGNITION_CALL);
    }

    public AIMotionState GetMotionState()
    {
        return m_MeshAI.m_Motion;
    }

    public void AnimationEnd(int nID)
    {
        Notify(101);
    }

    float GetActiveEnemyDistance2()
    {
        if(m_cActiveEnemy != null)
            return GetMesh().GetDistance2To(m_cActiveEnemy);
        else
            return -1F;
    }

    public Behavior GetCurrBehavior()
    {
        if(GetCurrWaypoint() != null && m_bActivityInWaypoint && GetCurrWaypoint().aBehaviors.length > 0)
            return GetCurrWaypoint().aBehaviors[m_iCurrWaypointBehavior - 1];
        else
            return null;
    }

    boolean ObjInSightAngle(ControlObject obj)
    {
        ObjectsSense objectSense = m_ObjectsSense;
        if(objectSense == null)
            return false;
        return AngleCosToObj(obj) > objectSense._AI_SIGHT_ANGLE_COS;
    }

    abstract void Drive();

    void StartGlobalTime(float fTime)
    {
        CallMethodIn("OnGlobalTimePassed", fTime);
    }

    float GetLastTraceVisibilityTime()
    {
        if(GetActiveEnemy() == null)
        {
            return -100F;
        } else
        {
            EnemyInfo info = (EnemyInfo)m_aEnemies.get(GetActiveEnemy());
            return info.m_fLastTraceVisibilityTime;
        }
    }

    abstract void SetObjectToDrive(IDrivenVehicle idrivenvehicle);

    void CalculateMorale()
    {
        m_fMorale = 1.0F;
        if(GetHealth() < 0.3F * GetMaxHealth())
            m_fMorale = Math.max(m_fMorale, 0.5F);
        if(GetActiveWeaponAmmo() < 10)
            m_fMorale *= 0.8F;
    }

    float GetReactTime()
    {
        return _REACTION_TIME[m_iCurrAlarmLevel];
    }

    boolean CanShoot()
    {
        return GetActiveWeapon() != null && HasAmmo();
    }

    void ReloadWeapon()
    {
        GetMesh().WeaponReload();
    }

    public boolean IsFrozen()
    {
        return m_bIsFrozen;
    }

    void MarkAsRecognized(EnemyInfo info)
    {
        info.m_bRecognized = true;
        info.m_fRecognitionStartTime = -1F;
        info.m_fRecognitionStopTime = GetTime();
        if(info == m_cSuspectInfo)
            m_cSuspectInfo = null;
    }

    boolean EnemyCanBeTraced(EnemyInfo info)
    {
        float fTime = GetTime();
        if(TimePassed(info.m_fLastTraceTimeCheck, GetTimeBtwTraceCheck(), fTime))
        {
            info.m_fLastTraceTimeCheck = fTime;
            if(AICheckTraceAbsoluteVehicleCheck(info.m_Reference, info.m_Reference.GetPointToLookAt(0), GetMesh().GetLookFromPoint()))
            {
                info.m_fLastTraceVisibilityTime = fTime;
                info.m_bTraceVisible = true;
            } else
            {
                info.m_bTraceVisible = false;
            }
        }
        return info.m_bTraceVisible;
    }

    public boolean JustHeardRicochet()
    {
        return !TimePassed(m_fLastHeardRicochetTime, _LONG_SOUND_IMPORTANCE_TIME, GetTime());
    }

    public static final boolean TimePassed(float fStartTime, float fTimeInterval, float fCurrTime)
    {
        return fCurrTime - fStartTime > fTimeInterval;
    }

    public boolean TimeFromImpulsePassed()
    {
        return GetTime() - m_fLastImpulseTime > _MAX_IMPULSE_TIME;
    }

    abstract void SetInCannon(boolean flag);

    void AddTask(Task cTask)
    {
        cTask.SetAIController(this);
        m_TaskList.AddTask(cTask, false);
    }

    public abstract boolean CanAttackFromCurrentHideout();

    void EnemyPresenceStated()
    {
        if(!m_bEnemyPresenceStated)
        {
            CallMethodIn("CallOnEnemyDetectedActions", GetMesh().fDetectionDelay * ChromeGame.GetAIDetectionDelayDiffLevelMult());
            m_bEnemyPresenceStated = true;
        }
    }

    float GetMaxHealth()
    {
        return ((Actor) (m_MeshAI)).fMaxHealth;
    }

    public void CallOnEnemyDetectedActions()
    {
        DisableCallMethod("CallOnEnemyDetectedActions");
        if(!((Actor) (GetMesh())).bDead)
        {
            GetMesh();
            GameObject.InvokeActionChain(GetMesh().aOnEnemyDetected);
        }
    }

    boolean AICheckTraceAbsoluteVehicleCheck(ControlObject cTarget, Vector vStart, Vector vEnd)
    {
        l_vEnd.Set(vEnd);
        m_aTraceExcludeObjects[0] = cTarget;
        m_aTraceExcludeObjects[1] = m_MeshAI;
        if(cTarget instanceof Vehicle)
        {
            Vehicle vehicle = (Vehicle)cTarget;
            vehicle.TurnOffPassengersCollisions();
            boolean bTraceReturn = m_MeshAI.AITrace(vStart, l_vEnd, NewAI._AITRACE_IGNORE_GLASS, m_aTraceExcludeObjects) == null;
            vehicle.TurnOnPassengersCollisions();
            return bTraceReturn;
        }
        return m_MeshAI.AITrace(vStart, l_vEnd, NewAI._AITRACE_IGNORE_GLASS, m_aTraceExcludeObjects) == null;
    }

    void CheckForAnyDying()
    {
        ObjectsSense senseObjects = m_ObjectsSense;
        if(senseObjects == null)
            return;
        float fTime = GetTime();
        if(!TimePassed(m_fLastDyingCheckTime, 1.0F, fTime))
            return;
        m_fLastDyingCheckTime = fTime;
        m_aAlliesList.clear();
        m_aAlliesList.addAll(m_aAllies.values());
        for(int i = 0; i < m_aAlliesList.size(); i++)
        {
            FriendInfo friendInfo = (FriendInfo)m_aAlliesList.get(i);
            if(friendInfo.m_Reference.IsActiveOnModule() && ((Actor) (friendInfo.m_Reference)).bDead && !friendInfo.WasBodySpotted())
            {
                Vector vFriendPos = friendInfo.m_Reference.GetPositionVectorVolatile();
                Vector vThisPos = m_MeshAI.GetPositionVectorVolatile();
                if(vFriendPos.Distance2(vThisPos) <= 9000000F)
                {
                    vFriendPos.Sub(vThisPos);
                    vFriendPos.Normalize();
                    Vector vLookDir = GetMesh().GetLookDir();
                    if(vLookDir.Dot(vFriendPos) >= senseObjects._AI_SIGHT_ANGLE_COS && TimePassed(friendInfo.m_fLastDeadBodyTraceTimeCheck, 1.0F, fTime))
                    {
                        friendInfo.m_fLastDeadBodyTraceTimeCheck = fTime;
                        if(AICheckTraceAbsoluteVehicleCheck(friendInfo.m_Reference, friendInfo.m_Reference.GetPointToLookAt(0), GetMesh().GetLookFromPoint()))
                        {
                            friendInfo.m_fDeadBodySeeTime = fTime;
                            if(m_LastBodySpotted == null)
                                m_LastBodySpotted = friendInfo.m_Reference;
                            else
                            if(m_LastBodySpotted.IsActiveOnModule() && friendInfo.m_Reference.IsActiveOnModule() && GetMesh().GetDistance2To(m_LastBodySpotted) > GetMesh().GetDistance2To(friendInfo.m_Reference))
                                m_LastBodySpotted = friendInfo.m_Reference;
                            if(GetAlarmLevel() < 1)
                                SetAlarmLevel(1);
                            ReactOnDeath(friendInfo.m_Reference, false);
                            EnemyPresenceStated();
                        }
                    }
                }
            }
        }

    }

    boolean ActiveEnemyGunTraceLostMoreThanShort()
    {
        if(GetActiveEnemy() == null)
            return false;
        else
            return !m_bActiveEnemyTraceFromGun && TimePassed(m_fLastFromGunVisibilityChangeTime, GetEnemyNoticedShortTime(), GetTime());
    }

    public boolean IsEditorEnemy(EnemyInfo info)
    {
        if(info == null)
            return false;
        else
            return info.m_bEditorEnemy;
    }

    void RecognizeEnemy(EnemyInfo info)
    {
        MarkAsRecognized(info);
        if(info.m_Reference.IsActiveOnModule())
        {
            info.m_fLastKnownPosTime = GetTime();
            info.m_vLastKnownPos = info.m_Reference.GetPosition();
        }
    }

    void RemoveEnemy(ChromeActor actor)
    {
        m_aEnemies.remove(actor);
        int iInd = m_RecognitionListPlayer.indexOf(actor);
        if(iInd != -1)
        {
            m_RecognitionListPlayer.remove(iInd);
        } else
        {
            iInd = m_RecognitionListNonPlayer.indexOf(actor);
            if(iInd != -1)
                m_RecognitionListNonPlayer.remove(iInd);
        }
    }

    public boolean JustGotDamageFromEnemy()
    {
        return GetTime() - m_fLastGotShotTime < _LONG_SOUND_IMPORTANCE_TIME;
    }

    void GotShotFromEnemy(EnemyInfo info, float fDamage)
    {
        info.m_fDamageFromThis += fDamage;
        info.m_fLastDamageFromThisTime = GetTime();
        m_fLastGotShotTime = info.m_fLastDamageFromThisTime;
        info.m_fLastKnownPosTime = info.m_fLastDamageFromThisTime;
        info.m_vLastKnownPos = info.m_Reference.GetPosition();
        SetAlarmLevel(2);
        EnemyPresenceStated();
        RequestEvent(6);
    }

    ChromeActor GetActiveEnemy()
    {
        return m_cActiveEnemy;
    }

    void SetCanAim()
    {
        m_bCanAim = true;
    }

    public void AnimationStopped(int nID)
    {
        Notify(110);
    }

    boolean ActiveEnemyCanBeTraced()
    {
        if(GetActiveEnemy() == null)
            return false;
        else
            return EnemyCanBeTraced((EnemyInfo)m_aEnemies.get(GetActiveEnemy()));
    }

    void RemoveAllEditorEnemies(boolean bReallyRemove)
    {
        Set enemiesSet = m_aEnemies.keySet();
        for(Iterator enemiesIter = enemiesSet.iterator(); enemiesIter.hasNext();)
        {
            ChromeActor enemy = (ChromeActor)enemiesIter.next();
            EnemyInfo info = GetEnemy(enemy);
            if(info != null && info.m_bEditorEnemy)
                if(bReallyRemove)
                    RemoveEnemy(enemy);
                else
                    info.m_bEditorEnemy = false;
        }

    }

    void ClearTaskTime()
    {
        DisableCallMethod(METHOD_OnTaskTimePassed);
    }

    TasksList GetTaskList()
    {
        return m_TaskList;
    }

    public void CollisionMsg(ControlObject controlobject, Vector vector, Vector vector1)
    {
    }

    public int Grenades()
    {
        if(GetMesh().m_nGrenadesLeft >= 0)
            return GetMesh().m_nGrenadesLeft;
        else
            return 0x7fffffff;
    }

    boolean FilterEvent(int nEvent)
    {
        return false;
    }

    void CheckEnemiesEvent()
    {
        if(m_cActiveEnemy != null && GetMesh().IsEnemy(m_cActiveEnemy))
        {
            if(!m_cActiveEnemy.IsActiveOnModule())
            {
                TryToChangeEnemy();
                return;
            }
            ActiveEnemyVisibleFromGun();
            if(m_fLastFromGunVisibilityChangeTime == GetTime())
                RequestEvent(16);
            if(((Actor) (m_cActiveEnemy)).bDead)
            {
                TryToChangeEnemy();
                return;
            }
            EnemyInfo cInfoMaxPriority = (EnemyInfo)m_aPriorityEnemies.get(0);
            EnemyInfo cInfoCurrent = (EnemyInfo)m_aEnemies.get(m_cActiveEnemy);
            if(cInfoCurrent.m_fPriority == 0.0F)
            {
                TryToChangeEnemy();
                return;
            }
            if(cInfoCurrent.m_Reference != cInfoMaxPriority.m_Reference && cInfoCurrent.m_fPriority < cInfoMaxPriority.m_fPriority)
            {
                TryToChangeEnemy();
                return;
            }
        } else
        {
            TryToChangeEnemy();
        }
    }

    public FriendInfo GetDeadBodyFriendInfo()
    {
        if(m_LastBodySpotted == null)
            return null;
        else
            return (FriendInfo)m_aAllies.get(m_LastBodySpotted);
    }

    boolean EnemyVisible(EnemyInfo info)
    {
        if(info == null)
            return false;
        ObjectsSense objectSense = m_ObjectsSense;
        if(objectSense == null)
            return false;
        float fTime = GetTime();
        if(fTime - info.m_fLastVisibleCheckTime > _TIME_BTW_ANGLE_CHECK)
        {
            info.m_fLastVisibleCheckTime = fTime;
            info.m_fLastAngleCos = AngleCosToObj(info.m_Reference);
            if(info.m_fLastAngleCos > objectSense._AI_SIGHT_ANGLE_COS)
            {
                info.m_fLastVisibleTime = fTime;
                return true;
            }
        }
        return info.m_fLastAngleCos > objectSense._AI_SIGHT_ANGLE_COS;
    }

    abstract boolean InsideVehicle();

    void SetCanFire(boolean bCanAim)
    {
        m_bCanFire = true;
        if(bCanAim)
            SetCanAim();
        else
            ResetCanAim();
    }

    ChromeActor GetObjectToFollow()
    {
        return m_ObjectToFollow;
    }

    void StartEvent()
    {
        m_Player = ((ChromeModuleSingle)GetModule()).MainPlayer;
        if(GetCurrWaypoint() == null)
            ServeNextWaypointActivity();
        RequestEvent(1);
    }

    public abstract boolean CanHitActiveEnemyFromHideout();

    public boolean IsValidLastHeardEnemyShotPos()
    {
        return GetTime() - m_fLastHeardEnemyShotTime < 30F;
    }

    void Notify(int nNotice)
    {
        if(nNotice == 100)
        {
            PerformNextTask();
            return;
        }
        if(m_CurrentTask != null)
            m_CurrentTask.ServeNotice(nNotice);
    }

    public boolean EnemyStronger()
    {
        if(GetActiveEnemy() == null)
            return false;
        return GetHealth() < GetMaxHealth() * 0.2F && m_fLastDamageTaken < GetMaxHealth() - GetHealth();
    }

    void OutputCurrScenario()
    {
        if(m_nCurrScenario >= 0 && m_nCurrScenario < Scenario._NUM_OF_SCENARIOS)
            GameObject.CrashLog("Current Scenario: " + m_aScenarios[m_nCurrScenario] + "\n");
    }

    void ClearTaskUpdate()
    {
        DisableCallMethod(METHOD_OnTaskUpdate);
    }

    void OnTaskUpdate()
    {
        m_CurrentTask.Update();
    }

    boolean CanReload()
    {
        return GetMesh().m_nAmmoForActiveWeapon > 0;
    }

    void ShowScenarios()
    {
        for(int i = 0; i < Scenario._NUM_OF_SCENARIOS; i++)
            GameObject.LogLine(" Sc: - " + m_aScenarios[i].GetID());

    }

    public final TriggerObject GetCurrentTrigger()
    {
        return m_CurrentTriggerObject;
    }

    boolean HasAmmo()
    {
        return GetActiveWeaponAmmo() > 0;
    }

    public abstract ChromeActor HideoutsNear();

    int GetAmmoLeftForActiveWeapon()
    {
        return GetMesh().m_nAmmoForActiveWeapon;
    }

    public boolean AttackedByManyEnemies()
    {
        float fTime = GetTime();
        if(!TimePassed(m_fAttackByManyEnemiesCheckTime, _TIME_BTW_MANY_ENEMIES_CHECK, fTime))
            return m_iAttackingEnemies >= _MANY_ATTACKING_ENEMIES;
        m_fAttackByManyEnemiesCheckTime = fTime;
        m_iAttackingEnemies = 0;
        EnemyInfo enemy = null;
        for(int i = 0; i < m_aPriorityEnemies.size(); i++)
        {
            enemy = (EnemyInfo)m_aPriorityEnemies.get(i);
            if(!TimePassed(enemy.m_fLastDamageFromThisTime, _ENEMY_ATTACK_IMPORTANCE_TIME, fTime))
                m_iAttackingEnemies++;
        }

        return m_iAttackingEnemies >= _MANY_ATTACKING_ENEMIES;
    }

    public void NoiseMsg(Actor Noisy, float fNoiseLevel, int nNoiseType)
    {
        if(Noisy == GetMesh())
            return;
        if(nNoiseType == 3)
        {
            m_fLastHeardRicochetTime = GetTime();
            m_fLastImpulseTime = m_fLastHeardRicochetTime;
            if(Noisy != null)
                m_vLastHeardRicochetMakerPos = Noisy.GetPosition();
            else
                m_vLastHeardRicochetMakerPos = GetMesh().GetPosition();
            m_fLastRicochetDist = fNoiseLevel;
            if(GetAlarmLevel() < 1)
                SetAlarmLevel(1);
            if(TimePassed(m_fLastHeardBulletAcceptTime, 3F, GetTime()))
            {
                m_NoiseManager.Request(this, 2);
                m_fLastHeardBulletAcceptTime = GetTime();
            }
            return;
        }
        if(nNoiseType == 7)
        {
            m_fLastHeardExplosionTime = GetTime();
            m_fLastImpulseTime = m_fLastHeardExplosionTime;
            if(Noisy != null)
                m_vLastHeardExplosionMakerPos = Noisy.GetPosition();
            else
                m_vLastHeardExplosionMakerPos = GetMesh().GetPosition();
            m_fLastExplosionDist = fNoiseLevel;
            if(GetAlarmLevel() < 1)
                SetAlarmLevel(1);
            if(TimePassed(m_fLastHeardExplosionAcceptTime, 3F, GetTime()))
            {
                m_NoiseManager.Request(this, 18);
                m_fLastHeardExplosionAcceptTime = GetTime();
            }
            if((Noisy instanceof ChromeActor) && GetMesh().DetectEnemyOnNoise() && GetMesh().IsEnemy((ChromeActor)Noisy))
                EnemyPresenceStated();
            return;
        }
        if(nNoiseType == 8 && Noisy != null)
        {
            float fTime = GetTime();
            if(TimePassed(m_fLastPassageNoiseTime, _PASSAGE_NOISE_UPDATE_TIME, fTime) && TimePassed(m_fLastPassageEnemyNoiseTime, _PASSAGE_ENEMY_ACCEPT_TIME, fTime))
            {
                m_fLastPassageNoiseTime = fTime;
                Noisy.GetMeshExtentsInWorld(m_vMinNoiseExt, m_vMaxNoiseExt);
                m_vMinNoiseExt.fX -= _NOISE_EXT_ADD;
                m_vMinNoiseExt.fY -= _NOISE_EXT_ADD;
                m_vMinNoiseExt.fZ -= _NOISE_EXT_ADD;
                m_vMaxNoiseExt.fX += _NOISE_EXT_ADD;
                m_vMaxNoiseExt.fY += _NOISE_EXT_ADD;
                m_vMaxNoiseExt.fZ += _NOISE_EXT_ADD;
                ControlObject aObjs[] = GetObjectsInExtents(m_vMinNoiseExt, m_vMaxNoiseExt);
                if(aObjs != null)
                {
                    for(int i = 0; i < aObjs.length; i++)
                        if(aObjs[i] instanceof ChromeActor)
                        {
                            ChromeActor actorObj = (ChromeActor)aObjs[i];
                            if(!actorObj.IsDead() && m_MeshAI.IsEnemy(actorObj))
                            {
                                if(GetAlarmLevel() < 1)
                                    SetAlarmLevel(1);
                                EnemyInfo info = AddEnemy(actorObj);
                                if(info != null)
                                {
                                    info.m_fLastKnownPosTime = fTime;
                                    info.m_vLastKnownPos = info.m_Reference.GetPosition();
                                }
                                m_fLastPassageEnemyNoiseTime = m_fLastImpulseTime = fTime;
                                m_vLastPassageEnemyNoisePos = Noisy.GetPosition();
                                m_NoiseManager.Request(this, 15);
                                return;
                            }
                        }

                }
            }
            return;
        }
        if(Noisy instanceof ChromeActor)
        {
            ChromeActor actor = (ChromeActor)Noisy;
            boolean reactOnScream = false;
            if((nNoiseType == 4 || nNoiseType == 6) && (Noisy instanceof NewAI))
            {
                NewAI ai = (NewAI)Noisy;
                int screamType = ai.GetLastScreamType();
                if(screamType == 2 || nNoiseType == 6)
                {
                    ReactOnDeath(actor, false);
                    reactOnScream = true;
                } else
                if(screamType == 1)
                    reactOnScream = true;
                else
                if(screamType == 3)
                {
                    reactOnScream = true;
                    m_fLastEnemySpottedScreamHeardTime = GetTime();
                    if(GetMesh().IsFriend(ai))
                    {
                        ChromeActor spottedEnemy = ai.GetController().GetActiveEnemy();
                        if(spottedEnemy != null && GetMesh().IsEnemy(spottedEnemy))
                        {
                            EnemyInfo info = AddEnemy(spottedEnemy);
                            if(info != null)
                                if(!info.m_bRecognized)
                                {
                                    float fTime = GetTime();
                                    if(TimePassed(m_fLastHearNoiseTraceCheckTime, 3F, fTime))
                                    {
                                        m_fLastHearNoiseTraceCheckTime = fTime;
                                        if(AICheckTraceAbsolute(ai, ai.GetPointToLookAt(0), GetMesh().GetLookFromPoint()))
                                            RecognizeEnemy(info);
                                    }
                                } else
                                {
                                    RecognizeEnemy(info);
                                }
                        }
                    }
                }
                if(reactOnScream)
                {
                    m_fLastHeardScreamTime = GetTime();
                    m_fLastImpulseTime = m_fLastHeardScreamTime;
                    if(GetAlarmLevel() < 1)
                        SetAlarmLevel(1);
                    if(TimePassed(m_fLastHeardScreamAcceptTime, 3F, GetTime()))
                    {
                        m_NoiseManager.Request(this, 12);
                        m_fLastHeardScreamAcceptTime = GetTime();
                    }
                    return;
                }
            }
            boolean bMadeByEnemy = GetMesh().IsEnemy(actor);
            if(bMadeByEnemy && ((Noisy instanceof NewAI) || (Noisy instanceof Vehicle) || (Noisy instanceof Player) || (Noisy instanceof StationaryCannon)))
            {
                EnemyInfo info = AddEnemy(actor);
                if(info != null)
                {
                    info.m_fLastKnownPosTime = GetTime();
                    info.m_vLastKnownPos = info.m_Reference.GetPosition();
                }
            }
            if(bMadeByEnemy && nNoiseType == 1)
            {
                m_fLastHeardEnemyStepsTime = GetTime();
                m_fLastImpulseTime = m_fLastHeardEnemyStepsTime;
                m_vLastHeardEnemyStepsPos = Noisy.GetPosition();
                if(GetAlarmLevel() < 1)
                    SetAlarmLevel(1);
                if(TimePassed(m_fLastHeardEnemyStepsAcceptTime, 3F, GetTime()))
                {
                    m_NoiseManager.Request(this, 14);
                    m_fLastHeardEnemyStepsAcceptTime = GetTime();
                }
                return;
            }
            if(nNoiseType == 2)
            {
                if(bMadeByEnemy)
                {
                    m_fLastHeardEnemyShotTime = GetTime();
                    m_fLastImpulseTime = m_fLastHeardEnemyShotTime;
                    m_vLastHeardEnemyShotPos = Noisy.GetPosition();
                    m_fLastEnemyShotDist = fNoiseLevel;
                    if(GetAlarmLevel() < 1)
                        SetAlarmLevel(1);
                    if(TimePassed(m_fLastHeardEnemyShotAcceptTime, 3F, GetTime()))
                    {
                        m_NoiseManager.Request(this, 10);
                        m_fLastHeardEnemyShotAcceptTime = GetTime();
                    }
                    if(GetMesh().DetectEnemyOnNoise())
                        EnemyPresenceStated();
                    return;
                }
                m_fLastHeardFriendShotTime = GetTime();
                m_vLastHeardFriendShotPos = Noisy.GetPosition();
                m_vLastFriendsTargetPos = null;
                if(Noisy instanceof NewAI)
                {
                    ChromeActor friendsEnemy = ((NewAI)Noisy).GetController().GetActiveEnemy();
                    if(friendsEnemy != null)
                        m_vLastFriendsTargetPos = friendsEnemy.GetPosition();
                }
                m_fLastImpulseTime = m_fLastHeardFriendShotTime;
                if(GetAlarmLevel() < 1)
                    SetAlarmLevel(1);
                if(TimePassed(m_fLastHeardFriendShotAcceptTime, 3F, GetTime()))
                {
                    m_NoiseManager.Request(this, 11);
                    m_fLastHeardFriendShotAcceptTime = GetTime();
                }
                return;
            }
            if(nNoiseType == 5)
            {
                if(Noisy instanceof Grenade)
                {
                    float fGrenOverAI = Noisy.GetPositionVectorVolatile().fY - GetMesh().GetPositionVectorVolatile().fY;
                    if(!bMadeByEnemy || fGrenOverAI > 400F || fGrenOverAI < 100F)
                        return;
                    if(m_MeshAI.bCanUseRadioCommunication)
                        m_MeshAI.SendRadioMessage(1);
                }
                m_fLastImpulseTime = GetTime();
                m_fLastHeardDObjectTime = m_fLastImpulseTime;
                m_fLastHeardEnemyStepsTime = m_fLastImpulseTime;
                m_vLastHeardEnemyStepsPos = Noisy.GetPosition();
                if(GetAlarmLevel() < 1)
                    SetAlarmLevel(1);
                if(Noisy instanceof Vehicle)
                {
                    Vehicle vehicle = (Vehicle)Noisy;
                    Vector vFromJeepToAI = vehicle.GetForwardVector();
                    vFromJeepToAI.Mul(-500F);
                    vFromJeepToAI.Add(m_vLastHeardEnemyStepsPos);
                    vFromJeepToAI.Negate();
                    vFromJeepToAI.Add(GetMesh().GetPositionVectorVolatile());
                    vFromJeepToAI.fY = 0.0F;
                    vFromJeepToAI.Normalize();
                    Vector vVehicleForward = vehicle.GetForwardVectorVolatile();
                    vVehicleForward.fY = 0.0F;
                    vVehicleForward.Normalize();
                    if(vFromJeepToAI.Dot(vVehicleForward) < m_fVehicleNoiseConeDot)
                        return;
                }
                if(TimePassed(m_fLastHeardDangerousAcceptTime, 3F, m_fLastImpulseTime))
                {
                    m_NoiseManager.Request(this, 13);
                    m_fLastHeardDangerousAcceptTime = m_fLastImpulseTime;
                    m_LastDangerousObject = (ChromeActor)Noisy;
                }
                return;
            }
        }
    }

    abstract SeatInfo GetSeat();

    public void MotionStateChanged()
    {
        ComputeAccuracy();
    }

    void C()
    {
        GameObject.CrashLog("GetCurrWaypoint():" + GetCurrWaypoint() + ", m_bPerformCurrActivity:" + m_bPerformCurrActivity + ", m_CurrActivity:" + m_CurrActivity + (m_CurrActivity != null ? ", m_CurrActivity.IsCritical():" + m_CurrActivity.IsCritical() : "") + ", GetActiveEnemy():" + GetActiveEnemy() + "\n");
    }

    abstract boolean InsideCannon();

    public void UpdateObjectsInformation()
    {
        CheckForAnyDying();
        RecalculateEnemiesVector();
        CheckObjectSenseEvent();
    }

    void TargetHitNotification(ChromeActor chromeactor, int i)
    {
    }

    public void AddGenerators()
    {
        m_DebugScenariosFilter.SetAllBits();
    }

    public Waypoint GetCurrWaypoint()
    {
        return m_MeshAI.GetWaypoint();
    }

    public abstract void Checkpoint();

    public void VehicleDestroyed(Vector vector, Vector vector1)
    {
    }

    public BitVector RecalcGenerators()
    {
        DebugUtils.ClearLog();
        DebugUtils.AddLog(m_MeshAI, "\nRecalcGenerators in AI:" + m_MeshAI.GetName() + "\n");
        m_bv.SetAllBits();
        for(int i = 0; i < m_aGenerators.length; i++)
        {
            m_aGenerators[i].UpdateScenarios();
            m_bv.CalcIntersectionWith(m_aGenerators[i].m_CurrScenarios);
        }

        for(int i = 0; i < m_aGenerators.length; i++)
            LogScenarioVector(m_aGenerators[i].getClass().getName(), m_aGenerators[i].m_CurrScenarios);

        DebugUtils.AddLog(m_MeshAI, "-----------------------------------------------------\n");
        LogScenarioVector("ChosenScenarios:", m_bv);
        DebugUtils.WriteOutLog(m_MeshAI);
        return m_bv;
    }

    boolean PerformNextTask()
    {
        if(IsFrozen())
        {
            m_bPerformNextTaskOnUnfreeze = true;
            return false;
        }
        m_bPerformNextTaskOnUnfreeze = false;
        float fTime = GetTime();
        if(Math.abs(m_fLastPerformTaskTime - fTime) > 0.001F)
        {
            m_fLastPerformTaskTime = fTime;
            m_nTasksPerCurrFrame = 0;
        } else
        if(m_nTasksPerCurrFrame++ == _MAX_ALLOWED_TASKS_PER_FRAME)
            GameObject.LogR("WARNING: Max allowed tasks per frame reached in " + GetName() + "\n");
        if(m_CurrentTask != null)
            m_CurrentTask.OnEndTask();
        Task cNextTask = null;
        cNextTask = GetTaskList().GetFirstTask();
        m_CurrentTask = cNextTask;
        if(cNextTask == null)
        {
            return false;
        } else
        {
            m_CurrentTask.Perform();
            return true;
        }
    }

    public ChromeActor GetLastDyingAISpotted()
    {
        return m_LastDyingAISpotted;
    }

    public void Freeze()
    {
        if(!IsFrozen())
        {
            if(m_HearingSense != null)
                ((Sense)m_HearingSense).Freeze();
            if(m_PainSense != null)
                ((Sense)m_PainSense).Freeze();
            if(m_ObjectsSense != null)
                m_ObjectsSense.Freeze();
            FreezeCallMethods();
            UnfreezeCallMethod(METHOD_WaitingForAppear);
            m_bIsFrozen = true;
        }
    }

    float GetTimeBtwRecognize()
    {
        if(m_Player == null)
        {
            GameObject.CrashLog("GetTimeBtwRecognize() : Nie ma playera !!!\n");
            return _MAX_TIME_BTW_RECOGNIZE_TRACE_CHECK;
        } else
        {
            return _MAX_TIME_BTW_RECOGNIZE_TRACE_CHECK * Tools.InterpLinear(_MIN_DIST_TO_PLAYER_RECOGNIZE2, _MAX_DIST_TO_PLAYER_RECOGNIZE2, GetMesh().GetDistance2To(m_Player));
        }
    }

    void TryToReduceAlarmLevel()
    {
        if(GetAlarmLevel() != 1)
            return;
        float fTime = GetTime();
        if(GetActiveEnemy() == null && TimePassed(m_fEnemyLostTime, _TIME_TO_CALM_DOWN_AFTER_ENEMY_LOST, fTime) && TimePassed(m_fLastHeardEnemyShotTime, _TIME_TO_INVALIDATE_NOISE, fTime) && TimePassed(m_fLastHeardFriendShotTime, _TIME_TO_INVALIDATE_NOISE, fTime) && TimePassed(m_fLastHeardRicochetTime, _TIME_TO_INVALIDATE_NOISE, fTime) && TimePassed(m_fLastHeardExplosionTime, _TIME_TO_INVALIDATE_NOISE, fTime) && TimePassed(m_fLastHeardDObjectTime, _TIME_TO_INVALIDATE_NOISE, fTime) && TimePassed(m_fLastHeardEnemyStepsTime, _TIME_TO_INVALIDATE_NOISE, fTime) && TimePassed(m_fLastHeardScreamTime, _TIME_TO_INVALIDATE_NOISE, fTime))
            SetAlarmLevel(0);
    }

    int GetAlarmLevel()
    {
        return m_iCurrAlarmLevel;
    }

    public Vector GetLastHeardEnemyShotPos()
    {
        return m_vLastHeardEnemyShotPos;
    }

    public Vector GetLastDyingScreamPos()
    {
        if(m_LastDyingAISpotted == null)
            return null;
        else
            return m_LastDyingAISpotted.GetPosition();
    }

    abstract IDrivenVehicle GetDrivenVehicle();

    boolean ActiveEnemyVisibilityLostMoreThanShort()
    {
        if(GetActiveEnemy() == null)
        {
            return false;
        } else
        {
            EnemyInfo enemyInfo = (EnemyInfo)m_aEnemies.get(GetActiveEnemy());
            return TimePassed(enemyInfo.m_fLastTraceVisibilityTime, GetEnemyNoticedShortTime(), GetTime());
        }
    }

    float GetTimeBtwTraceCheck()
    {
        if(m_cActiveEnemy != null)
        {
            ObjectsSense senseObjects = m_ObjectsSense;
            return Tools.InterpLinear(0.0F, senseObjects._AI_SIGHT_RANGE2, GetActiveEnemyDistance2()) * (_MAX_TIME_BTW_TRACE_CHECK - _MIN_TIME_BTW_TRACE_CHECK) + _MIN_TIME_BTW_TRACE_CHECK;
        } else
        {
            return _MAX_TIME_BTW_TRACE_CHECK;
        }
    }

    void RecalcEnemiesPriority()
    {
        float fTime = GetTime();
        EnemyInfo enemyInfo = null;
        for(int i = 0; i < m_aPriorityEnemies.size(); i++)
        {
            enemyInfo = (EnemyInfo)m_aPriorityEnemies.get(i);
            enemyInfo.m_fPriority = 0.0F;
            if(!enemyInfo.m_Reference.IsActiveOnModule() || !GetMesh().IsEnemy(enemyInfo.m_Reference) || ((Actor) (enemyInfo.m_Reference)).bDead)
                continue;
            if(IsEditorEnemy(enemyInfo))
            {
                enemyInfo.m_fPriority += _EDITOR_ENEMY_WEIGHT;
                enemyInfo.m_vLastKnownPos = enemyInfo.m_Reference.GetPosition();
                enemyInfo.m_fLastKnownPosTime = fTime;
            } else
            if(!enemyInfo.m_bRecognized)
                continue;
            if(((Actor) (enemyInfo.m_Reference)).fHealth < ((Actor) (enemyInfo.m_Reference)).fMaxHealth * _LOW_HEALTH_COEFF)
                enemyInfo.m_fPriority += _LOW_HEALTH_WEIGHT;
            if(enemyInfo.m_Reference == m_cActiveEnemy)
                enemyInfo.m_fPriority += _ACTIVE_ENEMY_WEIGHT;
            ObjectsSense senseObjects = m_ObjectsSense;
            if(senseObjects != null)
            {
                float fDist = enemyInfo.m_Reference.GetDistanceTo(m_MeshAI);
                float fDistanceCoeff = fDist / senseObjects._AI_SIGHT_RANGE;
                if(fDistanceCoeff < 0.0F)
                    fDistanceCoeff = 0.0F;
                if(fDistanceCoeff > 1.0F)
                    fDistanceCoeff = 1.0F;
                enemyInfo.m_fPriority += (1.0F - fDistanceCoeff) * _DISTANCE_WEIGHT;
                if(enemyInfo.m_Reference == GetActiveEnemy())
                {
                    if(EnemyCanBeTraced(enemyInfo))
                    {
                        if(EnemyVisible(enemyInfo))
                            EnemyPresenceStated();
                        enemyInfo.m_fPriority += _VISIBILITY_WEIGHT;
                        enemyInfo.m_fLastKnownPosTime = fTime;
                        enemyInfo.m_vLastKnownPos = enemyInfo.m_Reference.GetPosition();
                    }
                } else
                if(EnemyReallyVisible(enemyInfo, fTime))
                {
                    enemyInfo.m_fPriority += _VISIBILITY_WEIGHT;
                    EnemyPresenceStated();
                }
                if(TimePassed(enemyInfo.m_fLastKnownPosTime, _ENEMY_NOTICED_LONG_TIME, fTime))
                {
                    enemyInfo.m_fPriority = 0.0F;
                    continue;
                }
            }
            if(enemyInfo.m_fLastAngleCos > _SHARP_ANGLE_TO_TARGET_COS)
                enemyInfo.m_fPriority += _SHARP_ANGLE_TO_TARGET_WEIGHT;
            enemyInfo.m_fPriority += (((ChromeActor) (m_MeshAI)).fTargetImportance / ChromeActor.fMaxTargetImportance) * _TARGET_IMPORTANCE_WEIGHT;
            enemyInfo.m_fPriority += (enemyInfo.m_fDamageFromThis / GetMaxHealth()) * _ENEMY_ATTACK_WEIGHT;
        }

        if(GetCurrWaypoint() != null && m_bPerformCurrActivity && (m_CurrActivity instanceof mt_Destroy))
        {
            mt_Destroy destroy = (mt_Destroy)m_CurrActivity;
            boolean bAllDead = true;
            for(int i = 0; i < destroy.allTargets.size(); i++)
            {
                if(((IDestroyTarget)destroy.allTargets.get(i)).IsDead())
                    continue;
                bAllDead = false;
                break;
            }

            if(bAllDead)
                EditorActivityEnded();
        }
    }

    float GetTimeBtwGunTraceCheck()
    {
        if(m_cActiveEnemy != null)
        {
            ObjectsSense senseObjects = m_ObjectsSense;
            return Tools.InterpLinear(0.0F, senseObjects._AI_SIGHT_RANGE2, GetActiveEnemyDistance2()) * (_MAX_TIME_BTW_GUN_TRACE_CHECK - _MIN_TIME_BTW_GUN_TRACE_CHECK) + _MIN_TIME_BTW_GUN_TRACE_CHECK;
        } else
        {
            return _MAX_TIME_BTW_GUN_TRACE_CHECK;
        }
    }

    public abstract void MovingEnd();

    EnemyInfo AddEnemy(ChromeActor actor)
    {
        if(actor == null)
            return null;
        if(actor instanceof Grenade)
            return null;
        EnemyInfo info = (EnemyInfo)m_aEnemies.get(actor);
        if(info == null)
        {
            info = new EnemyInfo(actor);
            m_aEnemies.put(actor, info);
            if(actor.m_bRecognizedAsPlayer)
                m_RecognitionListPlayer.add(actor);
            else
                m_RecognitionListNonPlayer.add(actor);
        }
        return info;
    }

    EnemyInfo AddEnemy(ChromeActor actor, boolean bEditorEnemy)
    {
        EnemyInfo info = AddEnemy(actor);
        if(info != null)
            info.m_bEditorEnemy = bEditorEnemy;
        return info;
    }

    EnemyInfo GetEnemy(ChromeActor actor)
    {
        EnemyInfo info = (EnemyInfo)m_aEnemies.get(actor);
        return info;
    }

    EnemyInfo GetBestEnemy()
    {
        if(m_aPriorityEnemies.size() > 0)
        {
            EnemyInfo enemy = (EnemyInfo)m_aPriorityEnemies.get(0);
            if(enemy.m_fPriority == 0.0F)
                return null;
            else
                return enemy;
        } else
        {
            return null;
        }
    }

    public boolean JustHeardEnemySteps()
    {
        return GetTime() - m_fLastHeardEnemyStepsTime < _LONG_SOUND_IMPORTANCE_TIME;
    }

    public abstract void GotIn();

    static float _LOW_HEALTH_WEIGHT = 0.5F;
    static float _DISTANCE_WEIGHT = 5F;
    static float _TARGET_IMPORTANCE_WEIGHT = 5F;
    static float _ENEMY_ATTACK_WEIGHT = 2.0F;
    static float _VISIBILITY_WEIGHT = 4F;
    static float _ACTIVE_ENEMY_WEIGHT = 0.5F;
    static float _SHARP_ANGLE_TO_TARGET = 10F;
    static float _SHARP_ANGLE_TO_TARGET_COS = 0.0F;
    static float _SHARP_ANGLE_TO_TARGET_WEIGHT = 1.0F;
    static float _LOW_HEALTH_COEFF = 0.1F;
    static float _EDITOR_ENEMY_WEIGHT = 10F;
    static final float _INIT_TIME = -100F;
    static float _ENEMY_NOTICED_SHORT_TIME_MIN;
    static float _ENEMY_NOTICED_SHORT_TIME_MAX;
    static float _ENEMY_NOTICED_SHORT_TIME_DEFAULT;
    static float _ENEMY_NOTICED_LONG_TIME = 60F;
    static float _TIME_TO_CALM_DOWN_AFTER_ENEMY_LOST = 10F;
    static float _TIME_TO_INVALIDATE_NOISE = 20F;
    public static final int _ALARM_LEVEL_LOW = 0;
    public static final int _ALARM_LEVEL_MEDIUM = 1;
    public static final int _ALARM_LEVEL_HIGH = 2;
    public static final int _FAR_AWAY_FROM_ENEMY_DIST = 4000;
    public static final int _CLOSE_TO_ENEMY_DIST = 1500;
    public static final int _VERY_CLOSE_TO_ENEMY_DIST = 800;
    NewAI m_MeshAI;
    ControlObject m_aTraceExcludeObjects[];
    TasksList m_TaskList;
    Task m_CurrentTask;
    boolean m_bPerformNextTaskOnUnfreeze;
    IAIHearingSense m_HearingSense;
    IAIPainSense m_PainSense;
    ObjectsSense m_ObjectsSense;
    static Scenario m_aScenarios[] = null;
    int m_nCurrScenario;
    int m_nLastPreparedScenario;
    int m_nHelperScenariosInt;
    int m_nLastEvent;
    Generator m_aGenerators[];
    BitVector m_DebugScenariosFilter;
    HashMap m_aAllies;
    ArrayList m_aAlliesList;
    HashMap m_aEnemies;
    ArrayList m_aPriorityEnemies;
    ArrayList m_RecognitionListNonPlayer;
    ArrayList m_RecognitionListPlayer;
    boolean m_bCanFire;
    boolean m_bCanAim;
    float m_fCurrAccuracy;
    ChromeActor m_cActiveEnemy;
    EnemyInfo m_cSuspectInfo;
    static final float _SUSPECT_HOLDING_TIME = 5F;
    float fMaxEnemyRecognitionTime;
    float fMaxEnemyRecognitionTimeAlarmed;
    static final float _TIME_TO_INVALIDATE_HEARD_SHOT = 30F;
    static final float _HEARD_SHOOT_ACCEPT_TIME = 3F;
    static final float _HEARD_BULLET_ACCEPT_TIME = 3F;
    static final float _HEARD_EXPLOSION_ACCEPT_TIME = 3F;
    static final float _HEARD_STEPS_ACCEPT_TIME = 3F;
    static final float _HEARD_SCREAM_ACCEPT_TIME = 3F;
    static final float _HEARD_DANGEROUS_ACCEPT_TIME = 3F;
    float m_fLastHeardEnemyShotAcceptTime;
    float m_fLastHeardFriendShotAcceptTime;
    float m_fLastHeardBulletAcceptTime;
    float m_fLastHeardExplosionAcceptTime;
    float m_fLastHeardEnemyStepsAcceptTime;
    float m_fLastHeardScreamAcceptTime;
    float m_fLastHeardDangerousAcceptTime;
    float m_fLastDyingCheckTime;
    ChromeActor m_LastBodySpotted;
    static final float _TIME_BTW_DYING_CHECK = 1F;
    static final float _MAX_DIST_TO_SEE_DEAD_BODY = 3000F;
    static final float _MAX_DIST_TO_SEE_DEAD_BODY2 = 9000000F;
    float m_fLastHeardEnemyShotTime;
    float m_fLastHeardFriendShotTime;
    float m_fLastHeardRicochetTime;
    float m_fLastHeardExplosionTime;
    float m_fLastHeardDObjectTime;
    float m_fLastHeardEnemyStepsTime;
    Vector m_vLastHeardEnemyStepsPos;
    float m_fLastHeardScreamTime;
    float m_fLastGotShotTime;
    static float _LONG_SOUND_IMPORTANCE_TIME = 5F;
    static float _VERY_LONG_SOUND_IMPORTANCE_TIME = 10F;
    static float _SHORT_SOUND_IMPORTANCE_TIME = 2.0F;
    Vector m_vLastHeardEnemyShotPos;
    float m_fLastEnemyShotDist;
    Vector m_vLastHeardFriendShotPos;
    Vector m_vLastFriendsTargetPos;
    static NoiseManager m_NoiseManager = null;
    static final float _MAX_DIST_TO_CHECK_BODY = 2000F;
    ChromeActor m_LastDyingAISpotted;
    ChromeActor m_LastDangerousObject;
    static float m_fVehicleNoiseConeBack = 800F;
    static float m_fVehicleNoiseConeAngle = 5F;
    static float m_fVehicleNoiseConeDot = 0.0F;
    float m_fMorale;
    int m_iCurrAlarmLevel;
    float m_fLastAlarmedTime;
    static float _TIME_TO_PLAY_CALM_IDLE_ANIM = 60F;
    float _REACTION_TIME[] = {
        0.75F, 1.0F, 1.5F
    };
    ChromeActor m_ObjectToFollow;
    static float _ENEMY_ATTACK_IMPORTANCE_TIME = 5F;
    static float _TIME_BTW_MANY_ENEMIES_CHECK = 3F;
    float m_fAttackByManyEnemiesCheckTime;
    int m_iAttackingEnemies;
    boolean m_bIsFrozen;
    static float _TIME_BTW_ANGLE_CHECK = 0.1F;
    static float _MIN_TIME_BTW_TRACE_CHECK = 0.05F;
    static float _MAX_TIME_BTW_TRACE_CHECK = 0.4F;
    static float _MIN_TIME_BTW_GUN_TRACE_CHECK = 0.05F;
    static float _MAX_TIME_BTW_GUN_TRACE_CHECK = 1.0F;
    static float _MAX_TIME_BTW_RECOGNIZE_TRACE_CHECK = 2.0F;
    static float _MIN_DIST_TO_PLAYER_RECOGNIZE2 = 40000F;
    static float _MAX_DIST_TO_PLAYER_RECOGNIZE2 = 4000000F;
    static float _MIN_TIME_BTW_NPC_ENEMY_RECOGNITION_CALL = 0.1F;
    static float _MAX_TIME_BTW_NPC_ENEMY_RECOGNITION_CALL = 4F;
    static float _MIN_TIME_BTW_PLAYER_ENEMY_RECOGNITION_CALL = 0.1F;
    static float _MAX_TIME_BTW_PLAYER_ENEMY_RECOGNITION_CALL = 1.0F;
    RecognitionListInfo m_NonPlayerListInfo;
    RecognitionListInfo m_PlayerListInfo;
    Player m_Player;
    boolean m_bEnemyPresenceStated;
    float m_fLastTraceFromGunTimeCheck;
    float m_fLastFromGunVisibilityChangeTime;
    boolean m_bActiveEnemyTraceFromGun;
    Vector m_vLastHeardRicochetMakerPos;
    Vector m_vLastHeardExplosionMakerPos;
    float m_fLastRicochetDist;
    float m_fLastExplosionDist;
    int _MANY_ATTACKING_ENEMIES;
    float m_fEnemyLostTime;
    float m_fLastImpulseTime;
    static float _MAX_IMPULSE_TIME = 60F;
    public float _PASSAGE_NOISE_UPDATE_TIME;
    public float _PASSAGE_ENEMY_ACCEPT_TIME;
    float m_fLastPassageNoiseTime;
    float m_fLastPassageEnemyNoiseTime;
    Vector m_vLastPassageEnemyNoisePos;
    IAIActivity m_CurrActivity;
    Condition m_CurrCondition;
    int m_iCurrWaypointBehavior;
    boolean m_bPerformCurrActivity;
    boolean m_bActivityInWaypoint;
    public FightPoint m_CurrFightPoint;
    public float m_fFightPointLeaveTime;
    protected float m_fLastEnemySpottedTime;
    protected float m_fLastEnemySpottedReactionTime;
    protected float m_fLastEnemySpottedScreamHeardTime;
    protected float m_fLastHearNoiseTraceCheckTime;
    public static final float _TIME_BTW_HEAR_NOISE_TRACE_CHECK = 3F;
    public static final float _SHORT_OBJECT_SPOTTED_TIME = 1F;
    public static final float _OBJECT_SPOTTED_REACTION_TIME = 60F;
    public static final float _MIN_TIME_BTW_SUBSEQUENT_SCREAMS = 60F;
    public float m_fLastDamageTaken;
    int METHOD_CheckCurrWaypointCnd;
    int METHOD_WaitingForAppear;
    int METHOD_OnTaskUpdate;
    int METHOD_OnTaskTimePassed;
    boolean m_bSitsInVehicleOnSeat;
    private boolean m_bDead;
    private BitVector m_bv;
    private BitVector m_LSVFilter;
    public int _MAX_ALLOWED_TASKS_PER_FRAME;
    protected float m_fLastPerformTaskTime;
    protected int m_nTasksPerCurrFrame;
    public static final int _FIRINGPOS_STAND = 1;
    public static final int _FIRINGPOS_STAND_AIMING = 2;
    public static final int _FIRINGPOS_DUCK = 4;
    public static final int _FIRINGPOS_DUCK_AIMING = 8;
    private static Vector m_vMinNoiseExt = new Vector();
    private static Vector m_vMaxNoiseExt = new Vector();
    public float _NOISE_EXT_ADD;
    protected TriggerObject m_CurrentTriggerObject;
    protected ExecutionInfo m_CurrentExecutionInfo;
    static Vector l_vEnd = new Vector();

    static 
    {
        _ENEMY_NOTICED_SHORT_TIME_MIN = 0.5F;
        _ENEMY_NOTICED_SHORT_TIME_MAX = 5F;
        _ENEMY_NOTICED_SHORT_TIME_DEFAULT = (_ENEMY_NOTICED_SHORT_TIME_MAX - _ENEMY_NOTICED_SHORT_TIME_MIN) / 2.0F;
    }
}
