// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   AIControllerHuman.java

import java.util.*;

public class AIControllerHuman extends AIController
{
    protected class TrajectoryInfo
    {

        public float fMaxHeight;
        public Vector vEndPoint;
        public boolean bToLow;

        public TrajectoryInfo()
        {
        }
    }


    boolean SharpAngleToShoot(Vector vPointToShoot)
    {
        boolean bIsSharp = false;
        l_SATS_vDir.Set(vPointToShoot);
        l_SATS_vDir.Sub(super.m_MeshAI.GetFireOrigin());
        float fDist = l_SATS_vDir.Len();
        l_SATS_vDir.Mul(1.0F / fDist);
        float fMaxYDiff = _SHARP_Y_DIFF_TO_SHOOT + (2.0F - _SHARP_Y_DIFF_TO_SHOOT) * Tools.InterpLinear(0.0F, _MIN_DIST_TO_START_INC_Y_DIFF_ALLOWED, fDist);
        if(GetActiveWeapon() != null)
        {
            GetActiveWeapon().GetForwardVector(l_SATS_vWpn);
            l_SATS_vWpn.Normalize();
            bIsSharp = MathUtils.dot2D(l_SATS_vWpn, l_SATS_vDir) > _SHARP_ANGLE_TO_SHOOT_COS && Math.abs(l_SATS_vWpn.fY - l_SATS_vDir.fY) < fMaxYDiff;
        }
        return bIsSharp;
    }

    void SetObjectToDrive(IDrivenVehicle cObjectToDrive)
    {
        m_DrivenVehicle = cObjectToDrive;
    }

    void Drive()
    {
        if(GetDrivenVehicle() != null)
            GetDrivenVehicle().EditorPatrol(GetCurrWaypoint(), super.m_MeshAI);
        else
            GameObject.CrashLog("AIController.Drive(): GetDrivenVehicle() == null\n");
    }

    void RecalculateHideouts()
    {
        m_CurrentHideout = null;
        float fMinDist = 1E+07F;
        ChromeActor actor = null;
        for(int i = 0; i < m_aHideouts.size(); i++)
        {
            actor = (ChromeActor)m_aHideouts.get(i);
            if(actor.cHideoutInvader == null || actor.cHideoutInvader == GetMesh())
            {
                float fDistance = GetMesh().GetDistanceTo(actor);
                if(fDistance < fMinDist)
                {
                    fMinDist = fDistance;
                    m_CurrentHideout = actor;
                }
            }
        }

    }

    public boolean CanLieDown()
    {
        float fTime = GetTime();
        if(AIController.TimePassed(m_fLastLieDownCheckTime, 0.5F, fTime))
        {
            m_fLastLieDownCheckTime = fTime;
            super.m_MeshAI.GetPosition(m_vCLDMinExt);
            m_vCLDMaxExt.Set(m_vCLDMinExt);
            m_vCLDMinExt.fX -= 250F;
            m_vCLDMinExt.fY += 15F;
            m_vCLDMinExt.fZ -= 250F;
            m_vCLDMaxExt.fX += 250F;
            m_vCLDMaxExt.fY += 200F;
            m_vCLDMaxExt.fZ += 250F;
            m_bLastLieDownCheckResult = !AreTerrainFacesInExtents(m_vCLDMinExt, m_vCLDMaxExt);
            if(m_bLastLieDownCheckResult)
            {
                ControlObject aObjs[] = GetObjectsInExtents(m_vCLDMinExt, m_vCLDMaxExt);
                m_bLastLieDownCheckResult = true;
                if(aObjs != null)
                {
                    for(int i = 0; i < aObjs.length; i++)
                    {
                        ControlObject obj = aObjs[i];
                        if(obj == super.m_MeshAI || (obj instanceof InvObject))
                            continue;
                        m_bLastLieDownCheckResult = false;
                        break;
                    }

                }
            }
        }
        return m_bLastLieDownCheckResult;
    }

    public void GotIn()
    {
        m_bSitsInVehicle = true;
        if(((Pawn) (GetMesh())).cSeatInfo != null && (((Pawn) (GetMesh())).cSeatInfo.GetOccupiedObject() instanceof ISeatVehicle))
        {
            ISeatVehicle vehicle = (ISeatVehicle)((Pawn) (GetMesh())).cSeatInfo.GetOccupiedObject();
            vehicle.PawnGotIn(((Pawn) (GetMesh())).cSeatInfo, GetMesh());
            if(GetActiveWeapon() != null)
                GetActiveWeapon().EnableRendering(false);
            GetMesh().SetPhysicsActive(false);
            GetMesh().m_bHitReactionDisabled = true;
        } else
        {
            GameObject.CrashLog("Error in AIController: GotIn()\n");
        }
    }

    void Test()
    {
        FindNearbyTrees();
        CalcTreeHideoutData(m_aNearbyTrees[0], ((ChromeModuleSingle)GetModule()).MainPlayer.GetPosition());
    }

    float CalcActiveEnemyDistCoef(float fNearDistance2, float fFarDistance2)
    {
        return Tools.InterpLinear(fNearDistance2, fFarDistance2, GetActiveEnemyDistance2());
    }

    public boolean CanThrowGrenade()
    {
        ChromeActor cTarget = GetActiveEnemy();
        if(cTarget == null || !cTarget.IsActiveOnModule())
        {
            m_fLastGrenadeTargetPosTime = -1F;
            return false;
        }
        float fTime = GetTime();
        if(GrenadeTargetPosChanged(cTarget, fTime))
            return false;
        if(AIController.TimePassed(m_fLastGrenadeThrow, _MIN_TIME_BTW_GRENADES_THROW, fTime))
        {
            float fDist = GetMesh().GetDistanceTo(cTarget);
            if(fDist > _MIN_DIST_TO_THROW_GRENADE && fDist < _MAX_DIST_TO_THROW_GRENADE)
            {
                if(ActiveEnemyCanBeTraced())
                {
                    if(!MathUtils.CanHappen(((NewAIHuman)GetMesh()).fGrenadeChanceWhenEnemyVisible))
                        return false;
                } else
                {
                    EnemyInfo enemyInfo = (EnemyInfo)super.m_aEnemies.get(cTarget);
                    if(enemyInfo == null || AIController.TimePassed(enemyInfo.m_fLastTraceVisibilityTime, AIController._TIME_TO_CALM_DOWN_AFTER_ENEMY_LOST, fTime) || !MathUtils.CanHappen(((NewAIHuman)GetMesh()).fGrenadeChanceWhenEnemyNotVisible))
                        return false;
                }
                if(AIController.TimePassed(m_fLastGrenadeCheck, _MIN_TIME_BTW_GRENADES_CHECK, fTime))
                {
                    m_fLastGrenadeCheck = fTime;
                    float fHeight = fDist * _DEF_GRENAGE_TRAJECTORY_TAN;
                    if(fHeight > _MAX_GRENADE_TRAJECTORY_HEIGHT)
                        fHeight = _MAX_GRENADE_TRAJECTORY_HEIGHT;
                    Vector vStartPos = GetMesh().GetPosition();
                    vStartPos.fY += 150F;
                    Vector vEndPos = cTarget.GetPosition();
                    TrajectoryInfo info = CheckGrenadeTrajectory(vStartPos, vEndPos, fHeight);
                    if(info.bToLow)
                        info = CheckGrenadeTrajectory(vStartPos, vEndPos, _MAX_GRENADE_TRAJECTORY_END_DISTANCE);
                    else
                    if(info.fMaxHeight < fHeight)
                        info = CheckGrenadeTrajectory(vStartPos, vEndPos, info.fMaxHeight - 50F);
                    if(info.vEndPoint.Distance(vEndPos) < _MAX_GRENADE_TRAJECTORY_END_DISTANCE)
                    {
                        m_fLastCheckedGrenadeTrajectoryHeight = info.fMaxHeight;
                        m_bLastGrenadeTrajectoryCheckResult = true;
                    } else
                    {
                        m_bLastGrenadeTrajectoryCheckResult = false;
                    }
                }
                return m_bLastGrenadeTrajectoryCheckResult;
            }
        }
        return false;
    }

    void SetInCannon(boolean bInCannon)
    {
        m_bSitsInCannon = bInCannon;
    }

    public void PainMsg(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        super.PainMsg(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
        boolean bMaySendRadioMsg = super.m_MeshAI.bCanUseRadioCommunication && MathUtils.CanHappen(_WOUNDED_MSG_CHANCE);
        if(bMaySendRadioMsg)
            super.m_MeshAI.SendRadioMessage(5);
    }

    void FireAuto()
    {
        m_bFireModeSingle = false;
        ((NewAIHuman)super.m_MeshAI).StartFiring();
        Weapon weapon = GetActiveWeapon();
        if((weapon.GetState() & 2) == 0)
        {
            float fFiringTime = m_fMinBurstFiringTime + GameObject.RandomFloat(m_fRandomBurstFiringTime) * (1.0F - CalcActiveEnemyDistCoef(m_fNearTargetDistance2, m_fMaxBurstFireDistance2));
            int nPrevMode = weapon.nCurrentMode;
            weapon.StartFire((byte)2);
            if(nPrevMode != 2)
                Notify(109);
            CallMethodOnceIn(METHOD_FireDone, fFiringTime);
        } else
        {
            FireDone();
        }
    }

    public boolean CanAttackFromCurrentHideout()
    {
        if(!IsBehindHideout())
            return false;
        if(GetActiveEnemy() == null)
            return false;
        if(m_LastTrackedHideout == m_CurrentHideout)
        {
            return m_bCanAttackFromCurrHideout;
        } else
        {
            m_LastTrackedHideout = m_CurrentHideout;
            m_bCanAttackFromCurrHideout = AICheckTraceAbsoluteVehicleCheck(GetActiveEnemy(), GetActiveEnemy().GetPointToLookAt(0), super.m_MeshAI.GetBarrelPos((byte)4, m_nReadinessToStartAiming > 0)) && !AICheckTraceAbsoluteVehicleCheck(GetActiveEnemy(), GetActiveEnemy().GetPointToLookAt(0), super.m_MeshAI.GetTopmostPoint((byte)3, false));
            return m_bCanAttackFromCurrHideout;
        }
    }

    public void UpdateCurrHideout()
    {
        if(m_CurrentHideout == null)
            return;
        Vector vDestHideoutPos = GetDestHideoutPos();
        if(vDestHideoutPos == null)
            return;
        if(m_CurrentHideout.cHideoutInvader == null)
        {
            if(GetMesh().GetPosition().Distance(vDestHideoutPos) <= _BEHIND_HIDEOUT_FREEDOM)
                m_CurrentHideout.cHideoutInvader = GetMesh();
        } else
        if(m_CurrentHideout.cHideoutInvader == GetMesh() && GetMesh().GetDistanceTo(vDestHideoutPos) > _BEHIND_HIDEOUT_FREEDOM)
            m_CurrentHideout.cHideoutInvader = null;
    }

    public void ComputeAccuracy()
    {
        Weapon weapon = GetActiveWeapon();
        NewAIHuman mesh = (NewAIHuman)GetMesh();
        if(weapon != null)
        {
            ChromeActor enemy = GetActiveEnemy();
            if(enemy != null)
            {
                super.m_fCurrAccuracy = 1.0F - Tools.InterpLinear(weapon.fAINearTargetDistance, weapon.fAIEffectiveRange, mesh.GetDistanceTo(enemy));
                super.m_fCurrAccuracy += m_fTargetShootVisibilityFactorImportance * (enemy.GetShootVisibilityFactor(mesh) - 1.0F);
            } else
            {
                super.m_fCurrAccuracy = 0.0F;
            }
            AIMotionState motion = ((NewAI) (mesh)).m_ActualMotion;
            if(motion.GetSpeed() == 2 || motion.GetSpeed() == 3)
                super.m_fCurrAccuracy += m_fDuckCrawlAccAdd;
            if(motion.IsMoving())
                super.m_fCurrAccuracy += m_fMoveAccAdd;
            if(((MotionState) (motion)).bAiming)
                super.m_fCurrAccuracy += m_fAimingAccAdd;
            if(m_bFireModeSingle)
                super.m_fCurrAccuracy += m_fSingleFireAccAdd;
            super.m_fCurrAccuracy *= mesh.fOverallAIAccMult * ((NewAI) (mesh)).mod_fAccuracyMult;
            if(enemy != null)
                super.m_fCurrAccuracy *= enemy.GetHitChanceMult(mesh);
            if(super.m_fCurrAccuracy > 1.0F)
                super.m_fCurrAccuracy = 1.0F;
            else
            if(super.m_fCurrAccuracy < 0.0F)
                super.m_fCurrAccuracy = 0.0F;
            mesh.m_fDesiredHitRatio = m_fMinDesiredHitRatio + super.m_fCurrAccuracy * (m_fMaxDesiredHitRatio - m_fMinDesiredHitRatio);
        } else
        {
            super.m_fCurrAccuracy = 0.0F;
            mesh.m_fDesiredHitRatio = 0.0F;
        }
    }

    public void Respawn()
    {
        super.Respawn();
        UpdateCurrHideout();
        CallMethodEvery(METHOD_UpdateCurrHideout, 1.0F, 1.0F * GetMesh().GetTimeDeviation());
    }

    public boolean IsHidingBehindHideout()
    {
        return IsBehindHideout() && (GetMotionState().GetSpeed() == 2 || GetMotionState().GetSpeed() == 3);
    }

    public void GotOut()
    {
        m_bSitsInVehicle = false;
        if(((Pawn) (GetMesh())).cSeatInfo != null && (((Pawn) (GetMesh())).cSeatInfo.GetOccupiedObject() instanceof ISeatVehicle))
        {
            ISeatVehicle vehicle = (ISeatVehicle)((Pawn) (GetMesh())).cSeatInfo.GetOccupiedObject();
            vehicle.PawnGotOut(((Pawn) (GetMesh())).cSeatInfo, GetMesh());
            if(GetActiveWeapon() != null)
                GetActiveWeapon().EnableRendering(true);
            GetMesh().SetPhysicsActive(true);
            GetMesh().ClearDestinationDir();
            GetMesh().SetAngSpeed(0.0F);
            GetMesh().TryToVerticalize();
        } else
        {
            GameObject.CrashLog("Error in AIController: GotOut()\n");
        }
    }

    float TryToStartAiming()
    {
        boolean bHasToAim = m_nReadinessToStartAiming > 0 && (GetValidFiringPositions() & 5) == 0;
        if(super.m_bCanAim && !((MotionState) (GetMesh().m_Motion)).bAiming && (bHasToAim || ChooseBestAimingStrategy()) && MathUtils.CanHappen(m_nReadinessToStartAiming))
        {
            GetMesh().m_Motion.bAiming = true;
            return GetMesh().UpdateMotion();
        } else
        {
            return 0.0F;
        }
    }

    float TryToStopAiming()
    {
        if(((MotionState) (GetMesh().m_Motion)).bAiming && MathUtils.CanHappen(m_nReadinessToStopAiming))
        {
            GetMesh().m_Motion.bAiming = false;
            return GetMesh().UpdateMotion();
        } else
        {
            return 0.0F;
        }
    }

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[AIControllerHuman.SGSaveChunk]\n");
        FileChunk cFC = GameObject.NewChunk(1401, cFCParent);
        super.SGSaveChunk(cFC);
        cFC.SaveInt(m_aHideouts.size());
        for(int i = 0; i < m_aHideouts.size(); i++)
            cFC.SaveObjectRef((ChromeActor)m_aHideouts.get(i));

        cFC.SaveObjectRef(m_CurrentHideout);
        cFC.SaveVector(m_vCurrHideout);
        cFC.SaveBool(m_bCanHitActiveEnemyFromHideout);
        cFC.SaveFloat(m_fHideoutHitCalcTime);
        cFC.SaveFloat(m_fHideoutPosCalcTime);
        cFC.SaveObjectRef(m_LastTrackedHideout);
        cFC.SaveBool(m_bCanAttackFromCurrHideout);
        cFC.SaveInt(m_nBulletsToFire);
        cFC.SaveBool(m_bFireModeSingle);
        cFC.SaveBool(m_bIsShooting);
        cFC.SaveFloat(m_fNextShootTime);
        cFC.SaveObjectRef((GameObject)m_DrivenVehicle);
        cFC.SaveBool(m_bSitsInVehicle);
        cFC.SaveBool(m_bSitsInCannon);
        cFC.SaveVector(m_vLastGrenadeTargetPos);
        cFC.SaveFloat(m_fLastGrenadeTargetPosTime);
        cFC.SaveBool(m_bLastGrenadeTargetPosChangedResult);
        cFC.SaveFloat(m_fLastGrenadeCheck);
        cFC.SaveFloat(m_fLastGrenadeThrow);
        cFC.SaveFloat(m_fLastCheckedGrenadeTrajectoryHeight);
        cFC.SaveBool(m_bLastGrenadeTrajectoryCheckResult);
        cFC.SaveInt(m_nValidFiringPositions);
        cFC.SaveFloat(m_fLastLieDownCheckTime);
        cFC.SaveBool(m_bLastLieDownCheckResult);
        cFC.delete();
    }

    protected void CalcDestHideoutPos()
    {
        if(m_CurrentHideout == null)
        {
            m_vCurrHideout = null;
            return;
        }
        float fTime = GetTime();
        if(GetActiveEnemy() == null && (super.m_vLastHeardRicochetMakerPos == null || AIController.TimePassed(super.m_fLastHeardRicochetTime, _TIME_AFTER_RICOCHET_TO_GO_TO_HIDEOUT, fTime)))
        {
            m_vCurrHideout = null;
            return;
        }
        if(!AIController.TimePassed(m_fHideoutPosCalcTime, _MIN_TIME_BTW_HIDEOUT_POS_CALC, fTime))
            return;
        m_fHideoutPosCalcTime = fTime;
        Vector vTmp[] = {
            new Vector(), new Vector(), new Vector(), new Vector()
        };
        m_CurrentHideout.GetMeshExtents(vTmp[0], vTmp[1]);
        vTmp[2].Set(vTmp[0]);
        vTmp[2].fZ = vTmp[1].fZ;
        vTmp[3].Set(vTmp[0]);
        vTmp[3].fX = vTmp[1].fX;
        for(int i = 0; i < vTmp.length; i++)
        {
            vTmp[i] = m_CurrentHideout.PointLocalToWorld(vTmp[i]);
            vTmp[i].fY = 0.0F;
        }

        Vector vHideoutCenter = new Vector(vTmp[1]);
        vHideoutCenter.Sub(vTmp[0]);
        float fTmp = vHideoutCenter.Len() / 2.0F;
        vHideoutCenter.Normalize();
        vHideoutCenter.Mul(fTmp);
        vHideoutCenter.Add(vTmp[0]);
        Vector vEnemyPos = null;
        if(GetActiveEnemy() != null)
            vEnemyPos = GetActiveEnemy().GetPositionVectorVolatile();
        else
            vEnemyPos = super.m_vLastHeardRicochetMakerPos;
        if(vEnemyPos == null)
            GameObject.CrashLog("ERROR: AI nie ma ani przeciwnika ani nie slyszalo rykoszetu\n");
        Vector vHideoutToEnemyDir = new Vector(vEnemyPos);
        vHideoutToEnemyDir.Sub(vHideoutCenter);
        float fMaxDist = vHideoutToEnemyDir.Len();
        vHideoutToEnemyDir.Normalize();
        int iFarNdx = 0;
        for(int i = 0; i < vTmp.length; i++)
        {
            vTmp[i] = MathUtils.ProjVector(vHideoutCenter, vTmp[i], vHideoutToEnemyDir);
            fTmp = vTmp[i].Distance(vEnemyPos);
            if(fMaxDist < fTmp)
            {
                fMaxDist = fTmp;
                iFarNdx = i;
            }
        }

        vHideoutToEnemyDir.Negate();
        vHideoutToEnemyDir.Mul(_HIDEOUT_HIDE_DIST);
        m_vCurrHideout = new Vector(vTmp[iFarNdx]);
        m_vCurrHideout.Add(vHideoutToEnemyDir);
        Vector vTraceStart = new Vector(m_vCurrHideout);
        Vector vTraceEnd = new Vector(m_vCurrHideout);
        vTraceStart.fY = m_CurrentHideout.GetPositionVectorVolatile().fY + 150F;
        vTraceEnd.fY = vTraceStart.fY - 300F;
        super.m_aTraceExcludeObjects[0] = super.m_MeshAI;
        super.m_aTraceExcludeObjects[1] = null;
        super.m_MeshAI.AITrace(vTraceStart, vTraceEnd, NewAI._AITRACE_IGNORE_GLASS, super.m_aTraceExcludeObjects);
        m_vCurrHideout.fY = vTraceEnd.fY;
        if(GetMesh().IsUpdatingPathMap())
        {
            GetMesh().UpdatePathMap(false);
            if(!GetMesh().CanStandAtPos(m_vCurrHideout))
                m_vCurrHideout = null;
            GetMesh().UpdatePathMap(true);
        }
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[AIControllerHuman.SGLoadChunk]\n");
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        if(cFC.GetID() == 1401)
        {
            super.SGLoadChunk(cFC);
            m_aHideouts.clear();
            int size = cFC.LoadInt();
            for(int i = 0; i < size; i++)
                m_aHideouts.add((ChromeActor)cFC.LoadObjectRef());

            m_CurrentHideout = (ChromeActor)cFC.LoadObjectRef();
            m_vCurrHideout = cFC.LoadVector();
            m_bCanHitActiveEnemyFromHideout = cFC.LoadBool();
            m_fHideoutHitCalcTime = cFC.LoadFloat();
            m_fHideoutPosCalcTime = cFC.LoadFloat();
            m_LastTrackedHideout = (ChromeActor)cFC.LoadObjectRef();
            m_bCanAttackFromCurrHideout = cFC.LoadBool();
            m_nBulletsToFire = cFC.LoadInt();
            m_bFireModeSingle = cFC.LoadBool();
            m_bIsShooting = cFC.LoadBool();
            m_fNextShootTime = cFC.LoadFloat();
            m_DrivenVehicle = (IDrivenVehicle)cFC.LoadObjectRef();
            m_bSitsInVehicle = cFC.LoadBool();
            m_bSitsInCannon = cFC.LoadBool();
            m_vLastGrenadeTargetPos = cFC.LoadVector();
            m_fLastGrenadeTargetPosTime = cFC.LoadFloat();
            m_bLastGrenadeTargetPosChangedResult = cFC.LoadBool();
            m_fLastGrenadeCheck = cFC.LoadFloat();
            m_fLastGrenadeThrow = cFC.LoadFloat();
            m_fLastCheckedGrenadeTrajectoryHeight = cFC.LoadFloat();
            m_bLastGrenadeTrajectoryCheckResult = cFC.LoadBool();
            m_nValidFiringPositions = cFC.LoadInt();
            m_fLastLieDownCheckTime = cFC.LoadFloat();
            m_bLastLieDownCheckResult = cFC.LoadBool();
        }
        cFC.delete();
    }

    boolean CheckTraceFromBarrelPosToActiveEnemy(byte iSpeed, boolean bAim)
    {
        Vector vEnd = super.m_cActiveEnemy.GetPointToLookAt(0);
        Collision coll = ShortTraceForCollision(super.m_MeshAI.GetBarrelPos(iSpeed, bAim), vEnd, 500F, super.m_MeshAI);
        return coll == null || coll.Obstacle == super.m_cActiveEnemy;
    }

    void RedistributeObjects(ControlObject aObjs[])
    {
        m_aHideouts.clear();
        float fTime = GetTime();
        for(int i = 0; i < aObjs.length; i++)
            if(aObjs[i] != super.m_MeshAI)
            {
                ChromeActor actor = (ChromeActor)aObjs[i];
                if(actor.bIsHideout)
                    m_aHideouts.add(actor);
                else
                if((actor instanceof NewAI) || (actor instanceof Vehicle) || (actor instanceof Player))
                    AddToProperList(actor, fTime);
            }

    }

    public int GetValidFiringPositions()
    {
        return m_nValidFiringPositions;
    }

    void RecalcValidFiringPositions()
    {
        m_nValidFiringPositions = 0;
        if(super.m_cActiveEnemy != null)
        {
            if(m_nReadinessToStartAiming > 0)
            {
                if(CheckTraceFromBarrelPosToActiveEnemy((byte)4, true))
                    m_nValidFiringPositions |= 2;
                if(CheckTraceFromBarrelPosToActiveEnemy((byte)3, true))
                    m_nValidFiringPositions |= 8;
            }
            if(m_nReadinessToStartAiming < 100)
            {
                if(CheckTraceFromBarrelPosToActiveEnemy((byte)4, false))
                    m_nValidFiringPositions |= 1;
                if(CheckTraceFromBarrelPosToActiveEnemy((byte)3, false))
                    m_nValidFiringPositions |= 4;
            }
        }
    }

    public void FireOneBullet()
    {
        if(m_nBulletsToFire > 0)
        {
            Weapon weapon = GetActiveWeapon();
            if((weapon.GetState() & 2) == 0)
            {
                m_nBulletsToFire--;
                int nPrevMode = weapon.nCurrentMode;
                weapon.StartFire((byte)1);
                if(nPrevMode != 1)
                    Notify(109);
                CallMethodOnceIn(METHOD_FireOneBullet, m_fSingleBulletDelay + GameObject.RandomFloat(m_fRandomSingleBulletDelay));
            } else
            {
                FireDone();
            }
        } else
        {
            FireDone();
        }
    }

    public void Die()
    {
        super.Die();
        DisableCallMethod(METHOD_UpdateCurrHideout);
        FireDone();
        DisableCallMethod(METHOD_UpdateShootDecision);
    }

    public TrajectoryInfo CheckGrenadeTrajectory(Vector vStart, Vector vDest, float fMaxHeight)
    {
        m_cCGTRet.fMaxHeight = fMaxHeight;
        m_cCGTRet.bToLow = false;
        m_vCGTMiddle.Set(vDest);
        m_vCGTMiddle.Sub(vStart);
        m_vCGTMiddle.Mul(0.5F);
        m_vCGTMiddle.Add(vStart);
        m_vCGTMiddle.fY = vStart.fY + fMaxHeight;
        m_vCGTEnd.Set(vDest);
        Collision col = GetMesh().TraceForCollision(vStart, m_vCGTMiddle, GetMesh());
        if(col != null)
        {
            m_cCGTRet.vEndPoint = m_vCGTMiddle;
            Vector vNormal = col.vNormal;
            vNormal.Normalize();
            if(vNormal.Dot(Vector.Down) > _COS_1_PI_BY_4)
                m_cCGTRet.fMaxHeight = m_vCGTMiddle.fY - vStart.fY;
            else
                m_cCGTRet.bToLow = true;
        } else
        {
            col = GetMesh().TraceForCollision(m_vCGTMiddle, m_vCGTEnd, GetMesh());
            m_cCGTRet.vEndPoint = m_vCGTEnd;
        }
        return m_cCGTRet;
    }

    public void SGUpdate()
    {
        FileChunk.Log("[AIControllerHuman.SGUpdate]\n");
        super.SGUpdate();
        ActiveWeaponChanged();
    }

    protected void FindNearbyTrees()
    {
        m_nNearbyTrees = GetNearestTreesInRadius(GetMesh().GetPositionVectorVolatile(), m_fMaxNearbyTreeDistance, m_aNearbyTrees, 10);
        GameObject.LogR("  m_nNearbyTrees = " + m_nNearbyTrees + "\n");
    }

    public void CollisionMsg(ControlObject obstacle, Vector point, Vector normal)
    {
        super.CollisionMsg(obstacle, point, normal);
        if(obstacle instanceof ChromeActor)
        {
            ChromeActor actor = (ChromeActor)obstacle;
            EnemyInfo info = AddEnemy(actor);
            if(info != null)
                RecognizeEnemy(info);
        }
    }

    void SetObjectToGetIn(ISeatVehicle cObjectToGetIn, EnumGetInType cGetInAs)
    {
        if(cObjectToGetIn == null)
        {
            GetMesh().cSeatInfo = null;
            return;
        }
        GetMesh().cSeatInfo = cObjectToGetIn.GetFirstFreeSeat(cGetInAs.GetValue());
        if(((Pawn) (GetMesh())).cSeatInfo == null)
        {
            GameObject.CrashLog("AIController.SetObjectToGetIn(): no seat to getIn\n");
            return;
        } else
        {
            ((Pawn) (GetMesh())).cSeatInfo.Reserve(GetMesh());
            return;
        }
    }

    public float GetLastCheckedGrenadeTrajectoryHeight()
    {
        return m_fLastCheckedGrenadeTrajectoryHeight;
    }

    void SetCanFire(boolean bCanAim)
    {
        super.SetCanFire(bCanAim);
        m_bIsShooting = false;
        m_fNextShootTime = 0.0F;
        UpdateShootDecision();
        CallMethodEvery(METHOD_UpdateShootDecision, 0.5F, 0.5F * GetMesh().GetTimeDeviation());
    }

    public void UpdateShootDecision()
    {
        if(!IsDead())
        {
            if(!m_bIsShooting)
            {
                if(GetTime() > m_fNextShootTime && super.m_cActiveEnemy != null && GetActiveEnemyDistance2() < m_fWeaponEffectiveRange2)
                {
                    Vector vTargetPos = super.m_cActiveEnemy.GetPointToLookAt(0);
                    if(vTargetPos != null && SharpAngleToShoot(vTargetPos))
                        if(ActiveEnemyVisibleFromGun())
                        {
                            float fDelayTime = TryToStartAiming();
                            CallMethodOnceIn(METHOD_Fire, fDelayTime);
                        } else
                        if(!((MotionState) (super.m_MeshAI.m_ActualMotion)).bAiming && (((MotionState) (super.m_MeshAI.m_ActualMotion)).iSpeed == 3 && IsValidFiringPosition(8) || (((MotionState) (super.m_MeshAI.m_ActualMotion)).iSpeed == 4 || ((MotionState) (super.m_MeshAI.m_ActualMotion)).iSpeed == 5) && IsValidFiringPosition(2)))
                        {
                            float fDelayTime = TryToStartAiming();
                            CallMethodOnceIn(METHOD_TryToStartFiring, fDelayTime);
                        }
                }
            } else
            if(super.m_cActiveEnemy != null)
            {
                Vector vTargetPos = super.m_cActiveEnemy.GetPointToLookAt(0);
                if(vTargetPos != null)
                    if(!SharpAngleToShoot(vTargetPos))
                    {
                        FireDone();
                        TryToStopAiming();
                    } else
                    if(!AICheckTraceAbsoluteVehicleCheck(super.m_cActiveEnemy, vTargetPos, super.m_MeshAI.GetFireOrigin()))
                    {
                        FireDone();
                        TryToStopAiming();
                    }
            }
        } else
        if(GetActiveWeapon() != null)
            GetActiveWeapon().StopFire();
    }

    public boolean IsValidFiringPosition(int nFiringPos)
    {
        return (m_nValidFiringPositions & nFiringPos) != 0;
    }

    public void InitController(NewAI ai)
    {
        super.InitController(ai);
        UpdateCurrHideout();
        CallMethodEveryMinMax(METHOD_UpdateCurrHideout, 1.0F, 4F, 1.0F * GetMesh().GetTimeDeviation());
        super.m_HearingSense = (HearingSense)CreateObject("HearingSense");
        super.m_HearingSense.Init(this);
        super.m_PainSense = (PainSense)CreateObject("PainSense");
        super.m_PainSense.Init(this);
        super.m_ObjectsSense = (ObjectsSense)CreateObjectNoInit("ObjectsSense");
        super.m_ObjectsSense._AI_SIGHT_RANGE = ((NewAIHuman)ai).fSightRange;
        super.m_ObjectsSense._AI_RECOGNIZE_RANGE = ((NewAIHuman)ai).fSightRange * ((NewAIHuman)ai).fSightRangeRecognitionMult;
        super.m_ObjectsSense._AI_SIGHT_ANGLE = ((NewAIHuman)ai).fSightAngle;
        super.m_ObjectsSense.InitObject();
        super.m_ObjectsSense.Init(this);
        super.fMaxEnemyRecognitionTime = ((NewAIHuman)super.m_MeshAI).fMaxEnemyRecognitionTime;
        super.fMaxEnemyRecognitionTimeAlarmed = ((NewAIHuman)super.m_MeshAI).fMaxEnemyRecognitionTimeAlarmed;
    }

    Collision ShortTraceForCollision(Vector vStart, Vector vEnd, float fTraceLenFromStart, ControlObject cExclude)
    {
        m_vSTFC_Dir.Set(vEnd);
        m_vSTFC_Dir.Sub(vStart);
        float len = m_vSTFC_Dir.Len();
        if((double)len < 9.9999999999999995E-07D)
        {
            return null;
        } else
        {
            m_vSTFC_Dir.Mul(fTraceLenFromStart / len);
            m_vSTFC_Dir.Add(vStart);
            vEnd.Set(m_vSTFC_Dir);
            super.m_aTraceExcludeObjects[0] = cExclude;
            super.m_aTraceExcludeObjects[1] = null;
            return super.m_MeshAI.AITrace(vStart, vEnd, NewAI._AITRACE_IGNORE_GLASS, super.m_aTraceExcludeObjects);
        }
    }

    boolean InsideVehicle()
    {
        return m_bSitsInVehicle;
    }

    public void Fire()
    {
        ComputeAccuracy();
        switch(ChooseBestFireMode())
        {
        case 1: // '\001'
            FireSingle();
            break;

        case 2: // '\002'
            FireAuto();
            break;
        }
        m_bIsShooting = true;
    }

    public void FireDone()
    {
        DisableCallMethod(METHOD_Fire);
        DisableCallMethod(METHOD_FireDone);
        DisableCallMethod(METHOD_FireOneBullet);
        m_nBulletsToFire = 0;
        Weapon weapon = GetActiveWeapon();
        float fFireDelay = 1.0F;
        if(weapon != null)
        {
            switch(weapon.nCurrentMode)
            {
            case 1: // '\001'
                fFireDelay = m_fMinSingleFireDelay + GameObject.RandomFloat(m_fRandomSingleFireDelay) * CalcActiveEnemyDistCoef(m_fNearTargetDistance2, m_fFarTargetDistance2);
                break;

            case 2: // '\002'
                fFireDelay = m_fMinBurstFireDelay + GameObject.RandomFloat(m_fRandomBurstFireDelay) * CalcActiveEnemyDistCoef(m_fNearTargetDistance2, m_fFarTargetDistance2);
                break;
            }
            int nPrevMode = weapon.nCurrentMode;
            weapon.StopFire();
            if(nPrevMode != 0)
                Notify(109);
        } else
        if(IsDead())
            GameObject.LogR(GetName() + ": Fire done for null weapon in dead AI - possible zombie shooting!\n");
        m_bIsShooting = false;
        m_fNextShootTime = GetTime() + fFireDelay;
    }

    void CalcCanHitActiveEnemyFromHideout()
    {
        if(m_vCurrHideout == null || GetActiveEnemy() == null)
        {
            m_bCanHitActiveEnemyFromHideout = false;
            return;
        }
        float fTime = GetTime();
        if(!AIController.TimePassed(m_fHideoutHitCalcTime, _MIN_TIME_BTW_HIDEOUT_HIT_CALC, fTime))
        {
            return;
        } else
        {
            m_fHideoutHitCalcTime = fTime;
            Vector vTemp = new Vector(m_vCurrHideout);
            vTemp.fY += GetMesh().GetBarrelHeightOverGround((byte)4, m_nReadinessToStartAiming > 0);
            super.m_aTraceExcludeObjects[0] = GetActiveEnemy();
            super.m_aTraceExcludeObjects[1] = super.m_MeshAI;
            m_bCanHitActiveEnemyFromHideout = AICheckTraceAbsoluteVehicleCheck(GetActiveEnemy(), vTemp, GetActiveEnemy().GetPointToLookAt(0));
            return;
        }
    }

    public boolean CanHitActiveEnemyFromHideout()
    {
        return m_bCanHitActiveEnemyFromHideout;
    }

    void ResetCanFire()
    {
        super.ResetCanFire();
        DisableCallMethod(METHOD_UpdateShootDecision);
        FireDone();
    }

    void ResetCanAim()
    {
        super.ResetCanAim();
        TryToStopAiming();
        GetMesh().m_Motion.bAiming = false;
    }

    void MessageWeapon(int nState)
    {
        if((nState & 2) != 0)
        {
            if(GetActiveWeapon() != null)
                Notify(109);
            RequestEvent(9);
        }
    }

    private void ShowTrace(Vector vFrom, Vector vTo, String sType)
    {
        LaserPointer lazer = Tools.CreateLaserPointer(GetModule(), sType);
        lazer.PointFromTo(vFrom, vTo);
        aTracesList.add(lazer);
    }

    void RecalcState()
    {
        super.RecalcState();
        RecalcValidFiringPositions();
    }

    public void ThrowGrenade(Grenade cGrenade, Vector vStart, Vector vDest, float fMaxHeight)
    {
        m_fLastGrenadeThrow = GetTime();
        cGrenade.SetPosition(vStart);
        float fHeightDiff = vDest.fY - vStart.fY;
        Vector vTemp = new Vector(vDest);
        vTemp.Sub(vStart);
        vTemp.fY = 0.0F;
        float fDist = vTemp.Len();
        float fMaxHeightTime = (float)Math.sqrt((2.0F * fMaxHeight) / (10F * cGrenade.GetMass()));
        float fDiffTime = 0.0F;
        float fAllTime = 0.0F;
        if(fHeightDiff >= 0.0F)
        {
            fDiffTime = (float)Math.sqrt((2.0F * Math.abs(fHeightDiff)) / (10F * cGrenade.GetMass()));
            fAllTime = 2.0F * fMaxHeightTime - fDiffTime;
        } else
        {
            fDiffTime = (float)Math.sqrt((2.0F * (fMaxHeight - fHeightDiff)) / (10F * cGrenade.GetMass()));
            fAllTime = fMaxHeightTime + fDiffTime;
        }
        float fSpeedX = fDist / fAllTime;
        float fSpeedY = 10F * cGrenade.GetMass() * fMaxHeightTime;
        vTemp.Normalize();
        vTemp.Mul(fSpeedX);
        vTemp.fY += fSpeedY;
        float fForce = vTemp.Len() / 100F;
        vTemp.Normalize();
        cGrenade.Start(fForce, vTemp);
        if(Grenades() > 0)
            GetMesh().m_nGrenadesLeft--;
    }

    public ChromeActor HideoutsNear()
    {
        if(m_CurrentHideout != null && m_CurrentHideout.GetDistanceTo(GetMesh()) < _SHORT_HIDEOUT_DIST)
            return m_CurrentHideout;
        else
            return null;
    }

    void FireBullets(int nBullets)
    {
        m_nBulletsToFire = nBullets;
        FireOneBullet();
    }

    SeatInfo GetSeat()
    {
        return ((Pawn) (GetMesh())).cSeatInfo;
    }

    public void UpdateObjectsInformation()
    {
        RecalculateHideouts();
        super.UpdateObjectsInformation();
    }

    void TargetHitNotification(ChromeActor victim, int damageType)
    {
        super.TargetHitNotification(victim, damageType);
        if(super.m_MeshAI.bCanUseRadioCommunication && MathUtils.CanHappen(_ENEMY_HIT_MSG_CHANCE))
            super.m_MeshAI.SendRadioMessage(4);
    }

    public boolean InsideCannon()
    {
        return m_bSitsInCannon;
    }

    public void ActiveWeaponChanged()
    {
        super.ActiveWeaponChanged();
        Weapon weapon = GetActiveWeapon();
        if(weapon != null)
        {
            m_nReadinessToStartAiming = weapon.nAIReadinessToAim;
            m_nReadinessToStopAiming = weapon.nAIReadinessToStopAiming;
            m_fNearTargetDistance2 = weapon.fAINearTargetDistance * weapon.fAINearTargetDistance;
            m_fMaxAimingChanceDistance2 = weapon.fAIMaxAimingChanceDistance * weapon.fAIMaxAimingChanceDistance;
            m_fFarTargetDistance2 = weapon.fAIFarTargetDistance * weapon.fAIFarTargetDistance;
            m_fMaxBurstFireDistance2 = Math.min(weapon.fAIMaxBurstDistance * weapon.fAIMaxBurstDistance, m_fFarTargetDistance2);
            m_nMinBulletsToFire = (int)Math.max(1.0F, (float)weapon.nAIMinSingleFireBullets * super.m_MeshAI.mod_fFiringTimeMult);
            m_nMaxBulletsToFire = (int)Math.max(m_nMinBulletsToFire, (float)weapon.nAIMaxSingleFireBullets * super.m_MeshAI.mod_fFiringTimeMult);
            m_fMinBurstFiringTime = weapon.fAIBurstTime * super.m_MeshAI.mod_fFiringTimeMult;
            m_fRandomBurstFiringTime = weapon.fAIRandomBurstTime * super.m_MeshAI.mod_fFiringTimeMult;
            m_fMinSingleFireDelay = weapon.fAISingleFireDelay * super.m_MeshAI.mod_fFireDelayMult;
            m_fRandomSingleFireDelay = weapon.fAIRandomSingleFireDelay * super.m_MeshAI.mod_fFireDelayMult;
            m_fSingleBulletDelay = weapon.fAISingleBulletDelay;
            m_fRandomSingleBulletDelay = weapon.fAIRandomSingleBulletDelay;
            m_fSingleFireAccAdd = weapon.fAISingleFireAccAdd;
            m_fAimingAccAdd = weapon.fAIAimingAccAdd;
            m_fMinBurstFireDelay = weapon.fAIBurstFireDelay * super.m_MeshAI.mod_fFireDelayMult;
            m_fRandomBurstFireDelay = weapon.fAIRandomBurstFireDelay * super.m_MeshAI.mod_fFireDelayMult;
            m_fWeaponEffectiveRange2 = weapon.fAIEffectiveRange * weapon.fAIEffectiveRange;
            m_fMinDesiredHitRatio = MathUtils.crop((weapon.fAIMinDesiredHitRatio * super.m_MeshAI.mod_fMinHitRatioMult) / 100F, 0.0F, 1.0F);
            m_fMaxDesiredHitRatio = MathUtils.crop((weapon.fAIMaxDesiredHitRatio * super.m_MeshAI.mod_fMaxHitRatioMult) / 100F, m_fMinDesiredHitRatio, 1.0F);
        }
    }

    protected boolean GrenadeTargetPosChanged(ChromeActor cTarget, float fTime)
    {
        if(AIController.TimePassed(m_fLastGrenadeTargetPosTime, _GRENADE_TARGET_STILL_TIME, fTime))
        {
            boolean bPositionChanged = false;
            if(m_fLastGrenadeTargetPosTime > 0.0F)
            {
                if(cTarget.GetDistance2To(m_vLastGrenadeTargetPos) > _GRENADE_TARGET_POS_TOLERANCE * _GRENADE_TARGET_POS_TOLERANCE)
                    bPositionChanged = true;
            } else
            {
                bPositionChanged = true;
            }
            m_fLastGrenadeTargetPosTime = fTime;
            cTarget.GetPosition(m_vLastGrenadeTargetPos);
            m_bLastGrenadeTargetPosChangedResult = bPositionChanged;
        }
        return m_bLastGrenadeTargetPosChangedResult;
    }

    public void AddGenerators()
    {
        super.AddGenerators();
        Generator debugFilter = new ScenariosFilterHuman(this);
        super.m_DebugScenariosFilter.Set(debugFilter.m_GenScenarios);
        super.m_aGenerators = (new Generator[] {
            new CanMove(this), new CanShoot(this), new CanThrowGrenade(this), new EnemySpotted(this), new EnemyStronger(this), new FallDownCheck(this), new HasToKeepDistance(this), new HasToReload(this), new HideoutsCheck(this), new IdleAllowed(this), 
            new InVehicle(this), new IsUnarmed(this), new LongEnemyDistance(this), new NoiseShotEnemy(this), new PerformEditorActivity(this), new RunAwayCheck(this), new ScenariosFilterHuman(this), new ShortEnemyDistance(this), new ShouldAttackFromHideout(this), new ShouldCheckBody(this), 
            new ShouldLookForEnemy(this), new ShouldWaitForEnemyAction(this), new SilenceBroken(this), new SuspectSpotted(this)
        });
    }

    AIControllerHuman()
    {
        m_aHideouts = new ArrayList();
        m_CurrentHideout = null;
        m_vCurrHideout = null;
        m_bCanHitActiveEnemyFromHideout = false;
        m_fHideoutHitCalcTime = -100F;
        m_fHideoutPosCalcTime = -_MIN_TIME_BTW_HIDEOUT_POS_CALC;
        m_LastTrackedHideout = null;
        m_bCanAttackFromCurrHideout = false;
        METHOD_UpdateCurrHideout = 0;
        METHOD_FireOneBullet = 0;
        METHOD_FireDone = 0;
        METHOD_Fire = 0;
        METHOD_UpdateShootDecision = 0;
        METHOD_TryToStartFiring = 0;
        m_nBulletsToFire = 0;
        _SHARP_ANGLE_TO_SHOOT = 20F;
        _SHARP_Y_DIFF_TO_SHOOT = 0.4F;
        _MIN_DIST_TO_START_INC_Y_DIFF_ALLOWED = 300F;
        _SHARP_ANGLE_TO_SHOOT_COS = 0.0F;
        m_bIsShooting = false;
        m_fNextShootTime = 0.0F;
        m_fDuckCrawlAccAdd = 0.1F;
        m_fMoveAccAdd = -0.2F;
        m_fTargetShootVisibilityFactorImportance = 0.2F;
        m_nReadinessToStartAiming = 100;
        m_nReadinessToStopAiming = 100;
        m_fNearTargetDistance2 = 1.0F;
        m_fMaxAimingChanceDistance2 = 2.0F;
        m_fFarTargetDistance2 = 3F;
        m_fMaxBurstFireDistance2 = 1000000F;
        m_DrivenVehicle = null;
        m_bSitsInVehicle = false;
        m_bSitsInCannon = false;
        _MIN_TIME_BTW_GRENADES_THROW = 5F;
        _MIN_TIME_BTW_GRENADES_CHECK = 1.0F;
        _MAX_GRENADE_TRAJECTORY_HEIGHT = 500F;
        _DEF_GRENAGE_TRAJECTORY_TAN = 0.5F;
        _MAX_GRENADE_TRAJECTORY_END_DISTANCE = 200F;
        m_fLastGrenadeCheck = -100F;
        m_fLastGrenadeThrow = -100F;
        m_fLastCheckedGrenadeTrajectoryHeight = _MAX_GRENADE_TRAJECTORY_HEIGHT;
        m_bLastGrenadeTrajectoryCheckResult = false;
        m_fLastLieDownCheckTime = -100F;
        m_bLastLieDownCheckResult = false;
        m_vCLDMinExt = new Vector();
        m_vCLDMaxExt = new Vector();
        m_cCGTRet = new TrajectoryInfo();
        m_vCGTMiddle = new Vector();
        m_vCGTEnd = new Vector();
        m_vCGTDir = new Vector();
        m_vLastGrenadeTargetPos = new Vector();
        m_fLastGrenadeTargetPosTime = -1F;
        m_bLastGrenadeTargetPosChangedResult = false;
        m_fMaxNearbyTreeDistance = 5000F;
        m_aNearbyTrees = new int[10];
        m_vGNNTI_TreeDir = new Vector();
        aTracesList = new LinkedList();
        _MIN_STATIC_HIDEOUT_DIST = 200F;
        super._MANY_ATTACKING_ENEMIES = 2;
    }

    public void Checkpoint()
    {
        if(IsDead())
            return;
        if(GetDrivenVehicle() != null)
            GetDrivenVehicle().PatrolBreak();
        Notify(106);
    }

    public void VehicleDestroyed(Vector vCollPoint, Vector vNormal)
    {
        super.VehicleDestroyed(vCollPoint, vNormal);
        GetMesh().bUsePhysicsToDeathFall = true;
        Physics.Simulate(GetMesh(), vCollPoint, vNormal, 1.0F, 4, true);
        ((Pawn) (GetMesh())).cSeatInfo.Occupy(null);
        ((Pawn) (GetMesh())).cSeatInfo.Reserve(null);
        GetMesh().cSeatInfo = null;
        super.m_bSitsInVehicleOnSeat = false;
        ControlObject newParent = GetMesh().GetParent();
        if(newParent != null)
            newParent = newParent.GetParent();
        if(newParent == null)
            GetMesh().DetachFromParentAndKeepWorldPos();
        else
            GetMesh().AttachAsChildToAndKeepWorldPos(newParent);
    }

    public boolean IsBehindHideout()
    {
        UpdateCurrHideout();
        return GetDestHideoutPos() != null && m_CurrentHideout.cHideoutInvader == GetMesh();
    }

    public void TryToStartFiring()
    {
        if(ActiveEnemyVisibleFromGun())
            Fire();
    }

    int ChooseBestFireMode()
    {
        int nWeaponFireModes = GetActiveWeapon().nAIFireModes;
        if((nWeaponFireModes & 2) != 0 && ((nWeaponFireModes & 1) == 0 || GetActiveEnemyDistance2() < m_fMaxBurstFireDistance2))
            return 2;
        return (nWeaponFireModes & 1) == 0 ? 0 : 1;
    }

    public Vector GetDestHideoutPos()
    {
        CalcDestHideoutPos();
        CalcCanHitActiveEnemyFromHideout();
        return m_vCurrHideout;
    }

    IDrivenVehicle GetDrivenVehicle()
    {
        return m_DrivenVehicle;
    }

    boolean ChooseBestAimingStrategy()
    {
        if(m_nReadinessToStartAiming < 100)
        {
            float fDistCoef = CalcActiveEnemyDistCoef(m_fNearTargetDistance2, m_fMaxAimingChanceDistance2);
            AIMotionState cMotion = GetMesh().m_Motion;
            float fMotionCoef;
            if(cMotion.IsMovingLinear() && cMotion.GetSpeed() == 5)
                fMotionCoef = 0.7F;
            else
                fMotionCoef = 1.0F;
            return GameObject.RandomFloat(1.0F) <= fMotionCoef * fDistCoef;
        } else
        {
            return true;
        }
    }

    protected int GetNextNearbyTreeIndex(int nStartIndex, Vector vSearchDir)
    {
        for(int iNdx = nStartIndex; iNdx < m_nNearbyTrees; iNdx++)
        {
            GetTreePos(m_aNearbyTrees[iNdx], m_vGNNTI_TreeDir);
            m_vGNNTI_TreeDir.Sub(GetMesh().GetPositionVectorVolatile());
            if(vSearchDir == null || vSearchDir.Dot(m_vGNNTI_TreeDir) > 0.0F)
                return iNdx;
        }

        return -1;
    }

    private void RemoveAllTraces()
    {
        LaserPointer lazer;
        for(; aTracesList.size() > 0; lazer.delete())
            lazer = (LaserPointer)aTracesList.removeFirst();

    }

    public boolean ShouldPerformEditorActivity()
    {
        return GetCurrWaypoint() != null && super.m_bPerformCurrActivity && (super.m_CurrActivity != null && super.m_CurrActivity.IsCritical() || GetActiveEnemy() == null && TimeFromImpulsePassed() && !IsSuspectValid() || m_bSitsInVehicle && (super.m_CurrActivity instanceof mt_Move));
    }

    protected boolean CalcTreeHideoutData(int nTree, Vector vTarget)
    {
        RemoveAllTraces();
        Vector aExtents[] = {
            new Vector(), new Vector(), new Vector(), new Vector()
        };
        GetTreeExtents(nTree, aExtents[0], aExtents[1]);
        aExtents[1].fY = aExtents[0].fY;
        aExtents[2].Set(aExtents[0]);
        aExtents[2].fZ = aExtents[1].fZ;
        aExtents[3].Set(aExtents[0]);
        aExtents[3].fX = aExtents[1].fX;
        Vector vMid = new Vector();
        vMid.Set(aExtents[0]);
        vMid.Add(aExtents[1]);
        vMid.Mul(0.5F);
        for(int i = 0; i < 4; i++)
        {
            MeshObject c1 = Tools.AddHelperMesh(GetMesh(), "data/interface/choragiewka.3da");
            c1.SetPositionWorld(aExtents[i]);
        }

        MeshObject c1 = Tools.AddHelperMesh(GetMesh(), "data/interface/choragiewka.3da");
        c1.SetPositionWorld(vMid);
        float fMaxDist = MathUtils.dist2D2(aExtents[0], vTarget);
        for(int i = 1; i < 4; i++)
        {
            float fDist = MathUtils.dist2D2(aExtents[i], vTarget);
            if(fDist > fMaxDist)
                fMaxDist = fDist;
        }

        fMaxDist = (float)Math.sqrt(fMaxDist);
        GameObject.LogR("fMaxDist = " + fMaxDist + "\n");
        float fStartDist = fMaxDist + _MIN_STATIC_HIDEOUT_DIST;
        GameObject.LogR("fStartDist 1 = " + fStartDist + "\n");
        Vector vFromTgtDir = new Vector();
        vFromTgtDir.Set(vMid);
        vFromTgtDir.Sub(vTarget);
        vFromTgtDir.Normalize();
        Vector vStartPos = new Vector();
        vStartPos.Set(vFromTgtDir);
        vStartPos.Mul(fStartDist);
        vStartPos.Add(vTarget);
        Vector vTraceEnd = new Vector();
        vTraceEnd.Set(vMid);
        float fDuckHeadHeight = 70F + TerrainHeight(vStartPos.fX, vStartPos.fZ);
        vStartPos.fY = fDuckHeadHeight;
        vTraceEnd.fY = fDuckHeadHeight;
        GetMesh().SetPositionWorld(vStartPos);
        if(!RaytraceTree(nTree, vStartPos, vTraceEnd, null))
        {
            ShowTrace(vStartPos, vTraceEnd, "LaserBeamYellowNDT");
            GameObject.LogR("Odpadl przez 1 RaytraceTree!\n");
            return false;
        }
        ShowTrace(vStartPos, vTraceEnd, "LaserBeamYellowNDT");
        fStartDist = MathUtils.dist2D(vTarget, vTraceEnd) + _MIN_STATIC_HIDEOUT_DIST;
        vStartPos.Set(vFromTgtDir);
        vStartPos.Mul(fStartDist);
        vStartPos.Add(vTarget);
        int nStampSize = GetMesh().m_iPathFinderStampSize;
        vStartPos.fY = 5F + TerrainHeight(vStartPos.fX, vStartPos.fZ);
        GetMesh().SetPositionWorld(vStartPos);
        GetMesh().UpdatePathMap(false);
        if(!IsPlaceMoveable(vStartPos, nStampSize))
        {
            GameObject.LogR("Odpadl przez 1 pathmap test!\n");
            return false;
        } else
        {
            GameObject.LogR("Pozycja OK!\n");
            GetMesh().UpdatePathMap(true, nStampSize);
            return true;
        }
    }

    public void OnCreate()
    {
        METHOD_UpdateCurrHideout = RegisterCallMethod("UpdateCurrHideout");
        super.OnCreate();
        METHOD_FireOneBullet = RegisterCallMethod("FireOneBullet");
        METHOD_FireDone = RegisterCallMethod("FireDone");
        METHOD_Fire = RegisterCallMethod("Fire");
        METHOD_UpdateShootDecision = RegisterCallMethod("UpdateShootDecision");
        METHOD_TryToStartFiring = RegisterCallMethod("TryToStartFiring");
        _SHARP_ANGLE_TO_SHOOT_COS = (float)Math.cos(((double)_SHARP_ANGLE_TO_SHOOT * 3.1415926535897931D) / 180D);
    }

    public void MovingEnd()
    {
        if(GetDrivenVehicle() != null)
        {
            GetDrivenVehicle().PatrolResume();
            GetDrivenVehicle().FinishDrive();
        } else
        {
            GameObject.CrashLog("AIController.DriverMovingEnd(): GetDrivenVehicle() == null\n");
        }
        Notify(107);
    }

    void SetActiveEnemy(ChromeActor cEnemy)
    {
        if(super.m_MeshAI.bCanUseRadioCommunication && GetAlarmLevel() >= 2 && cEnemy == null)
            super.m_MeshAI.SendRadioMessage(6);
        super.SetActiveEnemy(cEnemy);
    }

    void FireSingle()
    {
        m_bFireModeSingle = true;
        ((NewAIHuman)super.m_MeshAI).StartFiring();
        FireBullets(m_nMinBulletsToFire + (int)(GameObject.RandomFloat(m_nMaxBulletsToFire - m_nMinBulletsToFire) * (1.0F - CalcActiveEnemyDistCoef(m_fMaxBurstFireDistance2, m_fFarTargetDistance2))));
    }

    public void ReloadWeapon()
    {
        super.ReloadWeapon();
        m_bIsShooting = false;
    }

    ArrayList m_aHideouts;
    ChromeActor m_CurrentHideout;
    Vector m_vCurrHideout;
    boolean m_bCanHitActiveEnemyFromHideout;
    float m_fHideoutHitCalcTime;
    static float _MIN_TIME_BTW_HIDEOUT_POS_CALC = 3F;
    static float _MIN_TIME_BTW_HIDEOUT_HIT_CALC = 1.0F;
    static float _HIDEOUT_HIDE_DIST = 150F;
    static float _BEHIND_HIDEOUT_FREEDOM = 100F;
    static float _SHORT_HIDEOUT_DIST = 2000F;
    float m_fHideoutPosCalcTime;
    ChromeActor m_LastTrackedHideout;
    boolean m_bCanAttackFromCurrHideout;
    static float _TIME_AFTER_RICOCHET_TO_GO_TO_HIDEOUT = 20F;
    int METHOD_UpdateCurrHideout;
    public static int _ENEMY_HIT_MSG_CHANCE = 20;
    public static int _WOUNDED_MSG_CHANCE = 20;
    int METHOD_FireOneBullet;
    int METHOD_FireDone;
    int METHOD_Fire;
    int METHOD_UpdateShootDecision;
    int METHOD_TryToStartFiring;
    int m_nBulletsToFire;
    boolean m_bFireModeSingle;
    float _SHARP_ANGLE_TO_SHOOT;
    float _SHARP_Y_DIFF_TO_SHOOT;
    float _MIN_DIST_TO_START_INC_Y_DIFF_ALLOWED;
    float _SHARP_ANGLE_TO_SHOOT_COS;
    boolean m_bIsShooting;
    float m_fNextShootTime;
    float m_fDuckCrawlAccAdd;
    float m_fMoveAccAdd;
    float m_fTargetShootVisibilityFactorImportance;
    int m_nReadinessToStartAiming;
    int m_nReadinessToStopAiming;
    float m_fNearTargetDistance2;
    float m_fMaxAimingChanceDistance2;
    float m_fFarTargetDistance2;
    float m_fMaxBurstFireDistance2;
    int m_nMinBulletsToFire;
    int m_nMaxBulletsToFire;
    float m_fMinBurstFiringTime;
    float m_fRandomBurstFiringTime;
    float m_fMinSingleFireDelay;
    float m_fRandomSingleFireDelay;
    float m_fSingleBulletDelay;
    float m_fRandomSingleBulletDelay;
    float m_fAimingAccAdd;
    float m_fSingleFireAccAdd;
    float m_fMinBurstFireDelay;
    float m_fRandomBurstFireDelay;
    float m_fWeaponEffectiveRange2;
    public float m_fMinDesiredHitRatio;
    public float m_fMaxDesiredHitRatio;
    IDrivenVehicle m_DrivenVehicle;
    boolean m_bSitsInVehicle;
    boolean m_bSitsInCannon;
    static float _MIN_DIST_TO_THROW_GRENADE = 1000F;
    static float _MAX_DIST_TO_THROW_GRENADE = 2500F;
    public static float _GRENADE_TARGET_STILL_TIME = 1.0F;
    public static float _GRENADE_TARGET_POS_TOLERANCE = 10F;
    public float _MIN_TIME_BTW_GRENADES_THROW;
    public float _MIN_TIME_BTW_GRENADES_CHECK;
    public float _MAX_GRENADE_TRAJECTORY_HEIGHT;
    public float _DEF_GRENAGE_TRAJECTORY_TAN;
    public float _MAX_GRENADE_TRAJECTORY_END_DISTANCE;
    protected float m_fLastGrenadeCheck;
    protected float m_fLastGrenadeThrow;
    protected float m_fLastCheckedGrenadeTrajectoryHeight;
    protected boolean m_bLastGrenadeTrajectoryCheckResult;
    public static final float _LIE_DOWN_CHECK_INTERVAL = 0.5F;
    public static final float _LIE_DOWN_CHECK_RADIUS = 250F;
    public static final float _LIE_DOWN_MIN_Y = 15F;
    public static final float _LIE_DOWN_MAX_Y = 200F;
    protected float m_fLastLieDownCheckTime;
    protected boolean m_bLastLieDownCheckResult;
    private Vector m_vCLDMinExt;
    private Vector m_vCLDMaxExt;
    private static Vector l_SATS_vDir = new Vector();
    private static Vector l_SATS_vWpn = new Vector();
    public static final float _NEARBY_OBSTACLE_DISTANCE = 500F;
    int m_nValidFiringPositions;
    private static Vector m_vSTFC_Dir = new Vector();
    public static final float _COS_1_PI_BY_4 = (float)Math.cos(0.78539816339744828D);
    private TrajectoryInfo m_cCGTRet;
    private Vector m_vCGTMiddle;
    private Vector m_vCGTEnd;
    private Vector m_vCGTDir;
    protected Vector m_vLastGrenadeTargetPos;
    protected float m_fLastGrenadeTargetPosTime;
    protected boolean m_bLastGrenadeTargetPosChangedResult;
    public final int m_nMaxNearbyTrees = 10;
    public float m_fMaxNearbyTreeDistance;
    protected int m_aNearbyTrees[];
    protected int m_nNearbyTrees;
    private Vector m_vGNNTI_TreeDir;
    LinkedList aTracesList;
    public float _MIN_STATIC_HIDEOUT_DIST;

}
