// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   CannonController.java


public class CannonController extends WeaponBullet
    implements ICannonController
{
    public class IdleState extends State
    {

        public void OnEnter()
        {
            DisableCallMethod("AdjustOrientation");
            DisableCallMethod("AdjustCannonPosition");
            DisableCallMethod("GetAllTargets");
            DisableCallMethod("RecalculateTargets");
            SetIdlePosition();
        }

        public IdleState()
        {
        }
    }

    public class ManualControlState extends State
    {

        public void OnInputMouseButton(int nButton, int nState)
        {
            CallOnInputKey(Player.ConvertMouseButtonToKey(nButton), nState, 48);
        }

        void OnInputMouseAxis(int nAxis, int nDelta)
        {
            HUDManager.ProcessMouseWheel(CannonController.this, nAxis, nDelta);
        }

        public void OnEnter()
        {
            m_OwnerMesh.SetElementAnimType(m_nElementH, (byte)0, false);
            m_OwnerMesh.SetElementAnimType(m_nElementV, (byte)0, false);
        }

        void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
        {
            if(nKeyCode == EGameControl.FIRE)
                if(bKeyState)
                {
                    if(m_PlayerManual != null && m_PlayerManual.HUD.GetHUDMap() != null && ((HUDComponent) (m_PlayerManual.HUD.GetHUDMap())).bActiveFlag)
                        return;
                    if(m_PlayerManual != null && !m_PlayerManual.HUD.m_bActivateAllowed)
                        return;
                    StartFire((byte)2);
                } else
                {
                    StopFire();
                }
        }

        void OnFrame()
        {
            if(m_bNetModule && m_PlayerManual != null)
                if(((GameObject) (m_PlayerManual)).bNetIsOwner)
                {
                    if(m_nFrame % 5 == 0)
                        m_PlayerManual.CheckTriggers(true);
                } else
                {
                    if(m_bPreFiringState != m_bPreFiring)
                        if(m_bPreFiring)
                            StartFire((byte)2);
                        else
                            StopFire();
                    if(m_bFiringState != m_bFiring)
                        if(m_bFiring)
                            SuperStartFireDo((byte)2);
                        else
                            StopFire();
                    if(m_vAimAtPoint.fX != m_fAimX || m_vAimAtPoint.fY != m_fAimY || m_vAimAtPoint.fZ != m_fAimZ)
                    {
                        m_vAimAtPoint.Set(m_fAimX, m_fAimY, m_fAimZ);
                        AimAtPoint(m_vAimAtPoint);
                    }
                }
        }

        public ManualControlState()
        {
        }
    }

    public class HuntingState extends State
    {

        public void SGUpdate()
        {
            FileChunk.Log("[CannonController$HuntingState] : SGUpdate\n");
            if(m_bGunAdvanced)
                AdjustCannonPosition();
        }

        void AdjustCannonPosition()
        {
            SetCannonPosition((45F + GameObject.RandomFloat(20F)) - 10F);
            CallMethodIn("AdjustCannonPosition", 3F + GameObject.RandomFloat(3F));
        }

        void AdjustOrientation()
        {
            if(m_Target == null)
            {
                GameObject.CrashLog("[AICannon] No target!");
                StopDelayedFire();
                return;
            }
            Vector target = m_Target.GetPointToLookAt(0);
            Vector forward = m_OwnerMesh.GetElementForwardVector(m_nElementBarrel);
            Vector pos = m_OwnerMesh.GetElementPos(m_nElementCenter);
            pos = m_OwnerMesh.PointWorldToLocal(pos);
            forward = m_OwnerMesh.VectorWorldToLocal(forward);
            forward.Normalize();
            target = m_OwnerMesh.PointWorldToLocal(target);
            target.Sub(pos);
            Vector targetNorm = new Vector(target);
            targetNorm.Normalize();
            if(targetNorm.Dot(forward) > m_fFiringAngleEpsilonCos)
            {
                if(m_OwnerMesh.CheckTraceAbsolute(m_Target, GetTargetTracingOrigin(), m_Target.GetPointToLookAt(0)))
                {
                    if(nCurrentMode == 0)
                    {
                        StartDelayedFire();
                        m_bClearShot = true;
                    }
                } else
                {
                    StopDelayedFire();
                    m_bClearShot = false;
                }
            } else
            if(nCurrentMode != 0)
            {
                StopDelayedFire();
                m_bClearShot = false;
            }
            if(targetNorm.Dot(forward) < m_fAimingAngleEpsilonCos)
            {
                Vector targetXZ = new Vector(target);
                targetXZ.fY = 0.0F;
                targetXZ.Normalize();
                Vector forwardXZ = new Vector(forward);
                forwardXZ.fY = 0.0F;
                forwardXZ.Normalize();
                float fAngleDiff = targetXZ.Dot(forwardXZ);
                if(fAngleDiff < m_fAimingAngleEpsilonCos)
                {
                    float fAngle = (SafeACOS(targetXZ.Dot(m_vVectorForward)) * 180F) / 3.14F;
                    if(targetXZ.Dot(m_vVectorRight) < 0.0F)
                        fAngle = -fAngle;
                    RotateGunHoriz(fAngle, false);
                }
                fAngleDiff = SafeACOS(targetNorm.Dot(m_vVectorUp)) - SafeACOS(forward.Dot(m_vVectorUp));
                if(Math.abs(fAngleDiff) > m_fAimingAngleEpsilon)
                {
                    float fAngle = (SafeACOS(targetNorm.Dot(m_vVectorUp)) * 180F) / 3.14F;
                    fAngle -= m_fInitAngleV;
                    if(fAngle > m_fMaxVAngle)
                        fAngle = m_fMaxVAngle;
                    else
                    if(fAngle < m_fMinVAngle)
                        fAngle = m_fMinVAngle;
                    RotateGunVert(fAngle, false);
                }
            }
        }

        public void OnEnter()
        {
            CallMethodEvery("AdjustOrientation", 0.1F);
            if(m_bGunAdvanced)
                AdjustCannonPosition();
        }

        public HuntingState()
        {
        }
    }

    public class AutonomicHuntingState extends HuntingState
    {

        public void RecalculateTargets()
        {
            ChromeActor cBestTarget = null;
            if(nTargetsCount > 0)
            {
                Vector vBarrelDir = m_OwnerMesh.GetElementForwardVector(m_nElementBarrel);
                Vector vOrigin = m_OwnerMesh.GetElementPos(m_nElementBarrel);
                Vector vDriveDir = m_OwnerMesh.GetForwardVector();
                float fMetric = 0.0F;
                float fMinDistMetric = 2.0F;
                for(int i = 0; i < nTargetsCount; i++)
                {
                    ChromeActor cCurrTarget = aTargets[i];
                    if(!((Actor) (cCurrTarget)).bDead && IsInsideForwardCone(cCurrTarget, m_fTargetFindingAngleCos))
                    {
                        fMetric = GetTargetDistanceMetric(cCurrTarget, vDriveDir, vBarrelDir, vOrigin);
                        if(fMetric < fMinDistMetric && m_OwnerMesh.CheckTraceAbsolute(cCurrTarget, GetTargetTracingOrigin(), cCurrTarget.GetPointToLookAt(0)))
                        {
                            cBestTarget = cCurrTarget;
                            fMinDistMetric = fMetric;
                        }
                    }
                }

            }
            m_Target = cBestTarget;
            DisableCallMethod("RecalculateTargets");
            CallMethodIn("RecalculateTargets", _RECALC_TARGETS_TIME + GameObject.RandomFloat(_RECALC_TARGETS_TIME) * 0.1F);
        }

        float GetTargetDistanceMetric(ChromeActor cTarget, Vector vDriveDir, Vector vBarrelDir, Vector vPosition)
        {
            Vector vTgtDir = cTarget.GetPosition();
            vTgtDir.Sub(vPosition);
            float fDistance = vTgtDir.Len();
            if(fDistance > 0.0F)
            {
                vTgtDir.Mul(1.0F / fDistance);
                float fGunDot = vBarrelDir.Dot(vTgtDir);
                float fDriveDot = vDriveDir.Dot(vTgtDir);
                float fMetric = 0.5F * (1.0F - fGunDot) * m_fAngleImportance + (fDistance / fRange) * m_fDistanceImportance + 0.5F * (1.0F - fDriveDot) * m_fForwardImportance;
                fMetric /= m_fAngleImportance + m_fDistanceImportance + m_fForwardImportance;
                if(fMetric < 0.0F)
                    fMetric = 0.0F;
                else
                if(fMetric > 1.0F)
                    fMetric = 1.0F;
                return fMetric;
            } else
            {
                return 0.0F;
            }
        }

        boolean IsInsideForwardCone(ControlObject cObj, float fConeAngleCos)
        {
            Vector vObjDir = cObj.GetPosition();
            vObjDir.Sub(m_OwnerMesh.GetPosition());
            vObjDir.Normalize();
            return m_OwnerMesh.GetForwardVector().Dot(vObjDir) > fConeAngleCos;
        }

        public void SGUpdate()
        {
            FileChunk.Log("[CannonController$AutonomicHuntingState] : SGUpdate\n");
            super.SGUpdate();
            if(IsActiveOnModule())
            {
                GetAllTargets();
                RecalculateTargets();
            }
            if(!m_bActiveInAutoMode)
                StopDelayedFire();
        }

        public void AdjustOrientation()
        {
            if(!m_bActiveInAutoMode)
            {
                StopDelayedFire();
                return;
            }
            if(m_Target != null && !((Actor) (m_Target)).bDead && IsInsideForwardCone(m_Target, m_fTargetHoldingAngleCos))
            {
                super.AdjustOrientation();
            } else
            {
                StopDelayedFire();
                SetIdlePosition();
            }
        }

        void AdjustCannonPosition()
        {
            if(CurrentState instanceof IdleState)
                SetActiveIdlePosition();
            else
                SetCannonPosition((45F + GameObject.RandomFloat(20F)) - 10F);
            CallMethodIn("AdjustCannonPosition", 3F + GameObject.RandomFloat(3F));
        }

        public void OnEnter()
        {
            super.OnEnter();
            GetAllTargets();
            RecalculateTargets();
            if(!m_bActiveInAutoMode)
                StopDelayedFire();
        }

        public void GetAllTargets()
        {
            m_fGetTargetsDistMax = fRange * 0.5F;
            float fNextGetAllTargetsCall = _GET_TARGETS_TIME_MAX;
            Vector vPos = GetPosition();
            if(m_vLastCannonPos == null)
                m_vLastCannonPos = vPos;
            float fDist = vPos.Distance(m_vLastCannonPos);
            if(fDist > 1.0F)
            {
                if(fDist > fRange)
                    fDist = fRange;
                fNextGetAllTargetsCall = (1.0F - fDist / fRange) * (_GET_TARGETS_TIME_MAX - _GET_TARGETS_TIME_MIN) + _GET_TARGETS_TIME_MIN;
                m_vTargetGetPos.Set(vPos);
                m_vTargetGetPos.Sub(m_vLastCannonPos);
                m_vTargetGetPos.Normalize();
                m_vTargetGetPos.Mul((fDist / fRange) * (m_fGetTargetsDistMax - m_fGetTargetsDistMin) + m_fGetTargetsDistMin);
                m_vTargetGetPos.Add(vPos);
            } else
            {
                m_vTargetGetPos.Set(vPos);
            }
            m_vLastCannonPos = vPos;
            DisableCallMethod("GetAllTargets");
            CallMethodIn("GetAllTargets", fNextGetAllTargetsCall + GameObject.RandomFloat(fNextGetAllTargetsCall) * 0.1F);
            FindAllPossibleTargets();
        }

        void SetActiveIdlePosition()
        {
            m_OwnerMesh.SetAnimMorphTime(m_nElementV, m_fCannonVertMorphTime, false);
            m_OwnerMesh.SetAnimMorphTime(m_nElementH, 0.5F, false);
            m_OwnerMesh.RotateElementWithAnim(m_nElementV, m_vVectorRight, 0.0F);
            m_OwnerMesh.RotateElementWithAnim(m_nElementH, m_vVectorUp, 180F);
        }

        void FindAllPossibleTargets()
        {
            ControlObject aActors[] = m_OwnerMesh.GetObjectsInRadiusOfFlagsFromClass(m_vTargetGetPos, fRange, 0x2000000, null);
            ChromeActor cCurrent = null;
            nTargetsCount = 0;
            for(int i = 0; i < aActors.length; i++)
                if(aActors[i] instanceof ChromeActor)
                {
                    cCurrent = (ChromeActor)aActors[i];
                    if(!((Actor) (cCurrent)).bDead && cCurrent.IsEnemy(m_nOwnerSide) && IsInsideForwardCone(cCurrent, m_fTargetFindingAngleCos))
                    {
                        aTargets[nTargetsCount++] = cCurrent;
                        if(nTargetsCount == _MAX_TARGETS)
                            return;
                    }
                }

        }

        int _MAX_TARGETS;
        int nTargetsCount;
        ChromeActor aTargets[];
        float _GET_TARGETS_TIME_MIN;
        float _GET_TARGETS_TIME_MAX;
        float m_fGetTargetsDistMin;
        float m_fGetTargetsDistMax;
        Vector m_vLastCannonPos;
        Vector m_vTargetGetPos;
        float _RECALC_TARGETS_TIME;

        public AutonomicHuntingState()
        {
            _MAX_TARGETS = 100;
            nTargetsCount = 0;
            aTargets = new ChromeActor[_MAX_TARGETS];
            _GET_TARGETS_TIME_MIN = 0.5F;
            _GET_TARGETS_TIME_MAX = 2.0F;
            m_fGetTargetsDistMin = 0.0F;
            m_fGetTargetsDistMax = 0.0F;
            m_vLastCannonPos = null;
            m_vTargetGetPos = new Vector();
            _RECALC_TARGETS_TIME = 0.5F;
        }
    }


    public boolean HasClearShot()
    {
        return m_bClearShot;
    }

    public Vector GetFireDir()
    {
        Vector target = null;
        if(m_Target != null)
        {
            target = m_Target.GetPointToLookAt(0);
            target.Sub(GetFireOrigin());
            target.Normalize();
        } else
        {
            target = m_OwnerMesh.GetElementForwardVector(m_nElementV);
        }
        float fTempAimMult;
        if(m_CannonUser instanceof Player)
            fTempAimMult = ((Player)m_CannonUser).fCurrentAccuracy;
        else
            fTempAimMult = fAimMultiplier * ChromeGame.GetCannonAimingDiffLevelMult();
        Vector vDev = new Vector(((GameObject.RandomFloat(1.0F) - 0.5F) * fTempAimMult) / 100F, ((GameObject.RandomFloat(1.0F) - 0.5F) * fTempAimMult) / 100F, ((GameObject.RandomFloat(1.0F) - 0.5F) * fTempAimMult) / 100F);
        target.Add(vDev);
        target.Normalize();
        return target;
    }

    public float GetAimAccChange()
    {
        return super.fAimAcc;
    }

    public Vector GetFireOrigin()
    {
        return m_OwnerMesh.GetElementPos(m_nElementBarrelExit);
    }

    public void SetAmmo(int nAmmoCount)
    {
        super.nAmmo = nAmmoCount;
    }

    public String GetStateName()
    {
        if(super.CurrentState != null)
        {
            int i = super.CurrentState.getClass().getName().lastIndexOf("$");
            if(i == -1)
                return new String(super.CurrentState.getClass().getName());
            else
                return new String(super.CurrentState.getClass().getName().substring(i + 1));
        } else
        {
            return null;
        }
    }

    public void SetShotSoundRange(float fMin, float fMax)
    {
        super.fMinShootSound = fMin;
        super.fMaxShootSound = fMax;
    }

    void SetIdlePosition()
    {
        m_OwnerMesh.SetElementAnimType(m_nElementV, (byte)3, false);
        m_OwnerMesh.SetElementAnimType(m_nElementH, (byte)3, false);
        SetCannonPosition(0.0F);
        ToStartPos();
    }

    public void SetFXSizeX(float fSize)
    {
        fFXBeamSizeX = fSize;
    }

    public void SetVertAngSpeed(float fSpeed)
    {
        m_fVertAngSpeed = fSpeed;
    }

    void LoadMeshElement(FileChunk cFC, int nMeshElementID)
    {
        Vector vForward = cFC.LoadVector();
        Vector vUp = cFC.LoadVector();
        Vector vPos = cFC.LoadVector();
        m_OwnerMesh.FromUpForwardPosElementWorld(nMeshElementID, vUp, vForward, vPos);
    }

    public float GetBaseAccuracy()
    {
        return super.fBaseAcc;
    }

    public void OnReplicateServer()
    {
        super.OnReplicateServer();
        if(m_PlayerManual != null && !((GameObject) (m_PlayerManual)).bNetIsOwner)
            Replicate(m_nSetState);
    }

    public ICannonMesh GetOwnerMesh()
    {
        return m_OwnerMesh;
    }

    public void StopAutonomicHunting()
    {
        m_CannonUser = null;
        m_Target = null;
        StopDelayedFire();
        SetState("IdleState");
    }

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[CannonController.SGSaveChunk]\n");
        FileChunk cFC = GameObject.NewChunk(1137, cFCParent);
        super.SGSaveChunk(cFC);
        cFC.SaveObjectRef((MeshObject)m_OwnerMesh);
        cFC.SaveObjectRef(m_CannonUser);
        cFC.SaveInt(m_nOwnerSide);
        cFC.SaveFloat(m_fInitAngleV);
        cFC.SaveFloat(m_fTargetFindingAngle);
        cFC.SaveFloat(m_fTargetHoldingAngle);
        cFC.SaveFloat(m_fTargetFindingAngleCos);
        cFC.SaveFloat(m_fTargetHoldingAngleCos);
        cFC.SaveObjectRef(m_Target);
        cFC.SaveBool(m_bClearShot);
        cFC.SaveFloat(m_fLongDelay);
        cFC.SaveFloat(m_fShotDeviation);
        cFC.SaveFloat(m_fHorizAngSpeed);
        cFC.SaveFloat(m_fVertAngSpeed);
        cFC.SaveBool(m_bGunAdvanced);
        cFC.SaveVector(m_vVectorForward);
        cFC.SaveVector(m_vVectorRight);
        cFC.SaveVector(m_vVectorUp);
        cFC.SaveBool(m_bInManualMode);
        cFC.SaveFloat(m_fInitialFireDelay);
        cFC.SaveBool(m_bFireAllowed);
        cFC.SaveBool(m_bAllowMethodCalled);
        cFC.SaveString(m_strOldState);
        cFC.SaveFloat(fAimMultiplier);
        cFC.SaveBool(m_bActiveInAutoMode);
        cFC.SaveObjectRef(m_PlayerManual);
        cFC.SaveFloat(m_fLastHorizAngle);
        cFC.SaveFloat(m_fLastVertAngle);
        cFC.SaveVector(m_vAimAtPoint);
        cFC.SaveInt(m_iLastCameraMode);
        cFC.SaveInt(m_iOldState);
        cFC.SaveFloat(m_fMaxHAngle);
        cFC.SaveFloat(m_fMinVAngle);
        cFC.SaveFloat(m_fMaxVAngle);
        cFC.SaveVector(m_vForwardDelta);
        cFC.SaveFloat(m_fAngleImportance);
        cFC.SaveFloat(m_fDistanceImportance);
        cFC.SaveFloat(m_fForwardImportance);
        cFC.SaveString(sParticleSystem);
        cFC.SaveFloat(fFXBeamSizeX);
        cFC.SaveFloat(m_fExecuteBeamProbability);
        cFC.SaveFloat(fMinBeamDistance);
        cFC.SaveInt(m_nOldRoundShots);
        cFC.SaveFloat(m_fOldVertAngSpeed);
        cFC.SaveFloat(m_fOldHorizAngSpeed);
        SaveMeshElement(cFC, m_nElementBarrel);
        SaveMeshElement(cFC, m_nElementBarrelExit);
        SaveMeshElement(cFC, m_nElementCenter);
        SaveMeshElement(cFC, m_nElementH);
        SaveMeshElement(cFC, m_nElementV);
        cFC.SaveBool(((Player) (((ChromeModuleSingle)GetModule()).MainPlayer)).Camera.m_HeavyWeapon == this);
        cFC.delete();
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[CannonController.SGLoadChunk]\n");
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        if(cFC.GetID() == 1137)
        {
            super.SGLoadChunk(cFC);
            m_OwnerMesh = (ICannonMesh)cFC.LoadObjectRef();
            ReInit();
            m_CannonUser = (ChromeActor)cFC.LoadObjectRef();
            m_nOwnerSide = cFC.LoadInt();
            m_fInitAngleV = cFC.LoadFloat();
            m_fTargetFindingAngle = cFC.LoadFloat();
            m_fTargetHoldingAngle = cFC.LoadFloat();
            m_fTargetFindingAngleCos = cFC.LoadFloat();
            m_fTargetHoldingAngleCos = cFC.LoadFloat();
            m_Target = (ChromeActor)cFC.LoadObjectRef();
            m_bClearShot = cFC.LoadBool();
            m_fLongDelay = cFC.LoadFloat();
            m_fShotDeviation = cFC.LoadFloat();
            m_fHorizAngSpeed = cFC.LoadFloat();
            m_fVertAngSpeed = cFC.LoadFloat();
            m_bGunAdvanced = cFC.LoadBool();
            m_vVectorForward = cFC.LoadVector();
            m_vVectorRight = cFC.LoadVector();
            m_vVectorUp = cFC.LoadVector();
            m_bInManualMode = cFC.LoadBool();
            m_fInitialFireDelay = cFC.LoadFloat();
            m_bFireAllowed = cFC.LoadBool();
            m_bAllowMethodCalled = cFC.LoadBool();
            m_strOldState = cFC.LoadString();
            fAimMultiplier = cFC.LoadFloat();
            m_bActiveInAutoMode = cFC.LoadBool();
            m_PlayerManual = (PlayerHUD)cFC.LoadObjectRef();
            m_fLastHorizAngle = cFC.LoadFloat();
            m_fLastVertAngle = cFC.LoadFloat();
            m_vAimAtPoint = cFC.LoadVector();
            m_iLastCameraMode = (byte)cFC.LoadInt();
            m_iOldState = cFC.LoadInt();
            m_fMaxHAngle = cFC.LoadFloat();
            m_fMinVAngle = cFC.LoadFloat();
            m_fMaxVAngle = cFC.LoadFloat();
            m_vForwardDelta = cFC.LoadVector();
            m_fAngleImportance = cFC.LoadFloat();
            m_fDistanceImportance = cFC.LoadFloat();
            m_fForwardImportance = cFC.LoadFloat();
            sParticleSystem = cFC.LoadString();
            fFXBeamSizeX = cFC.LoadFloat();
            m_fExecuteBeamProbability = cFC.LoadFloat();
            fMinBeamDistance = cFC.LoadFloat();
            m_nOldRoundShots = cFC.LoadInt();
            m_fOldVertAngSpeed = cFC.LoadFloat();
            m_fOldHorizAngSpeed = cFC.LoadFloat();
            LoadMeshElement(cFC, m_nElementBarrel);
            LoadMeshElement(cFC, m_nElementBarrelExit);
            LoadMeshElement(cFC, m_nElementCenter);
            LoadMeshElement(cFC, m_nElementH);
            LoadMeshElement(cFC, m_nElementV);
            if(cFC.LoadBool())
                ((Player) (((ChromeModuleSingle)GetModule()).MainPlayer)).Camera.m_HeavyWeapon = this;
        }
        cFC.delete();
    }

    public void SetMinVertAngle(float fMinVertAngle)
    {
        m_fMinVAngle = fMinVertAngle;
    }

    public float GetMaxHorizAngle()
    {
        return m_fMaxHAngle;
    }

    public void StartAutonomicHuntingByUser(ChromeActor cUser)
    {
        m_CannonUser = cUser;
        m_nOwnerSide = cUser.cConflictSide.GetValue();
        SetState("AutonomicHuntingState");
    }

    public float GetTargetHoldingAngle()
    {
        return m_fTargetHoldingAngle;
    }

    public void SetMinBeamDistance(float fDistance)
    {
        fMinBeamDistance = fDistance;
    }

    public void SetInitialFireDelay(float fDelay)
    {
        m_fInitialFireDelay = fDelay;
    }

    public void SetCombFX(String sCombName)
    {
        super.sFXCombName = sCombName;
    }

    void MessageLongDelay(float f)
    {
    }

    public void SetParticleSystem(String sParticleSystem)
    {
        this.sParticleSystem = sParticleSystem;
    }

    public void Die()
    {
        FreezeCallMethods();
        DeactivateOnModuleAlways();
    }

    public void SGUpdate()
    {
        FileChunk.Log("[CannonController.SGUpdate]\n");
        super.SGUpdate();
        if(m_CannonUser != null)
        {
            m_CannonUser.UnregisterMouseAxisRequest();
            m_CannonUser.UnregisterMouseButtonRequest();
            RegisterKeyRequest();
            RegisterMouseButtonRequest();
        } else
        {
            UnregisterKeyRequest();
            UnregisterMouseButtonRequest();
        }
    }

    void MsgSendClientState()
    {
        if(super.Role < 4)
        {
            return;
        } else
        {
            MessageNew(10);
            MessagePackInt(m_OwnerMesh == null ? -1 : m_OwnerMesh.GetNetId());
            MessageSend();
            return;
        }
    }

    void SetHorizAnimMorphTime(float fAnimMorphTime)
    {
        m_OwnerMesh.SetAnimMorphTime("Gun_podstawa", fAnimMorphTime);
        m_OwnerMesh.SetAnimMorphTime("Gun_lufy", fAnimMorphTime);
    }

    public ChromeActor GetTarget()
    {
        return m_Target;
    }

    public void SetAimMultiplier(float fMul)
    {
        fAimMultiplier = fMul;
    }

    public void AimAtPoint(Vector target)
    {
        m_fAimX = target.fX;
        m_fAimY = target.fY;
        m_fAimZ = target.fZ;
        Vector forward = m_OwnerMesh.GetElementForwardVector(m_nElementBarrel);
        Vector vDiff = new Vector();
        m_OwnerMesh.GetRenderPosition(vDiff, null, null);
        vDiff.Sub(m_OwnerMesh.GetPosition());
        Vector pos = m_OwnerMesh.GetElementPos(m_nElementCenter);
        pos.Add(vDiff);
        pos = m_OwnerMesh.PointWorldToLocal(pos);
        forward = m_OwnerMesh.VectorWorldToLocal(forward);
        forward.Normalize();
        target = m_OwnerMesh.PointWorldToLocal(target);
        target.Sub(pos);
        Vector targetNorm = new Vector(target);
        targetNorm.Normalize();
        Vector targetXZ = new Vector(target);
        targetXZ.fY = 0.0F;
        targetXZ.Normalize();
        Vector forwardXZ = new Vector(forward);
        forwardXZ.fY = 0.0F;
        forwardXZ.Normalize();
        float fAngle = (SafeACOS(targetXZ.Dot(m_vVectorForward)) * 180F) / 3.14F;
        if(targetXZ.Dot(m_vVectorRight) < 0.0F)
            fAngle = -fAngle;
        RotateGunHoriz(fAngle, true);
        float fAngleDiff = SafeACOS(targetNorm.Dot(m_vVectorUp)) - SafeACOS(forward.Dot(m_vVectorUp));
        fAngle = (SafeACOS(targetNorm.Dot(m_vVectorUp)) * 180F) / 3.14F;
        fAngle -= m_fInitAngleV;
        if(fAngle > m_fMaxVAngle)
            fAngle = m_fMaxVAngle;
        else
        if(fAngle < m_fMinVAngle)
            fAngle = m_fMinVAngle;
        RotateGunVert(fAngle, true);
    }

    static boolean HasCannonMounted(MeshObject mesh)
    {
        return mesh.GetElementID("Gun_podstawa") != -1 && mesh.GetElementID("Gun_lufy") != -1;
    }

    public void OnReplicateClient()
    {
        super.OnReplicateServer();
        if(m_PlayerManual != null && ((GameObject) (m_PlayerManual)).bNetIsOwner)
            Replicate(m_nSetState);
    }

    public void SetFireParams(int nShots, float fRateOfFire, float fLongDelay, float fRange, float fDamage)
    {
        if(nShots != -1)
            super.nRoundShots = nShots;
        if(fRateOfFire != -1F)
            SetRateOfFire(fRateOfFire);
        if(fLongDelay != -1F)
            m_fLongDelay = fLongDelay;
        if(fRange != -1F)
            super.fRange = fRange;
        if(fDamage != -1F)
        {
            super.fDamage = fDamage;
            super.fPhysicsSimDamage = fDamage;
        }
    }

    public void SuperStartFire(byte nMode)
    {
        if(super.m_bNetModule)
        {
            if(m_PlayerManual != null && ((GameObject) (m_PlayerManual)).bNetIsOwner)
                SuperStartFireDo(nMode);
            else
                GameObject.LogR("SuperStartFire failed\n");
        } else
        {
            SuperStartFireDo(nMode);
        }
    }

    public void StartDelayedFire()
    {
        if(!m_bAllowMethodCalled)
        {
            m_bAllowMethodCalled = true;
            CallMethodIn("AllowFire", m_fInitialFireDelay);
        }
        if(!m_bFireAllowed)
        {
            return;
        } else
        {
            StartFire((byte)2);
            return;
        }
    }

    public void StopDelayedFire()
    {
        StopFire();
        DisableCallMethod("AllowFire");
        m_bFireAllowed = false;
        m_bAllowMethodCalled = false;
    }

    public void InitController(ICannonMesh cOwnerMesh)
    {
        m_OwnerMesh = cOwnerMesh;
        m_OwnerMesh.SetFlag(0x100000);
        AttachAsChildTo((MeshObject)m_OwnerMesh);
        EnableRendering(false);
        ClearFlag(1);
        ClearFlag(32);
        m_nElementH = m_OwnerMesh.GetElementID(m_sElementH);
        m_nElementV = m_OwnerMesh.GetElementID(m_sElementV);
        m_nElementCenter = m_OwnerMesh.GetElementID(m_sElementCenterNew);
        if(m_nElementCenter == -1)
            m_nElementCenter = m_OwnerMesh.GetElementID(m_sElementCenterOld);
        m_nElementBarrel = m_OwnerMesh.GetElementID(m_sElementBarrel);
        m_nElementBarrelExit = m_OwnerMesh.GetElementID(m_sElementBarrelExit);
        m_vVectorForward = m_OwnerMesh.GetElementForwardVector(m_nElementBarrel);
        m_vVectorForward = m_OwnerMesh.VectorWorldToLocal(m_vVectorForward);
        m_vVectorForward.Normalize();
        m_vVectorUp = m_OwnerMesh.GetElementUpVector(m_nElementBarrel);
        m_vVectorUp = m_OwnerMesh.VectorWorldToLocal(m_vVectorUp);
        m_vVectorUp.Normalize();
        m_vVectorRight = m_vVectorUp.Cross(m_vVectorForward);
        m_vVectorRight.Normalize();
        Vector forward = new Vector(m_vVectorForward);
        m_fInitAngleV = (SafeACOS(forward.Dot(m_vVectorUp)) * 180F) / 3.14F;
        m_bGunAdvanced = m_OwnerMesh.GetElementID("Gun_ramie") != -1;
        if(m_bGunAdvanced)
            m_OwnerMesh.SetElementAnimType(m_OwnerMesh.GetElementID("Gun_ramie"), (byte)3, true);
        else
            m_OwnerMesh.SetElementAnimType(m_OwnerMesh.GetElementID("Gun_podstawa"), (byte)3, true);
        m_OwnerMesh.SetAnimMorphTime(0.5F);
        SetTargetFindingAngle(m_fTargetFindingAngle);
        SetMaxHorizAngle(m_fMaxHAngle);
        if(m_bGunAdvanced)
        {
            m_OwnerMesh.SetAnimMorphTime("Gun_podstawa2", m_fCannonVertMorphTime);
            m_OwnerMesh.SetAnimMorphTime("Gun_ramie", m_fCannonVertMorphTime);
        }
        SetState("IdleState");
        m_vCannonToParentDiff.Set(GetCannonOrigin());
        m_vCannonToParentDiff.Sub(m_OwnerMesh.GetPositionVectorVolatile());
        m_vCannonToParentDiff = VectorWorldToLocal(m_vCannonToParentDiff);
        MsgSendClientState();
    }

    void Fire(Vector v)
    {
        Vector vBarrel = GetFireOrigin();
        Vector vDir = v;
        if(!CheckIfCanLocalFire(m_CannonUser, vBarrel, vDir))
        {
            return;
        } else
        {
            Fire(vBarrel, vDir);
            return;
        }
    }

    void Fire(Vector vBarrel, Vector vDir)
    {
        if(m_OwnerMesh.GetRole() == 4)
            super.nAmmo--;
        super.fLastShotT = GetTime();
        float fDist = FireBullet(vBarrel, vDir);
        if(super.sFXCombName != null)
            m_OwnerMesh.ExecuteFX((MeshObject)m_OwnerMesh, m_sElementBarrelExit, super.sFXCombName, new Vector(0.0F, 0.0F, 0.0F));
        m_vForwardDelta = vDir.Sub2(m_OwnerMesh.GetElementForwardVector(m_nElementBarrel));
        if(CanExecuteBeam() && GameObject.RandomFloat(1.0F) < m_fExecuteBeamProbability)
        {
            m_OwnerMesh.SetFXSizeX(fFXBeamSizeX);
            m_OwnerMesh.SetFXZero(0.0F);
            if(fDist <= super.fRange)
            {
                m_OwnerMesh.SetFXSizeY(fDist - fMinBeamDistance);
                m_OwnerMesh.SetFXPosY(fDist / 2.0F + fMinBeamDistance / 2.0F);
            } else
            {
                m_OwnerMesh.SetFXSizeY(super.fRange - fMinBeamDistance);
                m_OwnerMesh.SetFXPosY(super.fRange / 2.0F + fMinBeamDistance / 2.0F);
            }
            m_OwnerMesh.ExecuteFX(sBeamName, vBarrel, vDir);
        }
        m_OwnerMesh.PlaySound(super.sSoundShoot, super.fMinShootSound, super.fMaxShootSound);
        m_OwnerMesh.MakeNoise(super.fNoiseShot, 2);
    }

    public boolean StartManualControl(Pawn cUser, float fOverGunHeight, float fOverGunBack, float fOverGunHeightAim, float fOverGunBackAim, float fOverGunFOV, float fOverGunAimFOV, 
            boolean bUseGyro)
    {
        if(m_CannonUser != null)
            return false;
        if(cUser == null)
            return false;
        if(cUser instanceof Player)
        {
            Player cPlayer = (Player)cUser;
            if(((GameObject) (cPlayer)).bNetIsOwner)
            {
                if((double)Math.abs(fOverGunHeight - fOverGunHeightAim) < 0.01D && (double)Math.abs(fOverGunBack - fOverGunBackAim) < 0.01D)
                    cPlayer.Camera.SetCameraOverGunPosition(fOverGunHeight, fOverGunBack, fOverGunFOV, fOverGunAimFOV);
                else
                    cPlayer.Camera.SetCameraOverGunPosition(fOverGunHeight, fOverGunBack, fOverGunHeightAim, fOverGunBackAim, fOverGunFOV, fOverGunAimFOV);
                cPlayer.Camera.SetWeaponToViewOver(this, (MeshObject)m_OwnerMesh, bUseGyro);
                m_iLastCameraMode = cPlayer.Camera.GetMode();
                cPlayer.Camera.SetMode((byte)5);
                RegisterMouseButtonRequest();
                RegisterKeyRequest();
                RegisterMouseAxisRequest();
            } else
            if(super.Role == 4)
                EnableIncomingReplication(true);
            m_fOldVertAngSpeed = m_fVertAngSpeed;
            m_fOldHorizAngSpeed = m_fHorizAngSpeed;
            SetVertAngSpeed(100F);
            SetHorizAngSpeed(500F);
            m_strOldState = GetStateName();
            m_CannonUser = cUser;
            m_nOldRoundShots = super.nRoundShots;
            super.nRoundShots = 0;
            SetHorizAnimMorphTime(0.0F);
            if(m_bGunAdvanced)
            {
                m_OwnerMesh.SetAnimMorphTime("Gun_podstawa2", 0.0F);
                m_OwnerMesh.SetAnimMorphTime("Gun_ramie", 0.0F);
            }
            SetState("ManualControlState");
            SetPlayerManual(cPlayer);
            m_bInManualMode = true;
            return true;
        } else
        {
            return false;
        }
    }

    public void StopManualControl()
    {
        Player player = (Player)m_CannonUser;
        if(player != null && ((GameObject) (player)).bNetIsOwner && player.Camera != null)
        {
            player.Camera.RestoreCameraDefaults();
            player.Camera.SetMode(m_iLastCameraMode);
            player.Camera.m_fAngleV = 0.0F;
            player.Camera.m_fAngleH = 0.0F;
        }
        if(super.Role == 4)
            EnableIncomingReplication(false);
        RestoreParamsAfterManualMode();
        m_CannonUser = null;
        UnregisterKeyRequest();
        UnregisterMouseButtonRequest();
        UnregisterMouseAxisRequest();
        if(m_strOldState != null)
            SetState(m_strOldState);
        SetPlayerManual(null);
        SetIdlePosition();
        StopFire();
    }

    float RotateGunHoriz(float fAngle, boolean bUltraFast)
    {
        float fTime = 0.0F;
        float fDelta = fAngle - m_fLastHorizAngle;
        if(bUltraFast)
        {
            m_OwnerMesh.RotateElement(m_nElementH, m_vVectorUp, fDelta);
            m_fLastHorizAngle += fDelta;
        } else
        {
            fTime = Math.abs(fAngle) / m_fHorizAngSpeed;
            m_OwnerMesh.SetAnimMorphTime(m_nElementH, fTime, false);
            m_OwnerMesh.RotateElementWithAnim(m_nElementH, m_vVectorUp, fAngle);
            m_fLastHorizAngle = fAngle;
        }
        return fTime;
    }

    public void SuperStartFireDo(byte nMode)
    {
        bDisableStopFire = true;
        super.StartFire(nMode);
        bDisableStopFire = false;
        m_bFiringState = m_bFiring = true;
    }

    public void SetHorizAngSpeed(float fSpeed)
    {
        m_fHorizAngSpeed = fSpeed;
    }

    public void ReplicationInit()
    {
        super.ReplicationInit();
        m_nSetState = NewReplicationSet("m_bPreFiring;m_bFiring;m_fAimX;m_fAimY;m_fAimZ");
    }

    public void ActivateInAutoMode(boolean bActivate)
    {
        m_bActiveInAutoMode = bActivate;
    }

    public boolean IsActiveInAutoMode()
    {
        return m_bActiveInAutoMode;
    }

    void SetRateOfFire(float fRate)
    {
        super.fRateOfFire = fRate;
        super.fDelay = 60F / super.fRateOfFire;
    }

    public void AllowFire()
    {
        m_bFireAllowed = true;
    }

    public void ToStartPos()
    {
        if(m_fLastHorizAngle == 0.0F)
            return;
        if(Math.abs(m_fLastHorizAngle) < 1.0F)
            RotateGunHoriz(0.0F, false);
        float fAngle = m_fLastHorizAngle / 2.0F;
        RotateGunHoriz(fAngle, false);
        if(m_fLastVertAngle == 0.0F)
            return;
        if(Math.abs(m_fLastVertAngle) < 1.0F)
            RotateGunVert(0.0F, false);
        fAngle = m_fLastVertAngle / 2.0F;
        RotateGunVert(fAngle, false);
        if(m_fLastHorizAngle == 0.0F && m_fLastVertAngle == 0.0F)
        {
            return;
        } else
        {
            CallMethodIn("ToStartPos", 0.07F);
            return;
        }
    }

    public void SetTargetFindingAngle(float fFindingAngle)
    {
        m_fTargetFindingAngle = fFindingAngle;
        m_fTargetFindingAngleCos = (float)Math.cos(((double)m_fTargetFindingAngle * 3.1415926535897931D) / 180D);
    }

    public float GetMinVertAngle()
    {
        return m_fMinVAngle;
    }

    public void SetMaxVertAngle(float fMaxVertAngle)
    {
        m_fMaxVAngle = fMaxVertAngle;
    }

    protected void FireModeSingle()
    {
        Fire(GetFireDir());
        SendWeaponMessage(1);
        super.nShots++;
    }

    float SafeACOS(float fValue)
    {
        if(fValue <= -1F)
            return 3.141593F;
        if(fValue >= 1.0F)
            return 0.0F;
        else
            return (float)Math.acos(fValue);
    }

    float FireBullet(Vector vBarrel, Vector vDir)
    {
        if(m_OwnerMesh instanceof ChromeActor)
            super.cFBMesh = (ChromeActor)m_OwnerMesh;
        super.cHitOwner = ((ChromeActor) ((GetModule() instanceof ModuleNet) ? ((ChromeActor) (super.Owner)) : (ChromeActor)m_OwnerMesh));
        if(m_CannonUser instanceof Player)
        {
            CameraPlayer cCamera = ((Player)m_CannonUser).Camera;
            SetShakeImpulse();
            if(cCamera != null)
                cCamera.ShakeImpulse(vShakeImpulse, 6, false);
        }
        return super.FireBullet(vBarrel, vDir);
    }

    void MsgRecvClientState()
    {
        m_nOwnerMeshNetId = MessageUnPackInt();
        MessageEnd();
        if(m_nOwnerMeshNetId > -1)
            TryToInitController();
    }

    void SetPlayerManual(Player player)
    {
        if(player instanceof PlayerHUD)
        {
            m_PlayerManual = (PlayerHUD)player;
            super.Owner = player;
        } else
        {
            m_PlayerManual = null;
            super.Owner = null;
        }
    }

    public void StartAutonomicHuntingByConflictSide(int nConflictSide)
    {
        m_CannonUser = null;
        m_nOwnerSide = nConflictSide;
        SetState("AutonomicHuntingState");
    }

    float RotateGunVert(float fAngle, boolean bUltraFast)
    {
        float fTime = 0.0F;
        if(bUltraFast)
        {
            float fDelta = fAngle - m_fLastVertAngle;
            m_OwnerMesh.RotateElement(m_nElementV, Vector.Right, fDelta);
            m_fLastVertAngle += fDelta;
        } else
        {
            fTime = Math.abs(fAngle) / m_fVertAngSpeed;
            m_OwnerMesh.SetAnimMorphTime(m_nElementV, fTime, false);
            m_OwnerMesh.RotateElementWithAnim(m_nElementV, Vector.Right, fAngle);
            m_fLastVertAngle = fAngle;
        }
        return fTime;
    }

    public void SetFXHitName(String sFXHitName)
    {
        super.sFXHitName = sFXHitName;
    }

    void SendWeaponMessage(int i)
    {
    }

    void SetShakeImpulse()
    {
        vShakeImpulse.Set((fShakeImpulseForce / 2.0F) * GameObject.RandomFloat(-1F, 2.0F), GameObject.RandomFloat(1.0F) <= 0.5F ? -fShakeImpulseForce : fShakeImpulseForce, GameObject.RandomFloat(1.0F) <= 0.5F ? -fShakeImpulseForce : fShakeImpulseForce);
    }

    public void OnMessage()
    {
        switch(MessageGetId())
        {
        case 10: // '\n'
            GameObject.LogD(" MSG_CLIENT_STATE\n");
            MsgRecvClientState();
            break;

        default:
            super.OnMessage();
            break;
        }
    }

    public void AdjustEllipsoid()
    {
    }

    void SetCannonPosition(float fAngle)
    {
        if(!m_bGunAdvanced);
    }

    protected void FireModeAuto()
    {
        if(super.nCurrentMode == 2)
        {
            int nState = GetState();
            if((nState & 2) == 0 && (super.nRoundShots == 0 || super.nShots < super.nRoundShots))
            {
                SetFireModeSingle();
                if(super.nShots == super.nRoundShots)
                {
                    super.fLastShotT += m_fLongDelay - super.fDelay;
                    MessageLongDelay(m_fLongDelay);
                }
            } else
            {
                StopFire();
                SendWeaponMessage(nState);
            }
        }
    }

    public Vector GetCannonOrigin()
    {
        return m_OwnerMesh.GetElementPos(m_nElementV);
    }

    public void SetShotSound(String sSoundName)
    {
        super.sSoundShoot = sSoundName;
    }

    public Vector GetTargetTracingOrigin()
    {
        return m_OwnerMesh.GetElementPos(m_nElementH);
    }

    public CannonController()
    {
        m_sElementH = "Gun_podstawa";
        m_sElementV = "Gun_lufy";
        m_sElementCenterOld = "Gun_podstawa";
        m_sElementCenterNew = "OsGorna";
        m_sElementBarrel = "Gun_lufy";
        m_sElementBarrelExit = "Barrel";
        m_nElementH = -1;
        m_nElementV = -1;
        m_nElementCenter = -1;
        m_nElementBarrel = -1;
        m_nElementBarrelExit = -1;
        m_OwnerMesh = null;
        m_vForwardDelta = null;
        m_CannonUser = null;
        m_nOwnerSide = EnumConflictSide._NEUTRAL;
        m_fInitAngleV = 0.0F;
        sBeamName = "WeaponBeam";
        m_fTargetFindingAngle = 35F;
        m_fTargetHoldingAngle = 90F;
        m_fTargetFindingAngleCos = 0.0F;
        m_fTargetHoldingAngleCos = 0.0F;
        m_Target = null;
        m_bClearShot = false;
        m_fLongDelay = 1.0F;
        m_fShotDeviation = 0.0F;
        m_fAimingAngleEpsilon = 0.01745329F;
        m_fAimingAngleEpsilonCos = (float)Math.cos(m_fAimingAngleEpsilon);
        m_fFiringAngleEpsilonCos = (float)Math.cos(m_fAimingAngleEpsilon * 5F);
        m_fHorizAngSpeed = 500F;
        m_fVertAngSpeed = 500F;
        m_fAngleImportance = 5F;
        m_fDistanceImportance = 5F;
        m_fForwardImportance = 20F;
        m_bGunAdvanced = false;
        m_vVectorForward = null;
        m_vVectorRight = null;
        m_vVectorUp = null;
        m_bInManualMode = false;
        m_fMaxHAngle = 100F;
        m_fMinVAngle = -30F;
        m_fMaxVAngle = 30F;
        m_fInitialFireDelay = 0.5F;
        m_bFireAllowed = false;
        m_bAllowMethodCalled = false;
        m_fCannonVertMorphTime = 1.0F;
        m_strOldState = null;
        fAimMultiplier = 1.0F;
        m_bActiveInAutoMode = true;
        sParticleSystem = null;
        fFXBeamSizeX = 2.0F;
        m_fExecuteBeamProbability = 1.0F;
        fMinBeamDistance = 100F;
        m_vCannonToParentDiff = new Vector();
        m_vAimAtPoint = new Vector();
        m_PlayerManual = null;
        m_iLastCameraMode = 0;
        m_iOldState = 0;
        m_nOldRoundShots = 0;
        m_fOldVertAngSpeed = 0.0F;
        m_fOldHorizAngSpeed = 0.0F;
        m_fLastHorizAngle = 0.0F;
        m_fLastVertAngle = 0.0F;
        cFirePointer = null;
        vShakeImpulse = new Vector();
        fShakeImpulseForce = 150F;
        m_nOwnerMeshNetId = -1;
        m_bPreFiring = false;
        m_bPreFiringState = false;
        m_bFiring = false;
        m_bFiringState = false;
        bDisableStopFire = false;
        m_nFrame = 0;
        m_fAimX = 0.0F;
        m_fAimY = 0.0F;
        m_fAimZ = 0.0F;
        super.nAmmo = super.nCapacity = 0x7fffffff;
    }

    void RestoreParamsAfterManualMode()
    {
        if(!m_bInManualMode)
            return;
        if(m_bGunAdvanced)
        {
            m_OwnerMesh.SetAnimMorphTime("Gun_podstawa2", m_fCannonVertMorphTime);
            m_OwnerMesh.SetAnimMorphTime("Gun_ramie", m_fCannonVertMorphTime);
        }
        super.nRoundShots = m_nOldRoundShots;
        m_fVertAngSpeed = m_fOldVertAngSpeed;
        m_fHorizAngSpeed = m_fOldHorizAngSpeed;
        m_bInManualMode = false;
    }

    void SaveMeshElement(FileChunk cFC, int nMeshElementID)
    {
        cFC.SaveVector(m_OwnerMesh.GetElementForwardVector(nMeshElementID));
        cFC.SaveVector(m_OwnerMesh.GetElementUpVector(nMeshElementID));
        cFC.SaveVector(m_OwnerMesh.GetElementPos(nMeshElementID));
    }

    boolean CanExecuteBeam()
    {
        return (!(m_CannonUser instanceof Player) || !((GameObject) (m_CannonUser)).bNetIsOwner || (m_OwnerMesh instanceof EnergyCannon)) && m_vForwardDelta.Len() < 0.02F;
    }

    void ReInit()
    {
        m_nElementH = m_OwnerMesh.GetElementID(m_sElementH);
        m_nElementV = m_OwnerMesh.GetElementID(m_sElementV);
        m_nElementCenter = m_OwnerMesh.GetElementID(m_sElementCenterNew);
        if(m_nElementCenter == -1)
            m_nElementCenter = m_OwnerMesh.GetElementID(m_sElementCenterOld);
        m_nElementBarrel = m_OwnerMesh.GetElementID(m_sElementBarrel);
        m_nElementBarrelExit = m_OwnerMesh.GetElementID(m_sElementBarrelExit);
    }

    public void StartFire(byte nMode)
    {
        m_OwnerMesh.FireStarted(nMode);
        m_bPreFiringState = m_bPreFiring = true;
    }

    public void StopFire()
    {
        super.StopFire();
        if(bDisableStopFire)
        {
            return;
        } else
        {
            m_bFiringState = m_bFiring = false;
            m_bPreFiringState = m_bPreFiring = false;
            m_OwnerMesh.FireStopped();
            return;
        }
    }

    void Acquire(Module module, Pawn pawn)
    {
    }

    public Vector GetCannonToParentPositionDiff()
    {
        return new Vector(m_vCannonToParentDiff);
    }

    void TryToInitController()
    {
        GameObject cObject = GetObjectByNetId(m_nOwnerMeshNetId);
        if(cObject == null)
        {
            CallMethodIn("TryToInitController", 0.1F);
            return;
        }
        if(cObject instanceof VehicleAttacker)
        {
            VehicleAttacker cAttacker = (VehicleAttacker)cObject;
            cAttacker.InitCannonController(this);
        } else
        {
            GameObject.CrashLog(" " + this + "TryToInitController()  failed \n");
        }
    }

    public void CancelFire()
    {
        super.CancelFire();
        if(bDisableStopFire)
        {
            return;
        } else
        {
            m_bPreFiringState = m_bPreFiring = false;
            m_bFiringState = m_bFiring = false;
            m_OwnerMesh.FireStopped();
            return;
        }
    }

    public void SetBeamProbability(float fProbability)
    {
        m_fExecuteBeamProbability = fProbability;
    }

    public void SetAccuracy(float fBase, float fAim)
    {
        super.fBaseAcc = fBase;
        super.fAimAcc = fAim;
    }

    public float GetTargetFindingAngle()
    {
        return m_fTargetFindingAngle;
    }

    public float GetMaxVertAngle()
    {
        return m_fMaxVAngle;
    }

    public void SetBeamFX(String sBeamName)
    {
        this.sBeamName = sBeamName;
    }

    public void OnCreate()
    {
        super.OnCreate();
        super.bSG = false;
        super.eBulletType = 10;
        super.sSoundShoot = "data/sounds/weapon/JeepCannon";
        SetShotSoundRange(500F, 5000F);
        SetRateOfFire(10F);
        super.nRoundShots = 10;
        super.sFXCombName = "FXGrzebienWalker";
        super.fNoiseShot = 4000F;
        super.fAimAcc = 2.4F;
        super.m_bFireOnlyFromHands = false;
    }

    public void SetMaxHorizAngle(float fMaxHorizAngle)
    {
        m_fMaxHAngle = fMaxHorizAngle;
        m_fTargetHoldingAngleCos = (float)Math.cos(((double)fMaxHorizAngle * 3.1415926535897931D) / 180D);
    }

    public boolean IsActive(ControlObject Activator)
    {
        return false;
    }

    String m_sElementH;
    String m_sElementV;
    String m_sElementCenterOld;
    String m_sElementCenterNew;
    String m_sElementBarrel;
    String m_sElementBarrelExit;
    int m_nElementH;
    int m_nElementV;
    int m_nElementCenter;
    int m_nElementBarrel;
    int m_nElementBarrelExit;
    ICannonMesh m_OwnerMesh;
    Vector m_vForwardDelta;
    ChromeActor m_CannonUser;
    int m_nOwnerSide;
    float m_fInitAngleV;
    public String sBeamName;
    float m_fTargetFindingAngle;
    float m_fTargetHoldingAngle;
    float m_fTargetFindingAngleCos;
    float m_fTargetHoldingAngleCos;
    ChromeActor m_Target;
    boolean m_bClearShot;
    float m_fLongDelay;
    float m_fShotDeviation;
    float m_fAimingAngleEpsilon;
    float m_fAimingAngleEpsilonCos;
    float m_fFiringAngleEpsilonCos;
    float m_fHorizAngSpeed;
    float m_fVertAngSpeed;
    float m_fAngleImportance;
    float m_fDistanceImportance;
    float m_fForwardImportance;
    boolean m_bGunAdvanced;
    Vector m_vVectorForward;
    Vector m_vVectorRight;
    Vector m_vVectorUp;
    boolean m_bInManualMode;
    float m_fMaxHAngle;
    float m_fMinVAngle;
    float m_fMaxVAngle;
    float m_fInitialFireDelay;
    boolean m_bFireAllowed;
    boolean m_bAllowMethodCalled;
    float m_fCannonVertMorphTime;
    String m_strOldState;
    float fAimMultiplier;
    boolean m_bActiveInAutoMode;
    String sParticleSystem;
    float fFXBeamSizeX;
    float m_fExecuteBeamProbability;
    float fMinBeamDistance;
    Vector m_vCannonToParentDiff;
    Vector m_vAimAtPoint;
    PlayerHUD m_PlayerManual;
    byte m_iLastCameraMode;
    int m_iOldState;
    int m_nOldRoundShots;
    float m_fOldVertAngSpeed;
    float m_fOldHorizAngSpeed;
    float m_fLastHorizAngle;
    float m_fLastVertAngle;
    LaserPointer cFirePointer;
    Vector vShakeImpulse;
    float fShakeImpulseForce;
    int m_nOwnerMeshNetId;
    boolean m_bPreFiring;
    boolean m_bPreFiringState;
    boolean m_bFiring;
    boolean m_bFiringState;
    boolean bDisableStopFire;
    int m_nFrame;
    static int m_nSetState = 0;
    float m_fAimX;
    float m_fAimY;
    float m_fAimZ;

}
