// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   ChromeActor.java

import java.util.Vector;

public class ChromeActor extends Actor
    implements ipar_ConflictSide, ipar_Health, ipar_DamageThreshold, IDestroyTarget
{

    PlayerNet GetPlayerNetByNetId(int nNetId)
    {
        GameObject object = GetObjectByNetId(nNetId);
        try
        {
            PlayerNet player = (PlayerNet)object;
            return player;
        }
        catch(ClassCastException e)
        {
            GameObject.LogD(": Object " + object + " (id " + String.valueOf(nNetId) + ") should have been inherited from PlayerNet\n");
        }
        return null;
    }

    public Vector GetFireDir()
    {
        return GetForwardVector();
    }

    Pawn GetPawnByNetId(int nNetId)
    {
        GameObject object = GetObjectByNetId(nNetId);
        try
        {
            Pawn pawn = (Pawn)object;
            return pawn;
        }
        catch(ClassCastException e)
        {
            GameObject.LogD(": Object " + object + " (id " + String.valueOf(nNetId) + ") should have been inherited from Pawn\n");
        }
        return null;
    }

    void SetMaxInterpolateDistance(float fMax)
    {
        m_fMaxInterpolateDistance2 = fMax * fMax;
    }

    public void MakeBlastDamage(float fBlastDamage, float fPhSimDamage, Vector vPos, float fBlastRange, boolean bExcludeActor, Actor cExcludeObj, int nDamageType)
    {
        if(FXBrokenGlass_CauseAnExplosion(vPos, fBlastDamage * 1.0F, fBlastRange) > 0)
            PlaySound("Data/Sounds/GlassShatter.wav", vPos);
        Actor cActor = null;
        ControlObject aObjects[] = GetObjectsInRadiusFromClass(fBlastRange, "Actor");
        Vector vSpeed = null;
        for(int i = 0; i < aObjects.length; i++)
        {
            cActor = (Actor)aObjects[i];
            if(cExcludeObj != cActor && (!bExcludeActor || cActor != this))
            {
                float fRange = vPos.Distance(cActor.GetPosition());
                if(fRange < fBlastRange)
                {
                    float fDamage = (fBlastRange - fRange) / fBlastRange;
                    float fPhDamage = fDamage;
                    fDamage *= fBlastDamage;
                    fPhDamage *= fPhSimDamage;
                    vSpeed = cActor.GetPosition();
                    vSpeed.Sub(vPos);
                    vSpeed.Normalize();
                    vSpeed.Mul(100000F);
                    if(fRange > fBlastRange * 0.1F)
                    {
                        Vector vActorMin = new Vector();
                        Vector vActorMax = new Vector();
                        cActor.GetMeshExtents(vActorMin, vActorMax);
                        vActorMin.fX = 0.0F;
                        vActorMin.fZ = 0.0F;
                        int nSamples = 4;
                        float fStep = (vActorMax.fY - vActorMin.fY) / (float)nSamples;
                        float fDamageStep = fDamage / (float)nSamples;
                        float fPhDamageStep = fPhDamage / (float)nSamples;
                        for(int j = 0; j < nSamples; j++)
                        {
                            if(bShowBeams)
                            {
                                CreateTestLaserBeams();
                                Vector vEnd = cActor.GetPosition();
                                vEnd.Add(vActorMin);
                                aBeams[j].PointFromTo(GetPositionVectorVolatile(), vEnd);
                            }
                            if(!CheckTrace(cActor, new Vector(), vActorMin))
                            {
                                fDamage -= fDamageStep;
                                fPhDamage -= fPhDamageStep;
                            }
                            vActorMin.fY += fStep;
                        }

                    }
                    Vector vHitPos = cActor.GetBoneJointPos((byte)2);
                    Collision stColl = TraceObjectsExclude(vPos, vHitPos, this);
                    Vector vDir = vHitPos.Sub2(vPos).Normalize2();
                    if(fDamage >= 1.0F)
                        cActor.TakeDamage(fDamage, fPhDamage, this, vHitPos, vDir, -1, nDamageType);
                }
            }
        }

    }

    void InitOriginalMaterials()
    {
        int nLodCount = 0;
        iOriginalMaterials = new int[4][];
        for(int i = 0; i < 4; i++)
        {
            String sMaterials[] = GetMaterials(i);
            if(sMaterials != null && sMaterials.length > 0)
            {
                iOriginalMaterials[nLodCount] = new int[sMaterials.length];
                for(int j = 0; j < sMaterials.length; j++)
                    if(sMaterials[j] != null && sMaterials[j].length() > 0)
                    {
                        int nMatID = GameObject.MaterialGetID(sMaterials[j]);
                        if(!IsInOriginalMaterialsTab(nMatID))
                            iOriginalMaterials[nLodCount][j] = nMatID;
                        else
                            iOriginalMaterials[nLodCount][j] = -1;
                    } else
                    {
                        iOriginalMaterials[nLodCount][j] = -1;
                    }

                nLodCount++;
            }
        }

    }

    public Vector GetFireOrigin()
    {
        return GetPosition();
    }

    void LoadTermovisionParams()
    {
        String sFile = super.MeshName + ".trm";
        ParseKeyword cRoot = GameObject.ParseFile(sFile);
        if(cRoot == null)
        {
            GameObject.LogR("Read or parse error in file " + sFile + " !\n");
        } else
        {
            TermoElement cElement = null;
            Vector vElems = new Vector();
            for(ParseKeyword cKey = cRoot; cKey != null; cKey = cKey.GetNext())
                if(cKey.Equals("TermoElement"))
                {
                    cElement = new TermoElement(cKey.GetSParam(0), new Vector(cKey.GetFParam(1), cKey.GetFParam(2), cKey.GetFParam(3)));
                    vElems.addElement(cElement);
                }

            m_tTermovisionMeshesNames = new String[vElems.size()];
            m_tTermovisionVisibleMeshElems = new int[vElems.size()];
            m_tTermovisionMeshesScales = new Vector[vElems.size()];
            m_tTermovisionMeshes = new MeshObject[vElems.size()];
            for(int i = 0; i < vElems.size(); i++)
            {
                cElement = (TermoElement)vElems.elementAt(i);
                m_tTermovisionVisibleMeshElems[i] = GetElementID(cElement.sMeshElementName);
                m_tTermovisionMeshesScales[i] = cElement.vScale;
                m_tTermovisionMeshesNames[i] = cElement.sMeshElementName;
            }

            cRoot.delete();
            m_bTermovisionParamsLoaded = true;
        }
    }

    public void ChangeDamageThreshold(float fDamageThreshold)
    {
        this.fDamageThreshold = fDamageThreshold;
    }

    int GetTeamRelation(ChromeActor targetToVerify)
    {
        int nResult = 0;
        if(targetToVerify != null)
        {
            int nIdToVerify = targetToVerify.nTeamID;
            if(nTeamID <= nProTeamIDsThreshold)
            {
                if(nIdToVerify <= nProTeamIDsThreshold)
                    nResult = 1;
                else
                if(nIdToVerify >= nCounterTeamIDsThreshold)
                    nResult = -1;
            } else
            if(nTeamID >= nCounterTeamIDsThreshold)
                if(nIdToVerify >= nCounterTeamIDsThreshold)
                    nResult = 1;
                else
                if(nIdToVerify <= nProTeamIDsThreshold)
                    nResult = -1;
        }
        return nResult;
    }

    int GetTeamRelation(int iTargetTeamID)
    {
        int nResult = 0;
        if(nTeamID <= nProTeamIDsThreshold)
        {
            if(iTargetTeamID <= nProTeamIDsThreshold)
                nResult = 1;
            else
            if(iTargetTeamID >= nCounterTeamIDsThreshold)
                nResult = -1;
        } else
        if(nTeamID >= nCounterTeamIDsThreshold)
            if(iTargetTeamID >= nCounterTeamIDsThreshold)
                nResult = 1;
            else
            if(iTargetTeamID <= nProTeamIDsThreshold)
                nResult = -1;
        return nResult;
    }

    void ShowFromUnderGround()
    {
        Vector vPos = GetPosition();
        vPos.fY -= -1000F;
        SetPositionWorld(vPos);
        ResetInterpolatePosAndDir();
        MsgSendClientState();
    }

    public final boolean IsNeutral(ChromeActor chromeActor)
    {
        return GetConflictSide() == EnumConflictSide._NEUTRAL || chromeActor.GetConflictSide() == EnumConflictSide._NEUTRAL;
    }

    public final boolean IsNeutral(int nConflictSide)
    {
        return nConflictSide == EnumConflictSide._NEUTRAL || GetConflictSide() == EnumConflictSide._NEUTRAL;
    }

    float GetInterpolateSpeed()
    {
        return m_fInterpolateSpeedOnStop;
    }

    public void ChangeHealth(float fHealth)
    {
        super.fHealth = fHealth;
    }

    void TermovisionOn()
    {
        SetUnImportanceThreshold(3500F);
        if(m_tTermovisionVisibleMeshElems == null)
            InitTermovisionMeshes();
        if(m_tTermovisionMeshes == null)
            SetupTermovisionMeshes();
    }

    void ServerRespawn(SpawnInfo cSpawnInfo, float fDelayTime)
    {
        FromUpForwardPos(cSpawnInfo.m_vUp, cSpawnInfo.m_vDir, cSpawnInfo.m_vPos);
        DisableCallMethod(METHOD_ShowFromUnderGround);
        if(fDelayTime > 0.0F)
            HideUnderGround(fDelayTime);
        else
            MsgSendClientState();
        DeleteAttachedFXes();
    }

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[ChromeActor.SGSaveChunk]\n");
        FileChunk cFC = GameObject.NewChunk(1104, cFCParent);
        super.SGSaveChunk(cFC);
        cFC.SaveBool(bIsActiveTarget);
        cFC.SaveFloat(fDamageThreshold);
        cFC.SaveInt(cConflictSide.GetValue());
        cFC.SaveInt(nTeamID);
        cFC.SaveFloat(fFXSizeX);
        cFC.SaveFloat(fFXSizeY);
        cFC.SaveFloat(fFXZero);
        cFC.SaveFloat(fFXPosY);
        GameObject.cSG.SaveObjectRef(cFC, cHideoutInvader);
        cFC.SaveBool(m_bCloaking);
        cFC.SaveFloat(m_fLastMakeNoiseTime);
        cFC.delete();
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[ChromeActor.SGLoadChunk]\n");
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        if(cFC.GetID() == 1104)
        {
            m_bDeadSG = super.bDead;
            super.SGLoadChunk(cFC);
            bIsActiveTarget = cFC.LoadBool();
            fDamageThreshold = cFC.LoadFloat();
            cConflictSide = new EnumConflictSide(cFC.LoadInt());
            nTeamID = cFC.LoadInt();
            fFXSizeX = cFC.LoadFloat();
            fFXSizeY = cFC.LoadFloat();
            fFXZero = cFC.LoadFloat();
            fFXPosY = cFC.LoadFloat();
            cHideoutInvader = (ChromeActor)GameObject.cSG.LoadObjectRef(cFC);
            m_bCloakingSG = cFC.LoadBool();
            m_fLastMakeNoiseTime = cFC.LoadFloat();
        }
        cFC.delete();
    }

    void ReleaseTermovisionMeshes()
    {
        for(int i = 0; i < m_tTermovisionMeshes.length; i++)
        {
            m_tTermovisionMeshes[i].DetachFromParent();
            ImplantTermovision.ReleaseTermoMesh(m_tTermovisionMeshes[i]);
            m_tTermovisionMeshes[i] = null;
        }

        m_tTermovisionMeshes = null;
    }

    void SetCloaking(boolean bOn)
    {
        if(m_bCloaking != bOn)
        {
            FileChunk.Log("[ChromeActor.SetCloaking] Type = <" + bOn + "> Class = <" + getClass().getName() + "> Name <" + GetName() + ">\n");
            m_bCloaking = bOn;
            if(bOn)
            {
                sPrevMaterials = new String[iOriginalMaterials.length][];
                for(int nLod = 0; nLod < iOriginalMaterials.length; nLod++)
                {
                    sPrevMaterials[nLod] = GetMaterials(nLod);
                    for(int i = 0; i < iOriginalMaterials[nLod].length; i++)
                        if(iOriginalMaterials[nLod][i] != -1)
                            ReplaceOriginalMaterial(iOriginalMaterials[nLod][i], "cloaked.mat");

                }

            } else
            {
                for(int nLod = 0; nLod < iOriginalMaterials.length; nLod++)
                {
                    for(int i = 0; i < iOriginalMaterials[nLod].length; i++)
                        if(iOriginalMaterials[nLod][i] != -1)
                            ReplaceOriginalMaterial(iOriginalMaterials[nLod][i], sPrevMaterials[nLod][i]);

                }

            }
        }
    }

    public void Die()
    {
        boolean bWasDead = super.bDead;
        super.Die();
        bIsActiveTarget = false;
        if(!bWasDead && super.bDead && (GetModule() instanceof ChromeModule))
        {
            SetCloaking(false);
            ((ChromeModule)GetModule()).ChromeActorDied(this);
        }
    }

    public final int GetConflictSide()
    {
        return cConflictSide.GetValue();
    }

    public float GetVisibilityRangeFactor(ChromeActor cObserver)
    {
        return 1.0F;
    }

    public void SGUpdate()
    {
        FileChunk.Log("[ChromeActor.SGUpdate]\n");
        super.SGUpdate();
        if(super.bDead && !m_bDeadSG)
        {
            bIsActiveTarget = false;
            TermovisionOff();
            SetCloaking(false);
            if(GetModule() instanceof ChromeModule)
                ((ChromeModule)GetModule()).ChromeActorDied(this);
        } else
        if(m_bCloakingSG && !m_bCloaking)
            SetCloaking(true);
        else
        if(!m_bCloakingSG && m_bCloaking && sPrevMaterials != null)
            SetCloaking(false);
    }

    public ChromeActor[] GetObjectsToDestroy()
    {
        if(!IsDead())
        {
            ChromeActor tab[] = new ChromeActor[1];
            tab[0] = this;
            return tab;
        } else
        {
            return null;
        }
    }

    TriggerObject GetTriggerObjByNetId(int nNetId)
    {
        GameObject object = GetObjectByNetId(nNetId);
        try
        {
            TriggerObject triggerObj = (TriggerObject)object;
            return triggerObj;
        }
        catch(ClassCastException e)
        {
            GameObject.LogD(": Object " + object + " (id " + String.valueOf(nNetId) + ") should have been inherited from TriggerObject\n");
        }
        return null;
    }

    Vehicle GetVehicleByNetId(int nNetId)
    {
        GameObject object = GetObjectByNetId(nNetId);
        try
        {
            Vehicle vehicle = (Vehicle)object;
            return vehicle;
        }
        catch(ClassCastException e)
        {
            GameObject.LogD(": Object " + object + " (id " + String.valueOf(nNetId) + ") should have been inherited from Vehicle\n");
        }
        return null;
    }

    void ResetInterpolatePosAndDir()
    {
        m_fRenderTime = -1F;
    }

    void InterpolateRenderDir(Vector vDir, Vector vDestDir, Vector vRenderDir)
    {
        if(m_bInterpolateRenderDir && m_fRenderTime > 0.0F && GetParent() == null && (vDir.fX * vDestDir.fX + vDir.fZ * vDestDir.fZ < 0.0F || Math.abs(vDir.fX * vDestDir.fZ - vDir.fZ * vDestDir.fX) > 0.001F))
        {
            float fDirAngle = (float)Math.atan2(vDir.fZ, vDir.fX);
            float fDestDirAngle = (float)Math.atan2(vDestDir.fZ, vDestDir.fX);
            float fInterval = GetTime() - m_fRenderTime;
            float fTurn = sm_fAngSpeed * 0.01745329F * fInterval;
            float fAngle = fDestDirAngle - fDirAngle;
            if((double)fAngle > 3.1415926535897931D)
                fAngle = (float)((double)fAngle - 6.2831853071795862D);
            else
            if((double)fAngle < -3.1415926535897931D)
                fAngle = (float)((double)fAngle + 6.2831853071795862D);
            if(Math.abs(fAngle) > fTurn)
            {
                if(fAngle < 0.0F)
                    fTurn = -fTurn;
                float fSin = (float)Math.sin(fTurn);
                float fCos = (float)Math.cos(fTurn);
                vRenderDir.fX = vDir.fX * fCos - vDir.fZ * fSin;
                vRenderDir.fZ = vDir.fX * fSin + vDir.fZ * fCos;
                vRenderDir.fY = vDestDir.fY;
            } else
            {
                vRenderDir.Set(vDestDir);
            }
        } else
        {
            vRenderDir.Set(vDestDir);
        }
    }

    public void Damage(float fDamage)
    {
        if(fDamage >= fDamageThreshold)
            super.Damage(fDamage);
    }

    public boolean IsDead()
    {
        return super.bDead;
    }

    Weapon GetWeaponByNetId(int nNetId)
    {
        GameObject object = GetObjectByNetId(nNetId);
        try
        {
            Weapon weapon = (Weapon)object;
            return weapon;
        }
        catch(ClassCastException e)
        {
            GameObject.LogD(": Object " + object + " (id " + String.valueOf(nNetId) + ") should have been inherited from Weapon\n");
        }
        return null;
    }

    void WeaponFireOnClientNotOwner()
    {
    }

    InvObject GetInvObjByNetId(int nNetId)
    {
        GameObject object = GetObjectByNetId(nNetId);
        try
        {
            InvObject invObj = (InvObject)object;
            return invObj;
        }
        catch(ClassCastException e)
        {
            GameObject.LogD(": Object " + object + " (id " + String.valueOf(nNetId) + ") should have been inherited from InvObject\n");
        }
        return null;
    }

    void OnPostRender()
    {
        if(m_bOnRenderPosition)
        {
            SetPositionWorld(m_vActuallyPosition);
            m_bOnRenderPosition = false;
        }
        if(m_bOnRenderDir)
        {
            SetDir(m_vActuallyDir);
            m_bOnRenderDir = false;
        }
    }

    void SetCorrectPosOnRender(boolean bVal)
    {
        m_bCorrectPosOnRender = bVal;
        m_bInterpolateRenderPos = bVal;
        m_bInterpolateRenderDir = bVal;
        m_fRenderTime = -1F;
    }

    void OnRender()
    {
    }

    public void NotifyHit(ChromeActor chromeactor, int i)
    {
    }

    void CreateTestLaserBeams()
    {
        if(aBeams == null)
        {
            aBeams = new LaserPointer[4];
            aBeams[0] = Tools.CreateLaserPointer(GetModule(), "LaserBeamGreen");
            aBeams[1] = Tools.CreateLaserPointer(GetModule(), "LaserBeamGreen");
            aBeams[2] = Tools.CreateLaserPointer(GetModule(), "LaserBeamGreen");
            aBeams[3] = Tools.CreateLaserPointer(GetModule(), "LaserBeamGreen");
        }
    }

    public float GetHitChanceMult(ChromeActor cShooter)
    {
        return 1.0F;
    }

    void ExecuteWeaponBeam(float fDistance, Vector vBeamPos, int nElementBarrelExit)
    {
        fFXPosY = fDistance * 0.75F;
        fFXSizeY = fDistance;
    }

    void InterpolateRenderPos(Vector vPos)
    {
        if(m_fRenderTime > 0.0F && GetParent() == null && vPos.Distance2(m_vRenderPosition) < m_fMaxInterpolateDistance2)
        {
            float fFrameTime = GetTime() - m_fRenderTime;
            if(fFrameTime > 0.0F)
            {
                float fSpeed = GetInterpolateSpeed();
                if(fSpeed <= m_fInterpolateSpeedOnStop)
                    fSpeed = m_fInterpolateSpeedOnStop;
                float fMaxDistance = fSpeed * fFrameTime;
                sm_vMove.Set(vPos);
                sm_vMove.Sub(m_vRenderPosition);
                if(sm_vMove.Len() > fMaxDistance)
                {
                    sm_vMove.Normalize();
                    sm_vMove.Mul(fMaxDistance);
                }
                vPos.Set(m_vRenderPosition);
                vPos.Add(sm_vMove);
            }
        }
    }

    boolean IsAvailableInDemo()
    {
        return (GetModule() instanceof ModuleNet) || !ChromeModuleSingle._bEnglishDemo1 || !(this instanceof WeaponPistolHeavy) && !(this instanceof WeaponRifleHeavy) && !(this instanceof WeaponRifleShortSilenced) && !(this instanceof WeaponRifleSniper) && !(this instanceof WeaponRifleSniperHeavy) && !(this instanceof WeaponRifleMachineGun) && !(this instanceof WeaponHeavyRocketLauncher) && !(this instanceof WeaponHeavyElectro) && !(this instanceof Speeder) && !(this instanceof CloakingDevice) && !(this instanceof WeaponGrenadeCluster) && !(this instanceof WalkerLight);
    }

    String GetDemoInfoText()
    {
        String sDemoVersionInfo = "&UNAVAILABLE_IN_DEMO&";
        if(this instanceof WeaponPistolHeavy)
            sDemoVersionInfo = "&UNAVAILABLE_IN_DEMO_PISTOL_HEAVY&";
        if(this instanceof WeaponRifleHeavy)
            sDemoVersionInfo = "&UNAVAILABLE_IN_DEMO_RIFLE_HEAVY&";
        if(this instanceof WeaponRifleShortSilenced)
            sDemoVersionInfo = "&UNAVAILABLE_IN_DEMO_RIFLE_SHORT_SILENCED&";
        if(this instanceof WeaponRifleSniper)
            sDemoVersionInfo = "&UNAVAILABLE_IN_DEMO_RIFLE_SNIPER&";
        if(this instanceof WeaponRifleSniperHeavy)
            sDemoVersionInfo = "&UNAVAILABLE_IN_DEMO_RIFLE_SNIPER_HEAVY&";
        if(this instanceof WeaponRifleMachineGun)
            sDemoVersionInfo = "&UNAVAILABLE_IN_DEMO_RIFLE_MACHINEGUN&";
        if(this instanceof WeaponHeavyRocketLauncher)
            sDemoVersionInfo = "&UNAVAILABLE_IN_DEMO_ROCKET_LAUNCHER&";
        if(this instanceof WeaponHeavyElectro)
            sDemoVersionInfo = "&UNAVAILABLE_IN_DEMO_ELECTRO&";
        if(this instanceof Speeder)
            sDemoVersionInfo = "&UNAVAILABLE_IN_DEMO_SPEEDER&";
        if(this instanceof CloakingDevice)
            sDemoVersionInfo = "&UNAVAILABLE_IN_DEMO_CLOAKING_DEVICE&";
        if(this instanceof WeaponGrenadeCluster)
            sDemoVersionInfo = "&UNAVAILABLE_IN_DEMO_GRENADE_CLUSTER&";
        if(this instanceof WalkerLight)
            sDemoVersionInfo = "&UNAVAILABLE_IN_DEMO_WALKER&";
        return sDemoVersionInfo;
    }

    public void MakeNoise(float fLoudness, int nNoiseType)
    {
        if(nNoiseType == 2)
        {
            float fTime = GetTime();
            if(fTime - m_fLastMakeNoiseTime > _MIN_TIME_BTW_MAKE_SHOT_NOISE)
            {
                m_fLastMakeNoiseTime = fTime;
                super.MakeNoise(fLoudness, nNoiseType);
            }
        } else
        {
            super.MakeNoise(fLoudness, nNoiseType);
        }
    }

    public void MakeNoise(Vector vPos, float fLoudness, int nNoiseType)
    {
        if(nNoiseType == 2)
        {
            float fTime = GetTime();
            if(fTime - m_fLastMakeNoiseTime > _MIN_TIME_BTW_MAKE_SHOT_NOISE)
            {
                m_fLastMakeNoiseTime = fTime;
                super.MakeNoise(vPos, fLoudness, nNoiseType);
            }
        } else
        {
            super.MakeNoise(vPos, fLoudness, nNoiseType);
        }
    }

    public void ChangeConflictSide(int nNewConflictSide)
    {
        cConflictSide = new EnumConflictSide(nNewConflictSide);
    }

    public float GetShootVisibilityFactor(ChromeActor cShooter)
    {
        return 1.0F;
    }

    public Vector GetAimDir()
    {
        return GetForwardVector();
    }

    void SetRenderTime(float fTime)
    {
        m_fRenderTime = fTime;
    }

    NetPlayerInfo GetPlayerInfoByNetId(int nNetId)
    {
        GameObject object = GetObjectByNetId(nNetId);
        try
        {
            NetPlayerInfo playerinfo = (NetPlayerInfo)object;
            return playerinfo;
        }
        catch(ClassCastException e)
        {
            GameObject.LogD(": Object " + object + " (id " + String.valueOf(nNetId) + ") should have been inherited from NetPlayerInfo\n");
        }
        return null;
    }

    float GetVisibilityRangeThreshold(ChromeActor cObserver)
    {
        return 3.402823E+38F;
    }

    void TermovisionOff()
    {
        SetUnImportanceThreshold(2000F);
        if(m_tTermovisionMeshes != null)
            ReleaseTermovisionMeshes();
    }

    boolean IsTermovisionOn()
    {
        return m_tTermovisionMeshes != null;
    }

    ChromeActor()
    {
        bIsActiveTarget = false;
        bIsAITarget = false;
        bIsEmpVulnerable = false;
        bIsHideout = false;
        cHideoutInvader = null;
        fTargetImportance = 50F;
        fDamageThreshold = 0.0F;
        m_bCloaking = false;
        iOriginalMaterials = null;
        sPrevMaterials = null;
        cConflictSide = new EnumConflictSide(EnumConflictSide._NEUTRAL);
        nTeamID = 0;
        nProTeamIDsThreshold = -1000;
        nCounterTeamIDsThreshold = 1000;
        m_bRecognizedAsPlayer = false;
        METHOD_ShowFromUnderGround = 0;
        fFXSizeX = 2.0F;
        fFXSizeY = 10000F;
        fFXZero = 0.0F;
        fFXPosY = 0.0F;
        bShowBeams = false;
        aBeams = null;
        _MIN_TIME_BTW_MAKE_SHOT_NOISE = 1.0F;
        m_fLastMakeNoiseTime = 0.0F;
        m_tTermovisionVisibleMeshElems = null;
        m_tTermovisionMeshes = null;
        m_tTermovisionMeshesNames = null;
        m_tTermovisionMeshesScales = null;
        m_bTermovisionParamsLoaded = false;
        m_bDeadSG = false;
        m_bCloakingSG = false;
        m_fRenderTime = -1F;
        m_fMaxInterpolateDistance2 = 1000000F;
        m_bCorrectPosOnRender = false;
        m_vActuallyPosition = new Vector();
        m_vRenderPosition = new Vector();
        m_bOnRenderPosition = false;
        m_bInterpolateRenderPos = false;
        m_fInterpolateSpeedOnStop = 300F;
        m_fInterpolateSpeedOnMoveMul = 1.2F;
        m_bInterpolateRenderDir = false;
        m_vActuallyDir = new Vector();
        m_vRenderDir = new Vector();
        m_bOnRenderDir = false;
        sm_fAngSpeed = 360F;
    }

    public Vector GetPointToLookAt(int nPoint)
    {
        if(nPoint == 0)
            return GetPosition();
        else
            return null;
    }

    boolean IsInOriginalMaterialsTab(int nMaterial)
    {
        if(iOriginalMaterials != null)
        {
            for(int nLod = 0; nLod < iOriginalMaterials.length; nLod++)
                if(iOriginalMaterials[nLod] != null)
                {
                    for(int i = 0; i < iOriginalMaterials[nLod].length; i++)
                        if(iOriginalMaterials[nLod][i] == nMaterial)
                            return true;

                }

        }
        return false;
    }

    public final boolean IsFriend(ChromeActor chromeActor)
    {
        return !IsNeutral(chromeActor) && GetConflictSide() == chromeActor.GetConflictSide();
    }

    public final boolean IsFriend(int nConflictSide)
    {
        return !IsNeutral(nConflictSide) && GetConflictSide() == nConflictSide;
    }

    void HideUnderGround(float fShowDelayTime)
    {
        Vector vPos = GetPosition();
        vPos.fY += -1000F;
        SetPositionWorld(vPos);
        ResetInterpolatePosAndDir();
        MsgSendClientState();
        CallMethodIn(METHOD_ShowFromUnderGround, fShowDelayTime);
    }

    void WeaponFireOnServer()
    {
    }

    public void ShakePlayersCamera(float fStrength, float fMinDistance, float fMaxDistance)
    {
        if(GetModule() instanceof ChromeModule)
        {
            Player player = ((ChromeModule)GetModule()).GetMainPlayer();
            if(player != null && player.Camera != null)
            {
                float dist2 = GetDistance2To(player);
                float minDist2 = fMinDistance * fMinDistance;
                float maxDist2 = fMaxDistance * fMaxDistance;
                float shakeVal = fStrength * (1.0F - Tools.InterpLinear(minDist2, maxDist2, dist2));
                if(shakeVal > 1.0F)
                    player.Camera.ShakeImpulse(shakeVal, shakeVal, shakeVal, 2);
            }
        }
    }

    void RespawnedOnLevel()
    {
    }

    public final boolean IsEnemy(ChromeActor chromeActor)
    {
        return !IsNeutral(chromeActor) && GetConflictSide() != chromeActor.GetConflictSide();
    }

    public final boolean IsEnemy(int nConflictSide)
    {
        return !IsNeutral(nConflictSide) && GetConflictSide() != nConflictSide;
    }

    void InitTermovisionMeshes()
    {
        if(m_tTermovisionVisibleMeshElems == null)
        {
            Vector vElems = new Vector();
            int nIdx = 1;
            do
            {
                String sName = "Termo_";
                if(nIdx < 10)
                    sName += "0" + nIdx;
                else
                    sName += String.valueOf(nIdx);
                int nElement = GetElementID(sName);
                if(nElement == -1)
                    break;
                vElems.addElement(new TermoElement(nElement, new Vector(0.33F, 0.33F, 0.33F)));
                nIdx++;
            } while(true);
            nIdx = 1;
            do
            {
                String sName = "TermoXL_";
                if(nIdx < 10)
                    sName += "0" + nIdx;
                else
                    sName += String.valueOf(nIdx);
                int nElement = GetElementID(sName);
                if(nElement == -1)
                    break;
                vElems.addElement(new TermoElement(nElement, new Vector(0.75F, 0.75F, 0.75F)));
                nIdx++;
            } while(true);
            nIdx = 1;
            do
            {
                String sName = "TermoXXL_";
                if(nIdx < 10)
                    sName += "0" + nIdx;
                else
                    sName += String.valueOf(nIdx);
                int nElement = GetElementID(sName);
                if(nElement == -1)
                    break;
                vElems.addElement(new TermoElement(nElement, new Vector(1.0F, 1.0F, 1.0F)));
                nIdx++;
            } while(true);
            int nElemCount = vElems.size();
            if(nElemCount == 0)
            {
                int nElement = GetElementID("Bip01 Head");
                if(nElement != -1)
                {
                    vElems.addElement(new TermoElement(nElement, new Vector(2.0F, 3F, 1.0F)));
                    nElemCount = 1;
                }
            }
            m_tTermovisionVisibleMeshElems = new int[nElemCount];
            m_tTermovisionMeshesScales = new Vector[nElemCount];
            for(int i = 0; i < m_tTermovisionVisibleMeshElems.length; i++)
            {
                TermoElement cElem = (TermoElement)vElems.elementAt(i);
                m_tTermovisionVisibleMeshElems[i] = cElem.nElementID;
                m_tTermovisionMeshesScales[i] = cElem.vScale;
            }

        }
    }

    void SetupTermovisionMeshes()
    {
        if(m_tTermovisionVisibleMeshElems != null)
            m_tTermovisionMeshes = new MeshObject[m_tTermovisionVisibleMeshElems.length];
        for(int i = 0; i < m_tTermovisionVisibleMeshElems.length; i++)
            if(m_tTermovisionVisibleMeshElems[i] != -1)
            {
                MeshObject cMesh = ImplantTermovision.GetTermoMesh();
                m_tTermovisionMeshes[i] = cMesh;
                AttachChild(cMesh, m_tTermovisionVisibleMeshElems[i]);
                cMesh.ClearFlag(0x20000);
                cMesh.FromUpForwardPos(new Vector(Vector.Up), new Vector(Vector.Forward), GetElementPos(m_tTermovisionVisibleMeshElems[i]));
                if(m_tTermovisionMeshesScales != null && m_tTermovisionMeshesScales[i] != null)
                    cMesh.SetScale(m_tTermovisionMeshesScales[i]);
                cMesh.ActivateOnModule();
            } else
            {
                Tools.CrashLogError("No elem " + m_tTermovisionMeshesNames[i]);
            }

    }

    void OnCreate()
    {
        METHOD_ShowFromUnderGround = RegisterCallMethod("ShowFromUnderGround");
        super.OnCreate();
        super.bSG = true;
        InitOriginalMaterials();
        if(bIsAITarget)
            SetFlag(0x2000000);
    }

    void DeactivateChildren()
    {
        GameObject children[] = GetChildren();
        if(children == null)
            return;
        for(int i = 0; i < children.length; i++)
        {
            ((MeshObject)children[i]).DetachFromParent();
            ((MeshObject)children[i]).EnableRendering(false);
            ((MeshObject)children[i]).DeactivateOnModuleAlways();
            ((MeshObject)children[i]).DeleteAttachedFXes();
        }

    }

    void Execute(Actor executor)
    {
        Module cModule = GetModule();
        if(cModule != null)
            cModule.TriggerExecuted(this, executor);
        GameObject.InvokeActionChain(super.aOnExecute);
    }

    float GetRenderTime()
    {
        return m_fRenderTime;
    }

    boolean bIsActiveTarget;
    boolean bIsAITarget;
    boolean bIsEmpVulnerable;
    public boolean bIsHideout;
    ChromeActor cHideoutInvader;
    public float fTargetImportance;
    public static float fMaxTargetImportance = 100F;
    public float fDamageThreshold;
    boolean m_bCloaking;
    int iOriginalMaterials[][];
    String sPrevMaterials[][];
    public EnumConflictSide cConflictSide;
    public int nTeamID;
    public int nProTeamIDsThreshold;
    public int nCounterTeamIDsThreshold;
    static final int _TEAM_RELATION_FRIENDLY = 1;
    static final int _TEAM_RELATION_NEUTRAL = 0;
    static final int _TEAM_RELATION_HOSTILE = -1;
    boolean m_bRecognizedAsPlayer;
    int METHOD_ShowFromUnderGround;
    public float fFXSizeX;
    public float fFXSizeY;
    public float fFXZero;
    public float fFXPosY;
    boolean bShowBeams;
    LaserPointer aBeams[];
    float _MIN_TIME_BTW_MAKE_SHOT_NOISE;
    float m_fLastMakeNoiseTime;
    int m_tTermovisionVisibleMeshElems[];
    MeshObject m_tTermovisionMeshes[];
    String m_tTermovisionMeshesNames[];
    Vector m_tTermovisionMeshesScales[];
    boolean m_bTermovisionParamsLoaded;
    boolean m_bDeadSG;
    boolean m_bCloakingSG;
    static final float _SHIFT_Y_TO_HIDE_UNDER_GROUND = -1000F;
    private float m_fRenderTime;
    float m_fMaxInterpolateDistance2;
    boolean m_bCorrectPosOnRender;
    Vector m_vActuallyPosition;
    Vector m_vRenderPosition;
    boolean m_bOnRenderPosition;
    boolean m_bInterpolateRenderPos;
    float m_fInterpolateSpeedOnStop;
    float m_fInterpolateSpeedOnMoveMul;
    static Vector sm_vPos = new Vector();
    static Vector sm_vSpeed = new Vector();
    static Vector sm_vMove = new Vector();
    boolean m_bInterpolateRenderDir;
    Vector m_vActuallyDir;
    Vector m_vRenderDir;
    boolean m_bOnRenderDir;
    static Vector sm_vDir = new Vector();
    float sm_fAngSpeed;

}
