// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   CurveManager.java

import java.io.*;

class CurveSpline extends Curve
{

    void AddKnot(float x, float y)
    {
        if(knots == null || knots.length / 2 <= n_knots)
        {
            float new_knots[] = new float[knots != null ? knots.length + 8 : 8];
            for(int i = 0; i < n_knots * 2; i++)
                new_knots[i] = knots[i];

            knots = new_knots;
        }
        int i;
        for(i = 0; i < n_knots && x > knots[2 * i]; i++);
        if(i < n_knots)
        {
            for(int j = n_knots; j > i; j--)
            {
                knots[j * 2] = knots[(j - 1) * 2];
                knots[j * 2 + 1] = knots[(j - 1) * 2 + 1];
            }

        }
        knots[i * 2] = x;
        knots[i * 2 + 1] = y;
        n_knots++;
    }

    public String toString()
    {
        return "SPLINE";
    }

    CurveSpline()
    {
        n_knots = 0;
        AddKnot(-1F, 0.0F);
        AddKnot(-0.5F, 0.5F);
        AddKnot(-0.3F, 0.8F);
        AddKnot(0.3F, -0.8F);
        AddKnot(0.5F, -0.5F);
        AddKnot(1.0F, 0.0F);
    }

    byte GetType()
    {
        return 1;
    }

    void DeleteKnot(int k)
    {
        if(k >= 0 && k < n_knots && n_knots > 2)
        {
            for(int i = k; i < n_knots - 1; i++)
            {
                knots[i * 2] = knots[(i + 1) * 2];
                knots[i * 2 + 1] = knots[(i + 1) * 2 + 1];
            }

            n_knots--;
            float new_knots[] = new float[n_knots * 2];
            for(int j = 0; j < n_knots; j++)
            {
                new_knots[j * 2] = knots[j * 2];
                new_knots[j * 2 + 1] = knots[j * 2 + 1];
            }

            knots = new_knots;
        }
    }

    int GetClosestKnot(double x, double y)
    {
        int closest = -1;
        float dist = 1E+10F;
        for(int i = 0; i < n_knots; i++)
        {
            double d = Math.sqrt(Math.pow(x - (double)knots[i * 2], 2D) + Math.pow(y - (double)knots[i * 2 + 1], 2D));
            if(d < (double)dist)
            {
                closest = i;
                dist = (float)d;
            }
        }

        return closest;
    }

    void Write(DataOutputStream s)
    {
        try
        {
            super.Write(s);
            s.writeShort(n_knots);
            for(int i = 0; i < n_knots * 2; i++)
                s.writeFloat(knots[i]);

        }
        catch(IOException e)
        {
            GameObject.CrashLog("Error writing curve data: curve spline\n");
        }
    }

    void SetKnotPos(int k, float x, float y)
    {
        if(k >= 0 && k < n_knots)
        {
            knots[k * 2] = x;
            knots[k * 2 + 1] = y;
        }
    }

    void Read(DataInputStream s)
    {
        try
        {
            super.Read(s);
            n_knots = s.readUnsignedShort();
            if(n_knots < 2)
                GameObject.CrashLog("Error in spline curve: insufficient number of knots\n");
            knots = new float[n_knots * 2];
            for(int i = 0; i < n_knots * 2; i++)
                knots[i] = s.readFloat();

        }
        catch(IOException e)
        {
            GameObject.CrashLog("Error reading curve data: curve spline\n");
        }
    }

    float Sample(float x)
    {
        int i;
        for(i = 0; i < n_knots && knots[i * 2] < x; i++);
        if(i == 0)
            return knots[1];
        if(i > n_knots - 1)
        {
            return knots[(n_knots - 1) * 2 + 1];
        } else
        {
            float k0 = i - 2 >= 0 ? knots[(i - 2) * 2 + 1] : knots[1];
            float k1 = knots[(i - 1) * 2 + 1];
            float k2 = knots[i * 2 + 1];
            float k3 = i + 1 <= n_knots - 1 ? knots[(i + 1) * 2 + 1] : knots[(n_knots - 1) * 2 + 1];
            float xx = (x - knots[(i - 1) * 2]) / (knots[i * 2] - knots[(i - 1) * 2]);
            float result = Tools.spline(xx, k0, k1, k2, k3);
            return result;
        }
    }

    float knots[];
    int n_knots;
}
