// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   Destroyable.java

import java.io.File;

public class Destroyable extends ChromeActor
{

    public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        if(super.bDead)
        {
            return;
        } else
        {
            bGreatHit = fDamage > fBlowThreshold;
            cAssassin = Assassin;
            Damage(fDamage, nDamageType);
            cAssassin = null;
            bGreatHit = false;
            return;
        }
    }

    void Blast()
    {
        MakeBlastDamage(fBlastDamage, fBlastDamage, GetPosition(), fBlastRange, true, (cAssassin instanceof Actor) ? (Actor)cAssassin : null, EnumDamageType._BLAST);
    }

    void DelayedBlow()
    {
        if(fBlastRange > 0.0F || fBlastDamage > 0.0F)
            Blast();
    }

    public void Demolish()
    {
        if(!super.bLoadingSG)
            CallMethodIn("DeleteAttachedFXes", 0.0F);
        if(!super.bLoadingSG)
            CallMethodIn("DieAllDestroyableChildren", 0.0F);
        super.MeshName = GetDemolishedMesh();
        LoadMesh();
        SetMeshColor(new Vector(0.3F, 0.3F, 0.3F));
        if(!super.bLoadingSG)
            SpawnFX();
    }

    Destroyable()
    {
        bDeleteAfterDestroy = false;
        fBlastRange = 0.0F;
        fBlastDamage = 0.0F;
        sBlowFX = null;
        sBlowSound = "Data/Sounds/Demolish/Demolish";
        fMinSoundRange = -1F;
        fMaxSoundRange = -1F;
        fBlowUpShakeStrength = 0.0F;
        fBlowUpShakeDistMin = 0.0F;
        fBlowUpShakeDistMax = 0.0F;
        fDelayTime = 0.5F;
        fBlowThreshold = 50F;
        fDemolishThreshold = 50F;
        cAssassin = null;
        m_bSecondParticleSystem = false;
        m_fDestroyableHealth = -1F;
        bGreatHit = false;
        super.fHealth = m_fDestroyableHealth;
    }

    public void Die()
    {
        super.Die();
        if(bGreatHit || bDeleteAfterDestroy)
        {
            super.bDead = true;
            if(!super.bLoadingSG)
                SpawnFX();
            DeleteAttachedFXes();
            DetachFromParentAndKeepWorldPos();
            DeactivateOnModuleAlways();
            DieAllDestroyableChildren();
            CallMethodIn("DelayedBlow", GameObject.RandomFloat(fDelayTime));
        } else
        {
            super.bDead = false;
        }
    }

    void DieAllDestroyableChildren()
    {
        GameObject aChildren[] = GetChildren();
        if(aChildren == null)
            return;
        for(int i = 0; i < aChildren.length; i++)
            if(aChildren[i] instanceof Destroyable)
            {
                Destroyable cDestroyable = (Destroyable)aChildren[i];
                cDestroyable.bDeleteAfterDestroy = true;
                cDestroyable.Die();
            }

    }

    public void Damage(float fDamage, int nDamageType)
    {
        if(!GetsDamageIfType(nDamageType))
            return;
        if(fDemolishThreshold != 0.0F && super.fHealth - fDamage < fDemolishThreshold && super.fHealth >= fDemolishThreshold)
            Demolish();
        super.Damage(fDamage, nDamageType);
    }

    public void SpawnFX()
    {
        if(sBlowFX != null)
        {
            ExecuteFX(sBlowFX, GetPosition(), Vector.Up);
            ExecuteParticleSystem(sBlowFX, GetPosition(), Vector.Up);
            if(m_bSecondParticleSystem)
                ExecuteParticleSystem(sBlowFX + "2", GetPosition(), Vector.Up);
            if(fBlowUpShakeStrength > 0.0F)
                ShakePlayersCamera(fBlowUpShakeStrength, fBlowUpShakeDistMin, fBlowUpShakeDistMax);
        }
        if(sBlowSound != null)
        {
            String sSound = sBlowSound + (1 + GameObject.RandomInt(3)) + ".wav";
            if(fMinSoundRange != -1F)
                PlaySound(sSound, fMinSoundRange, fMaxSoundRange);
            else
                PlaySound(sSound);
        }
    }

    String GetDemolishedMesh()
    {
        String sLowerName = super.MeshName.toLowerCase();
        int nExt = sLowerName.indexOf(".3da");
        String sBaseMesh = super.MeshName.substring(0, nExt);
        if(sLowerName.indexOf("dem00.3da") != -1)
            return super.MeshName;
        else
            return sBaseMesh + "Dem00.3da";
    }

    public void OnCreate()
    {
        super.OnCreate();
        super.bSG = true;
        if(super.MeshName.toLowerCase().endsWith("butelka.3da") || super.MeshName.toLowerCase().endsWith("butelkaczysta.3da") || super.MeshName.toLowerCase().endsWith("butelkapelna.3da"))
        {
            sBlowFX = "FXGlassBlow";
            if(super.fHealth < 0.0F)
                super.fHealth = 10F;
            fBlowThreshold = 10F;
            sBlowSound = "data/sounds/demolish/glass_large";
            fMinSoundRange = 300F;
            fMaxSoundRange = 1500F;
        } else
        if(super.MeshName.toLowerCase().endsWith("szklanka.3da") || super.MeshName.toLowerCase().endsWith("szklankapelna.3da"))
        {
            sBlowFX = "FXGlassBlowSmall";
            if(super.fHealth < 0.0F)
                super.fHealth = 10F;
            fBlowThreshold = 10F;
            sBlowSound = "data/sounds/demolish/glass_small";
            fMinSoundRange = 300F;
            fMaxSoundRange = 1500F;
        } else
        if(super.MeshName.toLowerCase().endsWith("butla.3da") || super.MeshName.toLowerCase().endsWith("kanister.3da"))
        {
            sBlowFX = "FXBlowFlammable";
            if(super.fHealth < 0.0F)
                super.fHealth = 80F;
            fMinSoundRange = 1500F;
            fMaxSoundRange = 3000F;
        } else
        if(super.MeshName.toLowerCase().endsWith("kostka.3da"))
        {
            sBlowFX = "FXTinBlow";
            if(super.fHealth < 0.0F)
                super.fHealth = 20F;
            fBlowThreshold = 20F;
            sBlowSound = "data/sounds/demolish/cube";
            fMinSoundRange = 300F;
            fMaxSoundRange = 1200F;
        } else
        if(super.MeshName.toLowerCase().endsWith("puszka.3da"))
        {
            sBlowFX = "FXTinBlow";
            if(super.fHealth < 0.0F)
                super.fHealth = 20F;
            fBlowThreshold = 20F;
            sBlowSound = "data/sounds/demolish/tin";
            fMinSoundRange = 300F;
            fMaxSoundRange = 1200F;
        } else
        if(super.MeshName.toLowerCase().endsWith("szachownica.3da"))
        {
            sBlowFX = "FXTinBlow";
            if(super.fHealth < 0.0F)
                super.fHealth = 20F;
            fBlowThreshold = 20F;
            sBlowSound = "data/sounds/demolish/board";
            fMinSoundRange = 300F;
            fMaxSoundRange = 1200F;
        } else
        if(super.MeshName.toLowerCase().endsWith("pudlo.3da"))
        {
            sBlowFX = "FXBlowBox";
            if(super.fHealth < 0.0F)
                super.fHealth = 80F;
            fBlowThreshold = 20F;
            fMinSoundRange = 300F;
            fMaxSoundRange = 2000F;
        } else
        if(super.MeshName.toLowerCase().endsWith("gasnica.3da"))
        {
            sBlowFX = "FXBlowBarrel";
            if(super.fHealth < 0.0F)
                super.fHealth = 100F;
            fMinSoundRange = 800F;
            fMaxSoundRange = 2500F;
        } else
        if(super.MeshName.toLowerCase().endsWith("laptop.3da"))
        {
            m_bSecondParticleSystem = true;
            sBlowFX = "FXBlowLaptop";
            if(super.fHealth < 0.0F)
                super.fHealth = 40F;
            fBlowThreshold = 20F;
            sBlowSound = "data/sounds/demolish/laptop";
            fMinSoundRange = 300F;
            fMaxSoundRange = 1200F;
        } else
        if(super.MeshName.toLowerCase().endsWith("rurakrataa.3da"))
        {
            sBlowFX = "FXBlowBigBar";
            fMinSoundRange = 800F;
            fMaxSoundRange = 2000F;
        } else
        if(super.MeshName.toLowerCase().endsWith("pretya.3da"))
        {
            sBlowFX = "FXBlowBar";
            fMinSoundRange = 300F;
            fMaxSoundRange = 2000F;
        }
        float fSize = GetMeshSize();
        if(sBlowFX == null)
        {
            if(fSize < 100F)
            {
                sBlowFX = "FXDemolishSmall";
                sBlowSound = "Data/Sounds/Demolish/DemolishSmall";
                if(super.fHealth < 0.0F)
                    super.fHealth = 300F;
                fMinSoundRange = 300F;
                fMaxSoundRange = 1500F;
            }
            if(100F <= fSize && fSize <= 200F)
            {
                sBlowFX = "FXDemolishCrate";
                sBlowSound = "Data/Sounds/Demolish/DemolishMedium";
                if(super.fHealth < 0.0F)
                    super.fHealth = 400F;
                fMinSoundRange = 500F;
                fMaxSoundRange = 2000F;
            }
            if(200F < fSize)
            {
                sBlowFX = "FXDemolishCrate";
                sBlowSound = "Data/Sounds/Demolish/DemolishLarge";
                if(super.fHealth < 0.0F)
                    super.fHealth = 500F;
                fMinSoundRange = 800F;
                fMaxSoundRange = 2500F;
            }
        }
        if(super.fHealth < 0.0F)
            super.fHealth = 300F;
        String sDemolishedMesh = GetDemolishedMesh();
        if(sDemolishedMesh != null)
        {
            File cCheckFile = new File(sDemolishedMesh);
            if(!cCheckFile.exists())
                fDemolishThreshold = 0.0F;
            else
                Precache.AddMeshToPrecache(sDemolishedMesh);
        }
    }

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[Destroyable.SGSaveChunk]\n");
        FileChunk cFC = GameObject.NewChunk(1103, cFCParent);
        super.SGSaveChunk(cFC);
        if(super.MeshName == null)
            FileChunk.Log("[Destroyable.SGSaveChunk] MeshName = NULL for <" + GetName() + "> \n");
        cFC.SaveString(super.MeshName);
        cFC.SaveFloat(super.fHealth);
        cFC.delete();
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[Destroyable.SGLoadChunk]\n");
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        if(cFC.GetID() == 1103)
        {
            super.SGLoadChunk(cFC);
            String sMeshName = cFC.LoadString();
            if(sMeshName == null)
                GameObject.CrashLog("[Destroyable.SGLoadChunk] ERROR! MeshName = NULL for <" + GetName() + "> \n");
            if(sMeshName != null && sMeshName.compareTo(super.MeshName) != 0)
            {
                FileChunk.Log("[LoadMesh] : " + sMeshName + " from " + super.MeshName + " Name = <" + GetName() + "> ID = <" + GetUniqueID() + ">\n");
                LoadMesh(sMeshName);
            }
            super.fHealth = cFC.LoadFloat();
            if(super.fHealth < fDemolishThreshold)
                Demolish();
        }
        cFC.delete();
    }

    public boolean bDeleteAfterDestroy;
    public float fBlastRange;
    public float fBlastDamage;
    public String sBlowFX;
    public String sBlowSound;
    float fMinSoundRange;
    float fMaxSoundRange;
    public float fBlowUpShakeStrength;
    public float fBlowUpShakeDistMin;
    public float fBlowUpShakeDistMax;
    public float fDelayTime;
    public float fBlowThreshold;
    public float fDemolishThreshold;
    GameObject cAssassin;
    boolean m_bSecondParticleSystem;
    public float m_fDestroyableHealth;
    boolean bGreatHit;
}
