// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   DialogLine.java

import java.io.File;

public abstract class DialogLine extends GameObject
{

    float PlayWave()
    {
        fTimeHelp = GetTime();
        if(bWaveValid)
        {
            if(nWavePos != -1L)
            {
                nPlayingWave = PlayWaveFromPos(sWaveFileName, nWavePos);
                nWavePos = -1L;
                return GetDuration() - (float)GetPlayingWaveTimePos(nPlayingWave);
            }
            nPlayingWave = PlayWave(sWaveFileName);
        }
        return GetDuration();
    }

    void BreakWave()
    {
        if(nPlayingWave != 0 && IsPlayingWave(nPlayingWave))
            StopWave(nPlayingWave);
        nPlayingWave = 0;
    }

    public void OnAudioPreReinitialize()
    {
        if(nPlayingWave != 0 && IsPlayingWave(nPlayingWave))
            nWavePos = GetPlayingWavePos(nPlayingWave);
    }

    public void OnAudioReinitialize()
    {
        if(nWavePos != -1L && nPlayingWave != 0)
            PlayWave();
    }

    public DialogLine()
    {
        super.sEditorComment = "Dialog text line";
        cCharacter = null;
        sTextID = "";
        sWaveFileName = null;
        fDuration = 0.0F;
        fTimeHelp = 0.0F;
        bWaveValid = false;
        nPlayingWave = 0;
        nWavePos = -1L;
    }

    String GetText()
    {
        return sTextID;
    }

    float GetDuration()
    {
        return fDuration;
    }

    public void OnCreate()
    {
        super.bSG = false;
        try
        {
            ChromeModuleSingle cModule = (ChromeModuleSingle)GetModule();
            String sWavePath = cModule.GetDialogSoundPath();
            bWaveValid = false;
            if(sTextID != null)
            {
                if(sWaveFileName == null)
                    sWaveFileName = CheckFile(sWavePath, sTextID, ".wav");
                if(sWaveFileName == null)
                    sWaveFileName = CheckFile("Data\\Sounds\\Others\\", sTextID, ".wav");
                if(sWaveFileName == null)
                    sWaveFileName = CheckFile(sWavePath, sTextID, ".ogg");
                if(sWaveFileName == null)
                    sWaveFileName = CheckFile("Data\\Sounds\\Others\\", sTextID, ".ogg");
                bWaveValid = sWaveFileName != null;
            }
            if(bWaveValid)
            {
                fDuration = GetWaveDuration(sWaveFileName);
            } else
            {
                fDuration = _DEFAULT_CHAR_DURATION * (float)Text.Get(sTextID).length();
                if(fDuration < _MIN_WAVE_DURATION)
                    fDuration = _MIN_WAVE_DURATION;
                if(fDuration > _MAX_WAVE_DURATION)
                    fDuration = _MAX_WAVE_DURATION;
            }
        }
        catch(ClassCastException e)
        {
            GameObject.CrashLog("[Dialog.OnCreate] Dialog on non single player module!\n");
        }
    }

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[DialogLine.SGSaveChunk]\n");
        FileChunk cFC = GameObject.NewChunk(1536, cFCParent);
        super.SGSaveChunk(cFC);
        if(nPlayingWave > 0 && !IsPlayingWave(nPlayingWave))
            nPlayingWave = 0;
        cFC.SaveBool(nPlayingWave > 0);
        if(nPlayingWave > 0)
        {
            cFC.SaveFloat(GetTime() - fTimeHelp);
            cFC.SaveLong(GetPlayingWavePos(nPlayingWave));
        }
        cFC.delete();
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[DialogLine.SGLoadChunk]\n");
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        if(cFC.GetID() == 1536)
        {
            super.SGLoadChunk(cFC);
            if(cFC.LoadBool())
            {
                fTimeHelp = cFC.LoadFloat();
                nWavePos = cFC.LoadLong();
            } else
            {
                nWavePos = -1L;
            }
        }
        cFC.delete();
    }

    String GetWave()
    {
        return sWaveFileName;
    }

    static String CheckFile(String sPath, String sTextID, String sExt)
    {
        String sWaveFileName = null;
        StringBuffer sbOut = new StringBuffer(sTextID);
        int nPointPos = sbOut.length() - 1;
        if(sbOut.length() == 0)
            sWaveFileName = "";
        else
        if(nPointPos == -1)
            sWaveFileName = sPath + sbOut + sExt;
        else
            sWaveFileName = sPath + sbOut.substring(1, nPointPos) + sExt;
        File cFile = new File(sWaveFileName);
        String sFileName = null;
        try
        {
            sFileName = cFile.getCanonicalPath();
        }
        catch(Exception e) { }
        if(cFile.canRead())
            return sFileName;
        else
            return null;
    }

    public static float _DEFAULT_WAVE_DURATION = 3F;
    public static float _MIN_WAVE_DURATION = 3F;
    public static float _MAX_WAVE_DURATION = 15F;
    public static float _DEFAULT_CHAR_DURATION = 0.06F;
    public DialogCharacter cCharacter;
    public String sTextID;
    String sWaveFileName;
    float fDuration;
    float fTimeHelp;
    boolean bWaveValid;
    int nPlayingWave;
    long nWavePos;

}
