// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   EnergyCannon.java


public class EnergyCannon extends StationaryCannon
{

    public void OnAudioReinitialize()
    {
        if(m_iChargeSoundId != 0)
        {
            m_iChargeSoundId = 0;
            AttachChargeSound();
            UpdateChargeSounds();
        }
    }

    EnergyCannon()
    {
        fChargeShootDelay = 3F;
        nChargeMaterialsCount = 9;
        nChargeMaterial = -1;
        sChargeMatPrefix = "Dzialo3Ammo0";
        aPreloadedChargeMaterials = new int[nChargeMaterialsCount];
        m_ChargeSoundName = "Data/Sounds/Weapon/EnergyCharge";
        m_iChargeSoundId = 0;
        m_fMinChargeFreq = 0.7F;
        m_fMaxChargeFreq = 2.0F;
        fLastShotTime = 0.0F;
        super.fFireDamage = 2000F;
        super.fRateOfFire = 20F;
        super.m_cMeshName = "data/meshes/ai/ckmd.3da";
        super.m_cAnimSeqFile = null;
        super.m_sWreckMeshName = "data/meshes/ai/ckmdwreck.3da";
    }

    public void FireStarted(byte nMode)
    {
        if(GetTime() - fLastShotTime < fChargeShootDelay)
        {
            return;
        } else
        {
            super.m_iMode = 1;
            CallMethodIn("DelayStartFire", 0.0F);
            fLastShotTime = GetTime();
            return;
        }
    }

    public void DelayStartFire()
    {
        super.m_Cannon.SuperStartFire(super.m_iMode);
        CallMethodEvery("UpdateChargeSounds", 0.01F);
    }

    public void Die()
    {
        super.Die();
        DisableCallMethod("UpdateChargeSounds");
        DisableCallMethod("DelayStartFire");
        DetachChargeSound();
    }

    void AttachChargeSound()
    {
        if(m_ChargeSoundName != null && m_iChargeSoundId == 0)
            m_iChargeSoundId = AttachSound(m_ChargeSoundName, 1000F, 5000F);
    }

    public void SGUpdate()
    {
        super.SGUpdate();
        FireStopped();
    }

    void InitCannon()
    {
        super.InitCannon();
        if(super.m_Cannon != null)
        {
            super.m_Cannon.SetBeamProbability(1.0F);
            super.m_Cannon.SetAccuracy(1.5F, 1.0F);
            super.m_Cannon.SetBeamFX("BeamEnergy");
            super.m_Cannon.SetFXHitName("FXBlowEnergy");
            super.m_Cannon.SetCombFX("FXCombEnergy");
            super.m_Cannon.SetMinBeamDistance(0.0F);
            super.m_Cannon.SetFXSizeX(6F);
            ((CannonController)super.m_Cannon).fShakeImpulseForce = 1000F;
            super.m_Cannon.SetShotSound("Data/Sounds/Weapon/EnergyFire");
        }
        for(int i = 0; i < nChargeMaterialsCount; i++)
        {
            String sChargeMat = sChargeMatPrefix + i + "_SI.mat";
            aPreloadedChargeMaterials[i] = GameObject.MaterialLoad(sChargeMat);
            nChargeMaterial = GameObject.MaterialGetID(sChargeMatPrefix + "0_SI.mat");
        }

        UpdateChargeSounds();
        super.m_Cannon.SetParticleSystem("FXBlowEnergy");
        ReplaceOriginalMaterial(nChargeMaterial, aPreloadedChargeMaterials[nChargeMaterialsCount - 1]);
    }

    void DetachChargeSound()
    {
        if(m_iChargeSoundId != 0)
        {
            DetachSound(m_iChargeSoundId);
            m_iChargeSoundId = 0;
        }
    }

    public void UpdateChargeSounds()
    {
        float fTime = GetTime() - fLastShotTime;
        if(fLastShotTime == 0.0F)
        {
            fLastShotTime = fTime - fChargeShootDelay;
            return;
        }
        if(fTime > fChargeShootDelay)
            fTime = fChargeShootDelay;
        if(m_iChargeSoundId == 0)
            AttachChargeSound();
        if(m_iChargeSoundId != 0)
        {
            float fFreq = m_fMinChargeFreq + ((m_fMaxChargeFreq - m_fMinChargeFreq) * fTime) / fChargeShootDelay;
            SetSoundFreq(m_iChargeSoundId, fFreq);
        }
        int nMat = (int)((float)(nChargeMaterialsCount - 1) * (fTime / fChargeShootDelay));
        if(nMat == nChargeMaterialsCount - 1)
        {
            DetachChargeSound();
            DisableCallMethod("UpdateChargeSounds");
        }
        ReplaceOriginalMaterial(nChargeMaterial, aPreloadedChargeMaterials[nMat]);
    }

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[EnergyCannon.SGSaveChunk]\n");
        FileChunk cFC = GameObject.NewChunk(1652, cFCParent);
        super.SGSaveChunk(cFC);
        cFC.SaveFloat(fChargeShootDelay);
        cFC.SaveFloat(fLastShotTime);
        cFC.delete();
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        if(m_iChargeSoundId != 0)
            DetachChargeSound();
        FileChunk.Log("[EnergyCannon.SGLoadChunk]\n");
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        if(cFC.GetID() == 1652)
        {
            super.SGLoadChunk(cFC);
            fChargeShootDelay = cFC.LoadFloat();
            fLastShotTime = cFC.LoadFloat();
        }
        cFC.delete();
    }

    public float fChargeShootDelay;
    int nChargeMaterialsCount;
    int nChargeMaterial;
    String sChargeMatPrefix;
    int aPreloadedChargeMaterials[];
    String m_ChargeSoundName;
    int m_iChargeSoundId;
    float m_fMinChargeFreq;
    float m_fMaxChargeFreq;
    float fLastShotTime;
}
