// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   FlyingTransporter.java


public class FlyingTransporter extends FlyingVehicle
    implements iact_Appear, iact_LockOpened, iact_LockUnlock
{

    void BurnEngines()
    {
        for(int i = 0; i < _ENGINE_EXHAUST_NUM; i++)
            if(m_EnginesExhaust[i] != -1)
                ExecuteFX(this, m_EnginesExhaust[i], sEnginesExhaust, Vector.Zero);

    }

    public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        if(super.bDead)
            return;
        super.OnTakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
        if(!m_bSmokeSpawned && super.fHealth <= (super.fMaxHealth * fSmokeHealthLevel) / 100F)
        {
            SpawnSmoke();
            m_bSmokeSpawned = true;
        }
    }

    void SpawnBlowFX()
    {
        Vector vUp = new Vector(Vector.Up);
        vUp.Mul(400F);
        ExecuteFX(this, "FXBlowFlyingVehicle", vUp, Vector.Up);
        ExecuteParticleSystem(this, "FXBlowFlyingVehicle", vUp, Vector.Up);
    }

    void PlayFXDustStart()
    {
        super.PlayFXDustStart();
        if(FlyingVehicle._VEHICLE_DUST_START != null)
            ExecuteFX(FlyingVehicle._VEHICLE_DUST_START, GetPosition());
    }

    public static void DefineVisualisation()
    {
        GameObject.DefineDebugLine("cWaypoint", new Vector(1.0F, 1.0F, 1.0F));
    }

    public void Unlock()
    {
        m_bLocked = false;
    }

    public void ToggleLockUnlock()
    {
        if(IsLocked())
            Unlock();
        else
            Lock();
    }

    void PlayAnimLand(float fTimeToIgnoreInSingleGame)
    {
        PlayAnimLand();
    }

    void PlayAnimLand()
    {
        if(m_iForwardWheelElem != -1)
            PlayAnim(sForwardWheel, sShowWheelsAnim, 1);
        if(m_iBackwardLeftWheelElem != -1)
            PlayAnim(sBackwardLeftWheel, sShowWheelsAnim, 1);
        if(m_iBackwardRightWheelElem != -1)
            PlayAnim(sBackwardRightWheel, sShowWheelsAnim, 1);
    }

    void CloseDoor()
    {
        if(m_bLocked)
            return;
        if(!m_bClosed && m_bChangingState)
            return;
        CallMethodIn("DoorsClosed", GetAnimLength(sCloseAnim));
        if(m_iDoorElem != -1)
            PlayAnim(sDoor, sCloseAnim, 1);
        if(m_iWysiegnikPElem != -1)
            PlayAnim(sWysiegnikP, sCloseAnim, 1);
        if(m_iWysiegnikLElem != -1)
            PlayAnim(sWysiegnikL, sCloseAnim, 1);
        if(sDoorCloseSound != null && m_iDoorElem != -1)
            PlaySound(sDoorCloseSound, GetElementPos(m_iDoorElem));
    }

    public void DeactivateCannons()
    {
        GameObject children[] = GetChildren();
        if(children == null)
            return;
        for(int i = 0; i < children.length; i++)
            if(children[i] instanceof SecurityCannon)
                ((SecurityCannon)children[i]).Disable();

    }

    public void ServeNextWaypointActivity()
    {
        if(m_CurrActivity != null)
            m_CurrActivity.StopActivity(this);
        m_bPerformCurrActivity = false;
        if(m_CurrWaypoint == null)
        {
            m_CurrWaypoint = cWaypoint;
            m_bActivityInWaypoint = false;
            m_iCurrWaypointBehavior = 0;
            if(m_CurrWaypoint != null)
            {
                if(m_CurrWaypoint.cMotion == null)
                    m_CurrWaypoint.cMotion = new mt_Fly();
                m_CurrActivity = (IAIActivity)m_CurrWaypoint.cMotion;
                m_CurrCondition = m_CurrWaypoint.cEnterCondition;
            }
        } else
        if(!m_bActivityInWaypoint && m_CurrWaypoint.aBehaviors != null && m_CurrWaypoint.aBehaviors.length > 0 || m_bActivityInWaypoint && m_iCurrWaypointBehavior > 0 && m_iCurrWaypointBehavior < m_CurrWaypoint.aBehaviors.length)
        {
            m_bActivityInWaypoint = true;
            m_CurrActivity = (IAIActivity)m_CurrWaypoint.aBehaviors[m_iCurrWaypointBehavior];
            if(m_CurrActivity != null)
                m_CurrCondition = m_CurrWaypoint.aBehaviors[m_iCurrWaypointBehavior].cCondition;
            if(m_iCurrWaypointBehavior == 0)
                GameObject.InvokeActionChain(m_CurrWaypoint.aActions);
            m_iCurrWaypointBehavior++;
        } else
        {
            GameObject.InvokeActionChain(m_CurrWaypoint.aActions);
            m_CurrWaypoint = m_CurrWaypoint.cNext;
            if(m_CurrWaypoint != null)
            {
                m_bActivityInWaypoint = false;
                m_iCurrWaypointBehavior = 0;
                if(m_CurrWaypoint.cMotion == null)
                    m_CurrWaypoint.cMotion = new mt_Move();
                m_CurrActivity = (IAIActivity)m_CurrWaypoint.cMotion;
                m_CurrCondition = m_CurrWaypoint.cEnterCondition;
            } else
            {
                m_CurrActivity = null;
                m_CurrCondition = null;
            }
        }
        CallMethodEvery(METHOD_CheckCurrWaypointCnd, 0.1F);
        CheckCurrWaypointCnd();
    }

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[FlyingTransporter.SGSaveChunk]\n");
        FileChunk cFC = GameObject.NewChunk(1627, cFCParent);
        super.SGSaveChunk(cFC);
        cFC.SaveBool(m_bClosed);
        cFC.SaveBool(m_bChangingState);
        cFC.SaveBool(m_bLocked);
        cFC.SaveBool(m_bEngineRotating);
        cFC.SaveFloat(m_fLastUpdateTime);
        cFC.SaveFloat(m_fCurrEngAngle);
        cFC.SaveFloat(fFXSmokeUpdateTime);
        cFC.SaveBool(m_bSmokeSpawned);
        cFC.SaveFloat(fSmokeHealthLevel);
        cFC.SaveBool(m_bLanded);
        cFC.SaveInt(m_nState);
        cFC.SaveFloat(m_fStateTime);
        cFC.SaveVector(m_vMinExt);
        cFC.SaveVector(m_vMaxExt);
        cFC.SaveObjectRef(m_CurrWaypoint);
        cFC.SaveObjectRef((ISaveGame)m_CurrActivity);
        cFC.SaveObjectRef(m_CurrCondition);
        cFC.SaveInt(m_iCurrWaypointBehavior);
        cFC.SaveBool(m_bPerformCurrActivity);
        cFC.SaveBool(m_bActivityInWaypoint);
        cFC.SaveBool(bSetEnginesInLandingPos);
        SaveMeshElements(cFC);
        cFC.delete();
    }

    void OpenDoor()
    {
        if(m_bLocked)
            return;
        if(m_bClosed && m_bChangingState)
            return;
        CallMethodIn("DoorsOpen", GetAnimLength(sOpenAnim));
        if(m_iDoorElem != -1)
            PlayAnim(sDoor, sOpenAnim, 1);
        if(m_iWysiegnikPElem != -1)
            PlayAnim(sWysiegnikP, sOpenAnim, 1);
        if(m_iWysiegnikLElem != -1)
            PlayAnim(sWysiegnikL, sOpenAnim, 1);
        if(sDoorOpenSound != null && m_iDoorElem != -1)
            PlaySound(sDoorOpenSound, GetElementPos(m_iDoorElem));
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[FlyingTransporter.SGLoadChunk]\n");
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        if(cFC.GetID() == 1627)
        {
            super.SGLoadChunk(cFC);
            m_bClosed = cFC.LoadBool();
            m_bChangingState = cFC.LoadBool();
            m_bLocked = cFC.LoadBool();
            m_bEngineRotating = cFC.LoadBool();
            m_fLastUpdateTime = cFC.LoadFloat();
            m_fCurrEngAngle = cFC.LoadFloat();
            fFXSmokeUpdateTime = cFC.LoadFloat();
            m_bSmokeSpawned = cFC.LoadBool();
            fSmokeHealthLevel = cFC.LoadFloat();
            m_bLanded = cFC.LoadBool();
            m_nState = cFC.LoadInt();
            m_fStateTime = cFC.LoadFloat();
            m_vMinExt = cFC.LoadVector();
            m_vMaxExt = cFC.LoadVector();
            m_CurrWaypoint = (Waypoint)cFC.LoadObjectRef();
            m_CurrActivity = (IAIActivity)cFC.LoadObjectRef();
            m_CurrCondition = (Condition)cFC.LoadObjectRef();
            m_iCurrWaypointBehavior = cFC.LoadInt();
            m_bPerformCurrActivity = cFC.LoadBool();
            m_bActivityInWaypoint = cFC.LoadBool();
            bSetEnginesInLandingPos = cFC.LoadBool();
            LoadMeshElements(cFC);
        }
        cFC.delete();
    }

    public void DeactivateVehicle()
    {
        super.DeactivateVehicle();
        DisableCallMethod("BurnEngines");
        DisableCallMethod(METHOD_DeactivateCannons);
        DisableCallMethod(METHOD_ActivateCannons);
        CallMethodIn(METHOD_DeactivateCannons, 0.0F);
        UnfreezeCallMethod(METHOD_DeactivateCannons);
    }

    void SetEngineAngle(float fAngle)
    {
        if(m_iEngine1Elem != -1)
            RotateElementWithAnim(m_iEngine1Elem, Vector.Right, fAngle);
        if(m_iEngine2Elem != -1)
            RotateElementWithAnim(m_iEngine2Elem, Vector.Right, fAngle);
        m_fCurrEngAngle = fAngle;
    }

    public void ActivateCannons()
    {
        GameObject children[] = GetChildren();
        if(children == null)
            return;
        for(int i = 0; i < children.length; i++)
            if(children[i] instanceof SecurityCannon)
                ((SecurityCannon)children[i]).Enable();

    }

    public void EditorMoveTo(mt_Fly motionType)
    {
        SetPreciseMoving(true);
        super.m_Physics.SetMovePrecision(motionType.fRadius);
        if(super.m_Physics.GetMaxForwardSpeed() < motionType.fSpeed)
            super.m_Physics.SetMaxForwardSpeed(motionType.fSpeed);
        super.m_Physics.SetCurrMaxForwardSpeed(motionType.fSpeed);
        if(GetCurrWaypoint().cNext != null && (GetCurrWaypoint().cNext.cMotion instanceof mt_Fly))
            super.m_Physics.MoveTo(GetCurrWaypoint().GetPosition(), false, false);
        else
            super.m_Physics.MoveTo(GetCurrWaypoint().GetPosition(), false, true);
    }

    public void DeleteFlying()
    {
        DeactivateVehicle();
        if(super.m_Physics != null)
        {
            super.m_Physics.delete();
            super.m_Physics = null;
        }
        DeactivateOnModuleAlways();
        DeleteAttachedFXes();
    }

    public void DoorsOpen()
    {
        m_bChangingState = false;
        m_bClosed = false;
    }

    public void Die()
    {
        if(super.bDead)
            return;
        SpawnBlowFX();
        PlaySound("Data/Sounds/Explosion/WalkerDieExplosion.wav", 10000F, 15000F);
        if(fBlowUpShakeStrength > 0.0F)
            ShakePlayersCamera(fBlowUpShakeStrength, fBlowUpShakeDistMin, fBlowUpShakeDistMax);
        DisableCallMethod(METHOD_CheckCurrWaypointCnd);
        DisableCallMethod(METHOD_WaitingForAppear);
        DeactivateChildren();
        EnableRendering(false);
        ClearFlag(1);
        DisableCallMethod("BurnEngines");
        CallMethodIn("DeleteFlying", 10F);
        super.Die();
    }

    public void SGUpdate()
    {
        FileChunk.Log("[FlyingTransporter.SGUpdate]\n");
        super.SGUpdate();
        if(m_bChangingState)
            if(m_bClosed)
                CallMethodIn("DoorsOpen", GetAnimLength(sOpenAnim));
            else
                CallMethodIn("DoorsClosed", GetAnimLength(sCloseAnim));
    }

    void SetCannonsShadows()
    {
        GameObject children[] = GetChildren();
        if(children == null)
            return;
        for(int i = 0; i < children.length; i++)
            if(children[i] instanceof SecurityCannon)
                ((SecurityCannon)children[i]).ClearFlag(4352);

    }

    public void ReadyToStart()
    {
        DisableCallMethod("ReadyToStart");
        PlayAnimStart(m_fStateTime + _READYTOSTART_DELAY);
    }

    public boolean IsLocked()
    {
        return m_bLocked;
    }

    public void SetVehicleForMovie(boolean bEnable, boolean bPlayEngineStartStopSound)
    {
        super.SetVehicleForMovie(bEnable, bPlayEngineStartStopSound);
        if(bEnable)
        {
            StartMovieBurnEngine();
        } else
        {
            StopMovieBurnEngine();
            StopSmoke();
        }
    }

    void VehicleStarted()
    {
        VehicleStarted(GetTime());
    }

    void VehicleStarted(float fTime)
    {
        m_nState = 2;
        m_fStateTime = fTime;
        super.m_bStarting = false;
        super.m_Physics.SetAccelUpDown(1000F);
        super.m_Physics.SetState("IdleState");
        AttachFlySound();
        if(m_bPerformCurrActivity)
            EditorActivityEnded();
    }

    public void ActivateVehicle()
    {
        super.ActivateVehicle();
        if(m_bSmokeSpawned)
        {
            DisableCallMethod("BurnEngines");
            CallMethodEvery("BurnEngines", _UPDATE_ENGINE_TIME);
        }
        DisableCallMethod(METHOD_DeactivateCannons);
        DisableCallMethod(METHOD_ActivateCannons);
        CallMethodIn(METHOD_ActivateCannons, 0.0F);
        UnfreezeCallMethod(METHOD_ActivateCannons);
    }

    void SpawnSmoke()
    {
        CallMethodIn("FXUpdate", fFXSmokeUpdateTime);
        m_bSmokeSpawned = true;
    }

    public void LockOpened()
    {
        if(m_bClosed || !m_bClosed && m_bChangingState)
        {
            m_bLocked = false;
            OpenDoor();
        }
        m_bLocked = true;
    }

    void PlayFXDustLand()
    {
        super.PlayFXDustLand();
        if(FlyingVehicle._VEHICLE_DUST_LAND != null && GetCurrWaypoint() != null)
            ExecuteFX(FlyingVehicle._VEHICLE_DUST_LAND, GetCurrWaypoint().GetPosition());
    }

    public void EditorActivityEnded()
    {
        ServeNextWaypointActivity();
    }

    public void Appear(ControlObject m_cRefMtxHolder)
    {
        if(m_cRefMtxHolder != null && m_cRefMtxHolder.GetPositionVectorVolatile() != null)
            FromUpForwardPos(m_cRefMtxHolder.GetUpVectorVolatile(), m_cRefMtxHolder.GetForwardVectorVolatile(), m_cRefMtxHolder.GetPositionVectorVolatile());
        UnfreezeCallMethods();
        ActivateVehicle();
        if(bAppearAttached)
        {
            ControlObject aChildren[] = GetChildren();
            if(aChildren == null)
                return;
            for(int i = 0; i < aChildren.length; i++)
                if(aChildren[i] instanceof iact_Appear)
                    aChildren[i].Appear(null);

        }
    }

    public void WaitingForAppear()
    {
        if(!super.m_bVehicleActive)
            CheckCurrWaypointCnd();
    }

    void StopSmoke()
    {
        DisableCallMethod("FXUpdate");
    }

    void StartMovieBurnEngine()
    {
        DisableCallMethod("BurnEngines");
        CallMethodEvery("BurnEngines", _UPDATE_ENGINE_TIME);
    }

    void StopMovieBurnEngine()
    {
        DisableCallMethod("BurnEngines");
    }

    public void CheckCurrWaypointCnd()
    {
        if(m_CurrWaypoint == null)
        {
            DisableCallMethod(METHOD_CheckCurrWaypointCnd);
            return;
        }
        if(!m_bPerformCurrActivity && (m_CurrCondition == null || m_CurrCondition.Evaluate()))
        {
            m_bPerformCurrActivity = true;
            DisableCallMethod(METHOD_WaitingForAppear);
            DisableCallMethod(METHOD_CheckCurrWaypointCnd);
            m_CurrActivity.StartActivity(this);
        }
    }

    public void EditorStartFly(mt_StartFlying motionType)
    {
        float fTime = GetTime();
        super.m_bStarting = true;
        m_nState = 1;
        m_fStateTime = fTime;
        m_bLanded = false;
        CloseDoor();
        DisableCallMethod("BurnEngines");
        CallMethodEvery("BurnEngines", _UPDATE_ENGINE_TIME);
        PlayStartSound(fTime);
        super.m_Physics.SetAccelUpDown(motionType.fAccelUpDown);
        super.m_Physics.SetMaxUpDownSpeed(motionType.fSpeedUpDown);
        super.m_Physics.StartFly(GetCurrWaypoint().GetPosition());
        CallMethodEvery(METHOD_UpdatePassengers, _UPDATE_PASSENGERS_TIME);
        float fDelay = (_READYTOSTART_DELAY + m_fStateTime) - GetTime();
        if(fDelay > 0.0F)
        {
            GameObject.LogD(" fDelay " + fDelay + "\n");
            DisableCallMethod("ReadyToStart");
            CallMethodIn("ReadyToStart", fDelay);
        } else
        {
            ReadyToStart();
        }
    }

    void PlayAnimStart(float fTimeToIgnoreInSingleGame)
    {
        PlayAnimStart();
    }

    void PlayAnimStart()
    {
        if(m_iForwardWheelElem != -1)
            PlayAnim(sForwardWheel, sHideWheelsAnim, 1);
        if(m_iBackwardLeftWheelElem != -1)
            PlayAnim(sBackwardLeftWheel, sHideWheelsAnim, 1);
        if(m_iBackwardRightWheelElem != -1)
            PlayAnim(sBackwardRightWheel, sHideWheelsAnim, 1);
    }

    void SetEngines()
    {
        m_iEngine1Elem = GetElementID(sEngineRight);
        m_iEngine2Elem = GetElementID(sEngineLeft);
        if(m_iEngine1Elem != -1)
            SetElementAnimType(m_iEngine1Elem, (byte)3, false);
        if(m_iEngine2Elem != -1)
            SetElementAnimType(m_iEngine2Elem, (byte)3, false);
        for(int i = 0; i < _ENGINE_EXHAUST_NUM; i++)
            m_EnginesExhaust[i] = GetElementID("Engine0" + Integer.toString(i + 1));

    }

    public void Lock()
    {
        if(!m_bClosed || m_bClosed && m_bChangingState)
        {
            m_bLocked = false;
            CloseDoor();
        }
        m_bLocked = true;
    }

    public void DoorsClosed()
    {
        m_bChangingState = false;
        m_bClosed = true;
    }

    void SetDoors()
    {
        m_iDoorElem = GetElementID(sDoor);
        if(m_iDoorElem == -1)
            m_iDoorElem = GetElementID("Box01");
        m_iWysiegnikPElem = GetElementID(sWysiegnikP);
        m_iWysiegnikLElem = GetElementID(sWysiegnikL);
    }

    void SetWheels()
    {
        m_iForwardWheelElem = GetElementID(sForwardWheel);
        m_iBackwardRightWheelElem = GetElementID(sBackwardRightWheel);
        m_iBackwardLeftWheelElem = GetElementID(sBackwardLeftWheel);
    }

    public FlyingTransporter()
    {
        bAppearAttached = true;
        sForwardWheel = "GolenP";
        m_iForwardWheelElem = -1;
        sBackwardRightWheel = "GolenTP";
        m_iBackwardRightWheelElem = -1;
        sBackwardLeftWheel = "GloenTL";
        m_iBackwardLeftWheelElem = -1;
        sHideWheelsAnim = "chowaniep";
        sShowWheelsAnim = "wysuwaniep";
        sDoor = "Rampa";
        m_iDoorElem = -1;
        sWysiegnikP = "WysiegnikP1";
        m_iWysiegnikPElem = -1;
        sWysiegnikL = "WysiegnikL1";
        m_iWysiegnikLElem = -1;
        sOpenAnim = "otwieraniedrzwi";
        sCloseAnim = "zamykaniedrzwi";
        m_bLocked = false;
        m_bClosed = false;
        m_bChangingState = false;
        sEngineLeft = "SilnikL";
        m_iEngine1Elem = -1;
        sEngineRight = "SilnikP";
        m_iEngine2Elem = -1;
        m_bEngineRotating = true;
        sEnginesExhaust = "FXFlyingEngine";
        _VEHICLE_SMOKE = "SmokeFlyingVehicle";
        sDoorOpenSound = "Data/Sounds/DoorD_Open";
        sDoorCloseSound = "Data/Sounds/DoorD_Close";
        _ENGINE_EXHAUST_NUM = 4;
        _UPDATE_ENGINE_TIME = 0.1F;
        _ENGINE_ROT_SPEED = 30F;
        _ENGINE_STOP_ANGLE = -90F;
        _ENGINE_FLY_ANGLE = -20F;
        _ENGINE_LAND_ANGLE = 0.0F;
        m_fLastUpdateTime = 0.0F;
        m_fCurrEngAngle = 0.0F;
        fFXSmokeUpdateTime = 0.15F;
        m_bSmokeSpawned = false;
        fSmokeHealthLevel = 10F;
        m_EnginesExhaust = new int[_ENGINE_EXHAUST_NUM];
        m_bLanded = true;
        fBlowUpShakeStrength = 0.0F;
        fBlowUpShakeDistMin = 0.0F;
        fBlowUpShakeDistMax = 0.0F;
        m_nState = 0;
        m_fStateTime = -1F;
        _UPDATE_PASSENGERS_TIME = 0.7F;
        _PASSENGERS_COLL_FLAGS = 0xc80000;
        m_fHorizExtMod = 100F;
        m_fMinVertExtMod = 50F;
        m_fMaxVertExtMod = 200F;
        m_vMinExt = new Vector();
        m_vMaxExt = new Vector();
        cWaypoint = null;
        m_CurrWaypoint = null;
        m_CurrActivity = null;
        m_CurrCondition = null;
        m_iCurrWaypointBehavior = 0;
        m_bPerformCurrActivity = false;
        m_bActivityInWaypoint = false;
        METHOD_CheckCurrWaypointCnd = 0;
        METHOD_WaitingForAppear = 0;
        METHOD_UpdatePassengers = 0;
        METHOD_ActivateCannons = 0;
        METHOD_DeactivateCannons = 0;
        bSetEnginesInLandingPos = true;
        super.fHealth = super.fMaxHealth = 5000F;
        super.fDamageThreshold = 100F;
        fBlowUpShakeStrength = 2000F;
        fBlowUpShakeDistMin = 2000F;
        fBlowUpShakeDistMax = 7000F;
    }

    public void EditorLand(mt_Land motionType)
    {
        float fTime = GetTime();
        super.m_bLanding = true;
        m_nState = 3;
        m_fStateTime = fTime;
        PlayAnimLand();
        super.m_Physics.SetAccelUpDown(motionType.fAccelUpDown);
        super.m_Physics.SetMaxUpDownSpeed(motionType.fSpeedUpDown);
        Vector vDestDir = null;
        if(motionType.DestinationDirObj != null)
            vDestDir = motionType.DestinationDirObj.GetForwardVector();
        super.m_Physics.StartLand(GetCurrWaypoint().GetPosition(), vDestDir);
        bSetEnginesInLandingPos = motionType.bSetEnginesInLandingPos;
    }

    public Waypoint GetCurrWaypoint()
    {
        return m_CurrWaypoint;
    }

    public IAIActivity GetCurrActivity()
    {
        if(m_CurrWaypoint != null)
            return m_CurrActivity;
        else
            return null;
    }

    void VehicleLanded()
    {
        VehicleLanded(GetTime());
    }

    void VehicleLanded(float fTime)
    {
        m_nState = 0;
        m_fStateTime = fTime;
        super.m_bLanding = false;
        OpenDoor();
        super.m_Physics.SetAccelUpDown(1000F);
        m_bLanded = true;
        super.m_Physics.SetState("IdleState");
        DisableCallMethod("BurnEngines");
        DetachFlySound();
        if(m_bPerformCurrActivity)
            EditorActivityEnded();
        DisableCallMethod(METHOD_UpdatePassengers);
    }

    void UpdatePassengers()
    {
        ControlObject aChildren[] = GetChildren();
        if(aChildren != null)
        {
            GetMeshExtentsInWorld(m_vMinExt, m_vMaxExt);
            m_vMinExt.fX -= m_fHorizExtMod;
            m_vMinExt.fY -= m_fHorizExtMod;
            m_vMinExt.fZ -= m_fMinVertExtMod;
            m_vMaxExt.fX += m_fHorizExtMod;
            m_vMaxExt.fY += m_fHorizExtMod;
            m_vMaxExt.fZ += m_fMaxVertExtMod;
            for(int i = 0; i < aChildren.length; i++)
            {
                ControlObject child = aChildren[i];
                if(child != null && (child.GetCollFlags() & _PASSENGERS_COLL_FLAGS) == _PASSENGERS_COLL_FLAGS)
                {
                    Vector vPos = child.GetPositionVectorVolatile();
                    if(m_vMinExt.fX > vPos.fX || vPos.fX > m_vMaxExt.fX || m_vMinExt.fY > vPos.fY || vPos.fY > m_vMaxExt.fY || m_vMinExt.fZ > vPos.fZ || vPos.fZ > m_vMaxExt.fZ)
                        child.DetachFromParentAndKeepWorldPos();
                }
            }

        }
    }

    void OnDestinationPos()
    {
        super.OnDestinationPos();
        if(m_bPerformCurrActivity && (GetCurrActivity() instanceof mt_Fly))
            EditorActivityEnded();
    }

    void SetEnginePos(float fTime)
    {
        if(super.m_Physics == null)
            return;
        float fNewAngle = m_fCurrEngAngle;
        if(m_bLanded && bSetEnginesInLandingPos)
        {
            if(fNewAngle < _ENGINE_LAND_ANGLE)
            {
                fNewAngle += _ENGINE_ROT_SPEED * fTime;
                if(fNewAngle > _ENGINE_LAND_ANGLE)
                    fNewAngle = _ENGINE_LAND_ANGLE;
            }
        } else
        {
            float fDestAngle = super.m_Physics.m_fCurrSpeed / super.m_Physics._MAX_FW_SPEED;
            fDestAngle = _ENGINE_STOP_ANGLE - (_ENGINE_STOP_ANGLE - _ENGINE_FLY_ANGLE) * fDestAngle;
            if(fNewAngle < fDestAngle)
            {
                fNewAngle += _ENGINE_ROT_SPEED * fTime;
                if(fNewAngle > fDestAngle)
                    fNewAngle = fDestAngle;
            } else
            if(fNewAngle > fDestAngle)
            {
                fNewAngle -= _ENGINE_ROT_SPEED * fTime;
                if(fNewAngle < fDestAngle)
                    fNewAngle = fDestAngle;
            }
        }
        SetEngineAngle(fNewAngle);
    }

    public void Disappear(ControlObject m_cRefMtxHolder)
    {
        if(m_cRefMtxHolder != null && m_cRefMtxHolder.GetPositionVectorVolatile() != null)
            FromUpForwardPos(m_cRefMtxHolder.GetUpVectorVolatile(), m_cRefMtxHolder.GetForwardVectorVolatile(), m_cRefMtxHolder.GetPositionVectorVolatile());
        FreezeCallMethods();
        DeactivateVehicle();
        UnfreezeCallMethod(METHOD_WaitingForAppear);
        if(m_CurrActivity instanceof mt_Appear)
            StartWaitingForAppear();
        if(bAppearAttached)
        {
            ControlObject aChildren[] = GetChildren();
            if(aChildren == null)
                return;
            for(int i = 0; i < aChildren.length; i++)
                if(aChildren[i] instanceof iact_Appear)
                    aChildren[i].Disappear(null);

        }
    }

    void StartWaitingForAppear()
    {
        CallMethodEvery(METHOD_WaitingForAppear, 0.1F);
        UnfreezeCallMethod(METHOD_WaitingForAppear);
    }

    public void EditorAppear(boolean bAppear)
    {
        if(bAppear)
            Appear(null);
        else
            Disappear(null);
        EditorActivityEnded();
    }

    public void OnCreate()
    {
        super.OnCreate();
        super.fMaxHealth = super.fHealth;
        SetFlag(256);
        SetFlag(4096);
        SetFlag(8192);
        ClearFlag(4);
        ClearFlag(2);
        SetAnimMorphTime(0.0F);
        SetDoors();
        SetEngines();
        SetWheels();
        PrepareInterior();
        m_nState = 0;
        m_fStateTime = -1F;
        METHOD_CheckCurrWaypointCnd = RegisterCallMethod("CheckCurrWaypointCnd");
        METHOD_WaitingForAppear = RegisterCallMethod("WaitingForAppear");
        METHOD_UpdatePassengers = RegisterCallMethod("UpdatePassengers");
        METHOD_ActivateCannons = RegisterCallMethod("ActivateCannons");
        METHOD_DeactivateCannons = RegisterCallMethod("DeactivateCannons");
        SetLighting(true);
        if(cWaypoint != null)
        {
            ActivateVehicle();
            ServeNextWaypointActivity();
        }
    }

    void DeactivateChildren()
    {
        GameObject children[] = GetChildren();
        if(children == null)
            return;
        for(int i = 0; i < children.length; i++)
            if(children[i] instanceof SecurityCannon)
            {
                SecurityCannon cannon = (SecurityCannon)children[i];
                cannon.DetachFromParent();
                cannon.Die();
            } else
            if(children[i] instanceof NewAI)
            {
                NewAI ai = (NewAI)children[i];
                if(ai.m_bIsActive)
                {
                    ai.Die();
                    ai.Deactivate();
                }
            } else
            {
                MeshObject mesh = (MeshObject)children[i];
                mesh.DetachFromParent();
                mesh.EnableRendering(false);
                mesh.DeactivateOnModuleAlways();
                mesh.DeleteAttachedFXes();
            }

    }

    void FXUpdate()
    {
        ExecuteFX(_VEHICLE_SMOKE, GetPosition());
        if(!super.bDead)
            CallMethodIn("FXUpdate", fFXSmokeUpdateTime);
    }

    void PrepareInterior()
    {
        ControlObject children[] = GetChildren();
        if(children == null)
            return;
        for(int i = 0; i < children.length; i++)
            if(children[i] instanceof MeshObject)
            {
                MeshObject mesh = (MeshObject)children[i];
                if(mesh.MeshName.toLowerCase().lastIndexOf("interior") != -1)
                {
                    mesh.ClearFlag(256);
                    mesh.ClearFlag(4096);
                    return;
                }
            }

    }

    public void OnFrame()
    {
        float fCurrTime = GetTime();
        if(m_bEngineRotating)
            SetEnginePos(fCurrTime - m_fLastUpdateTime);
        m_fLastUpdateTime = fCurrTime;
    }

    public boolean bAppearAttached;
    String sForwardWheel;
    int m_iForwardWheelElem;
    String sBackwardRightWheel;
    int m_iBackwardRightWheelElem;
    String sBackwardLeftWheel;
    int m_iBackwardLeftWheelElem;
    String sHideWheelsAnim;
    String sShowWheelsAnim;
    String sDoor;
    int m_iDoorElem;
    String sWysiegnikP;
    int m_iWysiegnikPElem;
    String sWysiegnikL;
    int m_iWysiegnikLElem;
    String sOpenAnim;
    String sCloseAnim;
    boolean m_bLocked;
    boolean m_bClosed;
    boolean m_bChangingState;
    String sEngineLeft;
    int m_iEngine1Elem;
    String sEngineRight;
    int m_iEngine2Elem;
    boolean m_bEngineRotating;
    String sEnginesExhaust;
    String _VEHICLE_SMOKE;
    String sDoorOpenSound;
    String sDoorCloseSound;
    int _ENGINE_EXHAUST_NUM;
    float _UPDATE_ENGINE_TIME;
    float _ENGINE_ROT_SPEED;
    float _ENGINE_STOP_ANGLE;
    float _ENGINE_FLY_ANGLE;
    float _ENGINE_LAND_ANGLE;
    float m_fLastUpdateTime;
    float m_fCurrEngAngle;
    float fFXSmokeUpdateTime;
    boolean m_bSmokeSpawned;
    public float fSmokeHealthLevel;
    int m_EnginesExhaust[];
    boolean m_bLanded;
    public float fBlowUpShakeStrength;
    public float fBlowUpShakeDistMin;
    public float fBlowUpShakeDistMax;
    static final int _STATE_ONGROUND = 0;
    static final int _STATE_STARTING = 1;
    static final int _STATE_FLYING = 2;
    static final int _STATE_LANDING = 3;
    int m_nState;
    float m_fStateTime;
    static float _READYTOSTART_DELAY = 2.0F;
    float _UPDATE_PASSENGERS_TIME;
    int _PASSENGERS_COLL_FLAGS;
    float m_fHorizExtMod;
    float m_fMinVertExtMod;
    float m_fMaxVertExtMod;
    private Vector m_vMinExt;
    private Vector m_vMaxExt;
    public Waypoint cWaypoint;
    Waypoint m_CurrWaypoint;
    IAIActivity m_CurrActivity;
    Condition m_CurrCondition;
    int m_iCurrWaypointBehavior;
    boolean m_bPerformCurrActivity;
    boolean m_bActivityInWaypoint;
    int METHOD_CheckCurrWaypointCnd;
    int METHOD_WaitingForAppear;
    int METHOD_UpdatePassengers;
    int METHOD_ActivateCannons;
    int METHOD_DeactivateCannons;
    boolean bSetEnginesInLandingPos;

}
