// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   GameStatusMsgManager.java

import java.util.Vector;

public class GameStatusMsgManager extends GameObject
{

    boolean IsActive()
    {
        return IsGameGoing() && m_cGameSettings != null;
    }

    void UpdateInfoMsgHUD()
    {
        String sText = "";
        Vector vColor = NetMsg._COLOR_DEFAULT;
        String sWave = null;
        if(IsActive() && GameStatusMsg.IsValid(m_cInfoMsg))
        {
            sText = m_cInfoMsg.GetText();
            vColor = m_cInfoMsg.GetColor();
            sWave = m_cInfoMsg.GetSound();
        }
        if(m_cGameInfo != null && m_cGameInfo.GetHUDNet() != null)
            m_cGameInfo.GetHUDNet().SetTextGameInfo(sText, vColor);
        if(sWave != null)
            PlaySound(sWave);
    }

    GameInfoMsgData GetData()
    {
        return m_cData;
    }

    void UpdateScoreHUD()
    {
        String sText = "";
        Vector vColor = NetMsg._COLOR_DEFAULT;
        if(IsActive() && GameStatusMsg.IsValid(m_cScoreMsg))
            sText = m_cScoreMsg.GetText();
        if(m_cGameInfo != null && m_cGameInfo.GetHUDNet() != null)
            m_cGameInfo.GetHUDNet().SetTextGameScore(sText, vColor);
    }

    void SetInfoMsg(GameInfoMsg cMsg)
    {
        m_cInfoMsg = cMsg;
        m_fInfoMsgUseTime = GetTime();
        if(m_cInfoMsg != null)
            m_cInfoMsg.Used();
        UpdateInfoMsgHUD();
        ScheduleSwitchInfoMsg();
    }

    private GameInfoMsg GetNextInfoMsg()
    {
        GameInfoMsg cNext = null;
        if(GameStatusMsg.IsValid(m_cInfoMsg))
        {
            int nCurrentPriority = m_cInfoMsg.GetPriority();
            for(int i = m_aInfoMsg.indexOf(m_cInfoMsg) + 1; i < m_aInfoMsg.size(); i++)
            {
                GameInfoMsg cMsg = (GameInfoMsg)m_aInfoMsg.get(i);
                if(!GameStatusMsg.IsValid(cMsg) || cMsg.GetPriority() != nCurrentPriority)
                    continue;
                cNext = cMsg;
                break;
            }

            if(cNext != null)
                return cNext;
            for(int i = 0; i < m_aInfoMsg.size(); i++)
            {
                GameInfoMsg cMsg = (GameInfoMsg)m_aInfoMsg.get(i);
                if(GameStatusMsg.IsValid(cMsg) && cMsg.GetPriority() < nCurrentPriority && (cNext == null || cNext.GetPriority() < cMsg.GetPriority()))
                    cNext = cMsg;
            }

        }
        if(cNext == null)
        {
            for(int i = 0; i < m_aInfoMsg.size(); i++)
            {
                GameInfoMsg cMsg = (GameInfoMsg)m_aInfoMsg.get(i);
                if(GameStatusMsg.IsValid(cMsg) && (cNext == null || cNext.GetPriority() < cMsg.GetPriority()))
                    cNext = cMsg;
            }

        }
        return cNext;
    }

    void ForceUpdate()
    {
        ForceUpdateInfo();
        ForceUpdateScore();
    }

    void OnGameRestart()
    {
        m_bGameIsGoing = true;
        ForceUpdate();
    }

    public GameStatusMsgManager()
    {
        m_cGameInfo = null;
        m_cGameSettings = null;
        m_aInfoMsg = new Vector();
        m_cTime = null;
        m_cPoints = null;
        m_cFrags = null;
        m_cData = null;
        m_cScoreMsg = null;
        m_cInfoMsg = null;
        m_fInfoMsgUseTime = 0.0F;
        m_bGameIsGoing = false;
        m_bSwitchInfoMsgScheduled = false;
    }

    boolean IsGameGoing()
    {
        return m_bGameIsGoing;
    }

    void ForceUpdateScore()
    {
        DisableCallMethod("UpdateScore");
        if(IsActive())
        {
            m_cScoreMsg.Update();
        } else
        {
            m_cScoreMsg.Clean();
            UpdateScoreHUD();
        }
    }

    int GetPlayerTeamId()
    {
        if(m_cGameInfo != null && m_cGameInfo.GetPlayerInfoList() != null && m_cGameInfo.GetPlayerInfoList().GetMyPlayer() != null)
            return m_cGameInfo.GetPlayerInfoList().GetMyPlayer().GetTeamId();
        else
            return 0;
    }

    void OnInfoMsgChange(GameInfoMsg cMsg)
    {
        if(cMsg == null)
            return;
        if(m_cInfoMsg == cMsg && !GameStatusMsg.IsValid(m_cInfoMsg))
            SwitchInfoMsg();
        else
        if(m_cInfoMsg == null || m_cInfoMsg == cMsg || m_cInfoMsg.GetPriority() < cMsg.GetPriority())
            SetInfoMsg(cMsg);
        else
        if(!m_bSwitchInfoMsgScheduled)
            ScheduleSwitchInfoMsg(GetTime() - m_fInfoMsgUseTime);
    }

    void OnScoreMsgChange(GameScoreMsg cMsg)
    {
        if(m_cScoreMsg != cMsg)
        {
            return;
        } else
        {
            UpdateScoreHUD();
            return;
        }
    }

    void AddInfoMsg(GameInfoMsg cMsg)
    {
        if(cMsg instanceof GameInfoMsg)
        {
            m_aInfoMsg.addElement(cMsg);
            cMsg.SetManager(this);
        }
    }

    void OnTeamChange()
    {
        ForceUpdate();
    }

    void OnGameScoreChange()
    {
        if(IsActive())
        {
            UpdateInfoScore();
            m_cScoreMsg.Update();
        }
    }

    void ScheduleSwitchInfoMsg()
    {
        ScheduleSwitchInfoMsg(0.0F);
    }

    void ScheduleSwitchInfoMsg(float fDelta)
    {
        DisableCallMethod("SwitchInfoMsg");
        m_bSwitchInfoMsgScheduled = false;
        if(IsActive())
        {
            int nCnt = 0;
            for(int i = 0; i < m_aInfoMsg.size(); i++)
            {
                GameInfoMsg cMsg = (GameInfoMsg)m_aInfoMsg.get(i);
                if(GameStatusMsg.IsValid(cMsg))
                    nCnt++;
            }

            m_bSwitchInfoMsgScheduled = nCnt > 1;
        }
        if(m_bSwitchInfoMsgScheduled)
            CallMethodIn("SwitchInfoMsg", 10F - fDelta);
    }

    void SwitchInfoMsg()
    {
        SetInfoMsg(GetNextInfoMsg());
    }

    void StatusChanged()
    {
        if(m_cGameInfo != null && ((GameObject) (m_cGameInfo)).Role == 4)
            m_cGameInfo.MsgSendClientGameStatusMsgUpdated(m_cData.ToDataContainer());
    }

    void UpdateInfo()
    {
        UpdateInfoTime();
        UpdateInfoScore();
    }

    void UpdateInfoScore()
    {
        if(!IsActive())
            return;
        if((float)m_cGameSettings.GetPointsLimit() > -1F)
        {
            int nPointsLeft = m_cGameSettings.GetPointsLimit() - m_cGameInfo.GetLeaderPoints();
            m_cPoints.Update(nPointsLeft);
        }
        if((float)m_cGameSettings.GetFragsLimit() > -1F)
        {
            int nFragsLeft = m_cGameSettings.GetFragsLimit() - m_cGameInfo.GetLeaderFrags();
            m_cFrags.Update(nFragsLeft);
        }
    }

    final void ForceUpdateInfo()
    {
        DisableCallMethod("UpdateInfoTime");
        if(IsActive())
        {
            UpdateInfo();
            if(m_cGameSettings != null && m_cGameSettings.GetGameTimeLimit() > -1F)
                CallMethodEvery("UpdateInfoTime", 1.0F);
        } else
        {
            if(m_cData != null)
                m_cData.Clean();
            SetInfoMsg(null);
        }
    }

    void UpdateInfoTime()
    {
        if(!IsActive())
            return;
        if(m_cGameSettings.GetGameTimeLimit() > -1F)
        {
            float fTimeLeft = m_cGameSettings.GetGameTimeLimit() - m_cGameInfo.GetGameTime();
            m_cTime.Update(fTimeLeft);
        }
    }

    void OnGameOver()
    {
        m_bGameIsGoing = false;
        ForceUpdate();
    }

    void OnCreate()
    {
        m_cTime = new GameInfoMsgTime();
        m_cPoints = new GameInfoMsgPoints();
        m_cFrags = new GameInfoMsgFrags();
        AddInfoMsg(m_cTime);
        AddInfoMsg(m_cPoints);
        AddInfoMsg(m_cFrags);
        m_cScoreMsg = new GameScoreMsg();
    }

    void Init(boolean bGameIsGoing, NetGameSettings cSettings)
    {
        m_bGameIsGoing = bGameIsGoing;
        m_cGameSettings = cSettings;
        if(m_cScoreMsg != null)
            m_cScoreMsg.SetGameSettings(cSettings);
        ForceUpdate();
    }

    void StatusUpdated(NetDataContainer cContainer)
    {
        if(m_cData != null)
            m_cData.FromDataContainer(cContainer);
        StatusChanged();
    }

    void SetGameInfo(NetGameInfoHud cGameInfo)
    {
        m_cGameInfo = cGameInfo;
        if(m_cScoreMsg != null)
            m_cScoreMsg.SetParams(this, cGameInfo);
    }

    void OnDestroy()
    {
        m_cGameInfo = null;
        m_cGameSettings = null;
        for(int i = 0; i < m_aInfoMsg.size(); i++)
        {
            GameInfoMsg cMsg = (GameInfoMsg)m_aInfoMsg.get(i);
            cMsg.Destroy();
        }

        m_aInfoMsg.removeAllElements();
        m_cTime = null;
        m_cPoints = null;
        m_cFrags = null;
        if(m_cScoreMsg != null)
        {
            m_cScoreMsg.Destroy();
            m_cScoreMsg = null;
        }
    }

    NetGameInfoHud m_cGameInfo;
    NetGameSettings m_cGameSettings;
    Vector m_aInfoMsg;
    GameInfoMsgTime m_cTime;
    GameInfoMsgPoints m_cPoints;
    GameInfoMsgFrags m_cFrags;
    GameInfoMsgData m_cData;
    GameScoreMsg m_cScoreMsg;
    GameInfoMsg m_cInfoMsg;
    float m_fInfoMsgUseTime;
    boolean m_bGameIsGoing;
    boolean m_bSwitchInfoMsgScheduled;
}
