// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   HintManager.java

import java.util.Vector;

public class HintManager extends GameObject
{

    protected void ShowText(String sText)
    {
        GameObject.LogR("HintManager.ShowText <" + sText + "> hint " + m_cActiveHint + "\n");
        if(m_cText == null)
            return;
        m_cText.SetFont(ChromeFonts.FONT_HINT);
        m_cText.SetTextPosFlags(ESpriteText.MULTILINE);
        int nTextLeftMargin = GameObject.GetScreenWidth() / 4;
        int nSizeX = GameObject.GetScreenWidth() / 3;
        int nSizeY = GameObject.GetScreenHeight();
        m_cText.SetSize(new Vector(nSizeX, nSizeY, 0.0F));
        m_cText.DisplayText(Text.Get(sText));
        Vector vMargin = new Vector(15F, 10F, 0.0F);
        Vector vTextSize = m_cText.GetTextExtent(sText);
        m_cText.SetSize(vTextSize);
        m_cText.DisplayText(sText);
        Vector vPos = new Vector(30F, ((float)GameObject.GetScreenHeight() * 2.0F) / 3F - m_cText.GetSize().fY / 2.0F, 0.0F);
        m_cText.SetPos(vPos);
        Vector vBkSize = vTextSize.Add2(vMargin.Mul2(2.0F));
        Vector vBkPos = vPos.Sub2(vMargin);
        m_cTextBkg.SetSize(vBkSize);
        m_cTextBkg.SetPos(vBkPos);
        m_cTextBkg.MoveTop();
        m_cTextBkg.Show();
        m_cText.MoveTop();
        m_cText.Show();
        if(m_bBlinking)
            InitBlinking();
    }

    void BlendText()
    {
        float fCoeff = (GetTime() - m_fBlendStartTime) / 5F;
        if(fCoeff >= 1.0F)
        {
            float fAlpha = 1.0F - fCoeff * 0.5F;
            GameObject.LogD(" " + GetTime() + " " + fAlpha + "\n");
            if(m_cText != null)
                m_cText.SetAlpha(fAlpha);
            DisableCallMethod(METHOD_BlendText);
            CallMethodIn(METHOD_BlendText, 0.0F);
        } else
        {
            HideText();
        }
    }

    void DeactivateHint()
    {
        GameObject.LogD("\n");
        if(m_cActiveHint == null)
            return;
        if(m_cActiveHint.m_fMinDisplayPause != -1F)
            m_fNextHintTime = GetTime() + m_cActiveHint.m_fMinDisplayPause;
        else
            m_fNextHintTime = GetTime() + _MIN_DISPLAY_PAUSE;
        if(m_bBlendingHide)
        {
            HideTextBlend();
            m_fNextHintTime += 5F;
        } else
        {
            HideText();
        }
        if(m_cActiveHint.DisplayOnce())
            m_cActiveHint.SetToRemove();
        else
            m_cActiveHint.ResolveNextCheckTimeAfterActivate(GetTime());
        m_cActiveHint.DisplayFinished();
        m_cActiveHint = null;
    }

    void CancelHint()
    {
        GameObject.LogD("\n");
        if(m_cActiveHint == null)
            return;
        m_fNextHintTime = GetTime() + _MIN_DISPLAY_PAUSE;
        if(m_bBlendingHide)
        {
            HideTextBlend();
            m_fNextHintTime += 5F;
        } else
        {
            HideText();
        }
        m_cActiveHint.ResolveNextCheckTimeAfterActivate(GetTime());
        m_cActiveHint.DisplayCanceled();
        m_cActiveHint = null;
    }

    void HideTextBlend()
    {
        m_fBlendStartTime = GetTime();
        CallMethodIn(METHOD_BlendText, 0.0F);
    }

    void ActivateHint(Hint hint)
    {
        GameObject.LogD("\n");
        if(hint == null)
        {
            return;
        } else
        {
            m_cActiveHint = hint;
            ShowText(m_cActiveHint.GetText());
            DisableCallMethod(METHOD_DeactivateHint);
            CallMethodIn(METHOD_DeactivateHint, m_cActiveHint.GetTimeDuration());
            m_cActiveHint.DisplayStarted();
            return;
        }
    }

    void Deactivate()
    {
        GameObject.LogD("\n");
        if(!m_bActive)
            return;
        m_bActive = false;
        if(m_cActiveHint == null)
        {
            return;
        } else
        {
            HideText();
            return;
        }
    }

    void AddHint(Hint hint)
    {
        if(hint == null)
            return;
        if(m_aHints == null)
        {
            return;
        } else
        {
            m_aHints.addElement(hint);
            hint.SetHintManager(this);
            return;
        }
    }

    public void SGUpdate()
    {
        super.SGUpdate();
        if(m_bActiveSG)
            Activate();
    }

    void Stop()
    {
        DisableCallMethod(METHOD_CheckHints);
        Deactivate();
    }

    public HintManager()
    {
        m_bActive = false;
        m_aHints = null;
        m_aRemovedHints = null;
        m_cActiveHint = null;
        m_fNextHintTime = 0.0F;
        m_cText = null;
        m_cTextBkg = null;
        m_nTextDownMargin = 150;
        m_bBlinking = true;
        m_bBlinkingOn = false;
        m_nBlinkingCnt = 0;
        m_bBlendingHide = false;
        m_fBlendStartTime = 0.0F;
        METHOD_CheckHints = 0;
        METHOD_DeactivateHint = 0;
        METHOD_BlinkText = 0;
        METHOD_BlendText = 0;
        cModule = null;
        m_bTutorial = false;
        m_bActiveSG = false;
        m_cActiveHintSG = null;
    }

    void BlinkText()
    {
        if(m_bBlinkingOn)
        {
            m_cTextBkg.Hide();
            m_cText.Hide();
            CallMethodIn(METHOD_BlinkText, 0.15F);
        } else
        {
            m_cTextBkg.Show();
            m_cText.Show();
            if(--m_nBlinkingCnt > 0)
                CallMethodIn(METHOD_BlinkText, 0.15F);
        }
        m_bBlinkingOn = !m_bBlinkingOn;
    }

    void CheckHintsToRemove()
    {
        if(m_aHints == null)
            return;
        if(m_aRemovedHints == null)
            return;
        for(int i = 0; i < m_aHints.size(); i++)
        {
            Hint hint = (Hint)m_aHints.elementAt(i);
            if(hint != null && hint.GetToRemove())
            {
                MoveHintToRemoved(i);
                i--;
            }
        }

    }

    void CheckHints()
    {
        if(cModule.cMoviePlaying != null)
            return;
        if((cModule instanceof ChromeModuleSingle) && ((ChromeModuleSingle)cModule).m_bPlayingScene)
            return;
        if(m_cActiveHint != null)
            return;
        if(GetTime() < m_fNextHintTime)
            return;
        CheckHintsToRemove();
        if(m_bActive)
            CheckHintsToActivate();
    }

    void Activate()
    {
        GameObject.LogD("\n");
        if(m_bActive)
            return;
        m_bActive = true;
        if(m_cActiveHint == null)
        {
            return;
        } else
        {
            ShowText(m_cActiveHint.GetText());
            return;
        }
    }

    void RemoveHint(Hint hint)
    {
        if(hint == null)
            return;
        if(m_aHints == null)
        {
            return;
        } else
        {
            m_aHints.remove(hint);
            return;
        }
    }

    void CheckHintsToActivate()
    {
        if(m_aHints == null)
            return;
        float fTimeNow = GetTime();
        Hint cHint = null;
        for(int i = 0; i < m_aHints.size(); i++)
        {
            Hint hint = (Hint)m_aHints.elementAt(i);
            if(hint == null || (!hint.Available() || fTimeNow < hint.GetNextCheckTime()))
                continue;
            hint.ResolveNextCheckTime(fTimeNow);
            if(!hint.ShouldBeActivated(fTimeNow))
                continue;
            if(cHint == null)
            {
                cHint = hint;
                break;
            }
            if(cHint.GetId() > hint.GetId())
                cHint = hint;
        }

        if(cHint != null)
        {
            cHint.ResolveNextCheckTime(fTimeNow);
            ActivateHint(cHint);
        }
    }

    void HideText()
    {
        GameObject.LogD("\n");
        m_cTextBkg.Hide();
        m_cText.Hide();
        DisableCallMethod(METHOD_BlinkText);
        DisableCallMethod(METHOD_BlendText);
    }

    void Clear()
    {
        HideText();
        if(m_cActiveHint != null)
        {
            m_cActiveHint.SetToRemove();
            m_cActiveHint.DisplayFinished();
            m_cActiveHint = null;
        }
        if(m_aRemovedHints != null)
            m_aRemovedHints.removeAllElements();
        if(m_aHints != null)
            m_aHints.removeAllElements();
        ClearTime();
        DisableCallMethods();
    }

    void MoveTop()
    {
        m_cTextBkg.MoveTop();
        m_cText.MoveTop();
    }

    void ClearTime()
    {
        m_fNextHintTime = GetTime() + _TIME_START_DELAY;
        DisableCallMethod(METHOD_CheckHints);
        CallMethodEvery(METHOD_CheckHints, 1.0F);
        for(int i = 0; i < m_aHints.size(); i++)
        {
            Hint hint = (Hint)m_aHints.elementAt(i);
            if(hint != null)
                hint.ResolveNextCheckTime(GetTime());
        }

    }

    void IncomingMessage(int nId)
    {
        if(m_bTutorial && nId < 101)
            return;
        for(int i = 0; i < m_aHints.size(); i++)
        {
            Hint hint = (Hint)m_aHints.elementAt(i);
            if(hint != null)
                hint.IncomingMessage(nId);
        }

        if(m_cActiveHint != null && m_cActiveHint.GetToRemove())
            CancelHint();
        CheckHints();
    }

    void OnCreate()
    {
        m_cTextBkg = (Sprite)CreateObject("Sprite");
        m_cTextBkg.SetTexture(m_cTextBkg.AddTexture("er_t_black.png"), new Rect(0.0F, 0.0F, 1.0F, 1.0F));
        m_cTextBkg.SetAlpha(0.4F);
        m_cTextBkg.ProcessMouse(false);
        m_cTextBkg.SetSize(new Vector(1024F, 768F, 0.0F));
        m_cTextBkg.SetPos(new Vector(10F, 455F, 0.0F));
        AddSprite(m_cTextBkg);
        m_cTextBkg.MoveTop();
        m_cText = (Sprite)CreateObject("Sprite");
        m_cText.ProcessMouse(false);
        m_cText.SetTextColor(1.0F, 1.0F, 1.0F, 1.0F);
        m_cText.SetSize(new Vector(1024F, 768F, 0.0F));
        m_cText.SetPos(new Vector(10F, 455F, 0.0F));
        m_cText.Show();
        AddSprite(m_cText);
        m_cText.MoveTop();
        m_cTextBkg.Hide();
        m_cText.Hide();
        m_aHints = new Vector(0, 8);
        m_aRemovedHints = new Vector(0, 8);
        METHOD_CheckHints = RegisterCallMethod("CheckHints");
        METHOD_DeactivateHint = RegisterCallMethod("DeactivateHint");
        METHOD_BlinkText = RegisterCallMethod("BlinkText");
        METHOD_BlendText = RegisterCallMethod("BlendText");
        cModule = (ChromeModule)GetModule();
    }

    void MoveHintToRemoved(int nIndex)
    {
        if(m_aHints == null)
            return;
        if(m_aHints.size() <= nIndex)
            return;
        Hint hint = (Hint)m_aHints.elementAt(nIndex);
        m_aHints.remove(nIndex);
        if(m_aRemovedHints == null)
        {
            return;
        } else
        {
            m_aRemovedHints.addElement(hint);
            return;
        }
    }

    void InitBlinking()
    {
        m_nBlinkingCnt = _BLINKING_CNT;
        m_bBlinkingOn = true;
        if(m_nBlinkingCnt > 0)
            CallMethodIn(METHOD_BlinkText, 0.15F);
    }

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[HintManager.SGSaveChunk]\n");
        FileChunk cFC = GameObject.NewChunk(1002, cFCParent);
        super.SGSaveChunk(cFC);
        cFC.SaveBool(m_bActive);
        cFC.SaveObjectsVectorRef(m_aHints);
        cFC.SaveObjectsVectorRef(m_aRemovedHints);
        cFC.SaveObjectRef(m_cActiveHint);
        cFC.SaveFloat(m_fNextHintTime);
        cFC.SaveBool(m_bBlinking);
        cFC.SaveBool(m_bBlinkingOn);
        cFC.SaveInt(m_nBlinkingCnt);
        cFC.SaveBool(m_bBlendingHide);
        cFC.SaveFloat(m_fBlendStartTime);
        cFC.SaveBool(m_bTutorial);
        cFC.SaveFloat(_MIN_DISPLAY_PAUSE);
        cFC.SaveFloat(_TIME_START_DELAY);
        cFC.delete();
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[HintManager.SGLoadChunk]\n");
        Deactivate();
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        if(cFC.GetID() == 1002)
        {
            super.SGLoadChunk(cFC);
            m_bActiveSG = cFC.LoadBool();
            m_aHints = cFC.LoadObjectsVectorRef();
            m_aRemovedHints = cFC.LoadObjectsVectorRef();
            for(int i = 0; i < m_aHints.size(); i++)
                ((Hint)m_aHints.elementAt(i)).SetHintManager(this);

            for(int i = 0; i < m_aRemovedHints.size(); i++)
                ((Hint)m_aRemovedHints.elementAt(i)).SetHintManager(this);

            m_cActiveHint = (Hint)cFC.LoadObjectRef();
            m_fNextHintTime = cFC.LoadFloat();
            m_bBlinking = cFC.LoadBool();
            m_bBlinkingOn = cFC.LoadBool();
            m_nBlinkingCnt = cFC.LoadInt();
            m_bBlendingHide = cFC.LoadBool();
            m_fBlendStartTime = cFC.LoadFloat();
            m_bTutorial = cFC.LoadBool();
            _MIN_DISPLAY_PAUSE = cFC.LoadFloat();
            _TIME_START_DELAY = cFC.LoadFloat();
        }
        cFC.delete();
    }

    void Start(boolean bTutorialOn)
    {
        m_bTutorial = bTutorialOn;
        m_fNextHintTime = GetTime() + _TIME_START_DELAY;
        CallMethodEvery(METHOD_CheckHints, 1.0F);
    }

    void OnDestroy()
    {
        DisableCallMethods();
        if(m_cText != null)
        {
            RemoveSprite(m_cText);
            m_cText.delete();
            m_cText = null;
        }
        if(m_cTextBkg != null)
        {
            RemoveSprite(m_cTextBkg);
            m_cTextBkg.delete();
            m_cTextBkg = null;
        }
    }

    static final float _CHECK_TIME = 1F;
    static float _MIN_DISPLAY_PAUSE = 5F;
    static float _TIME_START_DELAY = 5F;
    boolean m_bActive;
    Vector m_aHints;
    Vector m_aRemovedHints;
    protected Hint m_cActiveHint;
    float m_fNextHintTime;
    protected Sprite m_cText;
    protected Sprite m_cTextBkg;
    protected int m_nTextDownMargin;
    boolean m_bBlinking;
    static final float _BLINKING_ON_TIME = 0.15F;
    static final float _BLINKING_OFF_TIME = 0.15F;
    static int _BLINKING_CNT = 3;
    boolean m_bBlinkingOn;
    int m_nBlinkingCnt;
    boolean m_bBlendingHide;
    static final float _BLEND_TIME = 5F;
    float m_fBlendStartTime;
    int METHOD_CheckHints;
    int METHOD_DeactivateHint;
    int METHOD_BlinkText;
    int METHOD_BlendText;
    ChromeModule cModule;
    boolean m_bTutorial;
    static final int _MSG_MAPUSED = 0;
    static final int _MSG_BINOCULARSUSED = 1;
    static final int _MSG_JEEPUSED = 2;
    static final int _MSG_TAKENDAMAGE = 3;
    static final int _MSG_HEALTHEXUSED = 4;
    static final int _MSG_NOAMMO = 5;
    static final int _MSG_WEAPONRELOADED = 6;
    static final int _MSG_IMPLANTSUSED = 7;
    static final int _MSG_DEAD_BODY = 8;
    static final int _MSG_TUTORIAL = 101;
    static final int _MSG_TUTORIAL_STEP1_ENDED = 101;
    static final int _MSG_TUTORIAL_STEP2_ENDED = 102;
    static final int _MSG_TUTORIAL_STEP4_ENDED = 104;
    static final int _MSG_TUTORIAL_STEP5_ENDED = 105;
    static final int _MSG_TUTORIAL_STEP6_ENDED = 106;
    static final int _MSG_TUTORIAL_STEP7_ENDED = 107;
    static final int _MSG_TUTORIAL_STEP8_ENDED = 108;
    static final int _MSG_TUTORIAL_STEP9_ENDED = 109;
    static final int _MSG_TUTORIAL_STEP10_ENDED = 110;
    static final int _MSG_TUTORIAL_STEP11_ENDED = 111;
    static final int _MSG_TUTORIAL_STEP12_ENDED = 112;
    static final int _MSG_TUTORIAL_STEP13_ENDED = 113;
    static final int _MSG_TUTORIAL_STEP14_ENDED = 114;
    static final int _MSG_TUTORIAL_STEP15_ENDED = 115;
    boolean m_bActiveSG;
    Hint m_cActiveHintSG;

}
