// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   HitIndicators.java


public class HitIndicators extends GameObject
{

    public void OnDestroy()
    {
        for(int i = 0; i < m_HitIndSprites.length; i++)
        {
            if(m_HitIndTextNo[i] != 0)
                m_HitIndSprites[i].ReleaseTexture(m_HitIndTextNo[i]);
            RemoveSprite(m_HitIndSprites[i]);
            m_HitIndSprites[i].delete();
            m_HitIndSprites[i] = null;
        }

        m_HitIndSprites = null;
        m_cOverloadSprite.ReleaseTexture(m_nOverloadTexNo);
        RemoveSprite(m_cOverloadSprite);
        m_cOverloadSprite.delete();
        m_cOverloadSprite = null;
        m_cDrowningSprite.ReleaseTexture(m_nDrowningTexNo);
        RemoveSprite(m_cDrowningSprite);
        m_cDrowningSprite.delete();
        m_cDrowningSprite = null;
        GameObject.CrashLog("[HitIndicators.OnDestroy]: Destroing DONE. \n");
    }

    int CalculatePlace(Vector vFrom)
    {
        int iReturn = 0;
        Vector vDir = new Vector(vFrom);
        vDir.Sub(m_Player.GetPosition());
        vDir.fY = 0.0F;
        vDir.Normalize();
        Vector vPlayerFwd = m_Player.GetForwardVector();
        vPlayerFwd.fY = 0.0F;
        vPlayerFwd.Normalize();
        float fDot = vPlayerFwd.Dot(vDir);
        float fCross = vPlayerFwd.Cross(vDir).fY;
        if(fDot > _DOT_TABLE[0])
            iReturn |= _UP;
        else
        if(fDot > _DOT_TABLE[1])
        {
            if(fCross < 0.0F)
                iReturn |= _UP | _RIGHT;
            else
                iReturn |= _UP | _LEFT;
        } else
        if(fDot > _DOT_TABLE[2])
        {
            if(fCross < 0.0F)
                iReturn |= _RIGHT;
            else
                iReturn |= _LEFT;
        } else
        if(fDot > _DOT_TABLE[3])
        {
            if(fCross < 0.0F)
                iReturn |= _DOWN | _RIGHT;
            else
                iReturn |= _DOWN | _LEFT;
        } else
        {
            iReturn |= _DOWN;
        }
        return iReturn;
    }

    void ShowOverload()
    {
        m_cOverloadSprite.Show();
        m_fOverloadAlpha = 1.0F - GameObject.RandomFloat(0.1F);
        m_cOverloadSprite.SetAlpha(m_fOverloadAlpha);
        m_nOverloadAlphaWaves = 7;
        m_fOverloadAlphaCurWave = 0.2F + GameObject.RandomFloat(0.33F);
    }

    void ShowDrowning()
    {
        m_cDrowningSprite.Show();
        m_fDrowningDestAlpha = 0.6F;
    }

    void ShowHit(int iNum)
    {
        m_HitIndSprites[iNum].Show();
        m_Alpha[iNum] = 1.0F;
        m_HitIndSprites[iNum].SetAlpha(m_Alpha[iNum]);
    }

    void HideForMovie()
    {
        m_cOverloadSprite.Hide();
        m_cDrowningSprite.Hide();
    }

    public void SGUpdate()
    {
        super.SGUpdate();
        m_fLastUpdate = GetTime();
        for(int i = 0; i < _NOF_HIT_IND; i++)
        {
            m_Alpha[i] = 0.0F;
            m_HitIndSprites[i].SetAlpha(m_Alpha[i]);
            m_HitIndSprites[i].Hide();
        }

        if(m_cOverloadSprite != null)
        {
            m_cOverloadSprite.SetAlpha(0.0F);
            m_cOverloadSprite.Hide();
        }
        if(m_cDrowningSprite != null)
        {
            if(m_fDrowningAlpha > 0.0F)
                m_cDrowningSprite.Show();
            else
                m_cDrowningSprite.Hide();
            m_cDrowningSprite.SetAlpha(m_fDrowningAlpha);
        }
    }

    public HitIndicators()
    {
        m_Player = null;
        m_sHitTextureName = "CH_T_Cyber.png";
        m_HitIndSprites = new Sprite[_NOF_HIT_IND];
        m_cOverloadSprite = null;
        m_cDrowningSprite = null;
        m_HitIndTextNo = new int[_NOF_HIT_IND];
        m_nOverloadTexNo = 0;
        m_nDrowningTexNo = 0;
        m_vHitSpriteSize = new Vector(359F, 24F, 0.0F);
        m_Alpha = new float[4];
        m_fOverloadAlpha = 0.0F;
        m_fOverloadAlphaCurWave = 0.0F;
        m_nOverloadAlphaWaves = 0;
        m_fDrowningAlpha = 0.0F;
        m_fDrowningDestAlpha = -1F;
        m_fLastUpdate = 0.0F;
        m_bDisableInNetGame = false;
    }

    public void SetPlayer(PlayerHUD player)
    {
        m_Player = player;
        if(m_Player instanceof PlayerNetBase)
            m_bDisableInNetGame = !((GameObject) (m_Player)).bNetIsOwner;
    }

    void DecreaseAlphas(float fTime)
    {
        for(int i = 0; i < _NOF_HIT_IND; i++)
            if(m_Alpha[i] > 0.0F)
            {
                m_Alpha[i] -= fTime * _DISAPPEAR_SPEED;
                if(m_Alpha[i] < 0.0F)
                {
                    m_Alpha[i] = 0.0F;
                    m_HitIndSprites[i].Hide();
                }
                m_HitIndSprites[i].SetAlpha(m_Alpha[i]);
            }

        if(m_fOverloadAlpha > 0.0F)
        {
            m_fOverloadAlpha -= fTime * _DISAPPEAR_SPEED_OVERLOAD;
            if(m_nOverloadAlphaWaves > 0 && m_fOverloadAlpha <= m_fOverloadAlphaCurWave)
            {
                m_nOverloadAlphaWaves--;
                m_fOverloadAlphaCurWave = 0.5F + GameObject.RandomFloat(0.33F);
                m_fOverloadAlpha = m_fOverloadAlphaCurWave + GameObject.RandomFloat(0.5F);
            }
            if(m_fOverloadAlpha < 0.0F)
                m_fOverloadAlpha = 0.0F;
            if(m_fOverloadAlpha > 1.0F)
                m_fOverloadAlpha = 1.0F;
            m_cOverloadSprite.SetAlpha(m_fOverloadAlpha);
        }
        if(m_fDrowningDestAlpha > 0.0F)
        {
            m_fDrowningAlpha += fTime * _DISAPPEAR_SPEED_DROWNING;
            if(m_fDrowningAlpha >= m_fDrowningDestAlpha)
                m_fDrowningAlpha = m_fDrowningDestAlpha;
            m_cDrowningSprite.SetAlpha(m_fDrowningAlpha);
        } else
        if(m_fDrowningDestAlpha == 0.0F)
        {
            m_fDrowningAlpha -= fTime * _DISAPPEAR_SPEED_DROWNING;
            if(m_fDrowningAlpha <= m_fDrowningDestAlpha)
            {
                m_fDrowningAlpha = m_fDrowningDestAlpha;
                m_fDrowningDestAlpha = -1F;
                m_cDrowningSprite.Hide();
            }
            m_cDrowningSprite.SetAlpha(m_fDrowningAlpha);
        }
    }

    void HideOverload()
    {
        m_cOverloadSprite.Hide();
    }

    void HideDrowning()
    {
        m_fDrowningDestAlpha = 0.0F;
    }

    public void OnCreate()
    {
        int iRotation = 0;
        for(int i = 0; i < _NOF_HIT_IND; i++)
        {
            m_HitIndSprites[i] = (Sprite)CreateObject("Sprite");
            m_HitIndTextNo[i] = m_HitIndSprites[i].AddTexture(m_sHitTextureName);
            m_HitIndSprites[i].SetBlendingMode(25344);
            m_HitIndSprites[i].SetTexture(m_HitIndTextNo[i], Rect.WHOLE_TEX);
            m_HitIndSprites[i].SetSize(m_vHitSpriteSize);
            m_HitIndSprites[i].SetRotation(iRotation);
            iRotation += 90;
            m_HitIndSprites[i].ProcessMouse(false);
            AddSprite(m_HitIndSprites[i]);
            m_HitIndSprites[i].MoveTop();
        }

        m_cOverloadSprite = (Sprite)CreateObject("Sprite");
        AddSprite(m_cOverloadSprite);
        m_cOverloadSprite.SetBlendingMode(25344);
        m_cOverloadSprite.SetSize(new Vector(GameObject.GetScreenWidth(), GameObject.GetScreenHeight(), 0.0F));
        m_nOverloadTexNo = m_cOverloadSprite.AddTexture("er_t_black.png");
        m_cOverloadSprite.SetTexture(m_nOverloadTexNo, new Rect(0.0F, 0.0F, 1.0F, 1.0F));
        m_cOverloadSprite.MoveTop();
        m_HitIndSprites[0].SetPos(new Vector(((float)GameObject.GetScreenWidth() - m_vHitSpriteSize.fX) / 2.0F, _SPACE_SCREEN, 0.0F));
        m_HitIndSprites[1].SetPos(new Vector((float)GameObject.GetScreenWidth() - m_vHitSpriteSize.fY - m_vHitSpriteSize.fX / 2.0F - (float)_SPACE_SCREEN, (float)GameObject.GetScreenHeight() / 2.0F - m_vHitSpriteSize.fY / 2.0F, 0.0F));
        m_HitIndSprites[2].SetPos(new Vector(((float)GameObject.GetScreenWidth() - m_vHitSpriteSize.fX) / 2.0F, (float)GameObject.GetScreenHeight() - m_vHitSpriteSize.fY - (float)_SPACE_HUD - (float)_SPACE_SCREEN, 0.0F));
        m_HitIndSprites[3].SetPos(new Vector((float)_SPACE_SCREEN - m_vHitSpriteSize.fX / 2.0F, (float)GameObject.GetScreenHeight() / 2.0F - m_vHitSpriteSize.fY / 2.0F, 0.0F));
        m_cDrowningSprite = (Sprite)CreateObject("Sprite");
        AddSprite(m_cDrowningSprite);
        m_cDrowningSprite.SetSize(new Vector(GameObject.GetScreenWidth(), GameObject.GetScreenHeight(), 0.0F));
        m_nDrowningTexNo = m_cDrowningSprite.AddTexture("er_t_purple.png");
        m_cDrowningSprite.SetTexture(m_nDrowningTexNo, new Rect(0.0F, 0.0F, 1.0F, 1.0F));
        m_cDrowningSprite.MoveTop();
    }

    public void Hit(Vector vShotPoint)
    {
        if(m_Player == null)
            return;
        if(!m_Player.HUD.m_bActivateAllowed)
            return;
        if(m_bDisableInNetGame)
            return;
        int iShow = CalculatePlace(vShotPoint);
        if((iShow & _UP) > 0)
            ShowHit(0);
        if((iShow & _RIGHT) > 0)
            ShowHit(1);
        if((iShow & _DOWN) > 0)
            ShowHit(2);
        if((iShow & _LEFT) > 0)
            ShowHit(3);
    }

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk cFC = GameObject.NewChunk(1171, cFCParent);
        super.SGSaveChunk(cFC);
        cFC.SaveFloat(m_fDrowningAlpha);
        cFC.SaveFloat(m_fDrowningDestAlpha);
        cFC.delete();
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        super.SGLoadChunk(cFC);
        m_fDrowningAlpha = cFC.LoadFloat();
        m_fDrowningDestAlpha = cFC.LoadFloat();
        cFC.delete();
    }

    public void OnFrame()
    {
        float fCurrTime = GetTime();
        DecreaseAlphas(fCurrTime - m_fLastUpdate);
        m_fLastUpdate = fCurrTime;
    }

    static int _SPACE_SCREEN = 8;
    static int _SPACE_HUD = 62;
    static int _UP = 1;
    static int _RIGHT = 2;
    static int _DOWN = 4;
    static int _LEFT = 8;
    static float _DOT_TABLE[] = {
        0.9238F, 0.3826F, 0, -0.3826F, -0.9238F
    };
    static float _DISAPPEAR_SPEED = 2.0F;
    static float _DISAPPEAR_SPEED_OVERLOAD = 0.75F;
    static float _DISAPPEAR_SPEED_DROWNING = 0.6F;
    static int _NOF_HIT_IND = 4;
    PlayerHUD m_Player;
    String m_sHitTextureName;
    Sprite m_HitIndSprites[];
    Sprite m_cOverloadSprite;
    Sprite m_cDrowningSprite;
    int m_HitIndTextNo[];
    int m_nOverloadTexNo;
    int m_nDrowningTexNo;
    Vector m_vHitSpriteSize;
    float m_Alpha[];
    float m_fOverloadAlpha;
    static final int _OVERLOAD_WAVES = 7;
    float m_fOverloadAlphaCurWave;
    int m_nOverloadAlphaWaves;
    float m_fDrowningAlpha;
    float m_fDrowningDestAlpha;
    float m_fLastUpdate;
    boolean m_bDisableInNetGame;

}
