// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   InvObject.java


public abstract class InvObject extends ChromeActor
{

    void DisableAllWaitingMethod()
    {
        DisableCallMethod("ChangeStateInventory");
        DisableCallMethod("ChangeStateHands");
        DisableCallMethod("ChangeStateOnGround");
    }

    public void OnDestroy()
    {
        if(cInventory != null)
            cInventory.RemoveInvObject(this);
        if(cInvObjSprite != null)
        {
            RemoveSprite(cInvObjSprite);
            cInvObjSprite.ReleaseTexture(nInvObjSpriteTex);
            cInvObjSprite.CallMethodIn("delete", 0.0F);
            cInvObjSprite = null;
        }
        cInventory = null;
        DeleteAttachedFXes();
        super.OnDestroy();
    }

    float GetAutoRespawnTime()
    {
        return m_fAutoRespawnTime;
    }

    void RespawnedInInventory()
    {
        EnableDeleteOnLevelRestart();
        EnableAnnihilateIfNotUsed();
    }

    void WatchFallingDown()
    {
        Vector vStart = GetPosition();
        Vector vEnd = new Vector(vStart);
        vStart.fY += 50F;
        vEnd.fY -= 250F;
        TraceTerrain(vStart, vEnd);
        TraceTrees(vStart, vEnd);
        Collision cCol = TraceObjectsExclude(vStart, vEnd, this);
        if(cCol == null || !IsObjectAttachedTo(cCol.Obstacle, GetParent()))
        {
            Vector vSpeed = GetAbsoluteSpeed();
            DetachFromParentAndKeepWorldPos();
            SetSpeed(vSpeed);
            DisableCallMethod("WatchFallingDown");
        }
    }

    public void Use()
    {
    }

    void MsgSendServerThrowAwayRequest()
    {
        GameObject.LogD(" MSG_SERVER_THROW_AWAY_REQ\n");
        MessageNew(20);
        MessagePackInt(1);
        MessageSend();
    }

    void MsgRecvClientThrowAway()
    {
        int nVal = MessageUnPackInt();
        GameObject.LogLine("nVal =" + nVal);
        MessageEnd();
        ThrowAway();
    }

    void InGameMovieStart()
    {
    }

    void InGameMovieEnd()
    {
    }

    boolean IsObjectAttachedTo(ControlObject cObj, ControlObject cParent)
    {
        ControlObject cCurrObject;
        for(cCurrObject = cObj; cCurrObject != null && cCurrObject != cParent; cCurrObject = cCurrObject.GetParent());
        return cCurrObject == cParent;
    }

    void EnableDeleteOnLevelRestart()
    {
        m_bDeleteOnLevelRestart = true;
    }

    void EnableAnnihilateIfNotUsed()
    {
        m_bAnnihilateIfNotUsed = true;
    }

    void MsgRecvServerThrowAwayRequest()
    {
        int nVal = MessageUnPackInt();
        GameObject.LogLine("nVal =" + nVal);
        MessageEnd();
        ActionThrowAway();
    }

    void UnPackStateOnGround()
    {
        m_vReqPos = new Vector();
        m_vReqPos.fX = MessageUnPackFloat();
        m_vReqPos.fY = MessageUnPackFloat();
        m_vReqPos.fZ = MessageUnPackFloat();
    }

    void Unacquire()
    {
        RemoveSprite(cInvObjSprite);
        if(cInvObjSprite != null)
            RemoveSprite(cInvObjSprite.cSprBack);
        DetachFromParent();
        DeactivateOnModuleAlways();
    }

    void DisableAutoRespawn()
    {
        m_bAutoRespawn = false;
    }

    void ServerRespawn(InvObjectSpawnInfo cSpawnInfo, float fDelayTime)
    {
        super.ServerRespawn(cSpawnInfo, fDelayTime);
        SetAutoRespawnTime(cSpawnInfo.m_fAutoRespawnTime);
        SetAutoRespawnCnt(cSpawnInfo.m_nAutoRespawnCnt);
    }

    public void OnReplicateServer()
    {
        super.OnReplicateServer();
    }

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[InvObject.SGSaveChunk]\n");
        FileChunk cFC = GameObject.NewChunk(1132, cFCParent);
        super.SGSaveChunk(cFC);
        cFC.SaveVector(vUpOnGround);
        cFC.SaveInt(nInvIndex);
        cFC.SaveInt(nInvState);
        cFC.SaveInt(nCellX);
        cFC.SaveInt(nCellY);
        cFC.SaveInt(nGrid);
        cFC.SaveObjectRef(Owner);
        cFC.delete();
    }

    public boolean IsInInventory()
    {
        return cInventory != null;
    }

    void ChangeStateInventory()
    {
        Pawn pawn = GetPawnByNetId(m_nReqOwnerId);
        if(pawn == null)
        {
            CallMethodIn("ChangeStateInventory", 0.1F);
            return;
        }
        if(Owner != null)
            Owner.cInventory.RemoveInvObject(this);
        Execute(pawn, m_nReqGrid, m_nReqCellX, m_nReqCellY);
    }

    void JustAddedToInventory()
    {
    }

    void MsgRecvServerNewGridPos()
    {
        byte nG = MessageUnPackByte();
        byte nX = MessageUnPackByte();
        byte nY = MessageUnPackByte();
        MessageEnd();
        byte nOldG = nGrid;
        byte nOldX = nCellX;
        byte nOldY = nCellY;
        InvGrid cGrid = cInventory.GetInvGrid(nGrid);
        if(cGrid != null)
        {
            cGrid.SetFreeCells(nCellY, nCellsHeight, nCellX, nCellsWidth);
            cGrid.PrintFreeCells();
        }
        cGrid = cInventory.GetInvGrid(nG);
        if(cGrid != null && cGrid.AreCellsFree(nY, nCellsHeight, nX, nCellsWidth))
            SetNewGridPos(cInventory, nX, nY, nG);
        else
            SetNewGridPos(cInventory, nOldX, nOldY, nOldG);
        MsgSendClientNewGridPos();
    }

    void MsgRecvClientNewGridPos()
    {
        byte nG = MessageUnPackByte();
        byte nX = MessageUnPackByte();
        byte nY = MessageUnPackByte();
        MessageEnd();
        InvGrid cGrid = cInventory.GetInvGrid(nGrid);
        if(cGrid != null)
        {
            cGrid.SetFreeCells(nCellY, nCellsHeight, nCellX, nCellsWidth);
            cGrid.PrintFreeCells();
        }
        SetNewGridPos(cInventory, nX, nY, nG);
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[InvObject.SGLoadChunk]\n");
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        if(cFC.GetID() == 1132)
        {
            super.SGLoadChunk(cFC);
            vUpOnGround = cFC.LoadVector();
            nInvIndex = cFC.LoadInt();
            nInvState = cFC.LoadInt();
            nCellX = (byte)cFC.LoadInt();
            nCellY = (byte)cFC.LoadInt();
            nGrid = (byte)cFC.LoadInt();
            Owner = (Pawn)cFC.LoadObjectRef();
            if(Owner != null)
                cInventory = Owner.cInventory;
            else
                cInventory = null;
        }
        cFC.delete();
    }

    boolean IsInborn()
    {
        return m_bInborn;
    }

    void SetInborn()
    {
        m_bInborn = true;
        bLocked = true;
        bHidden = true;
    }

    boolean ThrowAwayOnRemoveFromInventory()
    {
        return m_bThrowAwayOnRemoveFromInventory;
    }

    void MessageUnPackData()
    {
        super.MessageUnPackData();
        m_bActionPlaceAtGivenCells = MessageUnPackBoolean();
        if(m_bActionPlaceAtGivenCells)
        {
            m_nActionGrid = MessageUnPackByte();
            m_nActionCellX = MessageUnPackByte();
            m_nActionCellY = MessageUnPackByte();
        }
    }

    void SetAutoRespawnCnt(int nCnt)
    {
        m_nAutoRespawnCnt = nCnt;
    }

    public void SetInvObjCellsGrid(byte cellX, byte cellY, byte grid)
    {
        nCellX = cellX;
        nCellY = cellY;
        nGrid = grid;
        ScaleTexture();
        if(cInventory != null && nGrid != -1)
        {
            InvGrid cGrid = cInventory.GetInvGrid(nGrid);
            if(cGrid != null)
                cInvObjSprite.SetPos(new Vector(cGrid.nGridPosX + EHudInvParams.GetCellWidth() * nCellX, cGrid.nGridPosY + EHudInvParams.GetCellHeight() * nCellY, 0.0F));
            else
                cInvObjSprite.SetPos(new Vector(0.0F, 0.0F, 0.0F));
        } else
        {
            cInvObjSprite.SetPos(new Vector(0.0F, 0.0F, 0.0F));
        }
    }

    void ChangeInvState(Pawn owner, int newState)
    {
        if(nInvState == 2)
            DetachFromParent();
        switch(newState)
        {
        default:
            break;

        case 0: // '\0'
            ActivateOnModule();
            EnableRendering(true);
            SetFlag(8);
            SetFlag(1);
            RemovedOnGround();
            SetFlag(0x100000);
            if(owner instanceof PlayerNet)
                ScheduleAnnihilateIfNotUsed();
            break;

        case 2: // '\002'
            SetPosition(new Vector(0.0F, 0.0F, 0.0F));
            StopFallingDown();
            ClearFlag(8);
            DeleteAttachedFXes();
            SetFlag(0x100000);
            if(owner != null)
            {
                if(owner.GetElementID("Right_hand") < 0)
                    owner.AttachChild(this, "Bip01 R Hand");
                else
                    owner.AttachChild(this, "Right_hand");
                SetPosition(Vector.Zero);
            } else
            {
                GameObject.CrashLog("ERROR: Null Owner during changing InvObj state to HANDS (object:" + this + ")");
            }
            ActivateOnModule();
            EnableRendering(true);
            ClearFlag(8);
            break;

        case 1: // '\001'
            ClearFlag(0x100000);
            DeleteAttachedFXes();
            ClearFlag(8);
            StopFallingDown();
            DetachFromParentAndKeepWorldPos();
            DeactivateOnModuleAlways();
            EnableRendering(false);
            AddedToInventory();
            CancelAnnihilateIfNotUsed();
            break;
        }
        nInvState = newState;
    }

    void ActionExecute(Actor executor)
    {
        m_bActionPlaceAtGivenCells = false;
        super.ActionExecute(executor);
    }

    void ActionExecute(Actor executor, byte nGrid, byte nCellX, byte nCellY)
    {
        m_bActionPlaceAtGivenCells = true;
        m_nActionGrid = nGrid;
        m_nActionCellX = nCellX;
        m_nActionCellY = nCellY;
        super.ActionExecute(executor);
    }

    void MsgSendClientState()
    {
        MessageNew(10);
        MessagePackInt(nInvState);
        PackExecuteTime();
        PackAdditionalData();
        GameObject.LogD(" " + getClass().getName() + " netid:" + GetNetId() + " state" + nInvState + "\n");
        switch(nInvState)
        {
        case 0: // '\0'
            PackStateOnGround();
            break;

        case 1: // '\001'
            PackStateInventory();
            break;

        case 2: // '\002'
            PackStateHands();
            break;
        }
        MessageSend();
    }

    boolean DeleteOnLevelRestartEnabled()
    {
        return m_bDeleteOnLevelRestart;
    }

    int GetAutoRespawnCnt()
    {
        return m_nAutoRespawnCnt;
    }

    public void SGUpdate()
    {
        FileChunk.Log("[InvObject.SGUpdate]\n");
        super.SGUpdate();
        if(Owner instanceof Player)
        {
            Player player = (Player)Owner;
            if(player.nCameraGameMode != 1)
                ChangeInvState(Owner, nInvState);
        }
        if(cInvObjSprite != null)
            cInvObjSprite.SGUpdate();
        fLastForceFieldCollision = 0.0F;
    }

    public void EndUse()
    {
    }

    void ThrowAway()
    {
        Pawn owner = Owner;
        if(owner == null)
            return;
        if(owner instanceof Player)
        {
            ((Player)owner).BreakWeaponReload();
            ((Player)owner).ForceWeaponGot();
        }
        boolean bInHands = nInvState == 2;
        if(bInHands)
            owner.WeaponThrowAway();
        owner.cInventory.RemoveInvObject(this);
        ChangeInvState(owner, 0);
        if(bAttachToMovingPlatformAfterDrop && owner.GetParent() != null)
        {
            AttachAsChildToAndKeepWorldPos(owner.GetParent());
            CallMethodEvery("WatchFallingDown", 0.5F);
        }
        PhysicsDrop(owner.ComputePhysicsDropPosition(), owner.ComputePhysicsDropSpeed());
        if(bInHands && owner.ActiveWeapon == null)
        {
            GameObject.LogD(" bInHands\n");
            if(owner instanceof Player)
            {
                Player player = (Player)owner;
                player.WeaponToUse = player.GetBestWeapon();
                player.SetState("ChangeWeaponState");
            }
        }
    }

    void PackStateHands()
    {
        PackStateInventory();
    }

    void SetStateHands()
    {
        DisableAllWaitingMethod();
        GameObject.LogD(" " + this + "\n");
        ChangeStateHands();
    }

    void MsgSendServerDeleteRequest()
    {
        GameObject.LogD(" MSG_SERVER_DELETE_REQ\n");
        MessageNew(24);
        MessagePackInt(1);
        MessageSend();
    }

    public void SetInvObjParams(int cellsWidth, int cellsHeight, byte cellX, byte cellY)
    {
        nCellsWidth = cellsWidth;
        nCellsHeight = cellsHeight;
        nCellX = cellX;
        nCellY = cellY;
    }

    public void StopFallingDown()
    {
        SetSpeed(new Vector());
        SetPhysicsActive(false);
        DisableCallMethod("WatchFallingDown");
    }

    void UnPackStateHands()
    {
        UnPackStateInventory();
    }

    void RemoveFromHands()
    {
        Pawn owner = Owner;
        if(nInvState == 2)
        {
            if(owner instanceof Player)
            {
                ((Player)owner).BreakWeaponReload();
                ((Player)owner).ForceWeaponGot();
            }
            owner.WeaponThrowAway();
            if(owner.ActiveWeapon == null && (owner instanceof Player))
            {
                Player player = (Player)owner;
                player.WeaponToUse = player.GetBestWeapon();
                player.SetState("ChangeWeaponState");
            }
        }
    }

    public void OnReplicateClient()
    {
    }

    public void DropOnTerrain(Vector pos)
    {
        SetPosition(pos);
    }

    public void RemovedOnGround()
    {
    }

    void ChangeStateOnGround()
    {
        if(Owner != null)
            Owner.cInventory.RemoveInvObject(this);
        ChangeInvState(null, 0);
        SetPosition(m_vReqPos);
        GameObject.LogD(" m_vReqPos " + m_vReqPos + "\n");
    }

    public void OnCollisionObject(ControlObject Col)
    {
        if(Col instanceof ForceFieldFence)
            return;
        StopFallingDown();
        if(super.Role == 4)
            MsgSendClientState();
        if(!IsObjectAttachedTo(Col, GetParent()))
            DetachFromParentAndKeepWorldPos();
    }

    public void Initialize(String name)
    {
        sName = new String(name);
    }

    String GetTip()
    {
        return sName + " " + Text.Get("&GET_OBJECT&");
    }

    public void ReplicationInit()
    {
    }

    public boolean DeleteIfNotRelevant()
    {
        return false;
    }

    public void SetInvObjCells(byte cellX, byte cellY)
    {
        nCellX = cellX;
        nCellY = cellY;
        ScaleTexture();
        cInvObjSprite.SetRelativePos(new Vector(EHudInvParams.GetCellWidth() * nCellX, EHudInvParams.GetCellHeight() * nCellY, 0.0F));
    }

    String GetInfoString()
    {
        if(sInfo != null && sInfo.length() > 0)
            return Text.Get(sInfo);
        else
            return "";
    }

    void ActionSetNewGridPos(Inventory cInventory, byte nX, byte nY, byte nZ)
    {
        SetNewGridPos(cInventory, nX, nY, nZ);
        if(super.Role == 4)
            MsgSendClientNewGridPos();
        else
            MsgSendServerNewGridPos();
    }

    boolean CanUseWhileAiming()
    {
        return m_bCanUseWhileAiming;
    }

    public void PhysicsDrop(Vector vFrom, Vector vSpeed)
    {
        SetPhysicsType(4);
        SetCollAction(0);
        SetCollHandler(512);
        SetCollType(1);
        SetSpeed(vSpeed);
        SetPhysicsActive(true);
        Vector vDir = new Vector();
        vDir.fX = 1.0F - GameObject.RandomFloat(2.0F);
        vDir.fZ = 1.0F - GameObject.RandomFloat(2.0F);
        vDir.fY = 0.0F;
        if(vDir.Len() > 0.0F)
            vDir.Normalize();
        else
            vDir = new Vector(Vector.Forward);
        if(this instanceof Weapon)
        {
            vUpOnGround.fZ = 1.0F - GameObject.RandomFloat(2.0F);
            vUpOnGround.Normalize();
            vDir = Vector.Forward;
        }
        FromUpForwardPos(vUpOnGround, vDir, vFrom);
    }

    public Vector GetCurrentPlace()
    {
        Vector retVect = new Vector(nCellX, nCellY, nGrid);
        return retVect;
    }

    private void AnnihilateIfNotUsedDo()
    {
        delete();
    }

    void PackAdditionalData()
    {
    }

    boolean ServerVerifyActionExecute(Actor cExecutor, float fMaxDistance)
    {
        return super.ServerVerifyActionExecute(cExecutor, fMaxDistance) && nInvState == 0;
    }

    void MsgRecvClientState()
    {
        m_nReqInvState = MessageUnPackInt();
        float fTime = UnPackExecuteTime();
        boolean bTimeOK = CheckExecuteTime(fTime);
        GameObject.LogLine("ClientState() " + m_nReqInvState + ", bTimeOK " + bTimeOK);
        UnPackAdditionalData();
        switch(m_nReqInvState)
        {
        default:
            break;

        case 0: // '\0'
            GameObject.LogD(" " + this + " EInvObjState._ONGROUND\n");
            UnPackStateOnGround();
            MessageEnd();
            if(bTimeOK)
                SetStateOnGround();
            break;

        case 1: // '\001'
            GameObject.LogD(" " + this + " EInvObjState._INVENTORY\n");
            UnPackStateInventory();
            MessageEnd();
            if(bTimeOK)
                SetStateInventory();
            break;

        case 2: // '\002'
            GameObject.LogD(" " + this + " EInvObjState._HANDS\n");
            UnPackStateHands();
            MessageEnd();
            if(bTimeOK)
                SetStateHands();
            if(Owner != null)
                GameObject.Log(" " + this + " OwnerWeapon " + Owner.ActiveWeapon + "\n");
            else
                GameObject.LogR("ERROR: " + this + " SetStateHands() Owner == null!!!!\n");
            break;
        }
    }

    public void SetInventory(Inventory cInventory)
    {
        this.cInventory = cInventory;
    }

    void OnRemoveFromInventory()
    {
    }

    public void Hide()
    {
        if(cInvObjSprite != null)
        {
            cInvObjSprite.bDrag = false;
            cInvObjSprite.Hide();
            cInvObjSprite.ProcessMouse(false);
        }
    }

    public void AddedToInventory()
    {
        DeleteAttachedFXes();
    }

    void PackStateInventory()
    {
        int nOwnerId = Owner == null ? -1 : Owner.GetNetId();
        MessagePackInt(nOwnerId);
        MessagePackByte(nGrid);
        MessagePackByte(nCellX);
        MessagePackByte(nCellY);
        MessagePackBoolean(bHidden);
        MessagePackBoolean(bHiddenButUsable);
        MessagePackBoolean(bLocked);
        if(nOwnerId == -1)
            GameObject.CrashLog("ERROR: " + this + " Owner " + Owner + "!!!!!!!!!!\n");
    }

    void SetStateInventory()
    {
        DisableAllWaitingMethod();
        ChangeStateInventory();
    }

    public String GetInvName()
    {
        return Text.Get(sName);
    }

    public void OnMessage()
    {
        switch(MessageGetId())
        {
        case 10: // '\n'
            GameObject.LogD(" MSG_CLIENT_STATE\n");
            MsgRecvClientState();
            break;

        case 20: // '\024'
            GameObject.LogD(" MSG_SERVER_THROW_AWAY_REQ\n");
            MsgRecvServerThrowAwayRequest();
            break;

        case 21: // '\025'
            GameObject.LogD(" MSG_CLIENT_THROW_AWAY\n");
            MsgRecvClientThrowAway();
            break;

        case 22: // '\026'
            GameObject.LogD(" MSG_SERVER_NEW_GRID_POS\n");
            MsgRecvServerNewGridPos();
            break;

        case 23: // '\027'
            GameObject.LogD(" MSG_CLIENT_NEW_GRID_POS\n");
            MsgRecvClientNewGridPos();
            break;

        case 24: // '\030'
            GameObject.LogD(" MSG_SERVER_DELETE_REQ\n");
            MsgRecvServerDeleteRequest();
            break;

        default:
            super.OnMessage();
            break;
        }
    }

    void MsgRecvServerDeleteRequest()
    {
        int nVal = MessageUnPackInt();
        GameObject.LogLine("nVal =" + nVal);
        MessageEnd();
    }

    void SetAutoRespawnTime(float fTime)
    {
        m_fAutoRespawnTime = fTime;
    }

    void ChangeStateHands()
    {
        Pawn pawn = GetPawnByNetId(m_nReqOwnerId);
        if(pawn == null)
        {
            CallMethodIn("ChangeStateHands", 0.1F);
            return;
        }
        if(pawn != Owner)
        {
            if(Owner != null)
                Owner.cInventory.RemoveInvObject(this);
            Execute(pawn, m_nReqGrid, m_nReqCellX, m_nReqCellY);
        }
        if(this instanceof Weapon)
        {
            if(this != pawn.ActiveWeapon)
                pawn.UseWeapon((Weapon)this);
            if(pawn instanceof PlayerNet)
            {
                PlayerNet player = (PlayerNet)pawn;
                ((Player) (player)).Anims.SetupAnims(((PawnAnimated) (player)).motion, ((Pawn) (player)).ActiveWeapon);
                player.UpdateMotion();
            }
        }
    }

    public void AdjustEllipsoid()
    {
        Vector vMin = new Vector();
        Vector vMax = new Vector();
        GetMeshExtents(vMin, vMax);
        Vector vSize = vMax.Sub2(vMin);
        if(vSize.fX > 10F)
            vSize.fX = 10F;
        SetEllipsoidNoExtents(vSize.fX / 2.0F, vSize.fY, vSize.fY / 2.0F);
    }

    void CancelAnnihilateIfNotUsed()
    {
        DisableCallMethod(METHOD_AnnihilateIfNotUsedDo);
    }

    boolean ScheduleAnnihilateIfNotUsed()
    {
        DisableCallMethod(METHOD_AnnihilateIfNotUsedDo);
        if(m_bAnnihilateIfNotUsed && m_fTimeToAnnihilateIfNotUsed >= 0.0F)
        {
            CallMethodIn(METHOD_AnnihilateIfNotUsedDo, m_fTimeToAnnihilateIfNotUsed);
            return true;
        } else
        {
            return false;
        }
    }

    public void Draw()
    {
        if(!bHidden && !bHiddenButUsable)
        {
            cInvObjSprite.Show();
            cInvObjSprite.CallMethodIn("MoveTop", 0.0F);
            cInvObjSprite.ProcessMouse(true);
        }
    }

    InvObject()
    {
        sTakeObjectSound = "Data/Sounds/InventoryPut.wav";
        bHidden = false;
        bHiddenButUsable = false;
        bMissionCritical = false;
        bPlaceAtGivenCells = false;
        bNearestCell = false;
        bJustTakenToInventory = false;
        bLocked = false;
        sName = "";
        sInfo = "";
        vUpOnGround = new Vector(0.0F, 1.0F, 0.0F);
        Owner = null;
        nInvType = -1;
        nInvIndex = 0;
        nInvState = 0;
        cInvObjSprite = null;
        nInvObjSpriteTex = 0;
        sTexFileName = "Data/Textures/gun1_tex.png";
        sObjTakenSound = "Data/Sounds/InventoryPut.wav";
        sObjNotTakenSound = "Data/Sounds/InventoryPutOut.wav";
        nOnTexPosX = 0.0F;
        nOnTexPosY = 0.0F;
        nTexSizeX = 256F;
        nTexSizeY = 256F;
        nCellsWidth = 3;
        nCellsHeight = 1;
        nCellX = 0;
        nCellY = 0;
        nGrid = 0;
        cInventory = null;
        fLastForceFieldCollision = 0.0F;
        bAttachToMovingPlatformAfterDrop = true;
        METHOD_AnnihilateIfNotUsedDo = 0;
        m_bActionPlaceAtGivenCells = false;
        m_nActionGrid = -1;
        m_nActionCellX = -1;
        m_nActionCellY = -1;
        m_vReqPos = null;
        m_nReqInvState = -1;
        m_nReqOwnerId = -1;
        m_nReqInvIndex = -1;
        m_nReqGrid = -1;
        m_nReqCellX = -1;
        m_nReqCellY = -1;
        m_bLocalObj = false;
        m_bCanUseWhileAiming = true;
        m_bDeleteOnLevelRestart = false;
        m_bRespawnOnLevelRestart = false;
        m_bAutoRespawn = false;
        m_fAutoRespawnTime = 60F;
        m_nAutoRespawnCnt = -1;
        m_bAnnihilateIfNotUsed = false;
        m_fTimeToAnnihilateIfNotUsed = 20F;
        m_bInborn = false;
        m_bThrowAwayOnRemoveFromInventory = false;
        super.Role = 4;
    }

    void PackStateOnGround()
    {
        Vector vPos = GetPosition();
        MessagePackFloat(vPos.fX);
        MessagePackFloat(vPos.fY);
        MessagePackFloat(vPos.fZ);
    }

    void SetStateOnGround()
    {
        DisableAllWaitingMethod();
        ChangeStateOnGround();
    }

    void Acquire(Module mod, Pawn owner)
    {
        GameObject.LogD("Acquiring: " + sName + " for " + owner + "\n");
        mod.AcquireObjectModule(this);
        METHOD_AnnihilateIfNotUsedDo = RegisterCallMethod("AnnihilateIfNotUsedDo");
        Owner = owner;
        if(owner != null)
        {
            mod.AcquireObjectModule(cInvObjSprite);
            mod.AcquireObjectModule(cInvObjSprite.cSprBack);
            mod.AddSprite(cInvObjSprite);
            mod.AddSprite(cInvObjSprite.cSprBack);
            if(owner instanceof PlayerHUD)
            {
                PlayerHUD playerHUD = (PlayerHUD)owner;
                if(playerHUD.HUD != null && playerHUD.HUD.GetHudCompInvPl() != null && playerHUD.HUD.GetHudCompInvPl().cInvGridSprite != null && cInvObjSprite != null)
                    playerHUD.HUD.GetHudCompInvPl().cInvGridSprite.AddChild(cInvObjSprite);
            }
        } else
        {
            RemoveSprite(cInvObjSprite);
            RemoveSprite(cInvObjSprite.cSprBack);
            mod.AcquireObjectModule(cInvObjSprite);
            mod.AcquireObjectModule(cInvObjSprite.cSprBack);
        }
    }

    public void ScaleTexture()
    {
        cInvObjSprite.SetSize(new Vector(EHudInvParams.GetCellWidth() * nCellsWidth, EHudInvParams.GetCellHeight() * nCellsHeight, 0.0F));
    }

    void EnableAutoRespawn()
    {
        m_bAutoRespawn = true;
    }

    void ExecuteDo()
    {
        if(m_bActionPlaceAtGivenCells)
        {
            Execute(super.m_cActionExecutor, m_nActionGrid, m_nActionCellX, m_nActionCellY);
            m_bActionPlaceAtGivenCells = false;
        } else
        {
            super.ExecuteDo();
        }
    }

    void AddToAutoRespawnIfNeeded()
    {
        Module cModule = GetModule();
        if(cModule instanceof ModuleNet)
            ((ModuleNet)cModule).AddInvObjectToAutoRespawn(this);
    }

    void RespawnedOnLevel()
    {
        EnableDeleteOnLevelRestart();
        EnableAnnihilateIfNotUsed();
        EnableAutoRespawn();
    }

    public void SetInvObjPos(int x, int y)
    {
        cInvObjSprite.SetPos(new Vector(x, y, 0.0F));
    }

    void MsgSendServerNewGridPos()
    {
        GameObject.LogD(" MSG_SERVER_NEW_GRID_POS\n");
        MessageNew(22);
        MessagePackByte(nGrid);
        MessagePackByte(nCellX);
        MessagePackByte(nCellY);
        MessageSend();
    }

    void MsgSendClientNewGridPos()
    {
        GameObject.LogD(" MSG_CLIENT_NEW_GRID_POS\n");
        MessageNew(23);
        MessagePackByte(nGrid);
        MessagePackByte(nCellX);
        MessagePackByte(nCellY);
        MessageSend();
    }

    void SetNewGridPos(Inventory cInventory, byte nX, byte nY, byte nG)
    {
        SetInvObjCellsGrid(nX, nY, nG);
        cInventory.aInvGrids[nG].SetTakenCells(nY, nCellsHeight, nX, nCellsWidth);
    }

    void MessagePackData()
    {
        super.MessagePackData();
        MessagePackBoolean(m_bActionPlaceAtGivenCells);
        if(m_bActionPlaceAtGivenCells)
        {
            MessagePackByte(m_nActionGrid);
            MessagePackByte(m_nActionCellX);
            MessagePackByte(m_nActionCellY);
        }
    }

    void UnPackAdditionalData()
    {
    }

    public void OnCreate()
    {
        super.bSG = true;
        METHOD_AnnihilateIfNotUsedDo = RegisterCallMethod("AnnihilateIfNotUsedDo");
        ClearFlag(32);
        SetFlag(2048);
        ClearFlag(8192);
        SetLighting(true);
        cInvObjSprite = (SpriteInvObj)CreateObject("SpriteInvObj");
        nInvObjSpriteTex = cInvObjSprite.AddTexture(sTexFileName);
        nTexSizeX = cInvObjSprite.GetTextureWidth(nInvObjSpriteTex);
        nTexSizeY = cInvObjSprite.GetTextureHeight(nInvObjSpriteTex);
        cInvObjSprite.SetTexture(nInvObjSpriteTex, new Rect(nOnTexPosX / nTexSizeX, nOnTexPosY / nTexSizeY, (nOnTexPosX + (float)nCellsWidth * (float)EHudInvParams.GetCellTexWidth()) / nTexSizeX, (nOnTexPosY + (float)nCellsHeight * (float)EHudInvParams.GetCellTexHeight()) / nTexSizeY));
        cInvObjSprite.ProcessMouse(false);
        cInvObjSprite.SetInvObj(this);
        SetInvObjCellsGrid((byte)0, (byte)0, (byte)0);
        SetInventory(null);
        SetMass(80F);
        ChangeInvState(null, 0);
        super.bIsActiveTarget = false;
        InitOriginalMaterials();
        AdjustEllipsoid();
    }

    public Inventory GetInventory()
    {
        return cInventory;
    }

    void Execute(Actor executor)
    {
        if(super.bDeleted)
        {
            GameObject.CrashLog("ERROR: " + this + " deleted! Owner: " + Owner + "\n");
            return;
        }
        if(executor == null)
        {
            GameObject.CrashLog("ERROR: " + this + " executor == null Owner: " + Owner + "\n");
            return;
        }
        if(Owner instanceof WeaponRackPawn)
            return;
        AddToAutoRespawnIfNeeded();
        Pawn oldOwner = Owner;
        AddToInventory(executor, false);
        super.Execute(executor);
        if(((GameObject) (executor)).bNetIsOwner)
            PlaySound(sTakeObjectSound);
    }

    boolean AddToInventory(Actor executor)
    {
        return AddToInventory(executor, false);
    }

    boolean AddToInventory(Actor executor, boolean bLoud)
    {
        Pawn pawn = null;
        PlayerHUD player = null;
        try
        {
            pawn = (Pawn)executor;
            bJustTakenToInventory = false;
            if(pawn != null && pawn.cInventory != null)
                if(bPlaceAtGivenCells)
                    bJustTakenToInventory = pawn.cInventory.AddInvObjectInPlace(this);
                else
                if(bNearestCell)
                    bJustTakenToInventory = pawn.cInventory.AddInvObjectNearest(this);
                else
                    bJustTakenToInventory = pawn.cInventory.AddInvObject(this);
            if(bJustTakenToInventory)
            {
                if(GetModule() != null && (GetModule() instanceof ChromeModuleSingle) && executor != null && (executor instanceof PlayerHUD))
                {
                    PlayerHUD playerHUD = (PlayerHUD)executor;
                    if(playerHUD.HUD != null && playerHUD.HUD.GetHudCompInvPl() != null && playerHUD.HUD.GetHudCompInvPl().cInvGridSprite != null && cInvObjSprite != null)
                        playerHUD.HUD.GetHudCompInvPl().cInvGridSprite.AddChild(cInvObjSprite);
                    if(playerHUD.GetActiveTrigger() == this)
                        playerHUD.SetActiveTrigger(null);
                }
                if(bLoud && ((GameObject) (pawn)).bNetIsOwner)
                    PlaySound(sObjTakenSound);
                Owner = pawn;
                ChangeInvState(pawn, 1);
                if(!bNearestCell && !bPlaceAtGivenCells)
                    JustAddedToInventory();
                try
                {
                    player = (PlayerHUD)executor;
                    if(player != null && player.HUD != null)
                    {
                        if(((Pawn) (player)).cInventory != null && player.HUD.aHUDComponent[1] != null && ((Pawn) (player)).cInventory.cActualUsableInvObj == null)
                        {
                            ((Pawn) (player)).cInventory.SetFirstUsableInvObj();
                            InvObject obj = ((Pawn) (player)).cInventory.GetActualUsableInvObj();
                            HUDCompPlayer hudInvUse = (HUDCompPlayer)player.HUD.aHUDComponent[1];
                            hudInvUse.ShowUsableInvObj(obj);
                        }
                        if(player.HUD.aHUDComponent[2] != null)
                            cInvObjSprite.SetHUDInvPl((HUDCompInvPl)player.HUD.aHUDComponent[2]);
                        else
                        if(player.HUD.GetInventoryMenu() != null)
                        {
                            cInvObjSprite.SetInvMenu(player.HUD.GetInventoryMenu());
                        } else
                        {
                            cInvObjSprite.SetHUDInvPl(null);
                            cInvObjSprite.SetInvMenu(null);
                        }
                    }
                }
                catch(Exception ex) { }
            } else
            {
                if(bLoud && ((GameObject) (executor)).bNetIsOwner)
                    PlaySound(sObjNotTakenSound);
                if((executor instanceof PlayerHUD) && sm_bShowMsgNoInvRoom)
                    ((PlayerHUD)executor).NotEnoughRoomInInventory();
            }
        }
        catch(ClassCastException e)
        {
            GameObject.LogD(": InventoryObject can be executed only by Pawn\n");
            return false;
        }
        return bJustTakenToInventory;
    }

    void Execute(Actor executor, byte nG, byte nCX, byte nCY)
    {
        nGrid = nG;
        nCellX = nCX;
        nCellY = nCY;
        bPlaceAtGivenCells = true;
        Execute(executor);
        bPlaceAtGivenCells = false;
    }

    void UnPackStateInventory()
    {
        m_nReqOwnerId = MessageUnPackInt();
        m_nReqGrid = MessageUnPackByte();
        m_nReqCellX = MessageUnPackByte();
        m_nReqCellY = MessageUnPackByte();
        bHidden = MessageUnPackBoolean();
        bHiddenButUsable = MessageUnPackBoolean();
        bLocked = MessageUnPackBoolean();
    }

    void ActionThrowAway()
    {
        GameObject.LogLine("ActionThrowAway");
        if(super.Role == 4)
        {
            ThrowAway();
            MsgSendClientThrowAway();
        } else
        {
            MsgSendServerThrowAwayRequest();
        }
    }

    void MsgSendClientThrowAway()
    {
        GameObject.LogD(" MSG_CLIENT_THROW_AWAY\n");
        MessageNew(21);
        MessagePackInt(1);
        MessageSend();
    }

    boolean RespawnOnLevelRestartEnabled()
    {
        return m_bRespawnOnLevelRestart;
    }

    boolean AutoRespawnEnabled()
    {
        return m_bAutoRespawn && (double)GetAutoRespawnTime() >= 0.0D && GetAutoRespawnCnt() != 0;
    }

    public boolean IsActive(ControlObject Activator)
    {
        return nInvState == 0;
    }

    static final int _W_KNIFE = 1;
    static final int _W_PISTOL = 2;
    static final int _W_PISTOL_SILENCED = 3;
    static final int _W_PISTOL_HEAVY = 4;
    static final int _W_RIFLE_SHOTGUN = 5;
    static final int _W_RIFLE_SHORT = 6;
    static final int _W_RIFLE_SHORT_SILENCED = 7;
    static final int _W_RIFLE_STANDARD = 8;
    static final int _W_RIFLE_SNIPER = 9;
    static final int _W_RIFLE_SNIPER_HEAVY = 10;
    static final int _W_RIFLE_HEAVY = 11;
    static final int _W_RIFLE_MACHINE_GUN = 12;
    static final int _W_HEAVY_HEX = 13;
    static final int _W_HEAVY_ROCKET_LAUNCHER = 14;
    static final int _W_HEAVY_ELECTRO = 15;
    static final int _W_GRENADE = 16;
    static final int _W_GRENADE_CLUSTER = 17;
    static final int _W_GRENADE_EMP = 18;
    static final int _W_HAND = 19;
    static final int _W_BINOCULARS = 20;
    static final int _E_DRUG_NEURALHEALTH = 500;
    static final int _E_DRUG_HEALTH = 501;
    static final int _E_BINOCULARS = 504;
    static final int _E_BOOK = 505;
    static final int _E_CDPLAYER = 506;
    static final int _E_CHIPSG = 507;
    static final int _E_CHIPSO = 508;
    static final int _E_CIGARS = 509;
    static final int _E_CIGARSL = 510;
    static final int _E_EXPLOSIVE = 511;
    static final int _E_KEY = 512;
    static final int _E_MP3PLAYER = 513;
    static final int _E_NANOCHIP = 514;
    static final int _E_POWERCELL = 515;
    static final int _E_REDBOX = 516;
    static final int _E_TIMEBOMB = 517;
    static final int _E_VODKAL = 518;
    static final int _E_VODKAS = 519;
    static final int _E_W_RACK = 520;
    static final int _E_W_RACK_CTRL = 521;
    static final int _E_W_BURBOT = 522;
    static final int _E_RADIO = 523;
    static final int _E_PROXIMITY_MINE = 524;
    static final int _E_CLOAKING_DEVICE = 525;
    static final int _E_NET_CTF_FLAG = 600;
    static final int _E_UNIFORM = 666;
    String sTakeObjectSound;
    public boolean bHidden;
    public boolean bHiddenButUsable;
    public boolean bMissionCritical;
    boolean bPlaceAtGivenCells;
    boolean bNearestCell;
    boolean bJustTakenToInventory;
    public boolean bLocked;
    protected String sName;
    protected String sInfo;
    Vector vUpOnGround;
    Pawn Owner;
    int nInvType;
    int nInvIndex;
    int nInvState;
    SpriteInvObj cInvObjSprite;
    int nInvObjSpriteTex;
    String sTexFileName;
    String sObjTakenSound;
    String sObjNotTakenSound;
    float nOnTexPosX;
    float nOnTexPosY;
    float nTexSizeX;
    float nTexSizeY;
    int nCellsWidth;
    int nCellsHeight;
    byte nCellX;
    byte nCellY;
    byte nGrid;
    Inventory cInventory;
    float fLastForceFieldCollision;
    boolean bAttachToMovingPlatformAfterDrop;
    int METHOD_AnnihilateIfNotUsedDo;
    static boolean sm_bShowMsgNoInvRoom = true;
    boolean m_bActionPlaceAtGivenCells;
    byte m_nActionGrid;
    byte m_nActionCellX;
    byte m_nActionCellY;
    static final int MSG_CLIENT_STATE = 10;
    static final int MSG_SERVER_THROW_AWAY_REQ = 20;
    static final int MSG_CLIENT_THROW_AWAY = 21;
    static final int MSG_SERVER_NEW_GRID_POS = 22;
    static final int MSG_CLIENT_NEW_GRID_POS = 23;
    static final int MSG_SERVER_DELETE_REQ = 24;
    Vector m_vReqPos;
    int m_nReqInvState;
    int m_nReqOwnerId;
    int m_nReqInvIndex;
    byte m_nReqGrid;
    byte m_nReqCellX;
    byte m_nReqCellY;
    boolean m_bLocalObj;
    boolean m_bCanUseWhileAiming;
    private boolean m_bDeleteOnLevelRestart;
    public boolean m_bRespawnOnLevelRestart;
    private boolean m_bAutoRespawn;
    public float m_fAutoRespawnTime;
    public int m_nAutoRespawnCnt;
    private boolean m_bAnnihilateIfNotUsed;
    public float m_fTimeToAnnihilateIfNotUsed;
    private boolean m_bInborn;
    boolean m_bThrowAwayOnRemoveFromInventory;

}
