// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   LaserPointer.java


public class LaserPointer extends MeshObject
{

    void SetSize(float fSize)
    {
        if(fSize > 0.0F)
            fFXSizeX = fSize;
    }

    public LaserPointer()
    {
        m_sFXBeamName = "LaserBeamRed";
        m_nCurSequence = -1;
        m_fRange = 10000F;
        m_bSingleBeam = true;
        fFXSizeX = 2.0F;
        fFXSizeY = m_fRange / 2.0F;
        fFXZero = 0.0F;
        fFXPosY = 0.0F;
    }

    void PointForward(float fRange)
    {
        if(fRange <= 0.0F)
            fRange = m_fRange;
        fFXSizeY = fRange;
        fFXPosY = fRange / 2.0F;
        ExecuteBeam(GetPositionVectorVolatile(), GetForwardVectorVolatile());
    }

    private void ExecuteBeamAttach(Vector vPos, Vector vDir)
    {
        if(m_nCurSequence != -1 && m_bSingleBeam)
            DeleteFXSequence(m_nCurSequence);
        m_nCurSequence = ExecuteFX(this, m_sFXBeamName, vPos, vDir);
    }

    void SetRange(float fRange)
    {
        m_fRange = fRange;
    }

    void PointForwardAttach(float fRange)
    {
        if(fRange <= 0.0F)
            fRange = m_fRange;
        fFXSizeY = fRange;
        fFXPosY = fRange / 2.0F;
        ExecuteBeamAttach(Vector.Zero, VectorWorldToLocal(GetForwardVectorVolatile()));
    }

    void PointFromTo(Vector vStart, Vector vEnd)
    {
        fFXSizeY = vStart.Distance(vEnd);
        fFXPosY = fFXSizeY / 2.0F;
        Vector vDir = vEnd.Sub2(vStart);
        vDir.Normalize();
        ExecuteBeam(vStart, vDir);
    }

    void PointFromTowards(Vector vStart, Vector vDir)
    {
        vDir.Normalize();
        fFXSizeY = m_fRange;
        fFXPosY = m_fRange / 2.0F;
        ExecuteBeam(vStart, vDir);
    }

    void PointTo(Vector vPoint)
    {
        Vector vPos = GetPositionVectorVolatile();
        Vector vDir = vPoint.Sub2(vPos);
        float fDist = vPos.Distance(vPoint);
        vDir.Normalize();
        fFXSizeY = fDist;
        fFXPosY = fDist / 2.0F;
        ExecuteBeam(vPos, vDir);
    }

    void PointTowards(Vector vDir)
    {
        vDir.Normalize();
        fFXSizeY = m_fRange;
        fFXPosY = m_fRange / 2.0F;
        ExecuteBeam(GetPositionVectorVolatile(), vDir);
    }

    void OnCreate()
    {
        super.OnCreate();
        EnableRendering(false);
        ClearFlag(1);
    }

    void PointFromToAttach(Vector vStart, Vector vEnd)
    {
        fFXSizeY = vStart.Distance(vEnd);
        fFXPosY = fFXSizeY / 2.0F;
        Vector vDir = vEnd.Sub2(vStart);
        vDir.Normalize();
        ExecuteBeamAttach(vStart, vDir);
    }

    public void delete()
    {
        if(m_nCurSequence != -1)
            DeleteFXSequence(m_nCurSequence);
        super.delete();
    }

    private void ExecuteBeam(Vector vPos, Vector vDir)
    {
        if(m_nCurSequence != -1 && m_bSingleBeam)
            DeleteFXSequence(m_nCurSequence);
        m_nCurSequence = ExecuteFX(m_sFXBeamName, vPos, vDir);
    }

    static final String _BEAM_RED = "LaserBeamRed";
    static final String _BEAM_BLUE = "LaserBeamBlue";
    static final String _BEAM_YELLOW = "LaserBeamYellow";
    static final String _BEAM_WHITE = "LaserBeamWhite";
    static final String _BEAM_GREEN = "LaserBeamGreen";
    static final String _BEAM_YELLOW_NDT = "LaserBeamYellowNDT";
    String m_sFXBeamName;
    int m_nCurSequence;
    float m_fRange;
    boolean m_bSingleBeam;
    public float fFXSizeX;
    public float fFXSizeY;
    public float fFXZero;
    public float fFXPosY;
}
