// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   LookForEnemy.java

import java.util.HashMap;

public class LookForEnemy extends Scenario
{

    void PrepareScenario(AIController ai)
    {
        m_vDestPos = null;
        NewAI mesh = ai.GetMesh();
        Vector vVolMeshPos = mesh.GetPositionVectorVolatile();
        ChromeActor cEnemy = ai.GetActiveEnemy();
        if(cEnemy != null)
        {
            EnemyInfo info = (EnemyInfo)ai.m_aEnemies.get(cEnemy);
            if(info != null && info.m_vLastKnownPos != null)
            {
                float fDist = mesh.GetDistanceTo(info.m_vLastKnownPos);
                if(fDist > _MIN_DIST_TO_LAST_ENEMY_POS)
                {
                    Vector vPos = vVolMeshPos;
                    m_vDestPos = new Vector(info.m_vLastKnownPos);
                    m_vDestPos.Sub(vPos);
                    m_vDestPos.Mul((fDist - _DEST_DIST_TO_ENEMY) / fDist);
                    m_vDestPos.Add(vPos);
                }
            }
        } else
        if(ai.JustHeardEnemySteps() && ai.m_vLastHeardEnemyStepsPos != null)
            m_vDestPos = new Vector(ai.m_vLastHeardEnemyStepsPos);
        else
        if(ai.m_vLastPassageEnemyNoisePos != null && !AIController.TimePassed(ai.m_fLastPassageEnemyNoiseTime, AIController._VERY_LONG_SOUND_IMPORTANCE_TIME, ai.GetTime()))
            m_vDestPos = new Vector(ai.m_vLastPassageEnemyNoisePos);
        else
        if(ai.IsValidLastHeardEnemyShotPos())
        {
            m_vDestPos = new Vector(ai.GetLastHeardEnemyShotPos());
        } else
        {
            Vector vPos = null;
            float fDistortionAngle = _MAX_RICOCHET_DIR_DISTORTION_ANGLE;
            if(ai.IsValidLastHeardFriendShotPos())
            {
                vPos = ai.m_vLastHeardFriendShotPos;
                float dist2 = 0.0F;
                if(vPos != null)
                    dist2 = mesh.GetDistance2To(vPos);
                if(dist2 < _MAX_DISTANCE_TO_FRIEND * _MAX_DISTANCE_TO_FRIEND)
                {
                    if(vPos == null || dist2 < _MIN_DISTANCE_TO_FRIEND * _MIN_DISTANCE_TO_FRIEND)
                        vPos = ai.m_vLastFriendsTargetPos;
                    if(vPos != null)
                        fDistortionAngle = _MAX_SHOT_DIR_DISTORTION_ANGLE;
                }
            }
            if(vPos == null && ai.JustHeardRicochet())
                vPos = ai.GetLastRicochetMakerPos();
            if(vPos == null && ai.JustHeardExplosion())
                vPos = ai.GetLastExplosionMakerPos();
            if(vPos != null)
            {
                m_vDestPos = new Vector(vPos);
                m_vDestPos.Sub(vVolMeshPos);
                if(m_vDestPos.Len() < _MIN_DISTANCE_TO_FRIEND)
                    m_vDestPos = ai.RotateVector(m_vDestPos, 180F, Vector.Up);
                else
                    m_vDestPos.Mul(GameObject.RandomFloat(0.2F, 0.8F));
                m_vDestPos = ai.RotateVector(m_vDestPos, GameObject.RandomFloat(-fDistortionAngle, fDistortionAngle), Vector.Up);
                m_vDestPos.Add(vVolMeshPos);
            }
        }
        ai.AddTask(new TaskTrackingStop());
        ai.AddTask(new TaskStopFire());
        if(m_vDestPos != null)
        {
            ai.AddTask(new TaskMotionStateChange((byte)5));
            ai.AddTask(new TaskTurnAtPos(m_vDestPos));
            if(mesh.m_GuardedObject == null || mesh.GetDistanceTo(mesh.GetValidGoToPosition(vVolMeshPos, m_vDestPos)) > _MIN_WALK_SEARCH_DISTANCE)
            {
                if(ai.GetMesh().GetDistanceTo(m_vDestPos) > _DEST_DIST_TO_ENEMY)
                {
                    ai.AddTask(new TaskGotoPos(m_vDestPos, _MAX_SEARCH_TIME));
                } else
                {
                    ai.AddTask(new TaskMotionStateChange((byte)4));
                    m_vDestPos.Add(MathUtils.CalcRandomMoveVolatile(_MIN_WALK_SEARCH_DISTANCE, _MAX_WALK_SEARCH_DISTANCE));
                    ai.AddTask(new TaskGotoPos(m_vDestPos, _MAX_SEARCH_TIME));
                }
            } else
            {
                if(mesh.m_fGuardedAreaRadius > _MIN_AREA_RADIUS_TO_RUN)
                {
                    m_vDestPos.Set(Vector.Forward);
                    m_vDestPos.Mul(GameObject.RandomFloat(_MIN_WALK_SEARCH_DISTANCE, mesh.m_fGuardedAreaRadius));
                    m_vDestPos = ai.RotateVector(m_vDestPos, GameObject.RandomFloat(360F), Vector.Up);
                    m_vDestPos.Add(mesh.m_GuardedObject.GetPositionVectorVolatile());
                    ai.AddTask(new TaskGotoPos(m_vDestPos, _MAX_SEARCH_TIME));
                }
                ai.AddTask(new TaskWait(GameObject.RandomFloat(0.5F, 2.0F)));
            }
        } else
        {
            ai.AddTask(new TaskWait(GameObject.RandomFloat(0.5F, 2.0F)));
        }
        super.PrepareScenario(ai);
    }

    public String toString()
    {
        return "LFE";
    }

    public LookForEnemy()
    {
    }

    int GetID()
    {
        return _ID;
    }

    static int _ID;
    static float _MIN_WALK_SEARCH_DISTANCE = 200F;
    static float _MAX_WALK_SEARCH_DISTANCE = 1000F;
    static float _MAX_SEARCH_TIME = 60F;
    static float _MAX_RICOCHET_DIR_DISTORTION_ANGLE = 90F;
    static float _MAX_SHOT_DIR_DISTORTION_ANGLE = 30F;
    static float _MIN_DIST_TO_LAST_ENEMY_POS = 500F;
    static float _DEST_DIST_TO_ENEMY = 200F;
    static float _MIN_DISTANCE_TO_FRIEND = 400F;
    static float _MAX_DISTANCE_TO_FRIEND = 2000F;
    static float _MIN_AREA_RADIUS_TO_RUN = 350F;
    private static Vector m_vDestPos;

    static 
    {
        _ID = Scenario._NUM_OF_SCENARIOS++;
    }
}
