// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   MovingCredits.java

import java.util.Vector;

public class MovingCredits extends GameObject
{
    class CreditsFont
    {

        void ReleaseFont(Module module)
        {
            module.ReleaseFont(m_sID);
        }

        String m_sID;
        String m_sName;
        int m_iHeight;

        CreditsFont(String ID, String name, int height, Module module)
        {
            m_sID = null;
            m_sName = null;
            m_iHeight = 0;
            m_sID = ID;
            m_sName = name;
            m_iHeight = height;
            if(!module.LoadFont(m_sID, m_sName, m_iHeight, 0))
                GameObject.CrashLog("Font ID " + m_sID + ", name " + m_sName + " not loaded !!!\n");
        }
    }

    class SpriteInfo
    {

        Sprite m_Sprite;
        Vector m_vStartPos;

        SpriteInfo(Sprite sprite, Vector vStart)
        {
            m_Sprite = null;
            m_vStartPos = new Vector();
            m_Sprite = sprite;
            m_vStartPos.Set(vStart);
        }
    }


    private void ReleaseFonts()
    {
        for(int i = 0; i < m_Fonts.size(); i++)
        {
            CreditsFont font = (CreditsFont)m_Fonts.elementAt(i);
            font.ReleaseFont(m_Module);
        }

        m_Fonts.clear();
    }

    private void Update()
    {
        float fDt = GetTime() - m_fLastTime;
        float fMove = m_fSpeed * fDt;
        for(int i = 0; i < m_Sprites.size(); i++)
        {
            SpriteInfo info = (SpriteInfo)m_Sprites.elementAt(i);
            Vector vPos = info.m_Sprite.GetPos();
            vPos.fY -= fMove;
            info.m_Sprite.SetPos(vPos);
            if(vPos.fY <= m_fScreenHeight && vPos.fY >= m_fLastElemSpacing)
                info.m_Sprite.Show();
            else
                info.m_Sprite.Hide();
        }

        if(m_Sprites.size() > 0)
        {
            SpriteInfo info = (SpriteInfo)m_Sprites.elementAt(m_Sprites.size() - 1);
            Vector vPos = info.m_Sprite.GetPos();
            if(info.m_Sprite.GetPos().fY < m_fLastElemSpacing)
                InitStartPos();
        }
        m_fLastTime = GetTime();
    }

    public MovingCredits()
    {
        m_Sprites = new Vector();
        m_Fonts = new Vector();
        m_Module = null;
        bUpdate = false;
        m_fLastTime = 0.0F;
        m_fSpeed = 0.0F;
        m_fLastElemSpacing = -50F;
    }

    private void InitStartPos()
    {
        for(int i = 0; i < m_Sprites.size(); i++)
        {
            SpriteInfo info = (SpriteInfo)m_Sprites.elementAt(i);
            info.m_Sprite.SetPos(info.m_vStartPos);
        }

    }

    private void ReleaseTexts()
    {
        for(int i = 0; i < m_Sprites.size(); i++)
        {
            SpriteInfo info = (SpriteInfo)m_Sprites.elementAt(i);
            info.m_Sprite.DetachFromParent();
            info.m_Sprite.RemoveSprite(info.m_Sprite);
            info.m_Sprite.delete();
            info.m_Sprite = null;
        }

        m_Sprites.clear();
    }

    public void Init(String sScriptFile, Module mod)
    {
        m_Module = mod;
        ParseKeyword Root = GameObject.ParseFile(sScriptFile);
        if(Root == null)
        {
            GameObject.CrashLog("No file " + sScriptFile + "!\n");
            return;
        }
        ParseKeyword Key = null;
        ParseKeyword SubKey = null;
        Sprite sprText = null;
        float fCurrPos = GameObject.GetScreenHeight();
        m_fScreenWidth = GameObject.GetScreenWidth();
        m_fScreenHeight = GameObject.GetScreenHeight();
        float fDefaultSpace = 0.0F;
        float fHorizPos = 0.5F * m_fScreenWidth;
        String sDefaultFont = Fonts.GetDefaultFont();
        for(Key = Root; Key != null; Key = Key.GetNext())
        {
            if(Key.Equals("LoadFont"))
            {
                CreditsFont font = new CreditsFont(Key.GetSParam(0), Key.GetSParam(1), Key.GetIParam(2), m_Module);
                m_Fonts.addElement(font);
            } else
            if(Key.Equals("DefaultFont"))
                sDefaultFont = Key.GetSParam(0);
            else
            if(Key.Equals("DefaultFontRes"))
            {
                int iWidth = Key.GetIParam(0);
                if(m_fScreenWidth == (float)iWidth)
                    sDefaultFont = Key.GetSParam(1);
            } else
            if(Key.Equals("DefaultSpace"))
            {
                fDefaultSpace = Key.GetFParam(0);
                if(fDefaultSpace < 1.0F)
                    fDefaultSpace *= m_fScreenHeight;
            } else
            if(Key.Equals("DefaultSpaceRes"))
            {
                int iWidth = Key.GetIParam(0);
                if(m_fScreenWidth == (float)iWidth)
                    fDefaultSpace = Key.GetFParam(1);
                if(fDefaultSpace < 1.0F)
                    fDefaultSpace *= m_fScreenHeight;
            } else
            if(Key.Equals("HorizPos"))
            {
                fHorizPos = Key.GetFParam(0);
                if(fHorizPos < 1.0F)
                    fHorizPos *= m_fScreenWidth;
            } else
            if(Key.Equals("Speed"))
            {
                m_fSpeed = Key.GetFParam(0);
                if(m_fSpeed < 1.0F)
                    m_fSpeed *= m_fScreenWidth;
            } else
            if(Key.Equals("LastLineSpacing"))
            {
                m_fLastElemSpacing = Key.GetFParam(0);
                if(Math.abs(m_fLastElemSpacing) < 1.0F)
                    m_fLastElemSpacing *= m_fScreenHeight;
            }
            if(Key.Equals("Line"))
            {
                float fSpace = fDefaultSpace;
                String sFont = sDefaultFont;
                Vector vSize = new Vector(1.0F, 1.0F, 0.0F);
                sprText = (Sprite)CreateObject("Sprite");
                m_Module.AddSprite(sprText);
                sprText.MoveTop();
                sprText.DisplayText(Key.GetSParamLocalized(0));
                sprText.SetTextPosFlags(ESpriteText.HORIZ_MIDDLE);
                for(SubKey = Key.GetChild(); SubKey != null; SubKey = SubKey.GetNext())
                    if(SubKey.Equals("Font"))
                        sFont = SubKey.GetSParam(0);
                    else
                    if(SubKey.Equals("FontRes"))
                    {
                        int iWidth = SubKey.GetIParam(0);
                        if(m_fScreenWidth == (float)iWidth)
                            sFont = SubKey.GetSParam(1);
                    } else
                    if(SubKey.Equals("Space"))
                    {
                        fSpace = SubKey.GetFParam(0);
                        if(fSpace < 1.0F)
                            fSpace *= m_fScreenWidth;
                    }

                sprText.SetFont(sFont);
                Vector vPos = new Vector(fHorizPos, fCurrPos + fSpace, 0.0F);
                SpriteInfo info = new SpriteInfo(sprText, vPos);
                fCurrPos += fSpace + vSize.fY;
                sprText.SetSize(vSize);
                m_Sprites.addElement(info);
            }
        }

        Root.delete();
    }

    public void End()
    {
        DisableCallMethod("Update");
        ReleaseTexts();
        ReleaseFonts();
    }

    public void Start()
    {
        CallMethodEvery("Update", 0.01F);
        InitStartPos();
        m_fLastTime = GetTime();
        if(m_Sprites.size() > 0)
            ((SpriteInfo)m_Sprites.elementAt(0)).m_Sprite.Show();
    }

    Vector m_Sprites;
    Vector m_Fonts;
    Module m_Module;
    boolean bUpdate;
    float m_fLastTime;
    float m_fSpeed;
    float m_fScreenWidth;
    float m_fScreenHeight;
    float m_fLastElemSpacing;
}
