// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   Music.java


public class Music extends GameObject
    implements iact_StartStop
{

    public void OnFrame()
    {
        if(nMusic != 0)
        {
            if(nRealLoops != 0 && !IsPlayingWave(nMusic))
            {
                nMusic = PlayWave(Text.Get(sMusic.toString()));
                GameObject.SetWaveVolume(nMusic, fMusicVolume);
                if(nRealLoops > 0)
                    nRealLoops--;
            }
            if(bFadeOut && nMusic != 0)
            {
                float fInterval = GetTime() - fStartTime;
                float fCurrVolume = (fVolume * fInterval) / fFadeOutTime;
                if(fInterval > fFadeOutTime)
                {
                    Fade(0.0F);
                    bFadeOut = false;
                    ForceStop();
                } else
                {
                    Fade(fVolume - fCurrVolume);
                }
            }
        }
    }

    public void ToggleStartStop()
    {
        if(nMusic != 0)
        {
            if(IsPlayingWave(nMusic))
                Stop();
        } else
        {
            Start();
        }
    }

    public void OnAudioPreReinitialize()
    {
        if(cPlayingMusic == this && cPlayingMusic.nMusic != 0 && IsPlayingWave(cPlayingMusic.nMusic))
            l_nWavePos = GetPlayingWavePos(cPlayingMusic.nMusic);
    }

    public void OnAudioReinitialize()
    {
        if(cPlayingMusic == this)
        {
            String sMusicFile = Text.Get(cPlayingMusic.sMusic.toString());
            if(l_nWavePos != -1L)
                nMusic = PlayWaveFromPos(sMusicFile, l_nWavePos);
            else
                nMusic = PlayWave(sMusicFile);
            GameObject.SetWaveVolume(nMusic, fMusicVolume);
        }
        l_nWavePos = -1L;
    }

    void ZeroPlayingMusic()
    {
        cPlayingMusic = null;
    }

    Music()
    {
        sMusic = null;
        nLoops = 1;
        fDuration = 0.0F;
        fFadeOutTime = 3F;
        fRealDuration = 0.0F;
        nRealLoops = 0;
        nMusic = 0;
        cNewMusic = null;
        bFadeOut = false;
        fVolume = 1.0F;
        fStartTime = 0.0F;
        bPlay = false;
        l_nWavePos = -1L;
        super.bSG = true;
    }

    public void SGUpdate()
    {
        FileChunk.Log("[Music.SGUpdate]\n");
        super.SGUpdate();
        if(bPlay)
        {
            nMusic = PlayWave(Text.Get(sMusic.toString()));
            GameObject.SetWaveVolume(nMusic, fMusicVolume);
        }
    }

    public void Stop()
    {
        String sMusicFile = sMusic == null ? "" : Text.Get(sMusic.toString());
        GameObject.LogR("[Music.Stop] Music <" + sMusicFile + ">\n");
        if(fFadeOutTime == 0.0F)
        {
            ForceStop();
        } else
        {
            bFadeOut = true;
            fVolume = GameObject.GetWaveVolume(nMusic);
            fStartTime = GetTime();
        }
    }

    public void Stop(Music newMusic)
    {
        cNewMusic = newMusic;
        Stop();
    }

    public void ForceStop()
    {
        bFadeOut = false;
        String sMusicFile = sMusic == null ? "" : Text.Get(sMusic.toString());
        GameObject.LogR("[Music.ForceStop] Music <" + sMusicFile + ">\n");
        if(nMusic != 0)
        {
            if(IsPlayingWave(nMusic))
                StopWave(nMusic);
            nMusic = 0;
            ZeroPlayingMusic();
        }
        if(cNewMusic != null)
        {
            cNewMusic.Start();
            cNewMusic = null;
        }
    }

    static void UpdateVolume()
    {
        int nCDVolume = GameObject.GetAudioCDVolume();
        fMusicVolume = (float)nCDVolume / 10F;
        if(cPlayingMusic != null && cPlayingMusic.nMusic != 0)
            GameObject.SetWaveVolume(cPlayingMusic.nMusic, fMusicVolume);
        GameObject tab[] = GameObject.GetObjectsFromClass("PortablePlayer");
        if(tab != null && tab.length > 0)
        {
            for(int i = 0; i < tab.length; i++)
                ((PortablePlayer)tab[i]).UpdateMusicVolume();

        }
    }

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[Music.SGSaveChunk]\n");
        FileChunk cFC = GameObject.NewChunk(1106, cFCParent);
        super.SGSaveChunk(cFC);
        cFC.SaveFloat(fRealDuration);
        cFC.SaveInt(nRealLoops);
        cFC.SaveBool(bFadeOut);
        cFC.SaveFloat(fVolume);
        cFC.SaveFloat(fStartTime);
        cFC.SaveFloat(fMusicVolume);
        cFC.SaveBool(nMusic != 0);
        cFC.SaveObjectRef(cNewMusic);
        cFC.delete();
    }

    public void Fade(float fFade)
    {
        GameObject.SetWaveVolume(nMusic, fFade);
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[Music.SGLoadChunk]\n");
        DisableCallMethod("Stop");
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        if(cFC.GetID() == 1106)
        {
            if(nMusic != 0)
            {
                StopWave(nMusic);
                nMusic = 0;
            }
            if(cPlayingMusic != null && cPlayingMusic.nMusic != 0)
            {
                StopWave(cPlayingMusic.nMusic);
                cPlayingMusic.nMusic = 0;
                cPlayingMusic = null;
            }
            super.SGLoadChunk(cFC);
            fRealDuration = cFC.LoadFloat();
            nRealLoops = cFC.LoadInt();
            bFadeOut = cFC.LoadBool();
            fVolume = cFC.LoadFloat();
            fStartTime = cFC.LoadFloat();
            fMusicVolume = cFC.LoadFloat();
            bPlay = cFC.LoadBool();
            cNewMusic = (Music)cFC.LoadObjectRef();
        }
        cFC.delete();
    }

    public void Start()
    {
        String sMusicFile = sMusic == null ? "" : Text.Get(sMusic.toString());
        if(cPlayingMusic != null && (cPlayingMusic == this || cPlayingMusic.cNewMusic == this))
        {
            GameObject.CrashLog("[Music.Play] <" + sMusicFile + "> already playing this music\n");
            return;
        }
        if(cPlayingMusic != null)
        {
            String sMusicFilePlaying = cPlayingMusic.sMusic == null ? "" : Text.Get(cPlayingMusic.sMusic.toString());
            GameObject.CrashLog("[Music.Play] <" + sMusicFile + "> some <" + sMusicFilePlaying + "> music already playing - stopping\n");
            cPlayingMusic.Stop(this);
            return;
        }
        if(sMusic != null)
        {
            if(nMusic != 0 && IsPlayingWave(nMusic))
                StopWave(nMusic);
            nMusic = PlayWave(sMusicFile);
            if(nMusic == 0)
                GameObject.CrashLog("[Music.Play] No music <" + sMusicFile + ">\n");
            else
                GameObject.LogR("[Music.Play] Music <" + sMusicFile + "> fMusicVolume=" + fMusicVolume + "\n");
            GameObject.SetWaveVolume(nMusic, fMusicVolume);
            cPlayingMusic = this;
            if(fDuration == 0.0F && nLoops > 0)
                fRealDuration = (float)nLoops * GameObject.GetWaveDuration(nMusic);
            else
                fRealDuration = fDuration;
            nRealLoops = nLoops;
            if(nRealLoops > 0)
                nRealLoops--;
            if(fRealDuration > 0.0F)
                CallMethodIn("Stop", fRealDuration);
            bFadeOut = false;
        }
    }

    public void OnDestroy()
    {
        cNewMusic = null;
        ForceStop();
    }

    static Music cPlayingMusic = null;
    static float fMusicVolume = 1.0F;
    public FileName sMusic;
    public int nLoops;
    public float fDuration;
    public float fFadeOutTime;
    float fRealDuration;
    int nRealLoops;
    int nMusic;
    Music cNewMusic;
    boolean bFadeOut;
    float fVolume;
    float fStartTime;
    boolean bPlay;
    long l_nWavePos;

}
