// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   NewAI.java

import java.io.File;
import java.util.*;

class NewAI extends Pawn
    implements IFreezable, IObjCount, iact_Appear, iact_Freeze, ipar_PathFinder, iact_ChangeWaypoint, ipar_WeaponParams, ipar_MotionSpeed, ipar_HitReaction, IVehiclePassenger
{

    public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        if(Assassin instanceof ChromeActor)
            ((ChromeActor)Assassin).NotifyHit(this, nDamageType);
        if(m_Pain != null && !IsDead() && !IsFrozen())
            m_Pain.OnTakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
        MakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
        if(bHitReactionAllowed && !m_bHitReactionDisabled)
            HitReaction(vSpeed);
        if((Assassin instanceof Player) && aOnDamageFromPlayer != null)
            GameObject.InvokeActionChain(aOnDamageFromPlayer);
        if(Assassin instanceof ChromeActor)
        {
            ChromeActor actor = (ChromeActor)Assassin;
            if(aOnDamageFromFriend != null && IsFriend(actor))
                GameObject.InvokeActionChain(aOnDamageFromFriend);
            if(aOnDamageFromEnemy != null && IsEnemy(actor))
                GameObject.InvokeActionChain(aOnDamageFromEnemy);
        }
    }

    public void MakeDamage(float fDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType, boolean bClampDamage)
    {
        float fMultiplier = GetDamageMultiplier(nMeshElementorBoneID);
        fDamage *= fMultiplier;
        Damage(fDamage, nDamageType);
    }

    protected void AnimationFinished()
    {
        if(m_nCurrentAnimID != _ANIM_ID_NONE)
        {
            int lastAnimID = m_nCurrentAnimID;
            m_nCurrentAnimID = _ANIM_ID_NONE;
            m_Controller.AnimationEnd(lastAnimID);
        }
    }

    public Vector GetVisibilityCheckFireOrigin()
    {
        return GetFireOrigin();
    }

    void InsertItems(String aItems[], int nItems)
    {
        for(int i = 0; i < nItems; i++)
            if(GetClassID(aItems[i]) != 0)
            {
                InvObject cObject = (InvObject)CreateObject(aItems[i]);
                cObject.AddToInventory(this);
            }

    }

    void InitializeAIAmmo(Weapon cWeapon)
    {
        if(MathUtils.CanHappen(mod_nSpareAmmoProbability))
        {
            int nDesiredAmmo = (int)((float)cWeapon.nCapacity * GameObject.RandomFloat(mod_fMinSpareAmmoClips, mod_fMaxSpareAmmoClips));
            if(nDesiredAmmo > 0)
            {
                String sAmmoClass = "";
                switch(cWeapon.eBulletType)
                {
                case 1: // '\001'
                    sAmmoClass = "Ammo12mmShort";
                    break;

                case 3: // '\003'
                    sAmmoClass = "Ammo14mmLong";
                    break;

                case 2: // '\002'
                    sAmmoClass = "Ammo8mmLong";
                    break;

                case 0: // '\0'
                    sAmmoClass = "Ammo9mmShort";
                    break;

                case 4: // '\004'
                    sAmmoClass = "AmmoEnergy";
                    break;

                case 5: // '\005'
                    sAmmoClass = "AmmoHEX";
                    break;

                case 7: // '\007'
                    sAmmoClass = "AmmoRockets";
                    break;

                case 6: // '\006'
                    sAmmoClass = "AmmoShotgun";
                    break;

                default:
                    return;
                }
                int nAmmo = 0;
                do
                {
                    Ammo cAmmo = (Ammo)CreateObject(sAmmoClass);
                    cAmmo.AddToInventory(this, false);
                    if(nDesiredAmmo - nAmmo > cAmmo.nCapacity)
                        cAmmo.nCount = cAmmo.nCapacity;
                    else
                        cAmmo.nCount = nDesiredAmmo - nAmmo;
                    nAmmo += cAmmo.nCount;
                } while(nAmmo < nDesiredAmmo);
            }
        }
    }

    public float Scream(int iScreamType)
    {
        float duration = 0.0F;
        float time = GetTime();
        String fileName;
        if(time >= m_fNextScreamTime && m_aSoundsGroups != null && m_aSoundsGroups[iScreamType] != null && time >= m_aNextScreamTypeTime[iScreamType] && (fileName = m_aSoundsGroups[iScreamType].GetSoundName()) != null)
        {
            m_nLastScreamType = iScreamType;
            float range = m_aSoundsGroups[iScreamType].fNoiseRange;
            if(range > 0.0F)
                MakeNoise(range * GetMakeNoiseMult(), 4);
            String filePath = m_sSoundsPathPrefix + fileName;
            duration = GetWaveDuration(filePath);
            m_fNextScreamTime = time + duration;
            m_aNextScreamTypeTime[iScreamType] = m_fNextScreamTime + m_aSoundsGroups[iScreamType].GetRandomDelay();
            AttachOneShotSound(filePath, m_fMinScreamRange, m_fMaxScreamRange);
        }
        return duration;
    }

    public void Respawn()
    {
        super.bDead = false;
        super.fHealth = super.fMaxHealth;
        if(m_Controller != null)
            m_Controller.Respawn();
        CallMethodIn(METHOD_CallUpdateMotion, 0.0F);
    }

    public void OnHearNoise(Actor Noisy, float fNoiseLevel, int nNoiseType)
    {
        if(m_Hearing != null && !IsDead() && !IsFrozen())
            m_Hearing.OnHearNoise(Noisy, fNoiseLevel, nNoiseType);
    }

    protected void TryToVerticalize()
    {
        if(GetUpVectorVolatile().fY < 0.999F)
        {
            ControlObject parent = GetParent();
            if(!(parent instanceof Vehicle) && !(parent instanceof StationaryCannon) && !(parent instanceof FlyingVehicle) && !(parent instanceof NewAIWalker))
            {
                GameObject.CrashLog("WARNING: AI sie przekrzywil (" + GetName() + "), parent = " + parent + "\n");
                FromUpForwardPos(Vector.Up, GetForwardVectorVolatile(), GetPositionVectorVolatile());
            }
        }
    }

    public void InitParamsFromMesh()
    {
        if(super.fHealth == -1F)
            super.fHealth = fDefaultAIHealth;
    }

    void SetHearing(IAIHearingSense hearing)
    {
        m_Hearing = hearing;
    }

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[NewAI.SGSaveChunk]\n");
        FileChunk cFC = GameObject.NewChunk(1300, cFCParent);
        super.SGSaveChunk(cFC);
        cFC.SaveObject(m_Controller);
        cFC.SaveBool(m_bHitReactionDisabled);
        cFC.SaveInt(m_nLastScreamType);
        cFC.SaveFloat(m_fNextScreamTime);
        if(m_aNextScreamTypeTime == null)
        {
            cFC.SaveInt(-1);
        } else
        {
            cFC.SaveInt(m_aNextScreamTypeTime.length);
            for(int i = 0; i < m_aNextScreamTypeTime.length; i++)
                cFC.SaveFloat(m_aNextScreamTypeTime[i]);

        }
        cFC.SaveObjectRef(cWaypoint);
        cFC.SaveObjectRef(cFirstWaypoint);
        cFC.SaveObjectRef(m_NewWaypoint);
        cFC.SaveBool(m_bWaypointChanged);
        cFC.SaveBool(bPortalIndependent);
        cFC.SaveObjectRef(m_Killer);
        cFC.SaveInt(m_nGrenadesLeft);
        cFC.SaveInt(m_nRoundsHit);
        cFC.SaveInt(m_nRoundsShot);
        cFC.SaveFloat(m_fDesiredHitRatio);
        cFC.SaveFloat(m_fLastDesiredHitRatio);
        cFC.SaveFloat(m_fFiringDevLineAngle);
        cFC.SaveFloat(m_fFiringDeviation);
        cFC.SaveFloat(m_fMaxHitFiringDeviation);
        cFC.SaveFloat(m_fHitRatioChangeSpeed);
        cFC.SaveFloat(m_fCriticalDesiredHitRatioChangeThreshold);
        cFC.SaveFloat(m_fLastDesiredHitRatioChangeCheckTime);
        cFC.SaveFloat(m_fLastResetFiringStatisticsTime);
        cFC.SaveInt(m_nCurrentAnimID);
        cFC.SaveObjectRef(m_TrackedObject);
        cFC.SaveBool(m_bTrackLookOnly);
        cFC.SaveBool(m_bTrackCanTurn);
        cFC.SaveBool(m_bIsFrozen);
        cFC.SaveBool(m_bWasPhysicsActiveBeforeFreeze);
        cFC.SaveBool(m_bIsActive);
        cFC.SaveBool(m_bWasFrozenBeforeDeactivate);
        cFC.SaveBool(m_bUsePathfinder);
        cFC.SaveBool(m_bUseIndoorPathfinder);
        if(m_aCurrentGoToPath != null)
        {
            cFC.SaveInt(m_aCurrentGoToPath.length);
            for(int i = 0; i < m_aCurrentGoToPath.length; i++)
                cFC.SaveVector(m_aCurrentGoToPath[i]);

        } else
        {
            cFC.SaveInt(-1);
        }
        cFC.SaveInt(m_nCurrentGoToPathLen);
        cFC.SaveInt(m_nWaypointsInPath);
        cFC.SaveVector(m_vCurrentGoToPoint);
        cFC.SaveInt(m_nCurrentGoToPathIdx);
        cFC.SaveVector(m_vGoToDestination);
        cFC.SaveFloat(m_fDestinationRadius);
        cFC.SaveBool(m_bLastGoToSuccessfull);
        cFC.SaveObjectRef(m_GuardedObject);
        cFC.SaveFloat(m_fGuardedAreaRadius);
        cFC.SaveBool(m_bGuardCritical);
        cFC.SaveVector(m_vStartPos);
        cFC.SaveFloat(m_fIntPosOldMass);
        cFC.SaveBool(m_bIntPos_BLOCK_MOVE);
        cFC.SaveVector(m_vIntPosDestPos);
        cFC.SaveVector(m_vIntPosDir);
        cFC.SaveVector(m_vIntPosDestDir);
        cFC.SaveBool(m_bIntPosWasUsingPathfinder);
        cFC.SaveObjectRef(cAIInventoryExecutor);
        cFC.SaveInt(m_nAmmoForActiveWeapon);
        cFC.SaveObject(m_Motion);
        cFC.SaveObject(m_OldMotion);
        cFC.SaveObject(m_ActualMotion);
        if(m_aMotionVelocity != null)
        {
            cFC.SaveInt(m_aMotionVelocity.length);
            for(int i = 0; i < m_aMotionVelocity.length; i++)
                cFC.SaveFloat(m_aMotionVelocity[i]);

        } else
        {
            cFC.SaveInt(-1);
        }
        cFC.SaveObject(m_WpSystem);
        cFC.delete();
    }

    public boolean CanStandAtPos(Vector vPos)
    {
        if(m_bUsePathfinder)
        {
            UpdatePathMap(false, m_iPathFinderStampSize);
            boolean bRet = IsPlaceMoveable(vPos, m_iPathFinderStampSize);
            UpdatePathMap(true, m_iPathFinderStampSize);
            return bRet;
        } else
        {
            return true;
        }
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[NewAI.SGLoadChunk]\n");
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        if(cFC.GetID() == 1300)
        {
            super.SGLoadChunk(cFC);
            m_Controller = (AIController)cFC.LoadObject(m_Controller, this);
            m_bHitReactionDisabled = cFC.LoadBool();
            m_nLastScreamType = cFC.LoadInt();
            m_fNextScreamTime = cFC.LoadFloat();
            int arrayLen = cFC.LoadInt();
            if(arrayLen < 0)
            {
                m_aNextScreamTypeTime = null;
            } else
            {
                m_aNextScreamTypeTime = new float[arrayLen];
                for(int i = 0; i < arrayLen; i++)
                    m_aNextScreamTypeTime[i] = cFC.LoadFloat();

            }
            cWaypoint = (Waypoint)cFC.LoadObjectRef();
            cFirstWaypoint = (Waypoint)cFC.LoadObjectRef();
            m_NewWaypoint = (Waypoint)cFC.LoadObjectRef();
            m_bWaypointChanged = cFC.LoadBool();
            bPortalIndependent = cFC.LoadBool();
            m_Killer = (ChromeActor)cFC.LoadObjectRef();
            m_nGrenadesLeft = cFC.LoadInt();
            m_nRoundsHit = cFC.LoadInt();
            m_nRoundsShot = cFC.LoadInt();
            m_fDesiredHitRatio = cFC.LoadFloat();
            m_fLastDesiredHitRatio = cFC.LoadFloat();
            m_fFiringDevLineAngle = cFC.LoadFloat();
            m_fFiringDeviation = cFC.LoadFloat();
            m_fMaxHitFiringDeviation = cFC.LoadFloat();
            m_fHitRatioChangeSpeed = cFC.LoadFloat();
            m_fCriticalDesiredHitRatioChangeThreshold = cFC.LoadFloat();
            m_fLastDesiredHitRatioChangeCheckTime = cFC.LoadFloat();
            m_fLastResetFiringStatisticsTime = cFC.LoadFloat();
            m_nCurrentAnimID = cFC.LoadInt();
            m_TrackedObject = (ChromeActor)cFC.LoadObjectRef();
            m_bTrackLookOnly = cFC.LoadBool();
            m_bTrackCanTurn = cFC.LoadBool();
            m_bIsFrozen = cFC.LoadBool();
            m_bWasPhysicsActiveBeforeFreeze = cFC.LoadBool();
            m_bIsActive = cFC.LoadBool();
            m_bWasFrozenBeforeDeactivate = cFC.LoadBool();
            m_bUsePathfinder = cFC.LoadBool();
            m_bUseIndoorPathfinder = cFC.LoadBool();
            arrayLen = cFC.LoadInt();
            if(arrayLen < 0)
            {
                m_aCurrentGoToPath = null;
            } else
            {
                m_aCurrentGoToPath = new Vector[arrayLen];
                for(int i = 0; i < arrayLen; i++)
                    m_aCurrentGoToPath[i] = cFC.LoadVector();

            }
            m_nCurrentGoToPathLen = cFC.LoadInt();
            m_nWaypointsInPath = cFC.LoadInt();
            m_vCurrentGoToPoint = cFC.LoadVector();
            m_nCurrentGoToPathIdx = cFC.LoadInt();
            m_vGoToDestination = cFC.LoadVector();
            m_fDestinationRadius = cFC.LoadFloat();
            m_bLastGoToSuccessfull = cFC.LoadBool();
            m_GuardedObject = (ControlObject)cFC.LoadObjectRef();
            m_fGuardedAreaRadius = cFC.LoadFloat();
            m_bGuardCritical = cFC.LoadBool();
            m_vStartPos = cFC.LoadVector();
            m_fIntPosOldMass = cFC.LoadFloat();
            m_bIntPos_BLOCK_MOVE = cFC.LoadBool();
            m_vIntPosDestPos = cFC.LoadVector();
            m_vIntPosDir = cFC.LoadVector();
            m_vIntPosDestDir = cFC.LoadVector();
            m_bIntPosWasUsingPathfinder = cFC.LoadBool();
            cAIInventoryExecutor = (Actor)cFC.LoadObjectRef();
            m_nAmmoForActiveWeapon = cFC.LoadInt();
            m_Motion = (AIMotionState)cFC.LoadObject(m_Motion, this);
            m_OldMotion = (AIMotionState)cFC.LoadObject(m_OldMotion, this);
            m_ActualMotion = (AIMotionState)cFC.LoadObject(m_ActualMotion, this);
            arrayLen = cFC.LoadInt();
            if(arrayLen < 0)
            {
                m_aMotionVelocity = null;
            } else
            {
                m_aMotionVelocity = new float[arrayLen];
                for(int i = 0; i < arrayLen; i++)
                    m_aMotionVelocity[i] = cFC.LoadFloat();

            }
            m_WpSystem = (WaypointSystem)cFC.LoadObject(m_WpSystem, this);
        }
        cFC.delete();
    }

    void CalcFiringDevLineAngle()
    {
        m_fFiringDevLineAngle = GameObject.RandomFloat(-45F, 45F);
        if(GameObject.RandomInt(2) == 0)
            m_fFiringDevLineAngle += 180F;
    }

    void PlaceWeapons()
    {
    }

    public void Die()
    {
        if(!IsDead())
        {
            super.Die();
            if(m_CommSystem != null)
                m_CommSystem.BreakRadioMessage(this);
            if(m_Controller != null)
                m_Controller.Die();
            if(GetAIGroup() != null)
                GetAIGroup().MemberDie(this);
            DisableBodyActivities();
            ((ChromeModule)GetModule()).GetDoorControler().IsNearDoorable(this);
        }
    }

    public float Turn(float fAngle)
    {
        return Turn(fAngle, GetAngSpeedForMotion(m_Motion));
    }

    public float Turn(float fAngle, float fAngSpeed)
    {
        TryToVerticalize();
        fAngSpeed = Math.abs(fAngSpeed);
        float fTime = Math.abs(fAngle) / fAngSpeed;
        SetAngSpeed(fAngSpeed * (float)(-MathUtils.sign(fAngle)));
        CallMethodOnceIn(METHOD_TurnDone, fTime);
        m_Motion.iTurn = (byte)MathUtils.sign(fAngle);
        UpdateMotion();
        return fTime;
    }

    public float Turn(Vector vDir)
    {
        Vector vWorldDir = new Vector(vDir);
        Vector vLocalDir = VectorWorldToLocal(vWorldDir);
        float fAngle = (float)((Math.atan2(vLocalDir.fX, vLocalDir.fZ) * 180D) / 3.1415926535897931D);
        SetFacingDestDir(vDir);
        float fAngSpeed = GetAngSpeedForMotion(m_Motion);
        SetMaxAngSpeed(fAngSpeed);
        float fTime = Math.abs(fAngle) / fAngSpeed;
        CallMethodOnceIn(METHOD_TurnDone, fTime);
        if(Math.abs(fAngle) > m_fMinTurnAngleToUpdateMotion)
        {
            m_Motion.iTurn = (byte)MathUtils.sign(fAngle);
            UpdateMotion();
        }
        TryToVerticalize();
        return fTime;
    }

    public void SGUpdate()
    {
        FileChunk.Log("[NewAI.SGUpdate]\n");
        super.SGUpdate();
        if(m_Controller != null)
            m_Controller.SGUpdate();
        else
            GameObject.CrashLog("[NewAI.SGUpdate] Error: AIController was not created !\n");
        if(!IsDead() && !m_bIsFrozen && m_bIsActive)
            UpdateAllTrackings();
        if(m_Motion != null)
            m_Motion.SGUpdate();
        if(m_OldMotion != null)
            m_OldMotion.SGUpdate();
        if(m_ActualMotion != null)
            m_ActualMotion.SGUpdate();
        if(cWaypoint != null && cWaypoint.cMotion == null)
            cWaypoint.cMotion = new mt_Move();
        if(cFirstWaypoint != null && cFirstWaypoint.cMotion == null)
            cFirstWaypoint.cMotion = new mt_Move();
        if(m_NewWaypoint != null && m_NewWaypoint.cMotion == null)
            m_NewWaypoint.cMotion = new mt_Move();
        if(m_nInstanceNumber == 0 && m_CommSystem != null)
            m_CommSystem.Reinitialize();
    }

    public boolean IsDead()
    {
        return super.bDead;
    }

    public void GoToFinished()
    {
        StopGoTo();
        m_Controller.Notify(103);
    }

    public void SetWeaponParams(ParamWeaponParams params)
    {
        if(super.ActiveWeapon != null)
        {
            super.ActiveWeapon.SetWeaponParams(params);
            if(m_Controller != null)
                m_Controller.ActiveWeaponChanged();
        }
    }

    public final void CallMethodOnceIn(int nMethodID, float fTime)
    {
        DisableCallMethod(nMethodID);
        CallMethodIn(nMethodID, fTime);
    }

    public boolean WasLastGoToSuccessfull()
    {
        return m_bLastGoToSuccessfull;
    }

    public static void AddModifier(AIParamsMod modifier)
    {
        s_ModifiersList.add(modifier);
    }

    protected void UpdateTrackingObject()
    {
    }

    public void UseIndoorPathfinder(boolean bUsePathFinder)
    {
        m_bUseIndoorPathfinder = bUsePathFinder;
        if(bUsePathFinder)
            UsePathfinder(false);
    }

    public int GetObjsCount()
    {
        return 1;
    }

    public Vector GetTopmostPoint(byte iSpeed, boolean bAiming)
    {
        Vector vMax = new Vector();
        Vector vMin = new Vector();
        GetMeshExtentsInWorld(vMin, vMax);
        float fY = vMax.fY - 5F;
        vMax.Add(vMin);
        vMax.Mul(0.5F);
        vMax.fY = fY;
        return vMax;
    }

    public Waypoint GetWaypoint()
    {
        return cWaypoint;
    }

    float GetSpeedValueForActualMotion()
    {
        return GetSpeedValueForMotion(m_ActualMotion);
    }

    public void GoToPosition(Vector vDest)
    {
        m_bLastGoToSuccessfull = true;
        GetPosition(m_vStartPos);
        Vector vEndPos = GetValidGoToPosition(m_vStartPos, vDest);
        if(MathUtils.dist2D(m_vStartPos, vEndPos) > m_fDestinationRadius)
        {
            if(m_bUsePathfinder)
            {
                m_aCurrentGoToPath = FindPath(m_vStartPos, vEndPos);
                m_nCurrentGoToPathLen = m_aCurrentGoToPath == null ? 0 : m_aCurrentGoToPath.length;
                if(m_nCurrentGoToPathLen > 1 && !IsPlaceMoveable(vEndPos, m_iPathFinderStampSize))
                {
                    float fLastDist2 = vEndPos.Distance2(m_aCurrentGoToPath[0]);
                    for(int i = 1; i < m_nCurrentGoToPathLen; i++)
                    {
                        float fDist2 = vEndPos.Distance2(m_aCurrentGoToPath[i]);
                        if(fDist2 > fLastDist2)
                        {
                            m_nCurrentGoToPathLen = i;
                            break;
                        }
                        fLastDist2 = fDist2;
                    }

                }
            } else
            if(m_WpSystem != null && (cWaypoint == null || !bPortalIndependent) && m_bUseIndoorPathfinder && bAllowUsingIndoorPathfinder)
            {
                FindPathInfo info = m_WpSystem.FindPath(GetPosition(), vEndPos);
                m_nCurrentGoToPathLen = info.GetRealSteps();
                m_nWaypointsInPath = info.GetWPSteps();
                if(m_nCurrentGoToPathLen > 1)
                    m_aCurrentGoToPath = m_WpSystem.GetPathTab();
                else
                    m_aCurrentGoToPath = null;
            } else
            {
                m_nCurrentGoToPathLen = 2;
                m_aCurrentGoToPath = new Vector[2];
                m_aCurrentGoToPath[0] = m_vStartPos;
                m_aCurrentGoToPath[1] = vEndPos;
            }
            if(m_aCurrentGoToPath != null && m_nCurrentGoToPathLen > 1)
            {
                m_vGoToDestination.Set(vEndPos);
                m_nCurrentGoToPathIdx = 1;
                m_vCurrentGoToPoint = m_aCurrentGoToPath[m_nCurrentGoToPathIdx];
                SetDestinationPos(m_vCurrentGoToPoint);
                SetDestinationRadius(m_fDestinationRadius);
                UpdateTrackingDir();
            } else
            {
                m_bLastGoToSuccessfull = false;
                DisableCallMethod("GoToFinished");
                CallMethodIn("GoToFinished", 0.0F);
            }
        } else
        {
            m_bLastGoToSuccessfull = false;
            DisableCallMethod("GoToFinished");
            CallMethodIn("GoToFinished", 0.0F);
        }
    }

    public void TriggerObjectNotification(TriggerObject trigger, ExecutionInfo currentExecutionInfo)
    {
        m_Controller.TriggerObjectNotification(trigger, currentExecutionInfo);
    }

    public void InitializeCommSystem(ChromeModuleSingle module)
    {
        m_CommSystem = (RadioCommunicationSystem)module.CreateObject("RadioCommunicationSystem");
        m_CommSystem.Init(module);
        m_CommSystem.ActivateOnModule();
    }

    void OnBlockMove()
    {
        if(m_bUsePathfinder)
            GoToPosition(m_vGoToDestination);
    }

    public void Appear(ControlObject m_cRefMtxHolder)
    {
        if(m_cRefMtxHolder != null && m_cRefMtxHolder.GetPositionVectorVolatile() != null)
        {
            Vector vPos = GetInFormationPosition(m_cRefMtxHolder.GetPositionVectorVolatile(), null);
            UpdatePathMap(false);
            FromUpForwardPos(m_cRefMtxHolder.GetUpVectorVolatile(), m_cRefMtxHolder.GetForwardVectorVolatile(), vPos);
            if(m_bUsePathfinder)
                UpdatePathMap(true);
            UpdatePortals();
            UpdateWaypointSystem(vPos);
        }
        Activate();
    }

    EnumGetInType GetGetInType()
    {
        return cGetInAs;
    }

    void MessageWeapon(int nState)
    {
        if((nState & 1) != 0)
        {
            m_nRoundsShot++;
            UpdatePosOnDevLine();
        }
        m_Controller.MessageWeapon(nState);
    }

    public void UseWeapon(Weapon weapon)
    {
        super.UseWeapon(weapon);
        m_Controller.ActiveWeaponChanged();
    }

    public void SetMotionSpeedValue(int iMotionSpeed, float fNewSpeedValue)
    {
        if(iMotionSpeed >= 0 && iMotionSpeed < m_aMotionVelocity.length)
            m_aMotionVelocity[iMotionSpeed] = fNewSpeedValue;
    }

    public void OnPostCreate()
    {
        CreateController(m_sControllerClassName);
        Initialize();
        CallMethodIn(METHOD_CallUpdateMotion, 0.0F);
        CallMethodEveryMinMax(METHOD_UpdateAllTrackings, m_fMinTrackingUpdateTime, m_fMaxTrackingUpdateTime, m_fMinTrackingUpdateTime * GetTimeDeviation());
        if(WaypointSystem.InBuilding(this))
        {
            WaypointSystem.CorrectPosInBuilding(this, 25F);
            m_bUsePathfinder = false;
            m_bUseIndoorPathfinder = true;
            m_WpSystem = null;
            m_WpSystem = WaypointSystem.LoadWaypoints(this);
            if(m_WpSystem == null)
            {
                m_WpSystem = new WaypointSystem(this);
                m_WpSystem.GenerateWaypoints();
            }
        }
        UsePathfinder(m_bUsePathfinder);
        if(bDisappearOnStart)
            Disappear(null);
    }

    public void Activate()
    {
        if(!m_bIsActive)
        {
            if(!m_bWasFrozenBeforeDeactivate)
                Unfreeze();
            ActivateOnModule();
            EnableRendering(true);
            m_bIsActive = true;
            if(m_Controller != null)
                m_Controller.NotifyMeshActivation(true);
        }
    }

    protected void UpdatePosOnDevLine()
    {
        float fActualHitRatio = CalcActualHitRatio();
        float fHitRatioDelta = Math.abs(fActualHitRatio - m_fDesiredHitRatio);
        fHitRatioDelta *= m_fHitRatioChangeSpeed;
        if(fHitRatioDelta < 0.05F)
            fHitRatioDelta = 0.05F;
        if(fActualHitRatio > m_fDesiredHitRatio)
            m_fFiringDeviation += fHitRatioDelta;
        else
            m_fFiringDeviation -= fHitRatioDelta;
        if(m_fFiringDeviation > 1.0F)
            m_fFiringDeviation = 1.0F;
        else
        if(m_fFiringDeviation <= fHitRatioDelta)
        {
            if(m_fFiringDeviation <= 0.0F)
                m_fFiringDeviation = 0.0F;
            CalcFiringDevLineAngle();
        }
        float fTime = GetTime();
        if(fTime - m_fLastDesiredHitRatioChangeCheckTime > _DESIRED_HIT_RATIO_CHANGE_CHECK_INTERVAL)
        {
            m_fLastDesiredHitRatioChangeCheckTime = fTime;
            m_fLastDesiredHitRatio = m_fDesiredHitRatio;
            if(Math.abs(m_fLastDesiredHitRatio - m_fDesiredHitRatio) > m_fCriticalDesiredHitRatioChangeThreshold)
                ResetFiringStatistics();
        }
        if(fTime - m_fLastResetFiringStatisticsTime > _MAX_RESET_FIRING_STATISTICS_INTERVAL)
            ResetFiringStatistics();
    }

    public void MovieDie()
    {
        TakeDamage(super.fHealth * 2.0F + 1.0F, 0.0F, null, null, null, -1, EnumDamageType._ALL);
    }

    public void ResetFiringStatistics()
    {
        m_nRoundsHit = m_nRoundsShot = 0;
        m_fMaxHitFiringDeviation = 0.0F;
        m_fLastResetFiringStatisticsTime = GetTime();
    }

    void StopTurn()
    {
        DisableCallMethod(METHOD_TurnDone);
        m_Motion.iTurn = 0;
        CallMethodIn(METHOD_CallUpdateMotion, m_fStopUpdateMotionDelay);
        SetAngSpeed(0.0F);
    }

    void UpdateMorphTime()
    {
    }

    public void SetNextScreamTime(float fTime)
    {
        m_fNextScreamTime = Math.max(fTime, m_fNextScreamTime);
    }

    protected void UpdateAllTrackings()
    {
        if(m_TrackedObject != null)
            UpdateTrackingObject();
        UpdateTrackingDir();
        if(m_bWPVis)
            m_ToCurrWPLine.PointFromTo(GetPositionVectorVolatile(), m_WpSystem.GetCurrWPPos());
    }

    public float GetBarrelHeightOverGround(byte iSpeed, boolean bAiming)
    {
        return 150F;
    }

    public int GetDeadObjsCount()
    {
        return !super.bDead ? 0 : 1;
    }

    NewAI()
    {
        bDebugLog = false;
        bLogEditorScenarios = false;
        fDefaultAIHealth = 100F;
        bHitReactionAllowed = false;
        m_bHitReactionDisabled = false;
        fDetectionDelay = 5F;
        sAnimSeqFile = "";
        m_fMinScreamRange = 500F;
        m_fMaxScreamRange = 5000F;
        sDefaultSoundsPaths = "";
        sSoundsPath = null;
        m_sSoundsPathPrefix = null;
        m_nLastScreamType = -1;
        m_fNextScreamTime = 0.0F;
        m_aNextScreamTypeTime = new float[9];
        m_aSoundsGroups = null;
        bCanUseRadioCommunication = false;
        _TEAM_RADIO_MSG_ACCEPTABLE_DIST2 = 2250000F;
        _TEAM_RADIO_MSG_MAX_DIST2 = 1.6E+07F;
        _LISTENER_RADIO_MSG_MAX_DIST2 = 2.5E+07F;
        m_Controller = null;
        m_sControllerClassName = null;
        m_Hearing = null;
        m_Pain = null;
        cWaypoint = null;
        cFirstWaypoint = null;
        m_NewWaypoint = null;
        m_bWaypointChanged = false;
        bPortalIndependent = false;
        bAllowUsingIndoorPathfinder = true;
        bDisappearOnStart = false;
        bCastShadows = true;
        bRandomWalkAllowed = true;
        fMinWalkOnPlayerDistance = 0.0F;
        _WALK_ON_PLAYER_ANGLE_COS = 0.85F;
        bCanTurnWhileMoving = true;
        bDetectEnemyOnNoise = true;
        m_Killer = null;
        fUnimportanceFactor = 0.0015F;
        m_cSkin = null;
        cGetInAs = new EnumGetInType(EnumGetInType._DRIVER);
        sDefaultItems = "%2 Radio";
        nDefaultItemProbability = 50;
        cAIWeapon = new WeaponRifle();
        fAIWeaponLODCoef = 0.3F;
        aItemsFromModule = null;
        aItems = null;
        nGrenades = 0;
        m_nGrenadesLeft = 0;
        m_fLastDesiredHitRatio = 0.0F;
        m_fMaxHitFiringDeviation = 0.0F;
        m_fHitRatioChangeSpeed = 1.0F;
        m_fCriticalDesiredHitRatioChangeThreshold = 0.1F;
        _DESIRED_HIT_RATIO_CHANGE_CHECK_INTERVAL = 1.0F;
        _MAX_RESET_FIRING_STATISTICS_INTERVAL = 8F;
        bCanForgetAboutEnemy = true;
        m_Motion = new AIMotionState();
        m_OldMotion = new AIMotionState();
        m_ActualMotion = new AIMotionState();
        m_fMinTurnAngleToUpdateMotion = 5F;
        m_fStopUpdateMotionDelay = 0.3F;
        m_fMinAngleToTurnWhileMovingCos = 1.0F;
        m_Anims = null;
        m_nCurrentAnimID = _ANIM_ID_NONE;
        METHOD_UpdateAllTrackings = 0;
        METHOD_AnimationFinished = 0;
        METHOD_CallUpdateMotion = 0;
        METHOD_TurnDone = 0;
        METHOD_InterpolatePositionDone = 0;
        m_TrackedObject = null;
        m_bTrackLookOnly = false;
        m_bTrackCanTurn = true;
        m_fMinTrackingUpdateTime = 0.3F;
        m_fMaxTrackingUpdateTime = 3F;
        m_fPainScreamRange = 3000F;
        m_fDeathScreamRange = 3000F;
        m_fDeathBodyFallRange = 1500F;
        fMakeNoiseMult = 1.0F;
        m_WpSystem = null;
        m_AIGroup = null;
        m_iPathFinderStampSize = 3;
        m_nInstanceNumber = 0;
        sAIProfilingPage = "AI Profiling";
        sBlobMaterial = null;
        fBlobMapSize = 55F;
        bBlobHasFixedOrientation = true;
        m_bIsFrozen = false;
        m_bWasPhysicsActiveBeforeFreeze = false;
        m_bIsActive = true;
        m_bWasFrozenBeforeDeactivate = false;
        m_bUsePathfinder = true;
        m_bUseIndoorPathfinder = true;
        m_aCurrentGoToPath = null;
        m_nCurrentGoToPathLen = 0;
        m_nWaypointsInPath = 0;
        m_vCurrentGoToPoint = null;
        m_nCurrentGoToPathIdx = 0;
        m_vGoToDestination = new Vector();
        m_fDestinationRadius = 50F;
        m_GuardedObject = null;
        m_fGuardedAreaRadius = 0.0F;
        m_bGuardCritical = false;
        m_vValidEnd = new Vector();
        m_vStartPos = new Vector();
        m_vSpeedDir = new Vector();
        m_fIntPosOldMass = -1F;
        m_vIntPosDestPos = new Vector();
        m_vIntPosDestDir = new Vector();
        m_vIntPosDir = new Vector();
        m_bIntPosWasUsingPathfinder = false;
        cAIInventoryExecutor = null;
        m_nAmmoForActiveWeapon = 0x989680;
        m_bWPVis = false;
        m_ToCurrWPLine = null;
        bUseParamsModifiers = true;
        mod_fAccuracyMult = 1.0F;
        mod_fFiringTimeMult = 1.0F;
        mod_fFireDelayMult = 1.0F;
        mod_nSingleHealtexProbability = 50;
        mod_nMaxHealtexesNumber = 1;
        mod_fMinHitRatioMult = 1.0F;
        mod_fMaxHitRatioMult = 1.0F;
        mod_fMinSpareAmmoClips = 0.5F;
        mod_fMaxSpareAmmoClips = 1.0F;
        mod_nSpareAmmoProbability = 100;
        mod_nSingleGrenadeProbability = 50;
        mod_nMaxGrenadesNumber = 1;
        super.cConflictSide = new EnumConflictSide(EnumConflictSide._COUNTER_PLAYER);
        super.bIsActiveTarget = true;
        super.bIsAITarget = true;
        super.fHealth = -1F;
    }

    void TurnDone()
    {
        TryToVerticalize();
        StopTurn();
        m_Controller.Notify(102);
    }

    boolean DetectEnemyOnNoise()
    {
        return bDetectEnemyOnNoise;
    }

    public static void ResetModifiers()
    {
        s_ModifiersList.clear();
    }

    public void StartMovieActing()
    {
    }

    public void StopMovieActing()
    {
        Vector vPos = GetPositionVectorVolatile();
        UpdateWaypointSystem(vPos);
        UpdatePortals();
    }

    public void Unfreeze()
    {
        if(IsFrozen())
        {
            m_bIsFrozen = false;
            if(m_bWasPhysicsActiveBeforeFreeze)
                SetPhysicsActive(true);
            UnfreezeCallMethods();
            StartAnim("");
            if(m_Controller != null)
                m_Controller.Unfreeze();
            if(super.ActiveWeapon != null)
                super.ActiveWeapon.UnfreezeCallMethods();
        }
    }

    public void Disappear(ControlObject m_cRefMtxHolder)
    {
        if(m_cRefMtxHolder != null && m_cRefMtxHolder.GetPositionVectorVolatile() != null)
        {
            UpdatePathMap(false);
            Vector vPos = GetInFormationPosition(m_cRefMtxHolder.GetPositionVectorVolatile(), null);
            FromUpForwardPos(m_cRefMtxHolder.GetUpVectorVolatile(), m_cRefMtxHolder.GetForwardVectorVolatile(), vPos);
            UpdatePortals();
            UpdateWaypointSystem(vPos);
        }
        Deactivate();
    }

    public float InterpolatePositionTo(Vector vNewPos, Vector vNewDir, float fMoveSpeed)
    {
        return InterpolatePositionTo(vNewPos, vNewDir, fMoveSpeed, false);
    }

    public float InterpolatePositionTo(Vector vNewPos, Vector vNewDir, float fMoveSpeed, boolean bDisableCollisions)
    {
        float fAbsSpeed = Math.abs(fMoveSpeed);
        float fTime = 0.0F;
        Vector vMyPos = GetPosition();
        if(vMyPos != null && vNewPos != null && fAbsSpeed > 0.001F)
        {
            m_vIntPosDir.Set(vNewPos);
            m_vIntPosDir.Sub(vMyPos);
            float fDistance = m_vIntPosDir.Len();
            if(fDistance > 0.001F)
            {
                m_fIntPosOldMass = GetMass();
                m_bIntPos_BLOCK_MOVE = IsSetFlag(32);
                m_bIntPosWasUsingPathfinder = m_bUsePathfinder;
                m_vIntPosDestPos.Set(vNewPos);
                m_vIntPosDir.Mul(fMoveSpeed / fDistance);
                SetPhysicsType(3);
                UsePathfinder(false);
                if(bDisableCollisions)
                {
                    SetCollFlags(28672);
                    ClearFlag(32);
                }
                SetMass(0.0F);
                SetSpeed(m_vIntPosDir);
                fTime = fDistance / fAbsSpeed;
                CallMethodOnceIn(METHOD_InterpolatePositionDone, fTime);
            }
        }
        if(vNewDir != null)
        {
            m_vIntPosDestDir.Set(vNewDir);
            SetDestDir(vNewDir);
        } else
        {
            m_vIntPosDestDir.Set(Vector.Zero);
        }
        return fTime;
    }

    public void OnCreate()
    {
        if(s_ModifiersList.size() == 0)
        {
            Vector vModifiers = LevelsManager.GetDiffModifiers(ChromeGame.GetDiffLevel());
            for(int i = 0; i < vModifiers.size(); i++)
                AddModifier((AIParamsMod)vModifiers.elementAt(i));

        }
        ApplyModifiers();
        m_nInstanceNumber = m_nInstances++;
        int nDotPos = super.MeshName.lastIndexOf('.');
        if(nDotPos > 0)
            sAnimSeqFile = super.MeshName.substring(0, nDotPos) + ".scr";
        else
            GameObject.CrashLog("[NewAI.OnCreate] ERROR: Incorrect mesh name (" + super.MeshName + ")\n");
        super.OnCreate();
        cFirstWaypoint = cWaypoint;
        cWaypoint = null;
        SetCollType(0);
        SetCollAction(16);
        SetCollHandler(768);
        SetTraceCollType(3);
        SetCollFlags(0x4000000);
        if(bCastShadows)
            SetFlag(256);
        else
            ClearFlag(256);
        SetFlag(0x10029);
        ClearFlag(4102);
        SetPhysicsType(1);
        SetPhysicsActive(true);
        SetAngSpeed(0.0F);
        SetSpeedValue(0.0F);
        SetUnImportanceFactor(fUnimportanceFactor);
        if(sBlobMaterial != null)
            SetBlobMaterial(sBlobMaterial);
        SetBlobMapSize(fBlobMapSize);
        SetBlobFixedOrientation(bBlobHasFixedOrientation);
        METHOD_UpdateAllTrackings = RegisterCallMethod("UpdateAllTrackings");
        METHOD_AnimationFinished = RegisterCallMethod("AnimationFinished");
        METHOD_CallUpdateMotion = RegisterCallMethod("CallUpdateMotion");
        METHOD_TurnDone = RegisterCallMethod("TurnDone");
        METHOD_InterpolatePositionDone = RegisterCallMethod("InterpolatePositionDone");
        if(bPortalIndependent)
        {
            SetFlag(2048);
            DetachFromParentAndKeepWorldPos();
        }
        if(m_nInstanceNumber == 0)
        {
            PROFILE_RequestEvent = ProfileAdd(sAIProfilingPage, "Request Event");
            PROFILE_CalcProfile = ProfileAdd(sAIProfilingPage, "AI Calculation");
            PROFILE_ObjectsMsg = ProfileAdd(sAIProfilingPage, "Objects Message");
            PROFILE_NoiseMsg = ProfileAdd(sAIProfilingPage, "Noise Message");
            PROFILE_PainMsg = ProfileAdd(sAIProfilingPage, "Pain Message");
            PROFILE_Recognition = ProfileAdd(sAIProfilingPage, "Recognition");
        }
        InitSounds();
        InitParamsFromMesh();
        super.fMaxHealth = super.fHealth;
    }

    String DescribeMotionState(AIMotionState cMotion)
    {
        String moveDir = "";
        if(((MotionState) (cMotion)).iMoveZ != 0 || ((MotionState) (cMotion)).iMoveX != 0)
        {
            moveDir += " move: ";
            if(((MotionState) (cMotion)).iMoveZ == 1)
                moveDir += "Fwd";
            else
            if(((MotionState) (cMotion)).iMoveZ == -1)
                moveDir += "Bk";
            if(((MotionState) (cMotion)).iMoveX == 1)
                moveDir += "L";
            else
            if(((MotionState) (cMotion)).iMoveX == -1)
                moveDir += "R";
        } else
        {
            moveDir += " <stop>";
        }
        if(((MotionState) (cMotion)).iTurn == -1)
            moveDir += " trnR";
        else
        if(((MotionState) (cMotion)).iTurn == 1)
            moveDir += " trnL";
        return MotionState.aSpeedNames[cMotion.GetSpeed()] + moveDir + ", fire = " + ((MotionState) (cMotion)).bFiring + ", aim = " + ((MotionState) (cMotion)).bAiming;
    }

    void InitializeAIWeapon()
    {
        if(super.ActiveWeapon != null)
        {
            Weapon toRemove = super.ActiveWeapon;
            UseWeapon(null);
            super.cInventory.RemoveInvObject(toRemove);
            toRemove.ChangeInvState(this, 0);
            toRemove.DetachFromParent();
            toRemove.DeactivateOnModuleAlways();
            toRemove = null;
        }
        if(cAIWeapon != null && !(cAIWeapon instanceof WeaponHands))
        {
            if(!cAIWeapon.IsCreatedFromEngine())
                cAIWeapon = (Weapon)CreateObject(cAIWeapon.getClass().getName());
            cAIWeapon.AddToInventory(this, false);
            cAIWeapon.SetLODCoeff(fAIWeaponLODCoef);
            InitializeAIAmmo(cAIWeapon);
            UseWeapon(cAIWeapon);
            WeaponReload();
            m_nGrenadesLeft = nGrenades;
            PlaceWeapons();
        }
    }

    public float GetNextScreamTime(int iScreamType)
    {
        if(m_aSoundsGroups != null && m_aSoundsGroups[iScreamType] != null)
            return Math.max(m_aNextScreamTypeTime[iScreamType], m_fNextScreamTime);
        else
            return -1F;
    }

    public void OnDestroy()
    {
        super.OnDestroy();
        m_nInstances--;
    }

    void DisableBodyActivities()
    {
        StopGoTo();
        StopTurn();
        StopInterpolatePosition(false);
        StopTrackingObject();
        SetPhysicsActive(false);
        StopAIAnim(false);
        DisableCallMethod(METHOD_UpdateAllTrackings);
        DisableCallMethod(METHOD_CallUpdateMotion);
    }

    public boolean SendRadioMessage(int nMsgType)
    {
        if(m_CommSystem != null && bCanUseRadioCommunication && !IsDead() && !s_bRadioCommDisabledForMovie)
        {
            float fTime = GetTime();
            if(fTime > m_fNextScreamTime && fTime > m_CommSystem.GetNextMessageTime(nMsgType))
            {
                Camera cam = ((ChromeModule)GetModule()).GetActiveViewCamera();
                float camDist2 = GetDistance2To(cam.GetPositionVolatile());
                if(camDist2 < _LISTENER_RADIO_MSG_MAX_DIST2)
                {
                    NewAI chatBuddy = null;
                    boolean bNeedsBuddy = m_CommSystem.CheckIfMessageNeedsBuddy(nMsgType);
                    float fMinDist2 = 3.402823E+38F;
                    ArrayList friendsList = m_Controller.m_aAlliesList;
                    for(int i = 0; i < friendsList.size(); i++)
                    {
                        FriendInfo friendInfo = (FriendInfo)friendsList.get(i);
                        if(!(friendInfo.m_Reference instanceof NewAI))
                            continue;
                        NewAI buddy = (NewAI)friendInfo.m_Reference;
                        if(!buddy.bCanUseRadioCommunication || !buddy.IsActiveOnModule() || buddy.IsDead() || buddy.IsFrozen() || !IsFriend(buddy) || fTime <= buddy.m_fNextScreamTime)
                            continue;
                        float fDist2 = GetDistance2To(buddy);
                        if(fDist2 < _TEAM_RADIO_MSG_ACCEPTABLE_DIST2)
                        {
                            chatBuddy = buddy;
                            break;
                        }
                        if(fDist2 >= fMinDist2 || fDist2 >= _TEAM_RADIO_MSG_MAX_DIST2)
                            continue;
                        chatBuddy = buddy;
                        fMinDist2 = fDist2;
                        if(!bNeedsBuddy)
                            break;
                    }

                    if(chatBuddy == null)
                        return false;
                    if(bNeedsBuddy)
                        return m_CommSystem.RadioMessage(nMsgType, this, chatBuddy);
                    else
                        return m_CommSystem.RadioMessage(nMsgType, this, null);
                }
            }
        }
        return false;
    }

    public boolean IsFrozen()
    {
        return m_bIsFrozen;
    }

    public static void DefineVisualisation()
    {
        GameObject.DefineDebugLine("cWaypoint", new Vector(1.0F, 1.0F, 1.0F));
    }

    public float GetTimeDeviation()
    {
        return (float)m_nInstanceNumber / (float)m_nInstances;
    }

    public void CallUpdateMotion()
    {
        UpdateMotion();
    }

    float GetSpeedValueForMotion(AIMotionState cMotion)
    {
        float fSpeed = m_aMotionVelocity[cMotion.GetSpeed()];
        if(((MotionState) (cMotion)).iMoveX != 0)
            fSpeed *= m_aMotionVelocityStrafeMultiplier[cMotion.GetSpeed()];
        return fSpeed;
    }

    public Vector GetLookFromPoint()
    {
        return GetPosition();
    }

    public void SetWaypoint(Waypoint waypoint)
    {
        cWaypoint = waypoint;
    }

    public Waypoint GetNextWaypoint()
    {
        Waypoint cRet = null;
        if(m_bWaypointChanged)
        {
            SetWaypoint(m_NewWaypoint);
            m_bWaypointChanged = false;
            cRet = cWaypoint;
        } else
        {
            cRet = cWaypoint.cNext;
        }
        return cRet;
    }

    float GetMakeNoiseMult()
    {
        return fMakeNoiseMult;
    }

    void SetPainSense(IAIPainSense pain)
    {
        m_Pain = pain;
    }

    public AIController GetController()
    {
        return m_Controller;
    }

    AIGroup GetAIGroup()
    {
        return m_AIGroup;
    }

    public final void StopAIAnim(boolean bControllerNotification)
    {
        m_Anims.Stop("");
        DisableCallMethod(METHOD_AnimationFinished);
        if(m_nCurrentAnimID != _ANIM_ID_NONE)
        {
            int lastAnimID = m_nCurrentAnimID;
            m_nCurrentAnimID = _ANIM_ID_NONE;
            if(bControllerNotification)
                m_Controller.AnimationStopped(lastAnimID);
        }
    }

    void InitInventory()
    {
        super.cInventory = (InventoryAI)CreateObjectNoInit("InventoryAI");
        super.cInventory.Owner = this;
        super.cInventory.InitObject();
        int METHOD_FillInventory = RegisterCallMethod("FillInventory");
        CallMethodIn(METHOD_FillInventory, 0.0F);
        UnfreezeCallMethod(METHOD_FillInventory);
    }

    public static RadioCommunicationSystem GetCommSystem()
    {
        return m_CommSystem;
    }

    boolean InBuilding()
    {
        return m_WpSystem != null;
    }

    public void Deactivate()
    {
        if(m_bIsActive)
        {
            m_bWasFrozenBeforeDeactivate = IsFrozen();
            Freeze();
            DeactivateOnModuleAlways();
            EnableRendering(false);
            m_bIsActive = false;
            if(m_Controller != null)
                m_Controller.NotifyMeshActivation(false);
        }
    }

    public Vector GetLookDir()
    {
        return GetForwardVector();
    }

    public void UsePathfinder(boolean bUsePathFinder)
    {
        m_bUsePathfinder = bUsePathFinder;
        if(bUsePathFinder)
        {
            UseIndoorPathfinder(false);
            UpdatePathMap(true, m_iPathFinderStampSize);
            SetFlag(16);
        } else
        {
            UpdatePathMap(false, m_iPathFinderStampSize);
            ClearFlag(16);
        }
    }

    public void PlayAIAnimLoop(int nID)
    {
        UpdateMorphTime();
        m_Anims.PlayLoop(nID);
    }

    private static Class _mthclass$(String s)
    {
        try
        {
            return Class.forName(s);
        }
        catch(ClassNotFoundException e)
        {
            throw new NoClassDefFoundError(e.getMessage());
        }
    }

    public Vector GetInFormationPosition(Vector vGroupPos, Vector vGroupDir)
    {
        if(m_AIGroup != null)
            return m_AIGroup.GetMemberFormationPosition(this, vGroupPos, vGroupDir);
        else
            return vGroupPos;
    }

    public void CallOrRemoveUpdateMotion()
    {
        if(m_Motion.IsEqual(m_OldMotion))
            DisableCallMethod(METHOD_CallUpdateMotion);
        else
            CallUpdateMotion();
    }

    public float UpdateMotion()
    {
        DisableCallMethod(METHOD_CallUpdateMotion);
        m_OldMotion = new AIMotionState(m_Motion);
        return 0.0F;
    }

    protected Vector GetValidGoToPosition(Vector vStart, Vector vEnd)
    {
        m_vValidEnd.Set(vEnd);
        m_vValidEnd.fY = 0.0F;
        Vector vGuardedPos;
        if(m_fGuardedAreaRadius > 0.0F && m_GuardedObject != null && (vGuardedPos = m_GuardedObject.GetPosition()) != null)
        {
            float fEndDist = MathUtils.dist2D(vGuardedPos, vEnd);
            if(fEndDist > m_fGuardedAreaRadius)
            {
                float fStartDist = MathUtils.dist2D(vGuardedPos, vStart);
                if(fStartDist > m_fGuardedAreaRadius)
                {
                    if(fStartDist < fEndDist)
                        m_vValidEnd.Set(vStart);
                } else
                {
                    m_vValidEnd.Sub(vStart);
                    float fLenFactor = (m_fGuardedAreaRadius - fStartDist) / fEndDist;
                    m_vValidEnd.fX *= fLenFactor;
                    m_vValidEnd.fZ *= fLenFactor;
                    m_vValidEnd.Add(vStart);
                    m_vValidEnd.fY = 0.0F;
                }
            }
        }
        return m_vValidEnd;
    }

    float GetAngSpeedForMotion(AIMotionState cMotion)
    {
        return m_aMotionAngularVelocity[cMotion.GetSpeed()];
    }

    public void NotifyHit(ChromeActor victim, int damageType)
    {
        if(m_Controller.GetActiveEnemy() == victim && m_nRoundsHit < m_nRoundsShot)
            m_nRoundsHit++;
        if(m_fFiringDeviation > m_fMaxHitFiringDeviation)
            m_fMaxHitFiringDeviation = m_fFiringDeviation;
        m_Controller.TargetHitNotification(victim, damageType);
    }

    public boolean StartTrackingObject(ChromeActor cTarget, boolean bLookOnly, boolean bCanTurn)
    {
        m_TrackedObject = cTarget;
        m_bTrackLookOnly = bLookOnly;
        m_bTrackCanTurn = bCanTurn;
        return cTarget != null;
    }

    public boolean StopTrackingObject()
    {
        if(m_TrackedObject != null)
        {
            m_TrackedObject = null;
            return true;
        } else
        {
            return false;
        }
    }

    public void GuardObject(ControlObject cObject, float fRadius, boolean bCritical)
    {
        m_GuardedObject = cObject;
        m_fGuardedAreaRadius = fRadius;
        m_bGuardCritical = bCritical;
    }

    void Initialize()
    {
        InitializeAIWeapon();
        if(m_nInstanceNumber == 0)
            InitializeCommSystem((ChromeModuleSingle)GetModule());
    }

    public float CalcActualHitRatio()
    {
        if(m_nRoundsShot > 0)
        {
            if(m_nRoundsHit == 0)
                return 0.0F;
            else
                return MathUtils.crop((float)m_nRoundsHit / (float)m_nRoundsShot, 0.0F, 1.0F);
        } else
        {
            return GameObject.RandomFloat(0.0F, 1.0F);
        }
    }

    public void ChangeWaypoint(Waypoint cNewWaypoint, boolean bStopCurrActivity)
    {
        cFirstWaypoint = cNewWaypoint;
        if(cWaypoint != null)
        {
            if(bStopCurrActivity)
            {
                SetWaypoint(null);
                m_bWaypointChanged = false;
                for(int i = 0; i < m_Controller.m_TaskList.GetTasksNum();)
                    if(m_Controller.m_TaskList.GetTask(i) instanceof TaskEditorActivityEnd)
                        m_Controller.m_TaskList.RemoveTask(i);
                    else
                        i++;

                m_Controller.RequestEvent(17, true);
                m_Controller.ServeNextWaypointActivity();
            } else
            {
                m_NewWaypoint = cNewWaypoint;
                m_bWaypointChanged = true;
            }
        } else
        {
            m_bWaypointChanged = false;
            m_Controller.ServeNextWaypointActivity();
        }
    }

    protected void InterpolatePositionDone()
    {
        StopInterpolatePosition(true);
    }

    boolean WeaponReload()
    {
        if(m_nAmmoForActiveWeapon >= super.ActiveWeapon.nCapacity)
        {
            m_nAmmoForActiveWeapon = m_nAmmoForActiveWeapon - super.ActiveWeapon.nCapacity;
            super.ActiveWeapon.Reload(super.ActiveWeapon.nCapacity);
        } else
        {
            super.ActiveWeapon.Reload(m_nAmmoForActiveWeapon);
            m_nAmmoForActiveWeapon = 0;
        }
        return true;
    }

    public final void PlayAIAnim(int nID)
    {
        PlayAIAnim(nID, 1);
    }

    public Vector GetBarrelPos(byte iSpeed, boolean bAiming)
    {
        return GetPosition();
    }

    public void PlayAIAnim(int nID, int nTimes)
    {
        if(nTimes > 0)
        {
            UpdateMorphTime();
            m_nCurrentAnimID = nID;
            m_Anims.Play(nID, nTimes);
            CallMethodOnceIn(METHOD_AnimationFinished, m_Anims.GetLength(nID) * (float)nTimes);
        }
    }

    public final void PlayAIAnim(String sSequenceName, int nTimes)
    {
        if(nTimes > 0)
        {
            UpdateMorphTime();
            m_nCurrentAnimID = _ANIM_ID_STRING;
            int nID = GetAnimID(m_Anims.m_sRootElementName, sSequenceName);
            StartAnim("");
            PlayAnim(nID, nTimes);
            CallMethodOnceIn(METHOD_AnimationFinished, GetAnimLength(sSequenceName) * (float)nTimes);
        }
    }

    public void StartFiring()
    {
        CalcFiringDevLineAngle();
        if(CalcActualHitRatio() > m_fDesiredHitRatio)
            m_fFiringDeviation = GameObject.RandomFloat(m_fMaxHitFiringDeviation, 1.0F);
        else
            m_fFiringDeviation = GameObject.RandomFloat(0.0F, m_fMaxHitFiringDeviation);
        m_fFiringDeviation = MathUtils.crop(m_fFiringDeviation, 0.0F, 1.0F);
    }

    static Collision AITrace(ControlObject objToCall, Vector vStart, Vector vEnd, int nAITraceFlags, ControlObject aExcludeObjects[])
    {
        int excludeObjectsCount = 0;
        if(aExcludeObjects != null)
        {
            excludeObjectsCount = aExcludeObjects.length;
            if(excludeObjectsCount > l_aExcludeObjectsOldFlags.length)
                l_aExcludeObjectsOldFlags = new int[excludeObjectsCount];
            for(int i = 0; i < excludeObjectsCount; i++)
            {
                ControlObject obj = aExcludeObjects[i];
                if(obj != null)
                {
                    l_aExcludeObjectsOldFlags[i] = obj.GetFlags();
                    obj.ClearFlag(8);
                }
            }

        }
        Collision collAll = objToCall.TraceTerrain(vStart, vEnd);
        Collision collCurr = objToCall.TraceTrees(vStart, vEnd);
        if(collCurr != null)
            collAll = collCurr;
        int nFaceIgnoreFlags = 1;
        if((nAITraceFlags & _AITRACE_IGNORE_GLASS) != 0)
            nFaceIgnoreFlags |= 4;
        collCurr = new Collision();
        if(objToCall.TraceObjectsWithFaceFlags(collCurr, vStart, vEnd, 0, nFaceIgnoreFlags))
            collAll = collCurr;
        for(int i = 0; i < excludeObjectsCount; i++)
        {
            ControlObject obj = aExcludeObjects[i];
            if(obj != null)
                obj.SetFlags(l_aExcludeObjectsOldFlags[i]);
        }

        return collAll;
    }

    Collision AITrace(Vector vStart, Vector vEnd, int nAITraceFlags, ControlObject aExcludeObjects[])
    {
        return AITrace(((ControlObject) (this)), vStart, vEnd, nAITraceFlags, aExcludeObjects);
    }

    protected String GetRandomSoundsDirectory()
    {
        StringTokenizer defaultSoundDirs = new StringTokenizer(sDefaultSoundsPaths, ";", false);
        ArrayList dirsArray = new ArrayList();
        while(defaultSoundDirs.hasMoreTokens()) 
        {
            String token = defaultSoundDirs.nextToken();
            File dir = new File(token);
            if(dir.exists() && dir.isDirectory())
                dirsArray.add(token);
        }
        if(dirsArray.size() > 0)
            return (String)dirsArray.get(GameObject.RandomInt(dirsArray.size()));
        else
            return "";
    }

    void ExecuteAIInventory()
    {
        if(cAIInventoryExecutor == null)
            return;
        try
        {
            PlayerHUD cPlayerHUD = (PlayerHUD)cAIInventoryExecutor;
            if(cPlayerHUD.SetAIInventory(super.cInventory))
                super.bIsCorpseActive = true;
        }
        catch(ClassCastException e)
        {
            GameObject.Log("[NewAI.Execute]: NewAI corpse can be executed only by PlayerHUD\n");
        }
        cAIInventoryExecutor = null;
    }

    void FillInventory()
    {
        String aItemClassNames[] = new String[10];
        if(aItemsFromModule != null)
        {
            for(int i = 0; i < aItemsFromModule.length; i++)
                if((aItemsFromModule[i] instanceof InvObjectInst) && !aItemsFromModule[i].IsInInventory())
                    aItemsFromModule[i].AddToInventory(this);

        }
        if(aItems != null)
        {
            for(int i = 0; i < aItems.length; i++)
                if((aItems[i] instanceof InvObjectInst) && !aItems[i].IsInInventory())
                    aItems[i].AddToInventory(this);

        }
        String aHealthexClass[] = {
            (DrugHealthex.class).getName()
        };
        for(int i = 0; i < mod_nMaxHealtexesNumber; i++)
            if(MathUtils.CanHappen(mod_nSingleHealtexProbability))
                InsertItems(aHealthexClass, 1);

        String aGrenadeClass[] = {
            (WeaponGrenade.class).getName()
        };
        for(int i = 0; i < mod_nMaxGrenadesNumber; i++)
            if(MathUtils.CanHappen(mod_nSingleGrenadeProbability))
                InsertItems(aGrenadeClass, 1);

        if(sDefaultItems != null)
        {
            StringTokenizer cDefaultItemsIter = new StringTokenizer(sDefaultItems, " ,+%", true);
            int nGroupItems = 0;
            int nProbability = nDefaultItemProbability;
            while(cDefaultItemsIter.hasMoreTokens()) 
            {
                String sToken = cDefaultItemsIter.nextToken();
                if(sToken.compareTo("%") == 0)
                {
                    if(cDefaultItemsIter.hasMoreTokens())
                    {
                        sToken = cDefaultItemsIter.nextToken();
                        try
                        {
                            nProbability = Integer.valueOf(sToken).intValue();
                        }
                        catch(NumberFormatException e)
                        {
                            GameObject.LogD("Incorrect probability value!\n");
                            nProbability = nDefaultItemProbability;
                        }
                    } else
                    {
                        GameObject.LogD("Default items names parsing error!\n");
                        return;
                    }
                } else
                if(sToken.compareTo(" ") != 0 && sToken.compareTo("+") != 0)
                    if(sToken.compareTo(",") == 0)
                    {
                        if(aItemClassNames[nGroupItems] != null && aItemClassNames[nGroupItems].compareTo("WeaponGrenade") != 0 && MathUtils.CanHappen(nProbability))
                            InsertItems(aItemClassNames, nGroupItems);
                        nGroupItems = 0;
                        nProbability = nDefaultItemProbability;
                    } else
                    {
                        aItemClassNames[nGroupItems++] = sToken;
                    }
            }
            if(MathUtils.CanHappen(nProbability))
                InsertItems(aItemClassNames, nGroupItems);
        }
    }

    int GetAmmoForActiveWeapon()
    {
        if(super.ActiveWeapon == null)
            return 0;
        else
            return m_nAmmoForActiveWeapon;
    }

    public int GetLastScreamType()
    {
        return m_nLastScreamType;
    }

    protected void CalcMotionStateFromSpeedDir(AIMotionState cMotion, Vector vBodyForward, Vector vSpeedDir)
    {
        cMotion.iMoveX = cMotion.iMoveZ = 0;
        vSpeedDir.fY = 0.0F;
        float fSpeedLen = vSpeedDir.Len();
        if(fSpeedLen > 0.1F)
        {
            vSpeedDir.Mul(1.0F / fSpeedLen);
            vBodyForward.fY = 0.0F;
            vBodyForward.Normalize();
            float fDot = vBodyForward.Dot(vSpeedDir);
            if(fDot > _COS_3_PI_BY_8)
                cMotion.iMoveZ = 1;
            else
            if(fDot < _COS_5_PI_BY_8)
                cMotion.iMoveZ = -1;
            if(fDot < _COS_1_PI_BY_8 && fDot > _COS_7_PI_BY_8)
                cMotion.iMoveX = 1;
            if(vBodyForward.fZ * vSpeedDir.fX - vSpeedDir.fZ * vBodyForward.fX < 0.0F)
                cMotion.iMoveX *= -1;
        }
    }

    public void CalcMotionStateFromSpeedDir(AIMotionState cMotion)
    {
        CalcMotionStateFromSpeedDir(cMotion, GetForwardVector(), GetSpeed());
    }

    public void UpdateTrackingDir()
    {
        if(m_vCurrentGoToPoint != null)
        {
            ((ChromeModule)GetModule()).GetDoorControler().IsNearDoorable(this);
            m_vSpeedDir.Set(m_vCurrentGoToPoint);
            m_vSpeedDir.Sub(GetPositionVectorVolatile());
            m_vSpeedDir.fY = 0.0F;
            float fSpeedDirLen = m_vSpeedDir.Len();
            if(fSpeedDirLen > 0.001F)
                m_vSpeedDir.Mul(1.0F / fSpeedDirLen);
            else
                m_vSpeedDir = GetForwardVector();
            if(m_TrackedObject == null || !bCanTurnWhileMoving)
            {
                SetMaxAngSpeed(GetAngSpeedForMotion(m_Motion));
                SetFacingDestDir(m_vSpeedDir);
            }
            boolean bShouldStop = false;
            if(fMinWalkOnPlayerDistance > 1.0F)
            {
                Player player = ((ChromeModule)GetModule()).GetMainPlayer();
                if(player != null && GetDistance2To(player) < fMinWalkOnPlayerDistance * fMinWalkOnPlayerDistance)
                {
                    player.GetPosition(sm_vUTD_PlayerDir);
                    sm_vUTD_PlayerDir.Sub(GetPositionVectorVolatile());
                    sm_vUTD_PlayerDir.Normalize();
                    if(sm_vUTD_PlayerDir.Dot(m_vSpeedDir) > _WALK_ON_PLAYER_ANGLE_COS)
                        bShouldStop = true;
                }
            }
            if(bShouldStop)
                m_Motion.StopMove();
            else
                CalcMotionStateFromSpeedDir(m_Motion, GetForwardVector(), m_vSpeedDir);
            UpdateMotion();
            float fSpeed = GetSpeedValueForActualMotion();
            m_vSpeedDir.Mul(fSpeed);
            if(bShouldStop)
                SetSpeedValue(0.0F);
            else
                SetSpeed(m_vSpeedDir);
            TryToVerticalize();
        }
    }

    public void InitSounds()
    {
        if(sSoundsPath == null)
            sSoundsPath = GetRandomSoundsDirectory();
        File fullPath = new File(sSoundsPath);
        if(fullPath != null && fullPath.exists())
            m_sSoundsPathPrefix = fullPath.getPath() + "/";
        else
            m_sSoundsPathPrefix = "";
        if(m_aSoundsGroups != null)
        {
            for(int i = 0; i < m_aSoundsGroups.length; i++)
                if(m_aSoundsGroups[i] != null)
                    m_aSoundsGroups[i].Init(sSoundsPath);

        }
    }

    void UpdatePortals()
    {
        Vector vMove = new Vector(0.0F, -100F, 0.0F);
        MoveByEllipsoid(vMove);
    }

    public void EnableHitReaction(boolean bHitReactionAllowed)
    {
        this.bHitReactionAllowed = bHitReactionAllowed;
    }

    public void HitReaction(Vector vector)
    {
    }

    float GetAngSpeedForActualMotion()
    {
        return GetAngSpeedForMotion(m_ActualMotion);
    }

    public void StopInterpolatePosition(boolean bMoveToDest)
    {
        DisableCallMethod(METHOD_InterpolatePositionDone);
        if(m_fIntPosOldMass >= 0.0F)
        {
            UsePathfinder(m_bIntPosWasUsingPathfinder);
            SetPhysicsType(1);
            SetMass(m_fIntPosOldMass);
            SetSpeedValue(0.0F);
            ClearCollFlags(28672);
            if(m_bIntPos_BLOCK_MOVE)
                SetFlag(32);
            if(bMoveToDest)
            {
                SetPositionWorld(m_vIntPosDestPos);
                if(m_vIntPosDestDir.Len2() > 0.0F)
                    SetDir(m_vIntPosDestDir);
            }
        }
    }

    public void StopGoTo()
    {
        ClearDestinationPos();
        ClearDestinationDir();
        m_vCurrentGoToPoint = null;
        m_aCurrentGoToPath = null;
        m_Motion.StopMove();
        CallMethodIn(METHOD_CallUpdateMotion, m_fStopUpdateMotionDelay);
        SetLocalSpeed(Vector.Zero);
    }

    public void Checkpoint()
    {
        m_Controller.Checkpoint();
    }

    public void OnCollisionFullInfo(ControlObject Col, Vector vPoint, Vector vNormal)
    {
        m_Controller.CollisionMsg(Col, vPoint, vNormal);
    }

    void CreateController(String sControllerClassName)
    {
        if(sControllerClassName == null)
        {
            GameObject.CrashLog("sControllerClassName == null\n");
            return;
        }
        m_Controller = (AIController)CreateObject(sControllerClassName);
        if(m_Controller == null)
        {
            GameObject.CrashLog("Error in creating AIController of class:" + sControllerClassName + "\n");
            return;
        } else
        {
            m_Controller.InitController(this);
            return;
        }
    }

    public void Freeze()
    {
        if(!IsFrozen())
        {
            m_bIsFrozen = true;
            m_bWasPhysicsActiveBeforeFreeze = GetPhysicsActive();
            SetPhysicsActive(false);
            FreezeCallMethods();
            StopAnim("");
            if(m_Controller != null)
                m_Controller.Freeze();
            if(super.ActiveWeapon != null)
                super.ActiveWeapon.FreezeCallMethods();
        }
    }

    void UpdateWaypointSystem(Vector vPos)
    {
        if(m_WpSystem != null)
        {
            short nearest = m_WpSystem.FindNearestPoint(vPos);
            if(nearest >= 0)
                m_WpSystem.m_CurrWaypoint = nearest;
        }
    }

    void OnDestinationPos()
    {
        if(m_vCurrentGoToPoint != null)
        {
            if(m_WpSystem != null && (cWaypoint == null || !bPortalIndependent) && m_nCurrentGoToPathIdx < m_nWaypointsInPath)
                m_WpSystem.SetCurrWaypoint(m_WpSystem.m_aWayPointsPath[m_nCurrentGoToPathIdx]);
            m_nCurrentGoToPathIdx++;
            if(m_nCurrentGoToPathIdx >= m_nCurrentGoToPathLen)
            {
                m_aCurrentGoToPath = null;
                m_vCurrentGoToPoint = null;
                if(MathUtils.dist2D(m_vGoToDestination, GetPosition()) > m_fDestinationRadius)
                    GoToPosition(m_vGoToDestination);
                else
                    GoToFinished();
            } else
            {
                m_vCurrentGoToPoint = m_aCurrentGoToPath[m_nCurrentGoToPathIdx];
                SetDestinationPos(m_vCurrentGoToPoint);
                UpdateTrackingDir();
            }
        }
    }

    public void VisualizeWaypointSystem(boolean bVisualize)
    {
        if(m_WpSystem == null)
            return;
        m_bWPVis = bVisualize;
        if(bVisualize)
        {
            WaypointSystem.VisualizeWaypointSystem(this);
            if(m_ToCurrWPLine == null)
                m_ToCurrWPLine = Tools.CreateLaserPointer(GetModule(), "LaserBeamRed", 1, 100F, true);
        } else
        {
            WaypointSystem.DevisualizeWaypointSystem(this);
            if(m_ToCurrWPLine != null)
            {
                m_ToCurrWPLine.delete();
                m_ToCurrWPLine = null;
            }
        }
    }

    public final float GetAIAnimLength(int nID)
    {
        return m_Anims.GetLength(nID);
    }

    public void LogMatrix()
    {
        GameObject.CrashLog(GetName() + "(Up: " + GetUpVector() + ",Forward: " + GetForwardVector() + ",Pos: " + GetPosition() + ")\n");
    }

    void SetAIGroup(AIGroup group)
    {
        m_AIGroup = group;
    }

    protected void ApplyModifiers()
    {
        if(bUseParamsModifiers)
        {
            for(int i = 0; i < s_ModifiersList.size(); i++)
            {
                AIParamsMod mod = (AIParamsMod)s_ModifiersList.get(i);
                mod.Apply(this);
            }

        }
    }

    public void MultiplyMotionSpeedValue(int iMotionSpeed, float fSpeedValueMulitplier)
    {
        if(iMotionSpeed >= 0 && iMotionSpeed < m_aMotionVelocity.length)
            m_aMotionVelocity[iMotionSpeed] *= fSpeedValueMulitplier;
    }

    public void MovingEnd()
    {
        m_Controller.MovingEnd();
    }

    void Execute(Actor cExecutor)
    {
        super.Execute(cExecutor);
        cAIInventoryExecutor = cExecutor;
        CallMethodIn("ExecuteAIInventory", 0.0F);
    }

    boolean bDebugLog;
    boolean bLogEditorScenarios;
    public float fDefaultAIHealth;
    public boolean bHitReactionAllowed;
    public boolean m_bHitReactionDisabled;
    public Action aOnEnemyDetected[];
    public float fDetectionDelay;
    public Action aOnDamageFromFriend[];
    public Action aOnDamageFromEnemy[];
    public Action aOnDamageFromPlayer[];
    String sAnimSeqFile;
    static final int _SCREAMTYPE_PAIN_FRIEND = 0;
    static final int _SCREAMTYPE_PAIN_ENEMY = 1;
    static final int _SCREAMTYPE_DEATH = 2;
    static final int _SCREAMTYPE_ENEMY_SPOTTED = 3;
    static final int _SCREAMTYPE_DEAD_BODY_SPOTTED = 4;
    static final int _SCREAMTYPE_GRENADE_THROW = 5;
    static final int _SCREAMTYPE_GRENADE_SPOTTED = 6;
    static final int _SCREAMTYPE_INFO = 7;
    static final int _SCREAMTYPE_STRANGER_SPOTTED = 8;
    static final int _NUM_OF_SCREAMTYPES = 9;
    public float m_fMinScreamRange;
    public float m_fMaxScreamRange;
    public String sDefaultSoundsPaths;
    public String sSoundsPath;
    private String m_sSoundsPathPrefix;
    private int m_nLastScreamType;
    private float m_fNextScreamTime;
    float m_aNextScreamTypeTime[];
    SoundsGroup m_aSoundsGroups[];
    public boolean bCanUseRadioCommunication;
    public static boolean s_bRadioCommDisabledForMovie = false;
    public float _TEAM_RADIO_MSG_ACCEPTABLE_DIST2;
    public float _TEAM_RADIO_MSG_MAX_DIST2;
    public float _LISTENER_RADIO_MSG_MAX_DIST2;
    AIController m_Controller;
    String m_sControllerClassName;
    IAIHearingSense m_Hearing;
    IAIPainSense m_Pain;
    public Waypoint cWaypoint;
    public Waypoint cFirstWaypoint;
    protected Waypoint m_NewWaypoint;
    protected boolean m_bWaypointChanged;
    public boolean bPortalIndependent;
    public boolean bAllowUsingIndoorPathfinder;
    public boolean bDisappearOnStart;
    public boolean bCastShadows;
    public boolean bRandomWalkAllowed;
    public float fMinWalkOnPlayerDistance;
    float _WALK_ON_PLAYER_ANGLE_COS;
    boolean bCanTurnWhileMoving;
    public boolean bDetectEnemyOnNoise;
    ChromeActor m_Killer;
    public float fUnimportanceFactor;
    public FileName m_cSkin;
    public EnumGetInType cGetInAs;
    public String sDefaultItems;
    public int nDefaultItemProbability;
    public Weapon cAIWeapon;
    public float fAIWeaponLODCoef;
    public InvObjectInst aItemsFromModule[];
    public InvObject aItems[];
    public int nGrenades;
    int m_nGrenadesLeft;
    int m_nRoundsHit;
    int m_nRoundsShot;
    float m_fDesiredHitRatio;
    float m_fLastDesiredHitRatio;
    float m_fFiringDevLineAngle;
    float m_fFiringDeviation;
    float m_fMaxHitFiringDeviation;
    public float m_fHitRatioChangeSpeed;
    public float m_fCriticalDesiredHitRatioChangeThreshold;
    float m_fLastDesiredHitRatioChangeCheckTime;
    float m_fLastResetFiringStatisticsTime;
    float _DESIRED_HIT_RATIO_CHANGE_CHECK_INTERVAL;
    float _MAX_RESET_FIRING_STATISTICS_INTERVAL;
    public boolean bCanForgetAboutEnemy;
    AIMotionState m_Motion;
    AIMotionState m_OldMotion;
    AIMotionState m_ActualMotion;
    public float m_aMotionVelocity[] = {
        0, 70F, 70F, 100F, 165F, 500F
    };
    public float m_aMotionVelocityStrafeMultiplier[] = {
        0, 1.0F, 1.0F, 0.6F, 0.5F, 0.5F
    };
    public float m_aMotionAngularVelocity[] = {
        0, 0, 30F, 90F, 180F, 300F
    };
    public float m_fMinTurnAngleToUpdateMotion;
    public float m_fStopUpdateMotionDelay;
    public float m_fMinAngleToTurnWhileMovingCos;
    AIAnimations m_Anims;
    public static int _ANIM_ID_NONE = -1;
    public static int _ANIM_ID_STRING = -2;
    protected int m_nCurrentAnimID;
    protected int METHOD_UpdateAllTrackings;
    protected int METHOD_AnimationFinished;
    protected int METHOD_CallUpdateMotion;
    protected int METHOD_TurnDone;
    protected int METHOD_InterpolatePositionDone;
    protected ChromeActor m_TrackedObject;
    protected boolean m_bTrackLookOnly;
    protected boolean m_bTrackCanTurn;
    public float m_fMinTrackingUpdateTime;
    public float m_fMaxTrackingUpdateTime;
    public float m_fPainScreamRange;
    public float m_fDeathScreamRange;
    public float m_fDeathBodyFallRange;
    public float fMakeNoiseMult;
    WaypointSystem m_WpSystem;
    AIGroup m_AIGroup;
    public int m_iPathFinderStampSize;
    public static int m_nInstances = 0;
    public int m_nInstanceNumber;
    String sAIProfilingPage;
    static int PROFILE_RequestEvent = 0;
    static int PROFILE_ObjectsMsg = 0;
    static int PROFILE_CalcProfile = 0;
    static int PROFILE_NoiseMsg = 0;
    static int PROFILE_PainMsg = 0;
    static int PROFILE_Recognition = 0;
    String sBlobMaterial;
    float fBlobMapSize;
    boolean bBlobHasFixedOrientation;
    public static int _AITRACE_NO_FLAGS = 0;
    public static int _AITRACE_IGNORE_GLASS = 1;
    private static int l_aExcludeObjectsOldFlags[] = new int[5];
    protected boolean m_bIsFrozen;
    private boolean m_bWasPhysicsActiveBeforeFreeze;
    protected boolean m_bIsActive;
    protected boolean m_bWasFrozenBeforeDeactivate;
    public static final float _COS_1_PI_BY_8 = (float)Math.cos(0.39269908169872414D);
    public static final float _COS_2_PI_BY_8 = (float)Math.cos(0.78539816339744828D);
    public static final float _COS_3_PI_BY_8 = (float)Math.cos(1.1780972450961724D);
    public static final float _COS_4_PI_BY_8 = (float)Math.cos(1.5707963267948966D);
    public static final float _COS_5_PI_BY_8 = (float)Math.cos(1.9634954084936207D);
    public static final float _COS_6_PI_BY_8 = (float)Math.cos(2.3561944901923448D);
    public static final float _COS_7_PI_BY_8 = (float)Math.cos(2.748893571891069D);
    protected boolean m_bUsePathfinder;
    protected boolean m_bUseIndoorPathfinder;
    protected Vector m_aCurrentGoToPath[];
    protected int m_nCurrentGoToPathLen;
    protected int m_nWaypointsInPath;
    protected Vector m_vCurrentGoToPoint;
    protected int m_nCurrentGoToPathIdx;
    protected Vector m_vGoToDestination;
    protected float m_fDestinationRadius;
    protected boolean m_bLastGoToSuccessfull;
    protected ControlObject m_GuardedObject;
    protected float m_fGuardedAreaRadius;
    protected boolean m_bGuardCritical;
    private Vector m_vValidEnd;
    private Vector m_vStartPos;
    protected Vector m_vSpeedDir;
    protected static Vector sm_vUTD_PlayerDir = new Vector();
    protected float m_fIntPosOldMass;
    protected boolean m_bIntPos_BLOCK_MOVE;
    protected Vector m_vIntPosDestPos;
    protected Vector m_vIntPosDestDir;
    private Vector m_vIntPosDir;
    private boolean m_bIntPosWasUsingPathfinder;
    Actor cAIInventoryExecutor;
    int m_nAmmoForActiveWeapon;
    boolean m_bWPVis;
    LaserPointer m_ToCurrWPLine;
    public static RadioCommunicationSystem m_CommSystem = null;
    public boolean bUseParamsModifiers;
    public float mod_fAccuracyMult;
    public float mod_fFiringTimeMult;
    public float mod_fFireDelayMult;
    public int mod_nSingleHealtexProbability;
    public int mod_nMaxHealtexesNumber;
    public float mod_fMinHitRatioMult;
    public float mod_fMaxHitRatioMult;
    public float mod_fMinSpareAmmoClips;
    public float mod_fMaxSpareAmmoClips;
    public int mod_nSpareAmmoProbability;
    public int mod_nSingleGrenadeProbability;
    public int mod_nMaxGrenadesNumber;
    protected static ArrayList s_ModifiersList = new ArrayList();

}
