// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   ObjectivesManager.java

import java.util.Vector;

public class ObjectivesManager extends NetObjectContainer
    implements ISaveGame
{

    void CopyDataToContainer()
    {
        super.m_cContainer.PackInt(m_Objectives.size());
        for(int i = 0; i < m_Objectives.size(); i++)
            if(m_Objectives.elementAt(i) instanceof SingleObjective)
            {
                SingleObjective cObjective = (SingleObjective)m_Objectives.elementAt(i);
                super.m_cContainer.PackInt(cObjective.m_iObjectiveNo);
                super.m_cContainer.PackInt(cObjective.m_iObjectiveGroupNo);
                super.m_cContainer.PackBoolean(cObjective.IsEnabled(false));
                super.m_cContainer.PackBoolean(cObjective.IsAccomplished());
            }

        int nLocations = 0;
        for(int i = 0; i < m_Locations.size(); i++)
            if(m_Locations.elementAt(i) instanceof DefLocation)
            {
                DefLocation cLocation = (DefLocation)m_Locations.elementAt(i);
                if(!cLocation.HasObjective())
                    nLocations++;
            }

        super.m_cContainer.PackInt(nLocations);
        for(int i = 0; i < m_Locations.size(); i++)
            if(m_Locations.elementAt(i) instanceof DefLocation)
            {
                DefLocation cLocation = (DefLocation)m_Locations.elementAt(i);
                if(!cLocation.HasObjective())
                {
                    super.m_cContainer.PackInt(cLocation.m_iObjectiveNo);
                    super.m_cContainer.PackInt(cLocation.m_iGroupNo);
                    super.m_cContainer.PackBoolean(cLocation.IsEnabled(false));
                }
            }

    }

    void SetUnaccomplished(int iObjNo)
    {
        SetUnaccomplished(iObjNo, 0);
    }

    void SetUnaccomplished(int iGroupNo, int iSubObjNo)
    {
        SingleObjective obj = FindObjective(iGroupNo, iSubObjNo);
        if(obj != null)
        {
            obj.SetUnaccomplished();
            TextMessage("&OBJECTIVE_UNACCOMPLISHED&");
            if(m_bOnServer)
                ServerObjectiveUpdated(1, iGroupNo, iSubObjNo);
        }
    }

    PlayerHUD GetMainPlayer()
    {
        if(m_Module == null)
            return null;
        if(m_Module.GetMainPlayer() instanceof PlayerHUD)
            return (PlayerHUD)m_Module.GetMainPlayer();
        else
            return null;
    }

    void AccomplishedLocation(int iGroupNo)
    {
        AccomplishedLocation(iGroupNo, 0);
    }

    void AccomplishedLocation(int iGroupNo, int iSubLocNo)
    {
        DefLocation loc = FindLocation(iGroupNo, iSubLocNo);
        if(loc != null)
        {
            loc.TrackObjectPosition(false);
            loc.SetAccomplishedTex();
        }
    }

    void TextMessage(String sText)
    {
        if(!m_bMesssagesActive)
            return;
        PlayerHUD cPlayer = GetMainPlayer();
        if(cPlayer == null)
            return;
        if(m_sLastMessage.compareTo(sText) == 0 && m_fLastMessageTime == cPlayer.GetTime())
            return;
        if(sText.equals("&OBJECTIVE_UPDATED&") || sText.equals("&OBJECTIVE_ACCOMPLISHED&") || sText.equals("&OBJECTIVE_UNACCOMPLISHED&"))
            cPlayer.TryPlayObjectiveChangeSound();
        m_sLastMessage = new String(sText);
        m_fLastMessageTime = cPlayer.GetTime();
        cPlayer.TextMessage(sText);
        if(cPlayer.HUD != null && cPlayer.HUD.GetHUDLogs() != null)
            cPlayer.HUD.GetHUDLogs().InputText(sText);
    }

    void AttachLocationsToParent(Sprite parent)
    {
        for(int i = 0; i < m_Locations.size(); i++)
            ((DefLocation)m_Locations.elementAt(i)).AttachLocationToParent(parent);

    }

    boolean IsVisible()
    {
        return m_bVisible;
    }

    void HideAll()
    {
        m_bVisible = false;
        for(int i = 0; i < m_Objectives.size(); i++)
            ((SingleObjective)m_Objectives.elementAt(i)).HideThisOnly();

        for(int i = 0; i < m_Locations.size(); i++)
        {
            DefLocation loc = (DefLocation)m_Locations.elementAt(i);
            loc.HideLocation();
        }

    }

    Vector FindSubObjectives(int iObjectiveNo)
    {
        Vector vector = new Vector();
        for(int i = 0; i < m_Objectives.size(); i++)
        {
            SingleObjective objective = (SingleObjective)m_Objectives.elementAt(i);
            if(objective.m_iObjectiveNo == iObjectiveNo && !objective.m_bIsSuperObjective)
                vector.addElement(objective);
        }

        return vector;
    }

    void EnableAllObjectives()
    {
        CheckSpritesAttached();
        for(int i = 0; i < m_Objectives.size(); i++)
        {
            SingleObjective obj = (SingleObjective)m_Objectives.elementAt(i);
            if(!obj.m_bIsSubObjective)
                obj.Enable();
        }

        for(int i = 0; i < m_Locations.size(); i++)
        {
            DefLocation loc = (DefLocation)m_Locations.elementAt(i);
            if(!loc.HasObjective())
                EnableLocation(loc.m_iGroupNo, loc.m_iObjectiveNo, false);
        }

    }

    void UpdateEnableNet()
    {
        for(int i = 0; i < m_Objectives.size(); i++)
            if(m_Objectives.elementAt(i) instanceof SingleObjective)
            {
                SingleObjective cObjective = (SingleObjective)m_Objectives.elementAt(i);
                if(CheckEnableNet(cObjective.m_iObjectiveNo))
                    cObjective.Enable(true);
                else
                    cObjective.Disable(true);
            }

        for(int i = 0; i < m_Locations.size(); i++)
            if(m_Locations.elementAt(i) instanceof DefLocation)
            {
                DefLocation cLocation = (DefLocation)m_Locations.elementAt(i);
                if(!cLocation.HasObjective())
                {
                    int nNumber = cLocation.m_iObjectiveNo;
                    if(nNumber == 0)
                        nNumber = cLocation.m_iGroupNo;
                    if(CheckEnableNet(nNumber))
                        cLocation.Enable(true);
                    else
                        cLocation.Disable(true);
                }
            }

        RecalculatePositions();
        Refresh();
    }

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[ObjectivesManager.SGSaveChunk]\n");
        FileChunk cFC = GameObject.NewChunk(1624, cFCParent);
        cFC.SaveBool(m_bMesssagesActive);
        cFC.delete();
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[ObjectivesManager.SGLoadChunk]\n");
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        if(cFC.GetID() == 1624)
            m_bMesssagesActive = cFC.LoadBool();
        cFC.delete();
    }

    Vector FindSubLocations(int iObjectiveNo)
    {
        Vector vector = new Vector();
        for(int i = 0; i < m_Locations.size(); i++)
        {
            DefLocation location = (DefLocation)m_Locations.elementAt(i);
            if(location.m_iGroupNo == iObjectiveNo && location.m_iObjectiveNo != 0)
                vector.addElement(location);
        }

        return vector;
    }

    public void SGUpdate()
    {
        m_sLastMessage = "";
        m_fLastMessageTime = 0.0F;
    }

    void EnableObjective(int iObjNo)
    {
        EnableObjective(iObjNo, 0);
    }

    void EnableObjective(int iGroupNo, int iSubObjNo)
    {
        CheckSpritesAttached();
        SingleObjective obj = FindObjective(iGroupNo, iSubObjNo);
        if(obj != null)
            obj.Enable();
        RecalculatePositions();
        TextMessage("&OBJECTIVE_UPDATED&");
        if(m_bOnServer)
            ServerObjectiveUpdated(2, iGroupNo, iSubObjNo);
    }

    void EnableObjectivesOnStart()
    {
        for(int i = 0; i < m_Objectives.size(); i++)
        {
            SingleObjective obj = (SingleObjective)m_Objectives.get(i);
            if(obj instanceof ObjectiveGroup)
            {
                ObjectiveGroup group = (ObjectiveGroup)obj;
                if(obj.m_bEnableOnStart)
                    EnableObjective(((SingleObjective) (group)).m_iObjectiveNo, ((SingleObjective) (group)).m_iObjectiveGroupNo);
                else
                    DisableObjective(((SingleObjective) (group)).m_iObjectiveNo, ((SingleObjective) (group)).m_iObjectiveGroupNo);
            } else
            if(obj.m_bEnableOnStart)
                EnableObjective(obj.m_iObjectiveNo);
            else
                DisableObjective(obj.m_iObjectiveNo);
        }

    }

    void Destroy()
    {
        for(int i = 0; i < m_Objectives.size(); i++)
            ((SingleObjective)m_Objectives.elementAt(i)).Destroy();

        for(int i = 0; i < m_Locations.size(); i++)
            ((DefLocation)m_Locations.elementAt(i)).Destroy();

    }

    void EnableLocation(int iGroupNo)
    {
        EnableLocation(iGroupNo, false);
    }

    void EnableLocation(int iGroupNo, boolean bNet)
    {
        EnableLocation(iGroupNo, 0, bNet);
    }

    void EnableLocation(int iGroupNo, int iSubLocNo, boolean bNet)
    {
        CheckSpritesAttached();
        DefLocation loc = FindLocation(iGroupNo, iSubLocNo);
        if(loc != null)
        {
            loc.Enable(bNet);
            if(loc.CanShow())
                loc.ShowLocation();
            if(m_bOnServer)
                ServerObjectiveUpdated(4, iGroupNo, iSubLocNo);
        }
    }

    void UnaccomplishedLocation(int iGroupNo)
    {
        UnaccomplishedLocation(iGroupNo, 0);
    }

    void UnaccomplishedLocation(int iGroupNo, int iSubLocNo)
    {
        DefLocation loc = FindLocation(iGroupNo, iSubLocNo);
        if(loc != null)
        {
            loc.TrackObjectPosition(true);
            loc.SetUnaccomplishedTex();
        }
    }

    void Init(Vector objectives, Vector locations)
    {
        GameObject.CrashLog("[ObjectivesManager.Init]\n");
        SingleObjective.SetObjectivesManager(this);
        m_Objectives = new Vector();
        for(int i = 0; i < objectives.size(); i++)
        {
            ObjectiveDescription objDes = (ObjectiveDescription)objectives.elementAt(i);
            SingleObjective obj = null;
            if(objDes.m_iObjectiveGroupNo == 0)
            {
                if(objDes.m_bIsGroup)
                    obj = new SingleObjective(objDes.m_iObjectiveNo, objDes.m_ObjectiveInfo, true);
                else
                    obj = new SingleObjective(objDes.m_iObjectiveNo, objDes.m_ObjectiveInfo, false);
                obj.m_bEnableOnStart = true;
            } else
            {
                obj = new ObjectiveGroup(objDes.m_iObjectiveNo, objDes.m_iObjectiveGroupNo, objDes.m_ObjectiveInfo);
                obj.m_bEnableOnStart = true;
            }
            m_Objectives.addElement(obj);
        }

        m_Locations = new Vector();
        for(int i = 0; i < locations.size(); i++)
        {
            LocationDescription locDes = (LocationDescription)locations.elementAt(i);
            if(locDes.m_TrackedName == null)
            {
                DefLocation location = (DefLocation)m_Module.CreateObject("DefLocation");
                location.m_bEnableOnStart = true;
                location.InitLocation(locDes.m_iLocationGroupNo, locDes.m_iLocationNo, locDes.m_TextStringID, locDes.m_vWorldPos, locDes.m_ToolTip);
                m_Locations.addElement(location);
            } else
            {
                DefLocation location = (DefLocation)m_Module.CreateObject("DefLocation");
                location.m_bEnableOnStart = true;
                location.InitLocation(locDes.m_iLocationGroupNo, locDes.m_iLocationNo, locDes.m_TextStringID, locDes.m_TrackedName, locDes.m_ToolTip);
                m_Locations.addElement(location);
            }
        }

        GameObject objTab[] = GameObject.GetObjectsOfClass("Objective");
        for(int i = 0; i < objTab.length; i++)
        {
            SingleObjective obj = null;
            Objective editorObj = (Objective)objTab[i];
            obj = new SingleObjective(((EditorObjective) (editorObj)).iObjectiveOrderNumber, ((EditorObjective) (editorObj)).sTextID, false);
            obj.m_bEnableOnStart = ((EditorObjective) (editorObj)).bEnableOnStart;
            boolean bInserted = false;
            for(int j = 0; j < m_Objectives.size(); j++)
            {
                SingleObjective curr = (SingleObjective)m_Objectives.get(j);
                if(obj.m_iObjectiveNo > curr.m_iObjectiveNo)
                    continue;
                m_Objectives.insertElementAt(obj, j);
                bInserted = true;
                break;
            }

            if(!bInserted)
                m_Objectives.addElement(obj);
        }

        objTab = GameObject.GetObjectsOfClass("SubObjective");
        for(int i = 0; i < objTab.length; i++)
        {
            SubObjective editorObj = (SubObjective)objTab[i];
            if(editorObj.cParent == null)
            {
                GameObject.CrashLog("ObjectivesManager ERROR: subobjective doesnt have parent !!!\n");
            } else
            {
                FindObjective(((EditorObjective) (editorObj.cParent)).iObjectiveOrderNumber, 0).SetAsGroupObjective(true);
                ObjectiveGroup obj = new ObjectiveGroup(((EditorObjective) (editorObj.cParent)).iObjectiveOrderNumber, ((EditorObjective) (editorObj)).iObjectiveOrderNumber, ((EditorObjective) (editorObj)).sTextID);
                obj.m_bEnableOnStart = ((EditorObjective) (editorObj)).bEnableOnStart;
                boolean bInserted = false;
                for(int j = 0; j < m_Objectives.size() && !bInserted; j++)
                {
                    SingleObjective curr = (SingleObjective)m_Objectives.get(j);
                    if(((SingleObjective) (obj)).m_iObjectiveNo == curr.m_iObjectiveNo)
                        while(!bInserted) 
                        {
                            if(++j == m_Objectives.size())
                            {
                                m_Objectives.addElement(obj);
                                bInserted = true;
                                break;
                            }
                            curr = (SingleObjective)m_Objectives.get(j);
                            if(curr instanceof ObjectiveGroup)
                            {
                                ObjectiveGroup currSubObjective = (ObjectiveGroup)curr;
                                if(((SingleObjective) (obj)).m_iObjectiveGroupNo <= ((SingleObjective) (currSubObjective)).m_iObjectiveGroupNo)
                                {
                                    m_Objectives.insertElementAt(obj, j);
                                    bInserted = true;
                                    break;
                                }
                            } else
                            {
                                m_Objectives.insertElementAt(obj, j);
                                bInserted = true;
                                break;
                            }
                        }
                }

            }
        }

        objTab = GameObject.GetObjectsFromClassModule("EditorLocation", m_Module);
        for(int i = 0; i < objTab.length; i++)
        {
            EditorLocation editorLocation = (EditorLocation)objTab[i];
            if(editorLocation.bTrackDynamic && editorLocation.cTrackedObject == null)
            {
                GameObject.CrashLog("ObjectivesManager ERROR: location doesnt have target !!!\n");
            } else
            {
                DefLocation location = (DefLocation)m_Module.CreateObject("DefLocation");
                location.m_bEnableOnStart = editorLocation.bEnableOnStart;
                String m_MeshID = editorLocation.cPicture.GetStringValue();
                int iNo;
                int iSubNo;
                if(editorLocation.m_iAutoNumber != 0)
                {
                    iNo = editorLocation.m_iAutoNumber;
                    iSubNo = 0;
                } else
                if(editorLocation.cObjective instanceof SubObjective)
                {
                    iNo = ((EditorObjective) (((SubObjective)editorLocation.cObjective).cParent)).iObjectiveOrderNumber;
                    iSubNo = editorLocation.cObjective.iObjectiveOrderNumber;
                } else
                {
                    iNo = editorLocation.cObjective.iObjectiveOrderNumber;
                    iSubNo = 0;
                }
                if(!editorLocation.bTrackDynamic)
                    location.InitLocation(iNo, iSubNo, m_MeshID, editorLocation.GetPosition(), editorLocation.sTipID);
                else
                    location.InitLocation(iNo, iSubNo, m_MeshID, editorLocation.cTrackedObject.GetName(), editorLocation.sTipID);
                m_Locations.addElement(location);
            }
        }

        EnableObjectivesOnStart();
        EnableLocationsOnStart();
    }

    void ServerObjectiveUpdated(int nUpdate, int iGroupNo, int iSubObjNo)
    {
        NetGameInfo cGameInfo = GetNetGameInfo();
        if(cGameInfo != null)
            cGameInfo.EventObjectiveUpdated(0, iGroupNo, iSubObjNo, m_bMesssagesActive);
    }

    void ObjectiveUpdated(int nUpdate, int iGroupNo, int iSubObjNo, boolean bForceMesssagesActive)
    {
        boolean bMesssagesActive = m_bMesssagesActive;
        m_bMesssagesActive = bForceMesssagesActive;
        switch(nUpdate)
        {
        case 0: // '\0'
            SetAccomplished(iGroupNo, iSubObjNo);
            break;

        case 1: // '\001'
            SetUnaccomplished(iGroupNo, iSubObjNo);
            break;

        case 2: // '\002'
            EnableObjective(iGroupNo, iSubObjNo);
            break;

        case 3: // '\003'
            DisableObjective(iGroupNo, iSubObjNo);
            break;

        case 4: // '\004'
            EnableLocation(iGroupNo, iSubObjNo, false);
            break;

        case 5: // '\005'
            DisableLocation(iGroupNo, iSubObjNo, false);
            break;
        }
        m_bMesssagesActive = bMesssagesActive;
    }

    NetGameInfo GetNetGameInfo()
    {
        if(m_Module instanceof ModuleNet)
            return ((ModuleNet)m_Module).GetGameInfo();
        else
            return null;
    }

    void DisableLocation(int iGroupNo, boolean bNet)
    {
        DisableLocation(iGroupNo, 0, bNet);
    }

    void DisableLocation(int iGroupNo, int iSubLocNo, boolean bNet)
    {
        CheckSpritesAttached();
        DefLocation loc = FindLocation(iGroupNo, iSubLocNo);
        if(loc != null)
        {
            loc.Disable(bNet);
            loc.HideLocation();
            if(m_bOnServer)
                ServerObjectiveUpdated(5, iGroupNo, iSubLocNo);
        }
    }

    static int GetNextAutoNumber()
    {
        return _START_AUTO_NUMBER++;
    }

    boolean IsAccomplishedLocation(int iGroupNo)
    {
        return IsAccomplishedLocation(iGroupNo, 0);
    }

    void DisableAllObjectives()
    {
        CheckSpritesAttached();
        for(int i = 0; i < m_Objectives.size(); i++)
        {
            SingleObjective obj = (SingleObjective)m_Objectives.elementAt(i);
            obj.Disable();
        }

        for(int i = 0; i < m_Locations.size(); i++)
        {
            DefLocation loc = (DefLocation)m_Locations.elementAt(i);
            if(!loc.HasObjective())
                DisableLocation(loc.m_iGroupNo, loc.m_iObjectiveNo, false);
        }

    }

    boolean IsAccomplishedLocation(int iGroupNo, int iSubLocNo)
    {
        DefLocation loc = FindLocation(iGroupNo, iSubLocNo);
        if(loc != null)
            return loc.IsAccomplished();
        else
            return false;
    }

    DefLocation FindLocation(int iGroupNo, int iSubLocNo)
    {
        for(int i = 0; i < m_Locations.size(); i++)
        {
            DefLocation location = (DefLocation)m_Locations.elementAt(i);
            if(location.m_iGroupNo == iGroupNo && location.m_iObjectiveNo == iSubLocNo)
                return location;
        }

        return null;
    }

    void StartOnServer()
    {
        m_bOnServer = true;
        UpdateEnableNet();
    }

    void DisableLocation(int iGroupNo)
    {
        DisableLocation(iGroupNo, 0, false);
    }

    void Refresh()
    {
        if(m_bVisible)
        {
            HideAll();
            ShowAll();
        }
    }

    void StartOnClient()
    {
        m_bOnServer = false;
        UpdateEnableNet();
    }

    void SetEnableNet(boolean bTeamGame, int nPlayerTeam)
    {
        m_bInit = true;
        m_bTeamGame = bTeamGame;
        m_nPlayerTeam = nPlayerTeam;
        UpdateEnableNet();
    }

    boolean CheckEnableNet(int nNumber)
    {
        if(!m_bInit)
            return false;
        if(m_bTeamGame)
        {
            switch(m_nPlayerTeam)
            {
            case 1: // '\001'
                return nNumber >= 100 && nNumber < 200;

            case 2: // '\002'
                return nNumber >= 200 && nNumber < 300;
            }
            return false;
        } else
        {
            return true;
        }
    }

    void RecalculatePositions()
    {
        float fY = _TEXT_START_INDENT_Y;
        if(GetMainPlayer() == null)
            return;
        Sprite cObjectives = GetMainPlayer().HUD.GetHUDMap().GetObjectivesSprite();
        for(int i = 0; i < m_Objectives.size(); i++)
        {
            SingleObjective obj = (SingleObjective)m_Objectives.elementAt(i);
            fY += obj.RecalculatePosition(fY, cObjectives.GetSize());
        }

    }

    void HideAllTooltips()
    {
        for(int i = 0; i < m_Locations.size(); i++)
        {
            DefLocation loc = (DefLocation)m_Locations.elementAt(i);
            loc.HideToolTip();
        }

    }

    void DisableObjective(int iObjNo)
    {
        DisableObjective(iObjNo, 0);
    }

    void DisableObjective(int iGroupNo, int iSubObjNo)
    {
        CheckSpritesAttached();
        SingleObjective obj = FindObjective(iGroupNo, iSubObjNo);
        if(obj != null)
            obj.Disable();
        RecalculatePositions();
        if(m_bOnServer)
            ServerObjectiveUpdated(3, iGroupNo, iSubObjNo);
    }

    SingleObjective FindObjective(int iObjectiveNo, int iGroupNo)
    {
        for(int i = 0; i < m_Objectives.size(); i++)
        {
            SingleObjective objective = (SingleObjective)m_Objectives.elementAt(i);
            if(objective.m_iObjectiveNo == iObjectiveNo)
                if(objective.m_bIsSuperObjective)
                {
                    if(iGroupNo == 0)
                        return objective;
                } else
                if(objective.m_bIsSubObjective)
                {
                    ObjectiveGroup group = (ObjectiveGroup)objective;
                    if(((SingleObjective) (group)).m_iObjectiveGroupNo == iGroupNo)
                        return objective;
                } else
                {
                    return objective;
                }
        }

        return null;
    }

    void CopyDataFromContainer()
    {
        SetMessagesActive(false);
        int nObjectives = super.m_cContainer.UnPackInt();
        if(nObjectives != m_Objectives.size())
            GameObject.LogD(" nObjectives:" + nObjectives + " " + m_Objectives.size() + "\n");
        for(int i = 0; i < m_Objectives.size(); i++)
            if(m_Objectives.elementAt(i) instanceof SingleObjective)
            {
                SingleObjective cObjective = (SingleObjective)m_Objectives.elementAt(i);
                int nObjectiveNo = super.m_cContainer.UnPackInt();
                if(nObjectiveNo != cObjective.m_iObjectiveNo)
                    GameObject.LogD(" nObjectiveNo:" + nObjectiveNo + " " + cObjective.m_iObjectiveNo + "\n");
                int nObjectiveGroupNo = super.m_cContainer.UnPackInt();
                if(nObjectiveGroupNo != cObjective.m_iObjectiveGroupNo)
                    GameObject.LogD(" nObjectiveGroupNo:" + nObjectiveGroupNo + " " + cObjective.m_iObjectiveGroupNo + "\n");
                boolean bEnabled = super.m_cContainer.UnPackBoolean();
                boolean bAccomplished = super.m_cContainer.UnPackBoolean();
                if(bEnabled)
                    cObjective.Enable(false);
                else
                    cObjective.Disable(false);
                if(bAccomplished)
                    cObjective.SetAccomplished();
                else
                    cObjective.SetUnaccomplished();
            }

        int nLocations = 0;
        for(int i = 0; i < m_Locations.size(); i++)
            if(m_Locations.elementAt(i) instanceof DefLocation)
            {
                DefLocation cLocation = (DefLocation)m_Locations.elementAt(i);
                if(!cLocation.HasObjective())
                    nLocations++;
            }

        int nRecvLocations = super.m_cContainer.UnPackInt();
        if(nLocations != nLocations)
            GameObject.LogD(" nRecvLocations:" + nRecvLocations + " " + nLocations + "\n");
        for(int i = 0; i < m_Locations.size(); i++)
            if(m_Locations.elementAt(i) instanceof DefLocation)
            {
                DefLocation cLocation = (DefLocation)m_Locations.elementAt(i);
                if(!cLocation.HasObjective())
                {
                    int nObjectiveNo = super.m_cContainer.UnPackInt();
                    if(nObjectiveNo != cLocation.m_iObjectiveNo)
                        GameObject.LogD(" nObjectiveNo:" + nObjectiveNo + " " + cLocation.m_iObjectiveNo + "\n");
                    int nGroupNo = super.m_cContainer.UnPackInt();
                    if(nGroupNo != cLocation.m_iGroupNo)
                        GameObject.LogD(" nGroupNo:" + nGroupNo + " " + cLocation.m_iGroupNo + "\n");
                    boolean bEnabled = super.m_cContainer.UnPackBoolean();
                    if(bEnabled)
                        cLocation.Enable(false);
                    else
                        cLocation.Disable(false);
                }
            }

        SetMessagesActive(true);
        RecalculatePositions();
        Refresh();
    }

    void SetAccomplished(int iObjNo)
    {
        SetAccomplished(iObjNo, 0);
    }

    void SetAccomplished(int iGroupNo, int iSubObjNo)
    {
        SingleObjective obj = FindObjective(iGroupNo, iSubObjNo);
        if(obj != null)
        {
            obj.SetAccomplished();
            TextMessage("&OBJECTIVE_ACCOMPLISHED&");
            if(m_bOnServer)
                ServerObjectiveUpdated(0, iGroupNo, iSubObjNo);
        }
    }

    boolean IsAccomplished(int iObjNo)
    {
        return IsAccomplished(iObjNo, 0);
    }

    boolean IsAccomplished(int iGroupNo, int iSubObjNo)
    {
        SingleObjective obj = FindObjective(iGroupNo, iSubObjNo);
        if(obj != null)
            return obj.IsAccomplished();
        else
            return true;
    }

    void CheckSpritesAttached()
    {
        if(!m_bSpritesAttached && GetMainPlayer() != null && GetMainPlayer().HUD != null && GetMainPlayer().HUD.GetHUDMap() != null && GetMainPlayer().HUD.GetHUDMap().GetObjectivesSprite() != null)
        {
            m_bSpritesAttached = true;
            AttachTextsToParent(GetMainPlayer().HUD.GetHUDMap().GetObjectivesSprite());
            AttachLocationsToParent(GetMainPlayer().HUD.GetHUDMap().m_cMap);
            RecalculatePositions();
        }
    }

    boolean IsEnabledObjective(int iGroupNo, int iSubObjNo)
    {
        SingleObjective obj = FindObjective(iGroupNo, iSubObjNo);
        if(obj != null)
            return obj.IsEnabled();
        else
            return false;
    }

    boolean IsEnabledObjective(int iGroupNo)
    {
        return IsEnabledObjective(iGroupNo, 0);
    }

    void SetMessagesActive(boolean bActive)
    {
        m_bMesssagesActive = bActive;
    }

    void ShowAll()
    {
        CheckSpritesAttached();
        m_bVisible = true;
        for(int i = 0; i < m_Objectives.size(); i++)
            if(m_Objectives.elementAt(i) instanceof SingleObjective)
            {
                SingleObjective cObjective = (SingleObjective)m_Objectives.elementAt(i);
                if(cObjective.CanShow())
                    cObjective.ShowThisOnly();
            }

        for(int i = 0; i < m_Locations.size(); i++)
            if(m_Locations.elementAt(i) instanceof DefLocation)
            {
                DefLocation cLocation = (DefLocation)m_Locations.elementAt(i);
                if(!cLocation.HasObjective() && cLocation.CanShow())
                    cLocation.ShowLocation();
            }

    }

    boolean IsEnabledLocation(int iGroupNo)
    {
        return IsEnabledLocation(iGroupNo, 0);
    }

    boolean IsEnabledLocation(int iGroupNo, int iSubLocNo)
    {
        DefLocation loc = FindLocation(iGroupNo, iSubLocNo);
        if(loc != null)
            return loc.IsEnabled();
        else
            return false;
    }

    ObjectivesManager()
    {
        m_Objectives = null;
        m_Locations = null;
        m_sLastMessage = "";
        m_fLastMessageTime = 0.0F;
        m_bSpritesAttached = false;
        m_bVisible = false;
        m_bMesssagesActive = true;
        m_bOnServer = false;
        m_bInit = false;
        m_bTeamGame = false;
        m_nPlayerTeam = 0;
    }

    ObjectivesManager(ChromeModule mod)
    {
        m_Objectives = null;
        m_Locations = null;
        m_sLastMessage = "";
        m_fLastMessageTime = 0.0F;
        m_bSpritesAttached = false;
        m_bVisible = false;
        m_bMesssagesActive = true;
        m_bOnServer = false;
        m_bInit = false;
        m_bTeamGame = false;
        m_nPlayerTeam = 0;
        m_Module = mod;
    }

    void AttachTextsToParent(Sprite parent)
    {
        for(int i = 0; i < m_Objectives.size(); i++)
            ((SingleObjective)m_Objectives.elementAt(i)).AttachTextToParent(parent);

    }

    void EnableLocationsOnStart()
    {
        for(int i = 0; i < m_Locations.size(); i++)
        {
            DefLocation location = (DefLocation)m_Locations.get(i);
            boolean bEnable = location.m_bEnableOnStart;
            SingleObjective obj = FindObjective(location.m_iGroupNo, location.m_iObjectiveNo);
            if(obj != null)
                bEnable = obj.m_bEnableOnStart;
            if(bEnable)
                EnableLocation(location.m_iGroupNo, location.m_iObjectiveNo, false);
            else
                DisableLocation(location.m_iGroupNo, location.m_iObjectiveNo, false);
        }

    }

    static int _START_AUTO_NUMBER = 0xf4240;
    static int _TEXT_INDENT_X = 10;
    static int _TEXT_SUB_INDENT_X = 10;
    static int _TEXT_START_INDENT_Y = 5;
    static int _TEXT_INDENT_Y = 5;
    Vector m_Objectives;
    Vector m_Locations;
    static ChromeModule m_Module = null;
    String m_sLastMessage;
    float m_fLastMessageTime;
    boolean m_bSpritesAttached;
    private boolean m_bVisible;
    boolean m_bMesssagesActive;
    private boolean m_bOnServer;
    private boolean m_bInit;
    private boolean m_bTeamGame;
    private int m_nPlayerTeam;
    static final int _OBJECTIVE_ACCOMPLISHED = 0;
    static final int _OBJECTIVE_UNACCOMPLISHED = 1;
    static final int _OBJECTIVE_ENABLED = 2;
    static final int _OBJECTIVE_DISABLED = 3;
    static final int _LOCATION_ENABLED = 4;
    static final int _LOCATION_DISABLED = 5;

}
