// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   Path.java

import java.io.IOException;
import java.util.Vector;

public class Path
    implements ISaveGame
{

    int GetPathID()
    {
        return nPathID;
    }

    public void PathToCrashLog()
    {
        GameObject.CrashLog("Path:" + this + "\n");
        GameObject.CrashLog("PathID:" + nPathID + ", StringID:" + sStringID + ", Flags:" + nFlags + "\n");
        for(int i = 0; i < aPoints.size(); i++)
        {
            PathPoint p = (PathPoint)aPoints.elementAt(i);
            GameObject.CrashLog("Point. flags:" + p.nFlags + ", pos:" + p.vPosition + ", radius:" + p.fRadius + "\n");
        }

    }

    PathPoint GetPoint(int nNum)
    {
        if(nNum < 0 || nNum >= aPoints.size())
            return null;
        else
            return (PathPoint)aPoints.elementAt(nNum);
    }

    boolean IsPathLooped()
    {
        return (nFlags & _PATH_LOOPED) != 0;
    }

    public void SGUpdate()
    {
        FileChunk.Log("[Path.SGSaveChunk]\n");
    }

    Path()
    {
        nFlags = _PATH_ONE_WAY;
        nPathID = -1;
        sStringID = "";
        aPoints = new Vector();
    }

    Path(MapInputStream cStream)
    {
        nFlags = _PATH_ONE_WAY;
        nPathID = -1;
        sStringID = "";
        aPoints = new Vector();
        try
        {
            nPathID = cStream.readInt();
            sStringID = cStream.readString();
            nFlags = cStream.readInt();
            switch(nFlags)
            {
            case 0: // '\0'
                nFlags = _PATH_ONE_WAY;
                break;

            case 1: // '\001'
                nFlags = _PATH_LOOPED;
                break;

            case 2: // '\002'
                nFlags = _PATH_TWO_WAYS;
                break;
            }
            int nPoints = cStream.readInt();
            for(int i = 0; i < nPoints; i++)
            {
                PathPoint point = new PathPoint(cStream);
                point.LoadPathPointData(cStream);
                aPoints.addElement(point);
            }

        }
        catch(IOException e)
        {
            GameObject.CrashLog("[LoadPathData] File error while reading Path data !!!\n");
            return;
        }
    }

    boolean IsPathTwoWays()
    {
        return (nFlags & _PATH_TWO_WAYS) != 0;
    }

    public void LoadPointData(MapInputStream cStream)
    {
        try
        {
            PathPoint point = new PathPoint(cStream);
            aPoints.addElement(point);
        }
        catch(Exception e)
        {
            GameObject.CrashLog("[Path] Error in loading points data\n");
        }
    }

    public void AddPathPoint(PathPoint p)
    {
        aPoints.addElement(p);
    }

    Vector[] ConvertToVector()
    {
        Vector points[] = new Vector[GetPointsNum()];
        for(int i = 0; i < GetPointsNum(); i++)
            points[i] = GetPoint(i).vPosition;

        return points;
    }

    String GetPathName()
    {
        return sStringID;
    }

    boolean IsPathOneWay()
    {
        return (nFlags & _PATH_ONE_WAY) != 0;
    }

    void SetPathOneWay()
    {
        nFlags = _PATH_ONE_WAY;
    }

    int GetPointsNum()
    {
        return aPoints.size();
    }

    public void SGSaveChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[Path.SGSaveChunk]\n");
        FileChunk cFC = GameObject.NewChunk(132, cParentFC);
        cFC.SaveInt(nFlags);
        cFC.SaveInt(nPathID);
        cFC.SaveString(sStringID);
        cFC.SaveInt(aPoints.size());
        for(int i = 0; i < aPoints.size(); i++)
        {
            PathPoint pt = (PathPoint)aPoints.get(i);
            cFC.SaveInt(pt.nFlags);
            cFC.SaveVector(pt.vPosition);
            cFC.SaveFloat(pt.fRadius);
            cFC.SaveString(pt.sTextField);
        }

        cFC.delete();
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[Path.SGLoadChunk]\n");
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        if(cFC.GetID() == 132)
        {
            this.nFlags = cFC.LoadInt();
            nPathID = cFC.LoadInt();
            sStringID = cFC.LoadString();
            int iTemp = cFC.LoadInt();
            aPoints.clear();
            for(int i = 0; i < iTemp; i++)
            {
                int nFlags = cFC.LoadInt();
                Vector vPos = cFC.LoadVector();
                float fRadius = cFC.LoadFloat();
                String sTextField = cFC.LoadString();
                PathPoint pt = new PathPoint(vPos, fRadius, nFlags);
                pt.sTextField = sTextField;
                aPoints.add(pt);
            }

        }
        cFC.delete();
    }

    static int _PATH_ONE_WAY = 1;
    static int _PATH_TWO_WAYS = 2;
    static int _PATH_LOOPED = 4;
    int nFlags;
    int nPathID;
    String sStringID;
    Vector aPoints;

}
