// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   RainManager.java

import java.util.Vector;

public class RainManager extends GameObject
{

    public void OnAudioReinitialize()
    {
        GameObject.LogR(this + " OnAudioReinitialize");
        if(m_Module.m_bRainPlayEnvSound && m_Module.m_sRainEnvironmentSound.length() != 0)
        {
            m_nEnvironmentSoundID = m_RainSpeaker.AttachSound(m_Module.m_sRainEnvironmentSound, m_fMinEnvSoundRange, m_fMaxEnvSoundRange);
            m_RainSpeaker.SetSoundVolume(m_nEnvironmentSoundID, m_Module.m_fRainEnvironmentSoundVolume * 0.01F);
        }
    }

    public void OnAudioPreReinitialize()
    {
        GameObject.LogR(this + " OnAudioPreReinitialize");
        if(m_nEnvironmentSoundID != 0)
        {
            StopWave(m_nEnvironmentSoundID);
            m_nEnvironmentSoundID = 0;
        }
    }

    void AddThunderToQueque(String sThunderSound, float fDelay, float fVolume)
    {
        ThunderInfo ti = new ThunderInfo();
        ti.fCreationTime = m_fLastTime;
        ti.fDelay = fDelay;
        ti.fVolume = fVolume;
        ti.sSound = sThunderSound;
        m_vstThundersQueque.add(ti);
    }

    void DeleteThundersQueque()
    {
        m_vstThundersQueque.clear();
    }

    void PlayThundersQueque()
    {
        for(int i = 0; i < m_vstThundersQueque.size();)
        {
            ThunderInfo ti = (ThunderInfo)m_vstThundersQueque.get(i);
            if(m_fLastTime >= ti.fCreationTime + ti.fDelay)
            {
                if(m_RainSpeaker != null)
                    m_RainSpeaker.AttachOneShotSound(ti.sSound, ti.fVolume);
                m_vstThundersQueque.remove(i);
            } else
            {
                i++;
            }
        }

    }

    private void Update()
    {
        if(!m_Module.m_bRainEnabled)
            return;
        float fTime = GetTime();
        float fDeltaTime = fTime - m_fLastTime;
        m_fLastTime = fTime;
        if(!m_bFXRainStarted)
            StartFXRain();
        if(m_Module.m_iRainLightningsPerMinute > 0)
        {
            float fProbability = ((float)m_Module.m_iRainLightningsPerMinute * fDeltaTime) / 60F;
            if(GameObject.RandomFloat(1.0F) <= fProbability)
            {
                if(m_Module.m_bRainLightningShowFlash)
                    ShowLightningFlash();
                if(GameObject.RandomFloat(100F) <= m_Module.m_fRainThunderProbability)
                {
                    float fDelay = m_Module.m_fRainMinThunderDelay + GameObject.RandomFloat(m_Module.m_fRainMaxThunderDelay - m_Module.m_fRainMinThunderDelay);
                    float fVolume = m_Module.m_fRainMinThunderVolume + GameObject.RandomFloat(m_Module.m_fRainMaxThunderVolume - m_Module.m_fRainMinThunderVolume);
                    String sThunderSound = GetRandomThunderSound();
                    if(sThunderSound != null)
                        AddThunderToQueque(sThunderSound, fDelay, fVolume);
                }
            }
            PlayThundersQueque();
        }
        if(m_RainListener == null)
            return;
        Vector vCameraPos = m_RainListener.GetPosition();
        float fHalfCube = m_Module.m_fRainCubeSize * 0.5F;
        float fMinHeight = FXRainHMapGetMinimalHeight(vCameraPos.fX - fHalfCube, vCameraPos.fX - fHalfCube, vCameraPos.fZ + fHalfCube, vCameraPos.fZ + fHalfCube);
        if(fMinHeight - fHalfCube > vCameraPos.fY)
            FXRainSetDensity(m_sRainName, 0.0D);
        else
            FXRainSetDensity(m_sRainName, m_Module.m_fRainDensity);
    }

    void StartFXRain()
    {
        AddRain(m_sRainName);
        FXRainSetCapacity(m_sRainName, m_Module.m_iRainDropsNumber);
        FXRainSetDensity(m_sRainName, m_Module.m_fRainDensity);
        FXRainSetDrawMode(m_sRainName, m_Module.m_iRainDrawMode);
        FXRainSetSortDrops(m_sRainName, m_Module.m_bRainSortDrops);
        FXRainSetMinVelocity(m_sRainName, m_Module.m_fRainMinVelocity);
        FXRainSetMaxVelocity(m_sRainName, m_Module.m_fRainMaxVelocity);
        FXRainSetDropsRotation(m_sRainName, m_Module.m_fRainDropsRotationMin, m_Module.m_fRainDropsRotationMax);
        FXRainSetDirection(m_sRainName, m_Module.m_vRainDirection);
        FXRainSetDirVariationAngle(m_sRainName, m_Module.m_fRainDirVariationAngle);
        FXRainSetMaterial(m_sRainName, m_Module.m_sRainMaterialName);
        FXRainSetTextureFrames(m_sRainName, m_Module.m_iRainTextureFramesX, m_Module.m_iRainTextureFramesY);
        FXRainSetDropSize(m_sRainName, m_Module.m_fRainDropWidth, m_Module.m_fRainDropHeight);
        FXRainSetAlpha(m_sRainName, m_Module.m_fRainAlpha);
        FXRainSetFadeDistanceStart(m_sRainName, m_Module.m_fRainFadeDistanceStart);
        FXRainSetTurbulencyAmplitude(m_sRainName, m_Module.m_fRainTurbulencyAmplitude);
        FXRainSetTurbulencySpeed(m_sRainName, m_Module.m_fRainTurbulencySpeed);
        FXRainSetCubeSize(m_sRainName, m_Module.m_fRainCubeSize);
        FXRainSetSplashProbability(m_sRainName, m_Module.m_fRainSplashProbability);
        FXRainSetWaterSplash(m_sRainName, m_Module.m_sRainWaterSplashFX);
        FXRainSetConcreteSplash(m_sRainName, m_Module.m_sRainConcreteSplashFX);
        StartRain(m_sRainName);
        m_bFXRainStarted = true;
    }

    public RainManager()
    {
        m_Module = null;
        m_RainListener = null;
        m_RainSpeaker = null;
        m_nEnvironmentSoundID = 0;
        m_fMinEnvSoundRange = 0.0F;
        m_fMaxEnvSoundRange = 0.0F;
        m_vstThunderSounds = new Vector(0);
        m_iNumThunderSounds = 0;
        m_bTSoundsArrayReady = false;
        m_vstThundersQueque = new Vector(0);
        m_bFXRainStarted = false;
        m_sRainName = "RainManagerRain";
    }

    public void RegisterRainObserver(Camera observer, float fMin, float fMax)
    {
        Module module = GetModule();
        if(!m_Module.m_bRainEnabled)
            return;
        if(m_RainSpeaker != null)
        {
            m_RainSpeaker.DeInit();
            m_RainSpeaker = null;
        }
        if(observer == null)
            return;
        m_RainSpeaker = (RainSpeaker)m_Module.CreateObject("RainSpeaker");
        observer.GetPosition(m_RainSpeaker.m_vWorldPosition);
        m_RainSpeaker.SetPositionWorld(m_RainSpeaker.m_vWorldPosition);
        m_RainSpeaker.ActivateOnModuleGridIndependent();
        m_RainSpeaker.m_RainObserver = observer;
        m_RainSpeaker.m_fSampleRadius = 200F;
        if(m_Module.m_bRainPlayEnvSound)
            if(m_Module.m_sRainEnvironmentSound.length() != 0)
            {
                m_fMinEnvSoundRange = fMin;
                m_fMaxEnvSoundRange = fMax;
                GameObject.CrashLog("Attaching rain's environment sound " + m_Module.m_sRainEnvironmentSound + " to speaker!\n");
                m_nEnvironmentSoundID = m_RainSpeaker.AttachSound(m_Module.m_sRainEnvironmentSound, fMin, fMax);
                m_RainSpeaker.SetSoundVolume(m_nEnvironmentSoundID, m_Module.m_fRainEnvironmentSoundVolume * 0.01F);
            } else
            {
                GameObject.CrashLog("Can't find rain's environment sound!\n");
            }
    }

    public void Deinit()
    {
        if(m_RainSpeaker != null)
        {
            m_RainSpeaker.DeInit();
            m_RainSpeaker = null;
        }
        m_Module = null;
    }

    public void ListenerGoesInToBuilding()
    {
    }

    void BuildThunderSounds()
    {
        Module module = GetModule();
        if(m_Module.m_sRainThunderSound1.length() > 0)
            m_vstThunderSounds.add(m_Module.m_sRainThunderSound1);
        if(m_Module.m_sRainThunderSound2.length() > 0)
            m_vstThunderSounds.add(m_Module.m_sRainThunderSound2);
        if(m_Module.m_sRainThunderSound3.length() > 0)
            m_vstThunderSounds.add(m_Module.m_sRainThunderSound3);
        if(m_Module.m_sRainThunderSound4.length() > 0)
            m_vstThunderSounds.add(m_Module.m_sRainThunderSound4);
        m_bTSoundsArrayReady = true;
    }

    public void Init(Module module)
    {
        m_Module = module;
        m_fLastTime = m_Module.GetTime();
        CallMethodEvery("Update", 1.0F);
    }

    String GetRandomThunderSound()
    {
        if(!m_bTSoundsArrayReady)
            BuildThunderSounds();
        int iRandSound = GameObject.RandomInt(m_vstThunderSounds.size());
        if(m_vstThunderSounds.size() == 0)
            return null;
        else
            return (String)m_vstThunderSounds.get(iRandSound);
    }

    void ShowLightningFlash()
    {
    }

    public void ListenerGoesToOpenSpace()
    {
    }

    Module m_Module;
    Camera m_RainListener;
    RainSpeaker m_RainSpeaker;
    int m_nEnvironmentSoundID;
    float m_fMinEnvSoundRange;
    float m_fMaxEnvSoundRange;
    Vector m_vstThunderSounds;
    int m_iNumThunderSounds;
    boolean m_bTSoundsArrayReady;
    Vector m_vstThundersQueque;
    float m_fLastTime;
    boolean m_bFXRainStarted;
    String m_sRainName;
}
