// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   SecurityCannon.java


public class SecurityCannon extends ChromeActor
    implements ISecuritySystemComponent, ICannonMesh
{

    public void SetFXSizeY(float fSizeY)
    {
        super.fFXSizeY = fSizeY;
    }

    public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        if(Assassin instanceof ChromeActor)
            ((ChromeActor)Assassin).NotifyHit(this, nDamageType);
        Damage(fDamage, nDamageType);
    }

    public void OnAudioReinitialize()
    {
        if(m_iSoundLoopId != 0)
        {
            m_iSoundLoopId = 0;
            AttachCannonSound();
        }
    }

    void AttachCannonSound()
    {
        if(m_CannonSoundName != null && m_iSoundLoopId == 0)
            m_iSoundLoopId = AttachSound(m_CannonSoundName, 1000F, 5000F);
    }

    public void UpdateRotationBarrel()
    {
        if(!super.bDead)
            UpdateCannonSounds(m_fCurrAngleSpeed);
        if(m_fCurrAngleAccel != 0.0F && m_iRevolvingBarrel != -1)
        {
            float fT = GetTime();
            m_fCurrAngleSpeed += (fT - m_fLastUpdateTime) * m_fCurrAngleAccel;
            if(m_fCurrAngleSpeed <= 0.0F)
            {
                m_fCurrAngleAccel = 0.0F;
                m_fCurrAngleSpeed = 0.0F;
            }
            if(m_fCurrAngleSpeed > _MAX_ANGLE_SPEED)
            {
                if(!m_bFiring)
                {
                    m_bFiring = true;
                    m_Cannon.SuperStartFire(m_iMode);
                    m_fCurrAngleAccel = _ANGLE_ACCEL;
                }
                m_fCurrAngleSpeed = _MAX_ANGLE_SPEED;
            }
            m_fCurrAngle += (fT - m_fLastUpdateTime) * m_fCurrAngleSpeed;
            RotateElementWithAnim(m_iRevolvingBarrel, Vector.Forward, m_fCurrAngle);
            m_fLastUpdateTime = fT;
        }
    }

    public SecurityCannon()
    {
        cSecuritySystem = null;
        bEnabledOnStart = true;
        nRoundShots = 30;
        fRateOfFire = 600F;
        fLongDelay = 0.5F;
        fFireRange = 2000F;
        fFireDamage = 60F;
        m_fMaxHAngle = 180F;
        m_fMinVAngle = -90F;
        m_fMaxVAngle = 30F;
        m_fRotationSpeedVert = 500F;
        m_fRotationSpeedHoriz = 500F;
        m_fShootVisibleDelay = 0.5F;
        m_Cannon = null;
        m_bIsEnabled = false;
        m_iRevolvingBarrel = -1;
        _MAX_ANGLE_SPEED = 1080F;
        _ANGLE_ACCEL = 2880F;
        m_fCurrAngle = 0.0F;
        m_fCurrAngleAccel = 0.0F;
        m_fCurrAngleSpeed = 0.0F;
        m_fLastUpdateTime = 0.0F;
        m_bFiring = false;
        m_iMode = 0;
        m_CannonSoundName = "Data/Sounds/Weapon/JeepCannonSpin";
        m_iSoundLoopId = 0;
        m_fMinCannonFreq = 0.7F;
        m_fMaxCannonFreq = 1.6F;
        super.fDamageThreshold = 100F;
        super.fHealth = 10000F;
        super.bIsAITarget = true;
    }

    public void FireStarted(byte iMode)
    {
        m_iMode = iMode;
        m_bFiring = false;
        m_fCurrAngleAccel = _ANGLE_ACCEL;
        m_fLastUpdateTime = GetTime();
    }

    public void Die()
    {
        super.Die();
        ExecuteFX("FXBlowBarrel", GetPosition());
        PlaySound("Data/Sounds/Weapon/GrenadeExplosion");
        DetachFromParentAndKeepWorldPos();
        Disable();
        EnableRendering(false);
        DeactivateOnModuleAlways();
        FreezeCallMethods();
        m_Cannon.Die();
        DetachCannonSound();
    }

    void DetachCannonSound()
    {
        if(m_iSoundLoopId != 0)
        {
            DetachSound(m_iSoundLoopId);
            m_iSoundLoopId = 0;
        }
    }

    public void SGUpdate()
    {
        super.SGUpdate();
        DetachCannonSound();
        if(m_bIsEnabled)
            Enable();
        else
            Disable();
        m_iSoundLoopId = 0;
    }

    public void Enable()
    {
        m_bIsEnabled = true;
        m_Cannon.StartAutonomicHuntingByUser(this);
    }

    void InitCannon()
    {
        m_Cannon = (ICannonController)CreateObject("CannonController");
        m_Cannon.InitController(this);
        m_Cannon.SetHorizAngSpeed(m_fRotationSpeedHoriz);
        m_Cannon.SetVertAngSpeed(m_fRotationSpeedVert);
        m_Cannon.SetFireParams(nRoundShots, fRateOfFire, fLongDelay, fFireRange, fFireDamage);
        m_Cannon.SetAccuracy(1.5F, 1.5F);
        m_Cannon.SetTargetFindingAngle(m_fMaxHAngle);
        m_Cannon.SetMaxHorizAngle(m_fMaxHAngle);
        m_Cannon.SetMinVertAngle(m_fMinVAngle);
        m_Cannon.SetMaxVertAngle(m_fMaxVAngle);
        m_Cannon.SetInitialFireDelay(m_fShootVisibleDelay);
    }

    void TakeDamage(float fDamage)
    {
        OnTakeDamage(fDamage, fDamage, null, null, null, 0, EnumDamageType._BULLET);
    }

    void UpdateCannonSounds(float fSpeed)
    {
        if(fSpeed == 0.0F && m_iSoundLoopId == 0)
            return;
        if(fSpeed == 0.0F)
        {
            DetachCannonSound();
            return;
        }
        if(m_iSoundLoopId == 0)
            AttachCannonSound();
        if(m_iSoundLoopId != 0)
        {
            float fFreq = m_fMinCannonFreq + ((m_fMaxCannonFreq - m_fMinCannonFreq) * fSpeed) / _MAX_ANGLE_SPEED;
            SetSoundFreq(m_iSoundLoopId, fFreq);
        }
    }

    public void SetFXSizeX(float fSizeX)
    {
        super.fFXSizeX = fSizeX;
    }

    public void LogState()
    {
        GameObject.CrashLog(GetName() + " enabled: " + m_bIsEnabled + " side: " + super.cConflictSide.GetValue() + "\n");
    }

    public void ChangeConflictSide(int nNewConflictSide)
    {
        super.ChangeConflictSide(nNewConflictSide);
        if(m_bIsEnabled)
            Enable();
    }

    public void SetFXZero(float fZero)
    {
        super.fFXZero = fZero;
    }

    public void Disable()
    {
        m_bIsEnabled = false;
        m_Cannon.StopAutonomicHunting();
    }

    void OnCreate()
    {
        super.OnCreate();
        super.bSG = true;
        InitCannon();
        m_iRevolvingBarrel = GetElementID("lufy");
        if(m_iRevolvingBarrel != -1)
        {
            SetElementAnimType(m_iRevolvingBarrel, (byte)3, false);
            SetAnimMorphTime("lufy", 0.0F);
        }
        SetTraceCollType(5);
        SetCollType(2);
        ClearFlag(4358);
        SetFlag(40);
        SetLighting(true);
        if(cSecuritySystem != null)
            cSecuritySystem.RegisterComponent(this);
        else
        if(bEnabledOnStart)
            Enable();
        else
            Disable();
    }

    public void FireStopped()
    {
        m_bFiring = false;
        m_fCurrAngleAccel = -_ANGLE_ACCEL;
    }

    public void SetFireParams(int nShots, float fRateOfFire, float fLongDelay, float fRange, float fDamage)
    {
        if(m_Cannon == null)
        {
            return;
        } else
        {
            m_Cannon.SetFireParams(nShots, fRateOfFire, fLongDelay, fRange, fDamage);
            return;
        }
    }

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[SecurityCannon.SGSaveChunk]\n");
        FileChunk cFC = GameObject.NewChunk(1537, cFCParent);
        super.SGSaveChunk(cFC);
        cFC.SaveObjectRef(cSecuritySystem);
        cFC.SaveBool(bEnabledOnStart);
        cFC.SaveInt(nRoundShots);
        cFC.SaveFloat(fRateOfFire);
        cFC.SaveFloat(fLongDelay);
        cFC.SaveFloat(fFireRange);
        cFC.SaveFloat(fFireDamage);
        cFC.SaveFloat(m_fMaxHAngle);
        cFC.SaveFloat(m_fMinVAngle);
        cFC.SaveFloat(m_fMaxVAngle);
        cFC.SaveFloat(m_fShootVisibleDelay);
        cFC.SaveObject((GameObject)m_Cannon);
        cFC.SaveBool(m_bIsEnabled);
        cFC.SaveFloat(m_fCurrAngle);
        cFC.SaveFloat(m_fCurrAngleAccel);
        cFC.SaveFloat(m_fCurrAngleSpeed);
        cFC.SaveFloat(m_fLastUpdateTime);
        cFC.SaveBool(m_bFiring);
        cFC.SaveByte(m_iMode);
        cFC.delete();
    }

    public void SetFXPosY(float fPosY)
    {
        super.fFXPosY = fPosY;
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[SecurityCannon.SGLoadChunk]\n");
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        if(cFC.GetID() == 1537)
        {
            super.SGLoadChunk(cFC);
            cSecuritySystem = (SecuritySystem)cFC.LoadObjectRef();
            bEnabledOnStart = cFC.LoadBool();
            nRoundShots = cFC.LoadInt();
            fRateOfFire = cFC.LoadFloat();
            fLongDelay = cFC.LoadFloat();
            fFireRange = cFC.LoadFloat();
            fFireDamage = cFC.LoadFloat();
            m_fMaxHAngle = cFC.LoadFloat();
            m_fMinVAngle = cFC.LoadFloat();
            m_fMaxVAngle = cFC.LoadFloat();
            m_fShootVisibleDelay = cFC.LoadFloat();
            m_Cannon = (ICannonController)cFC.LoadObject(m_Cannon, this);
            m_bIsEnabled = cFC.LoadBool();
            m_fCurrAngle = cFC.LoadFloat();
            m_fCurrAngleAccel = cFC.LoadFloat();
            m_fCurrAngleSpeed = cFC.LoadFloat();
            m_fLastUpdateTime = cFC.LoadFloat();
            m_bFiring = cFC.LoadBool();
            m_iMode = cFC.LoadByte();
        }
        cFC.delete();
    }

    public int GetRole()
    {
        return super.Role;
    }

    public void OnFrame()
    {
        UpdateRotationBarrel();
    }

    public SecuritySystem cSecuritySystem;
    public boolean bEnabledOnStart;
    public int nRoundShots;
    public float fRateOfFire;
    public float fLongDelay;
    public float fFireRange;
    public float fFireDamage;
    public float m_fMaxHAngle;
    public float m_fMinVAngle;
    public float m_fMaxVAngle;
    public float m_fRotationSpeedVert;
    public float m_fRotationSpeedHoriz;
    public float m_fShootVisibleDelay;
    protected ICannonController m_Cannon;
    protected boolean m_bIsEnabled;
    int m_iRevolvingBarrel;
    float _MAX_ANGLE_SPEED;
    float _ANGLE_ACCEL;
    float m_fCurrAngle;
    float m_fCurrAngleAccel;
    float m_fCurrAngleSpeed;
    float m_fLastUpdateTime;
    boolean m_bFiring;
    byte m_iMode;
    String m_CannonSoundName;
    int m_iSoundLoopId;
    float m_fMinCannonFreq;
    float m_fMaxCannonFreq;
}
