// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   Species.java

import java.util.Vector;

public class Species
{

    public boolean LoadData(String sFileName)
    {
        ParseKeyword root = GameObject.ParseFile(sFileName);
        if(root == null)
        {
            GameObject.CrashLog("No file !\n");
            return false;
        }
        for(ParseKeyword key = root; key != null; key = key.GetNext())
        {
            if(key.Equals("Name"))
                m_sName = key.GetSParam(0);
            if(key.Equals("Mesh"))
                m_sMeshFileName = key.GetSParam(0);
            if(key.Equals("AdverbSpace"))
                LoadAdverbSpace(key);
            if(key.Equals("ActivityGraph"))
                LoadActivityGraph(key);
        }

        root.delete();
        return true;
    }

    public void LoadAdverbSpace(ParseKeyword adverbSpace)
    {
        for(ParseKeyword adverb = adverbSpace.GetChild(); adverb != null; adverb = adverb.GetNext())
            if(adverb.Equals("Adverb"))
            {
                m_advSpace.AddAdverb(adverb.GetSParam(0));
                for(ParseKeyword value = adverb.GetChild(); value != null; value = value.GetNext())
                    if(value.Equals("Value"))
                        m_advSpace.AddValue(adverb.GetSParam(0), value.GetSParam(0));

            }

    }

    public void LoadActivityGraph(ParseKeyword actGraph)
    {
        for(ParseKeyword object = actGraph.GetChild(); object != null; object = object.GetNext())
        {
            if(object.Equals("Verb"))
            {
                Verb verb = new Verb();
                String sName = object.GetSParam(0);
                verb.SetName(sName);
                for(ParseKeyword attrib = object.GetChild(); attrib != null; attrib = attrib.GetNext())
                {
                    if(attrib.Equals("StartAnimations"))
                        verb.SetStartAnimations(ReadAnims(attrib));
                    if(attrib.Equals("InnerAnimations"))
                        verb.SetInnerAnimations(ReadAnims(attrib));
                    if(attrib.Equals("EndAnimations"))
                        verb.SetEndAnimations(ReadAnims(attrib));
                    if(attrib.Equals("Sounds"))
                        verb.SetSounds(ReadSounds(attrib));
                    if(attrib.Equals("Stable"))
                        verb.m_bStable = attrib.GetIParam(0) != 0;
                    if(attrib.Equals("MorphTime"))
                        verb.m_fMorphTime = attrib.GetFParam(0);
                    if(attrib.Equals("AngleSpeed"))
                        verb.m_AngleSpeed = attrib.GetFParam(0);
                    if(attrib.Equals("Physics"))
                    {
                        verb.m_bPhysic = attrib.GetIParam(0) != 0;
                        verb.m_nPhysicType = attrib.GetIParam(1);
                    }
                }

                AddVerb(verb);
            }
            if(object.Equals("Transition"))
            {
                Transition trans = new Transition();
                String sSource = object.GetSParam(0);
                String sName = object.GetSParam(1);
                trans.SetVerb(GetVerb(sName));
                trans.SetName(sName);
                trans.SetPredecessor(sSource);
                for(ParseKeyword attrib = object.GetChild(); attrib != null; attrib = attrib.GetNext())
                {
                    if(attrib.Equals("Animations"))
                        trans.SetAnimations(ReadAnims(attrib));
                    if(attrib.Equals("Sounds"))
                        trans.SetSounds(ReadSounds(attrib));
                    if(attrib.Equals("Probability"))
                        trans.m_fProbability = attrib.GetFParam(0);
                    if(attrib.Equals("MorphTime"))
                        trans.m_fMorphTime = attrib.GetFParam(0);
                    if(attrib.Equals("Physics"))
                    {
                        trans.m_bPhysic = attrib.GetIParam(0) != 0;
                        trans.m_nPhysicType = attrib.GetIParam(1);
                    }
                }

                AddTransition(trans);
                Verb verb = GetVerb(sSource);
                verb.AddTransition(trans);
            }
        }

    }

    MediaList ReadSounds(ParseKeyword soundNode)
    {
        MediaList sounds = new MediaList();
        int nSizeContext = m_advSpace.GetDimension();
        for(ParseKeyword node = soundNode.GetChild(); node != null; node = node.GetNext())
            if(node.Equals("Sound"))
            {
                Sound sound = new Sound(node.GetSParam(0));
                Context context = new Context(nSizeContext);
                for(ParseKeyword subnode = node.GetChild(); subnode != null; subnode = subnode.GetNext())
                {
                    if(subnode.Equals("Context"))
                    {
                        for(int c = 0; c < nSizeContext; c++)
                            context.SetValue(subnode.GetSParam(0), subnode.GetSParam(1), m_advSpace);

                    }
                    if(subnode.Equals("Length"))
                        sound.m_fLength = subnode.GetFParam(0);
                    if(subnode.Equals("RangeMin"))
                        sound.m_fRangeMin = subnode.GetFParam(0);
                    if(subnode.Equals("RangeMax"))
                        sound.m_fRangeMax = subnode.GetFParam(0);
                    if(subnode.Equals("Pause"))
                        sound.m_fPause = subnode.GetFParam(0);
                    if(subnode.Equals("Cyclic"))
                        sound.m_bIsCyclic = subnode.GetIParam(0) != 0;
                }

                sound.SetPattContext(context);
                sounds.AddObject(sound);
            }

        return sounds;
    }

    public int GetVerbCount()
    {
        return m_verbs.size();
    }

    Species()
    {
        m_sName = null;
        m_verbs = null;
        m_transitions = null;
        m_advSpace = new AdverbSpace();
        m_verbs = new Vector();
        m_transitions = new Vector();
    }

    public String GetName()
    {
        return m_sName;
    }

    public void AddVerb(Verb verb)
    {
        m_verbs.addElement(verb);
    }

    public Verb GetVerb(String sName)
    {
        int nIndex = -1;
        int nSize = m_verbs.size();
        for(int i = 0; i < nSize; i++)
        {
            Verb verb = (Verb)m_verbs.elementAt(i);
            if(!sName.equals(verb.GetName()))
                continue;
            nIndex = i;
            break;
        }

        if(nIndex == -1)
            return null;
        else
            return (Verb)m_verbs.elementAt(nIndex);
    }

    public Verb GetVerb(int nIndex)
    {
        if(m_verbs.size() > 0)
            return (Verb)m_verbs.elementAt(nIndex);
        else
            return null;
    }

    public void AddTransition(Transition trans)
    {
        m_transitions.addElement(trans);
    }

    public Transition GetTransition(String sSource, String sDest)
    {
        int nIndex = -1;
        int nSize = m_transitions.size();
        for(int i = 0; i < nSize; i++)
        {
            Transition trans = (Transition)m_transitions.elementAt(i);
            String sSourceName = trans.GetPredecessor();
            String sDestName = trans.GetName();
            if(!sSourceName.equals(sSourceName) || !sDest.equals(sDestName))
                continue;
            nIndex = i;
            break;
        }

        if(nIndex == -1)
            return null;
        else
            return (Transition)m_transitions.elementAt(nIndex);
    }

    public Transition GetTransition(int nIndex)
    {
        if(m_transitions.size() > 0)
            return (Transition)m_transitions.elementAt(nIndex);
        else
            return null;
    }

    public int GetTransCount()
    {
        return m_transitions.size();
    }

    MediaList ReadAnims(ParseKeyword animNode)
    {
        MediaList animations = new MediaList();
        int nSizeContext = m_advSpace.GetDimension();
        for(ParseKeyword node = animNode.GetChild(); node != null; node = node.GetNext())
            if(node.Equals("Animation"))
            {
                Animation anim = new Animation(node.GetSParam(0));
                Context context = new Context(nSizeContext);
                for(ParseKeyword subnode = node.GetChild(); subnode != null; subnode = subnode.GetNext())
                {
                    if(subnode.Equals("Context"))
                        context.SetValue(subnode.GetSParam(0), subnode.GetSParam(1), m_advSpace);
                    if(subnode.Equals("Speed"))
                        anim.m_fSpeed = subnode.GetFParam(0);
                    if(subnode.Equals("Frequency"))
                        anim.m_fFrequency = subnode.GetFParam(0);
                }

                anim.SetPattContext(context);
                animations.AddObject(anim);
            }

        return animations;
    }

    void Show()
    {
        if(m_advSpace != null)
            m_advSpace.Show();
        else
            GameObject.LogLine(" No adverb space ");
        GameObject.LogLine("VERBS : ");
        for(int i = 0; i < m_verbs.size(); i++)
        {
            Verb cVerb = (Verb)m_verbs.elementAt(i);
            cVerb.Show();
        }

        GameObject.LogLine("TRANSITIONS : ");
        for(int i = 0; i < m_transitions.size(); i++)
        {
            Transition cTrans = (Transition)m_transitions.elementAt(i);
            cTrans.Show();
        }

    }

    void delete()
    {
        if(m_advSpace != null)
            m_advSpace.delete();
        m_advSpace = null;
        if(m_transitions != null)
        {
            for(int i = 0; i < m_transitions.size(); i++)
                ((Transition)m_transitions.elementAt(i)).delete();

            m_transitions.removeAllElements();
            m_transitions = null;
        }
        if(m_verbs != null)
        {
            for(int i = 0; i < m_verbs.size(); i++)
                ((Verb)m_verbs.elementAt(i)).delete();

            m_verbs.removeAllElements();
            m_verbs = null;
        }
    }

    String m_sName;
    AdverbSpace m_advSpace;
    String m_sMeshFileName;
    Vector m_verbs;
    Vector m_transitions;
}
