// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   Speeder.java


public class Speeder extends VehicleCar
{

    public void ActivateVehicle(boolean bActivate, boolean bGridIndependent, boolean bActivatePhysics)
    {
        super.ActivateVehicle(bActivate, bGridIndependent, bActivatePhysics);
        if(m_bEnginesOn)
            if(bActivate)
                TurnEngines(true);
            else
                StopEngineFXes();
    }

    void TurnEngines(boolean bTurn)
    {
        m_bEnginesOn = bTurn;
        StopEngineFXes();
        if(bTurn)
            CallMethodEvery("BurnEngines", _UPDATE_ENGINE_TIME);
    }

    void BurnEngines()
    {
        for(int i = 0; i < _NOF_ENGINES; i++)
            aEnginesRunTimeFXes[i] = ExecuteFX(this, aEngines[i], _ENGINES_EXHAUST, new Vector());

    }

    Speeder()
    {
        _UPDATE_ENGINE_TIME = 0.1F;
        _NOF_ENGINES = 18;
        aEngines = null;
        aEnginesRunTimeFXes = null;
        m_bEnginesOn = false;
        m_fOldTurningValue = 0.0F;
        bWereEnginesOn = false;
        bIsInMovie = false;
        super.m_sSoundAccelName = null;
        super.m_sSoundBrakeName = null;
        super.m_sSoundSlideName = null;
        super.m_sSoundStartName = null;
        super.m_sSoundLoopName = "Data/Sounds/Vehicles/shuttle";
        super.m_sSoundStopName = null;
        super.fBlobMapSize = 275F;
        super.sBlobMaterial = "blobs_speeder.mat";
        super.m_fObservedSightVAngle = 15F;
        super.m_fOverObservedHeight = 200F;
        super.m_fOverObservedBack = 650F;
        super.m_aSpeeds = (new float[] {
            0, 300F, 900F, 1500F, 2250F, 3000F
        });
        super.m_iStampSize = 13;
        super.fBlowUpShakeStrength = 300F;
        super.fBlowUpShakeDistMin = 500F;
        super.fBlowUpShakeDistMax = 2000F;
    }

    public boolean IsArmed()
    {
        return false;
    }

    public Vector GetPointToLookAt(int nPoint)
    {
        Vector vPoint = GetPosition();
        vPoint.fY += 100F;
        return vPoint;
    }

    public void Die()
    {
        super.Die();
        TurnEngines(false);
    }

    public void SGUpdate()
    {
        FileChunk.Log("[Speeder.SGSaveChunk]\n");
        super.SGUpdate();
        boolean bEnginesOn = m_bEnginesOn;
        TurnEngines(false);
        if((super.CurrentState instanceof Vehicle.MovieSimulateState) || bEnginesOn)
            TurnEngines(true);
        if(bIsInMovie)
            m_bEnginesOn = bWereEnginesOn;
    }

    void CheckRadiuses()
    {
        if(super.m_VehiclePath != null)
        {
            for(int i = 0; i < super.m_VehiclePath.GetPointsNum(); i++)
                if(super.m_VehiclePath.GetPoint(i).fRadius == 0.0F)
                    super.m_VehiclePath.GetPoint(i).fRadius = 300F;

        }
    }

    void StopEngineFXes()
    {
        DeleteAttachedFXes();
        DisableCallMethod("BurnEngines");
        for(int i = 0; i < aEnginesRunTimeFXes.length; i++)
            if(aEnginesRunTimeFXes[i] != 0)
                DeleteFXSequence(aEnginesRunTimeFXes[i]);

    }

    void SetVehicleParamsForPatrol()
    {
        super.SetVehicleParamsForPatrol();
        m_fOldTurningValue = super.m_Physics.m_Params._MAX_TURN_ANGLE;
        super.m_Physics.m_Params._MAX_TURN_ANGLE = 120F;
    }

    void RestoreVehicleParamsBeforePatrol()
    {
        super.RestoreVehicleParamsBeforePatrol();
        super.m_Physics.m_Params._MAX_TURN_ANGLE = m_fOldTurningValue;
    }

    public void PawnGotOut(SeatInfo info, Pawn pawn)
    {
        super.PawnGotOut(info, pawn);
        TurnEngines(false);
    }

    void CreatePhysics()
    {
        super.m_Physics = new PhysicsSpeeder(this);
        super.m_Physics.Init();
    }

    void GetTriggerExtents(Camera cam, Vector vMinExtent, Vector vMaxExtent)
    {
        GetScreenExtents(cam, vMinExtent, vMaxExtent);
    }

    public void PawnGotIn(SeatInfo info, Pawn pawn)
    {
        super.PawnGotIn(info, pawn);
        TurnEngines(true);
    }

    void SetUpEngines()
    {
        aEngines = new int[_NOF_ENGINES];
        aEnginesRunTimeFXes = new int[_NOF_ENGINES];
        for(int i = 0; i < 9; i++)
            aEngines[i] = GetElementID("LEngine0" + Integer.toString(i + 1));

        for(int i = 0; i < 9; i++)
            aEngines[i + 9] = GetElementID("REngine0" + Integer.toString(i + 1));

        for(int i = 0; i < aEnginesRunTimeFXes.length; i++)
            aEnginesRunTimeFXes[i] = 0;

    }

    void OnCreate()
    {
        super.OnCreate();
        SetUnImportanceFactor(0.0F);
        DeleteAllSeatsInfos();
        SeatInfo seatInfo = new SeatInfo(this, "Driver", 0, EGetInOutAnimType._UNKNOWN, new Vector(250F, 0.0F, 0.0F));
        seatInfo.m_fBeginPosRadius = 500F;
        AddSeatInfo(seatInfo);
        if(super.m_Physics != null)
        {
            super.m_Physics.m_Params._TIME_BETWEEN_SLIDE_SOUNDS = 0.15F;
            super.m_Physics.m_Params._TIME_BETWEEN_ACCEL_SOUNDS = 0.1F;
            super.m_Physics.m_Params._SLIDE_SUPRESS = 700F;
            super.m_Physics.m_Params._ACCELERATION_COEF = 1500F;
            super.m_Physics.m_Params._TREE_HIT_SUPR = 0.2F;
            super.m_Physics.m_Params._TURNING_SPEED = 2000F;
            super.m_Physics.m_Params._MAX_TURN_ANGLE = 90F;
            super.m_Physics.m_Params._WHEEL_MOVE_SPEED_COEF = 1.0F;
            super.m_Physics.m_Params.SetMaxSpeed(3000F);
            super.m_Physics._HEIGHT_OVER_GROUND = 100F;
            super.m_Physics.m_Params._MAX_HORIZ_DEV = 20F;
            super.m_Physics.m_Params._HORIZ_DEV_ACCEL = 60F;
            super.m_Physics.m_bFlyOverWater = true;
        }
        SetFlag(256);
        SetBlobMaterial(super.sBlobMaterial);
        SetBlobMapSize(super.fBlobMapSize);
        SetTraceCollType(5);
        SetCollType(2);
        SetUpEngines();
        super.sBlowUpFX = "FXJeepBlow";
        super.m_fAttenuation = 0.92F;
        super.m_fForceFactor = 100F;
        super.m_fAmplitudeCoeff = 0.3F;
        super.m_fDownTestVectorLen = -350F;
    }

    public void SetVehicleForMovie(boolean bIsInMovie, boolean bPlayEngineStartStopSound)
    {
        super.SetVehicleForMovie(bIsInMovie, bPlayEngineStartStopSound);
        this.bIsInMovie = bIsInMovie;
        if(bIsInMovie)
        {
            bWereEnginesOn = m_bEnginesOn;
            TurnEngines(true);
        } else
        {
            TurnEngines(bWereEnginesOn);
        }
    }

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[Speeder.SGSaveChunk]\n");
        FileChunk cFC = GameObject.NewChunk(1612, cFCParent);
        super.SGSaveChunk(cFC);
        cFC.SaveBool(m_bEnginesOn);
        cFC.SaveBool(bWereEnginesOn);
        cFC.SaveBool(bIsInMovie);
        cFC.delete();
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[Speeder.SGLoadChunk]\n");
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        if(cFC.GetID() == 1612)
        {
            super.SGLoadChunk(cFC);
            m_bEnginesOn = cFC.LoadBool();
            bWereEnginesOn = cFC.LoadBool();
            bIsInMovie = cFC.LoadBool();
        }
        cFC.delete();
    }

    public boolean IsActive(ControlObject Activator)
    {
        if(!super.bActiveTrigger)
            return false;
        if(Activator == GetFirstOccupant(0))
            return false;
        else
            return GetFirstOccupant(0) == null && super.fHealth > 0.0F && super.m_bCanDrive;
    }

    float _UPDATE_ENGINE_TIME;
    static String _ENGINES_EXHAUST = "FXFlyerEngine";
    int _NOF_ENGINES;
    int aEngines[];
    int aEnginesRunTimeFXes[];
    boolean m_bEnginesOn;
    float m_fOldTurningValue;
    private boolean bWereEnginesOn;
    private boolean bIsInMovie;

}
