// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   Spring.java


public class Spring
    implements ISaveGame
{

    Vector GetAttenuation()
    {
        return m_Attenuation;
    }

    void SetInducedStateThreshold(float fThreshold)
    {
        m_fInducedStateThreshold = fThreshold;
        m_bInducedStateDirty = true;
    }

    float GetInducedStateThreshold()
    {
        return m_fInducedStateThreshold;
    }

    Vector GetPosition()
    {
        return m_X;
    }

    Vector GetVelocity()
    {
        return m_V;
    }

    void AddVelocity(Vector Vel)
    {
        m_V.Add(Vel);
        m_bInducedStateDirty = true;
    }

    void AddVelocity(float fX, float fY, float fZ)
    {
        m_V.fX += fX;
        m_V.fY += fY;
        m_V.fZ += fZ;
        m_bInducedStateDirty = true;
    }

    void Calculate(float fTime)
    {
        if(fTime > 0.0F)
            for(m_fRetainedTime += fTime; m_fRetainedTime >= 0.01F; m_fRetainedTime -= 0.01F)
                InternalCalculate(0.01F);

    }

    public void SGUpdate()
    {
    }

    Spring()
    {
        m_X = null;
        m_V = null;
        m_A = null;
        m_ForceFactor = null;
        m_Attenuation = null;
        m_fInducedStateThreshold = 0.01F;
        m_bIsInduced = false;
        m_bInducedStateDirty = true;
        m_X = new Vector(0.0F, 0.0F, 0.0F);
        m_V = new Vector(0.0F, 0.0F, 0.0F);
        m_A = new Vector(0.0F, 0.0F, 0.0F);
        m_fRetainedTime = 0.0F;
        m_ForceFactor = new Vector(30F, 30F, 30F);
        m_Attenuation = new Vector(0.9F, 0.9F, 0.9F);
    }

    Vector GetForceFactor()
    {
        return m_ForceFactor;
    }

    void ApplySpringForce()
    {
        m_A.fX = -m_X.fX * m_ForceFactor.fX;
        m_A.fY = -m_X.fY * m_ForceFactor.fY;
        m_A.fZ = -m_X.fZ * m_ForceFactor.fZ;
    }

    boolean IsInduced()
    {
        if(m_bIsInduced || m_bInducedStateDirty)
        {
            m_bIsInduced = Math.abs(m_A.fX) >= m_fInducedStateThreshold || Math.abs(m_A.fY) >= m_fInducedStateThreshold || Math.abs(m_A.fZ) >= m_fInducedStateThreshold || Math.abs(m_V.fX) >= m_fInducedStateThreshold || Math.abs(m_V.fY) >= m_fInducedStateThreshold || Math.abs(m_V.fZ) >= m_fInducedStateThreshold || Math.abs(m_X.fX) >= m_fInducedStateThreshold || Math.abs(m_X.fY) >= m_fInducedStateThreshold || Math.abs(m_X.fZ) >= m_fInducedStateThreshold;
            m_bInducedStateDirty = false;
        }
        return m_bIsInduced;
    }

    void SetAttenuation(Vector Attenuation)
    {
        m_Attenuation.Set(Attenuation);
    }

    void InternalCalculate(float fTime)
    {
        ApplySpringForce();
        m_V.fX += m_A.fX * fTime;
        m_V.fY += m_A.fY * fTime;
        m_V.fZ += m_A.fZ * fTime;
        m_X.fX += m_V.fX * fTime;
        m_X.fY += m_V.fY * fTime;
        m_X.fZ += m_V.fZ * fTime;
        m_V.fX *= m_Attenuation.fX;
        m_V.fY *= m_Attenuation.fY;
        m_V.fZ *= m_Attenuation.fZ;
    }

    void SetVelocity(Vector Vel)
    {
        m_V.Set(Vel);
        m_bInducedStateDirty = true;
    }

    void SetVelocity(float fX, float fY, float fZ)
    {
        m_V.fX = fX;
        m_V.fY = fY;
        m_V.fZ = fZ;
        m_bInducedStateDirty = true;
    }

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[Spring.SGSaveChunk]\n");
        FileChunk cFC = GameObject.NewChunk(1202, cFCParent);
        cFC.SaveVector(m_X);
        cFC.SaveVector(m_V);
        cFC.SaveVector(m_A);
        cFC.SaveVector(m_ForceFactor);
        cFC.SaveVector(m_Attenuation);
        cFC.SaveFloat(m_fRetainedTime);
        cFC.SaveFloat(m_fInducedStateThreshold);
        cFC.delete();
    }

    void SetForceFactor(Vector ForceFactor)
    {
        m_ForceFactor.Set(ForceFactor);
        m_bInducedStateDirty = true;
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[Spring.SGLoadChunk]\n");
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        if(cFC.GetID() == 1202)
        {
            m_X = cFC.LoadVector();
            m_V = cFC.LoadVector();
            m_A = cFC.LoadVector();
            m_ForceFactor = cFC.LoadVector();
            m_Attenuation = cFC.LoadVector();
            m_fRetainedTime = cFC.LoadFloat();
            m_fInducedStateThreshold = cFC.LoadFloat();
            m_bInducedStateDirty = true;
        }
        cFC.delete();
    }

    void SetPosition(Vector Pos)
    {
        m_X.Set(Pos);
        m_bInducedStateDirty = true;
    }

    Vector m_X;
    Vector m_V;
    Vector m_A;
    Vector m_ForceFactor;
    Vector m_Attenuation;
    float m_fRetainedTime;
    static final float CONSTANT_TIME_GRAIN = 0.01F;
    protected float m_fInducedStateThreshold;
    protected boolean m_bIsInduced;
    protected boolean m_bInducedStateDirty;
}
