// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   Vehicle.java

import java.util.ArrayList;
import java.util.StringTokenizer;

public class Vehicle extends ChromeActor
    implements IDrivenVehicle, ISeatVehicle, ipar_MotionSpeed, ipar_MovieVehicle
{
    public class DrivenState extends State
    {

        public void OnEnter()
        {
            if(m_bGameLoading)
            {
                m_bGameLoading = false;
                return;
            }
            Pawn driver = GetFirstOccupant(0);
            if(driver instanceof ChromeActor)
                nTeamID = ((ChromeActor) (driver)).nTeamID;
            fLastT = m_bModuleNet ? GetModule().GetPhysicsLastUpdateTime() : GetTime();
            SetPhysicsLastUpdateTime(fLastT);
            SetPhysicsVehicleActive(true);
            if(m_bModuleNet && driver != null && ((GameObject) (driver)).bNetIsOwner)
                RegisterKeyRequest();
        }

        public void OnFrame()
        {
            GlobalOnFrame();
            Simulate(true);
            MakeVehicleNoise();
        }

        public DrivenState()
        {
        }
    }

    public class UncaredDriveState extends State
    {

        public void OnEnter()
        {
            if(m_bGameLoading)
            {
                m_bGameLoading = false;
                return;
            } else
            {
                GameObject.LogLine("[Vehicle.UncaredDriveState]");
                nTeamID = 0;
                motion.Stop();
                InitPhysicsParamsFromVehicle();
                return;
            }
        }

        public void OnFrame()
        {
            GlobalOnFrame();
            if(m_Physics != null && m_Physics.m_fCurrSpeed == 0.0F)
                SetState("StillState");
            Simulate(false);
            MakeVehicleNoise();
        }

        public UncaredDriveState()
        {
        }
    }

    public class CrashedState extends State
    {

        void OnTakeDamage(float f, float f1, GameObject gameobject, Vector vector, Vector vector1, int i, int j)
        {
        }

        public void OnEnter()
        {
            if(m_bGameLoading)
            {
                m_bGameLoading = false;
                return;
            }
            SetPhysicsVehicleActive(false);
            nTeamID = 0;
            Vector vTemp = GetPosition();
            vTemp.Add(m_vPositionModifier);
            ExecuteFX(sBlowUpFX, vTemp, m_vFXDir);
            ExecuteParticleSystem(sBlowUpFX, vTemp, m_vFXParticlesDir);
            PlaySound(sBlowUpSound);
            if(fBlowUpShakeStrength > 0.0F)
                ShakePlayersCamera(fBlowUpShakeStrength, fBlowUpShakeDistMin, fBlowUpShakeDistMax);
            CallMethodIn("DisableAllActivities", 0.2F);
        }

        public void DisableAllActivities()
        {
            EnableRendering(false);
            DeactivateOnModuleAlways();
            DisableCallMethods();
            CallMethodIn("DeleteAttachedFXes", 10F);
        }

        public CrashedState()
        {
        }
    }

    public class StillState extends State
    {

        public void OnEnter()
        {
            if(m_bGameLoading)
            {
                m_bGameLoading = false;
                return;
            }
            nTeamID = 0;
            if(m_bModuleNet)
                UnregisterKeyRequest();
        }

        public void OnFrame()
        {
            GlobalOnFrame();
        }

        public StillState()
        {
        }
    }

    public class PatrolPathState extends State
    {

        public void OnEnter()
        {
            if(m_bGameLoading)
            {
                m_bGameLoading = false;
                return;
            }
            m_bIsPatrolling = true;
            fLastT = GetTime();
            if(!m_bPhysicsActive)
                SetPhysicsVehicleActive(true);
            m_iCurrPatrolPoint = 0;
            m_iAddValue = 1;
            m_bDriveFinished = false;
            motion.iAcc = 1;
        }

        public void OnFrame()
        {
            GlobalOnFrame();
            SimulatePathMove();
            MakeVehicleNoise();
        }

        public PatrolPathState()
        {
        }
    }

    public class MovieSimulateState extends State
    {

        public void MovieSimulate()
        {
            if(!m_bSimulate)
                return;
            float fCurrentT = GetTime();
            float fdT = fCurrentT - fLastT;
            if(fdT == 0.0F)
                return;
            if(fdT > 1.0F)
            {
                fLastT = fCurrentT;
                return;
            }
            Vector vPos = GetPosition();
            float fSpeed = vPos.Distance(m_vLastPos) / fdT;
            m_vLastPos.Set(vPos);
            Vector vForward = GetForwardVector();
            float fAngle = 0.0F;
            Vector vUpDir = null;
            if(vForward.Distance(m_vLastDir) > 1E-04F)
            {
                vUpDir = m_vLastDir.Cross(vForward);
                vUpDir.Normalize();
                fAngle = (float)Math.acos(vForward.Dot(m_vLastDir)) * Vehicle.RAD_TO_DEG;
                if(vUpDir.fY > 0.0F)
                    fAngle *= -1F;
            }
            float fAngleSpeed = fAngle / fdT;
            if(m_Physics != null && m_bPhysicsActive)
            {
                SetAllFramePeriod(fdT);
                for(float fTimePeriod = GetNextTimePeriod(); fTimePeriod > 0.0F; fTimePeriod = GetNextTimePeriod())
                    m_Physics.MovieSimulate(fSpeed, fAngleSpeed, fTimePeriod);

            }
            m_vLastDir.Set(vForward);
            fLastT = fCurrentT;
        }

        public void OnEnter()
        {
            if(m_bGameLoading)
            {
                m_bGameLoading = false;
                return;
            }
            fLastT = GetTime();
            if(!m_bPhysicsActive)
                SetPhysicsVehicleActive(true);
            m_vLastPos = GetPosition();
            m_vLastDir = GetForwardVector();
        }

        public void OnFrame()
        {
            GlobalOnFrame();
            MovieSimulate();
            if(m_bMakeVehicleNoiseInMovie)
                MakeVehicleNoise();
        }

        public MovieSimulateState()
        {
        }
    }


    public SeatInfo[] GetSeats()
    {
        int nNum = aSeatsInfo.size();
        if(nNum == 0)
            return null;
        SeatInfo tab[] = new SeatInfo[nNum];
        for(int i = 0; i < aSeatsInfo.size(); i++)
            tab[i] = (SeatInfo)aSeatsInfo.get(i);

        return tab;
    }

    void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        if(super.Role < 4)
            return;
        if(Assassin instanceof ChromeActor)
            ((ChromeActor)Assassin).NotifyHit(this, nDamageType);
        if(super.bDead)
        {
            return;
        } else
        {
            Damage(fDamage, nDamageType);
            float fOccupantsDamage = m_fOccupantsDamageMul * fDamage;
            OccupantsDamage(fOccupantsDamage, Assassin);
            CheckCanDrive();
            return;
        }
    }

    public boolean IsRelevantConstans()
    {
        return false;
    }

    void SetMotionMoveFromKeysState(Player cDriver)
    {
        if(cDriver == null || !((GameObject) (cDriver)).bNetIsOwner)
            return;
        if(motion == null)
        {
            return;
        } else
        {
            motion.SetMoveFromKeysState(GetKeyState(EGameControl.FORWARD), GetKeyState(EGameControl.BACKWARD), GetKeyState(EGameControl.STRAFE_RIGHT), GetKeyState(EGameControl.STRAFE_LEFT));
            return;
        }
    }

    void VehicleCrashed()
    {
        SeatInfo seats[] = GetSeats();
        if(seats != null)
        {
            for(int i = 0; i < seats.length; i++)
                seats[i].SetCanGetOut(true);

        }
        Pawn tab[] = GetAllOccupants();
        if(tab != null)
        {
            for(int i = 0; i < tab.length; i++)
                tab[i].VehicleCrashed();

        }
        StopFXSmokeUpdate();
        SetState("CrashedState");
        SetCorrectPosOnRender(false);
        super.bActiveTrigger = false;
        super.bIsActiveTarget = false;
        if(super.Role == 4)
        {
            CheckAddVehicleToAutoRespawn();
            MsgSendClientCrash();
        }
    }

    void MsgRecvServerCollision()
    {
        float fDamage = MessageUnPackFloat();
        int iVehicleId = MessageUnPackInt();
        MessageEnd();
        Vehicle damagedVehicle = (Vehicle)GetObjectByNetId(iVehicleId);
        damagedVehicle.TakeDamage(fDamage, EnumDamageType._BULLET);
    }

    void AttachLoopSound()
    {
        if(m_sSoundLoopName != null && m_nSoundLoopId == 0 && m_bSoundsStarted)
        {
            m_nSoundLoopId = AttachSound(m_sSoundLoopName, m_fSoundLoopMin, m_fSoundLoopMax);
            UpdateSounds();
            m_bEngineOn = true;
        }
    }

    int GetAllOccupantsNum()
    {
        int nNum = 0;
        for(int i = 0; i < aSeatsInfo.size(); i++)
        {
            SeatInfo info = (SeatInfo)aSeatsInfo.get(i);
            if(info.IsOccupied())
                nNum++;
        }

        return nNum;
    }

    void HitSound()
    {
        if(m_sSoundHitName != null)
            PlaySound(m_sSoundHitName);
    }

    void AccelSound()
    {
        if(m_sSoundAccelName != null)
            PlaySound(m_sSoundAccelName);
    }

    void BrakeSound()
    {
        if(m_sSoundBrakeName != null)
            PlaySound(m_sSoundBrakeName);
    }

    float GetInterpolateSpeed()
    {
        return m_Physics.m_Params.GetMaxSpeed() * super.m_fInterpolateSpeedOnMoveMul;
    }

    public void Disable()
    {
        super.Disable();
        SetCanGetOut(false);
    }

    void ServerRespawn(VehicleSpawnInfo cSpawnInfo, float fDelayTime, boolean bOnLevelRestart)
    {
        ForceStillState();
        super.ServerRespawn(cSpawnInfo, fDelayTime);
        super.fHealth = cSpawnInfo.m_fHealth;
        m_nRespawnCnt++;
        if(bOnLevelRestart)
        {
            m_nRespawnCnt = 0;
            Enable();
        }
        Respawn(bOnLevelRestart);
        MsgSendClientRespawn(bOnLevelRestart);
    }

    void Respawn(boolean bOnRestartLevel)
    {
        if(m_cPod != null)
            m_cPod.Respawn(bOnRestartLevel, this);
        ForceStillState();
        StopFXSmokeUpdate();
        super.fHealth = super.fMaxHealth;
        m_bCanDrive = true;
        super.bDead = false;
        super.bIsActiveTarget = true;
        super.bActiveTrigger = true;
        Enable();
        EnableCallMethods();
        InitPhysicsParamsFromVehicle();
        EnableRendering(true);
        ActivateOnModule();
        SetCorrectPosOnRender(true);
        DisableCallMethod("DeleteAttachedFXes");
        DeleteAttachedFXes();
        super.SetState("StillState");
        EnableIncomingReplication(super.Role < 4);
    }

    public void OnReplicateServer()
    {
        Pawn cDriver = GetFirstOccupant(0);
        Pawn cPassenger = GetFirstOccupant(1);
        if(super.bNetInit || cDriver == null || !((GameObject) (cDriver)).bNetIsOwner)
            Replicate(sm_nVehicleMoveSet);
        if(super.bNetInit || cDriver != null && ((GameObject) (cDriver)).bNetIsOwner || cPassenger != null && ((GameObject) (cPassenger)).bNetIsOwner)
            Replicate(sm_nVehicleHealthSet);
    }

    void CheckAddVehicleToAutoRespawn()
    {
        if(GetModule() instanceof ModuleNet)
            ((ModuleNet)GetModule()).CheckAddVehicleToAutoRespawn(this);
    }

    void MsgRecvClientHideWreck()
    {
        MessageEnd();
        HideWreck();
    }

    public float GetRelevantLevel()
    {
        if(super.fNetForceRelevantLevel >= 0.0F)
            return super.fNetForceRelevantLevel;
        Pawn cDriver = GetFirstOccupant(0);
        Pawn cPassenger = GetFirstOccupant(1);
        if(cDriver == null || !((GameObject) (cDriver)).bNetIsOwner || cPassenger == null || !((GameObject) (cPassenger)).bNetIsOwner)
            return 1.0F;
        float fRel = 1.0F - (GetCurrentClientDistance() - GetModule().fMinDistToCalculateRelevant) / (GetModule().fMaxDistToCalculateRelevant - GetModule().fMinDistToCalculateRelevant);
        if(fRel > 1.0F)
            fRel = 1.0F;
        return fRel;
    }

    public void PatrolBreak()
    {
        m_bBreakPatrol = true;
    }

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[Vehicle.SGSaveChunk]\n");
        FileChunk cFC = GameObject.NewChunk(1150, cFCParent);
        super.SGSaveChunk(cFC);
        cFC.SaveBool(m_bSimulate);
        cFC.SaveInt(aSeatsInfo.size());
        for(int i = 0; i < aSeatsInfo.size(); i++)
            cFC.SaveObjectRef((SeatInfo)aSeatsInfo.get(i));

        cFC.SaveObject(m_Physics);
        cFC.SaveBool(m_bPhysicsActive);
        cFC.SaveBool(m_bEngineOn);
        cFC.SaveObjectRef(motion);
        cFC.SaveFloat(fLastT);
        cFC.SaveBool(m_bCanDrive);
        cFC.SaveFloat(fFuel);
        cFC.SaveFloat(m_fAllFrameTime);
        cFC.SaveInt(m_iCurrPatrolPoint);
        cFC.SaveInt(m_iAddValue);
        cFC.SaveBool(m_bDriveFinished);
        cFC.SaveBool(m_bBreakPatrol);
        cFC.SaveBool(m_bIsPatrolling);
        cFC.SaveObjectRef(m_VehiclePath);
        cFC.SaveFloat(m_fOldSlideValue);
        cFC.SaveFloat(m_fOldSlowDownValue);
        cFC.SaveFloat(m_fOldAccelValue);
        cFC.SaveFloat(m_fOldBrakeValue);
        cFC.SaveInt(m_nSoundLoopId);
        cFC.SaveBool(m_bPlayEngineStartStopSound);
        cFC.SaveBool(m_bSoundsStarted);
        cFC.SaveInt(m_aSpeeds.length);
        for(int i = 0; i < m_aSpeeds.length; i++)
            cFC.SaveFloat(m_aSpeeds[i]);

        cFC.SaveBool(m_bUseMotionSpeed);
        cFC.SaveBool(m_bEditorAction);
        cFC.SaveObjectRef((ISaveGame)m_VehicleController);
        cFC.SaveBool(m_bIsGridIndependent);
        cFC.SaveFloat(m_fLastVehicleNoiseTime);
        cFC.SaveVector(m_vNoisePos);
        cFC.SaveVector(m_vLastPos);
        cFC.SaveVector(m_vLastDir);
        cFC.SaveBool(m_bVehicleInMovie);
        cFC.SaveBool(m_bValuesSetForPatrol);
        cFC.SaveBool(m_bSmokeSpawned);
        cFC.SaveBool(bOnAppearShowWreckOnly);
        cFC.delete();
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[Vehicle.SGLoadChunk]\n");
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        if(cFC.GetID() == 1150)
        {
            super.SGLoadChunk(cFC);
            m_bSimulate = cFC.LoadBool();
            int iTemp = cFC.LoadInt();
            for(int i = 0; i < iTemp; i++)
                aSeatsInfo.set(i, (SeatInfo)cFC.LoadObjectRef());

            m_Physics = (PhysicsVehicle)cFC.LoadObject(m_Physics, this);
            m_bPhysicsActive = cFC.LoadBool();
            m_bEngineOn = cFC.LoadBool();
            motion = (VehicleMotionState)cFC.LoadObjectRef();
            fLastT = cFC.LoadFloat();
            m_bCanDrive = cFC.LoadBool();
            fFuel = cFC.LoadFloat();
            m_fAllFrameTime = cFC.LoadFloat();
            m_iCurrPatrolPoint = cFC.LoadInt();
            m_iAddValue = cFC.LoadInt();
            m_bDriveFinished = cFC.LoadBool();
            m_bBreakPatrol = cFC.LoadBool();
            m_bIsPatrolling = cFC.LoadBool();
            m_VehiclePath = (Path)cFC.LoadObjectRef();
            m_fOldSlideValue = cFC.LoadFloat();
            m_fOldSlowDownValue = cFC.LoadFloat();
            m_fOldAccelValue = cFC.LoadFloat();
            m_fOldBrakeValue = cFC.LoadFloat();
            m_nSoundLoopIdSG = cFC.LoadInt();
            m_bPlayEngineStartStopSound = cFC.LoadBool();
            m_bSoundsStarted = cFC.LoadBool();
            iTemp = cFC.LoadInt();
            for(int i = 0; i < iTemp; i++)
                m_aSpeeds[i] = cFC.LoadFloat();

            m_bUseMotionSpeed = cFC.LoadBool();
            m_bEditorAction = cFC.LoadBool();
            m_VehicleController = (IVehiclePassenger)cFC.LoadObjectRef();
            m_bIsGridIndependent = cFC.LoadBool();
            m_fLastVehicleNoiseTime = cFC.LoadFloat();
            m_vNoisePos = cFC.LoadVector();
            m_vLastPos = cFC.LoadVector();
            m_vLastDir = cFC.LoadVector();
            m_bVehicleInMovie = cFC.LoadBool();
            m_bValuesSetForPatrol = cFC.LoadBool();
            m_bSmokeSpawned = cFC.LoadBool();
            bOnAppearShowWreckOnly = cFC.LoadBool();
            m_bGameLoading = true;
        }
        cFC.delete();
    }

    void SimulatePathMove()
    {
        if(!m_bSimulate)
            return;
        byte iAcc = motion.iAcc;
        float fTurn = motion.fTurn;
        if(!m_bCanDrive)
        {
            iAcc = 0;
            fTurn = 0.0F;
        } else
        if(!m_bEngineOn)
        {
            iAcc = 0;
        } else
        {
            float fCurrentT = GetTime();
            float fdT = fCurrentT - fLastT;
            fLastT = fCurrentT;
            if(fdT > 1.0F)
                GameObject.CrashLog("Czas updejtu fizyki wiekszy niz 1s\n");
            SetAllFramePeriod(fdT);
            float fTimePeriod = GetNextTimePeriod();
            TurnOffPassengersCollisions();
            for(; fTimePeriod > 0.0F; fTimePeriod = GetNextTimePeriod())
            {
                if(!m_bDriveFinished)
                {
                    Vector vCurrDir = GetForwardVector();
                    vCurrDir.fY = 0.0F;
                    vCurrDir.Normalize();
                    Vector vCurrPos = GetPosition();
                    Vector vToDestVect = new Vector(m_VehiclePath.GetPoint(m_iCurrPatrolPoint).vPosition);
                    vToDestVect.Sub(vCurrPos);
                    vToDestVect.fY = 0.0F;
                    float fDist = vToDestVect.Len();
                    vToDestVect.Normalize();
                    if(fDist < m_VehiclePath.GetPoint(m_iCurrPatrolPoint).fRadius)
                    {
                        TryToCallPointHandler();
                        OnDestinationPos(m_iCurrPatrolPoint);
                    }
                    if(!m_bDriveFinished)
                    {
                        float fDot = vToDestVect.Dot(vCurrDir);
                        fTurn = ((float)Math.acos(fDot) * RAD_TO_DEG) / m_Physics.m_Params._MAX_TURN_ANGLE;
                        if(fTurn > 1.0F)
                            fTurn = 1.0F;
                        if(vToDestVect.Cross(vCurrDir).fY < 0.0F)
                            fTurn *= -1F;
                        if(m_bBreakPatrol)
                        {
                            if(m_Physics.m_fCurrSpeed > 0.0F)
                                iAcc = -1;
                            else
                                iAcc = 0;
                        } else
                        {
                            SlowDownOnCurve(fDist, vCurrDir, vToDestVect);
                        }
                    } else
                    {
                        iAcc = motion.iAcc;
                        fTurn = motion.fTurn;
                    }
                }
                m_Physics.Simulate(iAcc, fTurn, fTimePeriod);
            }

            TurnOnPassengersCollisions();
        }
        if(m_bDriveFinished && m_Physics.m_fCurrSpeed == 0.0F)
        {
            SetState("UncaredDriveState");
            OnDestinationPos();
        }
    }

    float GetAmplitudeCoeff()
    {
        return m_fAmplitudeCoeff;
    }

    public void TurnOffPassengersCollisions()
    {
        ControlObject children[] = GetChildren();
        m_TempObjects.clear();
        if(children == null)
            return;
        if(children.length > m_BoolTab.length)
        {
            m_BoolTab = null;
            m_BoolTab = new boolean[children.length];
        }
        for(int i = 0; i < children.length; i++)
        {
            m_BoolTab[i] = children[i].IsSetFlag(1);
            m_TempObjects.add(children[i]);
            if(m_BoolTab[i])
                children[i].ClearFlag(1);
        }

    }

    void ActionExecute(Actor executor)
    {
        super.Execute(executor);
        if(!(executor instanceof Pawn))
        {
            GameObject.CrashLog("[Vehicle.ActionExecute]: Vehicle can be executed only by Pawn\n");
            return;
        }
        Pawn pawn = (Pawn)executor;
        SeatInfo seat = GetCurrentPointedSeat(executor);
        if(seat == null)
            return;
        pawn.PrepareToGetIn(seat);
        if(seat.GetReserver() == pawn)
            pawn.ActionGetIn(seat);
    }

    public void Die()
    {
        if(super.Role < 4)
            return;
        super.Die();
        VehicleCrashed();
        Pawn occupants[] = GetAllOccupants();
        if(occupants != null)
        {
            for(int i = 0; i < occupants.length; i++)
                occupants[i].Die();

        }
    }

    void StartFXSmokeUpdate()
    {
        StopFXSmokeUpdate();
        if(m_bSmokeSpawned || !bSpawnSmokeFX)
        {
            return;
        } else
        {
            m_bSmokeSpawned = true;
            CallMethodEvery(METHOD_UpdateSmokeFX, fFXSmokeUpdateTime);
            return;
        }
    }

    void StopFXSmokeUpdate()
    {
        DisableCallMethod(METHOD_UpdateSmokeFX);
        m_bSmokeSpawned = false;
    }

    public void SGUpdate()
    {
        FileChunk.Log("[Vehicle.SGSaveChunk]\n");
        super.SGUpdate();
        boolean bEngineWasOn = m_bEngineOn;
        DetachLoopSound();
        if(bEngineWasOn)
            AttachLoopSound();
        if(m_Physics != null)
            m_Physics.SGUpdate();
        m_bGameLoading = false;
    }

    void CannotDrive()
    {
        m_bCanDrive = false;
        StartFXSmokeUpdate();
        TextMessageDestroyed();
        GameObject.InvokeActionChain(aOnCantDrive);
        if(super.Role == 4)
        {
            Pawn occupants[] = GetAllOccupants();
            if(occupants != null)
            {
                for(int i = 0; i < occupants.length; i++)
                    occupants[i].ActionGetOut();

            }
            CheckAddVehicleToAutoRespawn();
            MsgSendClientCannotDrive();
        }
    }

    public void GlobalOnFrame()
    {
    }

    void StartSounds()
    {
        m_bSoundsStarted = true;
        if(m_sSoundStartName != null && m_bPlayEngineStartStopSound)
        {
            PlaySound(m_sSoundStartName);
            float fWaitTime = GetWaveDuration(m_sSoundStartName) - 0.1F;
            if(m_bCanDrive)
            {
                CallMethodIn("AttachLoopSound", fWaitTime);
            } else
            {
                CallMethodIn("StopSounds", fWaitTime);
                CallMethodIn("AlreadyCannotDrive", fWaitTime + _TIME_TO_GET_OUT_IF_VEHICLE_ALREADY_DESTROYED);
            }
        } else
        if(m_bCanDrive)
        {
            AttachLoopSound();
        } else
        {
            StopSounds();
            CallMethodIn("AlreadyCannotDrive", _TIME_TO_GET_OUT_IF_VEHICLE_ALREADY_DESTROYED);
        }
    }

    void OccupantsDamage(float fDamage, GameObject Assassin)
    {
        Pawn occupants[] = GetAllOccupants();
        if(occupants != null)
        {
            for(int i = 0; i < occupants.length; i++)
                if(occupants[i] instanceof Player)
                    occupants[i].TakeDamage(fDamage, fDamage, Assassin, null, null, -1, EnumDamageType._BULLET);

        }
    }

    public SeatInfo GetFirstFreeSeat(int nPassengerRole)
    {
        for(int i = 0; i < aSeatsInfo.size(); i++)
        {
            SeatInfo info = (SeatInfo)aSeatsInfo.get(i);
            if((info.GetRole() == nPassengerRole || nPassengerRole == 2) && !info.IsOccupied() && info.GetReserver() == null)
                return info;
        }

        return null;
    }

    void StopSounds()
    {
        if(m_bSoundsStarted)
        {
            if(m_sSoundStopName != null && m_bPlayEngineStartStopSound)
                PlaySound(m_sSoundStopName);
            DetachLoopSound();
            m_bSoundsStarted = false;
        }
    }

    int GetOccupantsNum(int nPassengerRole)
    {
        int nNum = 0;
        for(int i = 0; i < aSeatsInfo.size(); i++)
        {
            SeatInfo info = (SeatInfo)aSeatsInfo.get(i);
            if(info.GetRole() == nPassengerRole && info.IsOccupied())
                nNum++;
        }

        return nNum;
    }

    int GetAllAliveOccupantsNum()
    {
        int nNum = 0;
        for(int i = 0; i < aSeatsInfo.size(); i++)
        {
            SeatInfo info = (SeatInfo)aSeatsInfo.get(i);
            if(info.IsOccupied() && !((Actor) (info.GetOccupant())).bDead)
                nNum++;
        }

        return nNum;
    }

    void LoadSoundParams(String sFile)
    {
        ParseKeyword Root = GameObject.ParseFile(sFile);
        if(Root == null)
        {
            GameObject.CrashLog("No file " + sFile + "\n");
            return;
        }
        for(ParseKeyword Key = Root; Key != null; Key = Key.GetNext())
        {
            if(Key.Equals("MinFreq"))
                m_fMinFreq = Key.GetFParam(0);
            if(Key.Equals("MaxFreq"))
                m_fMaxFreq = Key.GetFParam(0);
            if(Key.Equals("MaxFreqBack"))
                m_fMaxFreqBack = Key.GetFParam(0);
        }

        Root.delete();
    }

    void TryToLoadPath()
    {
        Path path = GetModule().cPathsManager.GetPathByName(GetName());
        if(path != null)
            SetVehiclePath(path);
    }

    void TryToLoadPath(Waypoint waypoint)
    {
        Path path = new Path();
        path.SetPathOneWay();
        mt_Move defMotion = new mt_Move();
        Waypoint firstWaypoint = waypoint;
        while(waypoint != null && ((waypoint.cMotion instanceof mt_Move) || waypoint.cMotion == null)) 
        {
            mt_Move motion;
            if(waypoint.cMotion == null)
                motion = defMotion;
            else
                motion = (mt_Move)waypoint.cMotion;
            motion.bCritical = true;
            path.AddPathPoint(new PathPoint(waypoint.GetPosition(), motion.fRadius, motion.cSpeed.GetValue()));
            waypoint = waypoint.cNext;
            if(waypoint == firstWaypoint)
                break;
        }
        if(path != null)
            SetVehiclePath(path);
    }

    Vector Collision(Vector vStart, Vector vEnd, MeshObject objExclude)
    {
        Vector vCollPoint = new Vector(vEnd);
        TraceObjectsExclude(vStart, vCollPoint, objExclude);
        TraceTerrain(vStart, vCollPoint);
        TraceTrees(vStart, vCollPoint);
        return vCollPoint;
    }

    void OnRender()
    {
        if(!super.m_bCorrectPosOnRender)
            return;
        GetPosition(super.m_vActuallyPosition);
        GetForwardVector(super.m_vActuallyDir);
        GetUpVector(m_vActuallyUp);
        if(m_bLocalPlayerDriver)
        {
            super.m_vRenderPosition.Set(super.m_vActuallyPosition);
            super.m_vRenderDir.Set(super.m_vActuallyDir);
            m_vRenderUp.Set(m_vActuallyUp);
            AdditionalSimulateOnRender(super.m_vRenderPosition, super.m_vRenderDir, null, m_vRenderUp);
            FromUpForwardPos(m_vRenderUp, super.m_vRenderDir, super.m_vRenderPosition);
            super.m_bOnRenderPosition = true;
            super.m_bOnRenderDir = true;
            m_bOnRenderUp = true;
        } else
        {
            if(super.m_bInterpolateRenderPos)
            {
                GetPosition(super.m_vActuallyPosition);
                ChromeActor.sm_vPos.Set(super.m_vActuallyPosition);
                InterpolateRenderPos(ChromeActor.sm_vPos);
                super.m_vRenderPosition.Set(ChromeActor.sm_vPos);
                SetPositionWorld(super.m_vRenderPosition);
                super.m_bOnRenderPosition = true;
            }
            if(super.m_bInterpolateRenderDir)
            {
                GetForwardVector(super.m_vActuallyDir);
                InterpolateRenderDir(super.m_vRenderDir, super.m_vActuallyDir, ChromeActor.sm_vDir);
                super.m_vRenderDir.Set(ChromeActor.sm_vDir);
                SetDir(super.m_vRenderDir);
                super.m_bOnRenderDir = true;
            }
        }
        SetRenderTime(GetTime());
    }

    public void OnReplicateClient()
    {
        if(m_bLocalPlayerDriver)
            Replicate(sm_nVehicleMoveSet);
    }

    void SlowDownOnCurve(float fDist, Vector vDir, Vector vDestDir)
    {
        float fDot = vDir.Dot(vDestDir);
        motion.iAcc = 1;
        m_Physics.m_Params._SLOW_COEF = m_fOldSlowDownValue;
        if(m_Physics.m_fCurrSpeed > 600F && fDot < 0.866F)
        {
            m_Physics.m_Params._SLOW_COEF = (((float)Math.abs(Math.acos(fDot)) * 57F) / 90F) * _PATH_SLOW_VALUE;
            motion.iAcc = 0;
            return;
        }
        if(m_Physics.m_fCurrSpeed > 200F && (double)(fDist / m_Physics.m_fCurrSpeed) < (Math.abs(Math.acos(fDot)) * 28.645000457763672D) / (double)m_Physics.m_Params._MAX_TURN_ANGLE)
        {
            m_Physics.m_Params._SLOW_COEF = (((float)Math.abs(Math.acos(fDot)) * 57F) / 90F) * _PATH_SLOW_VALUE;
            motion.iAcc = 0;
        }
    }

    float GetCameraAttenuation()
    {
        return m_fAttenuation;
    }

    void MsgSendClientRespawn(boolean bOnLevelRestart)
    {
        MessageNew(0);
        MessagePackPos();
        MessagePackBoolean(bOnLevelRestart);
        MessageSend();
    }

    public void EditorPatrol(Waypoint waypoint, IVehiclePassenger controller)
    {
        if(m_bEditorAction)
        {
            if(m_iCurrPatrolPoint >= 0 && m_iCurrPatrolPoint < m_VehiclePath.GetPointsNum())
            {
                int iSpeed = m_VehiclePath.GetPoint(m_iCurrPatrolPoint).nFlags;
                if(iSpeed >= 0 && iSpeed <= m_aSpeeds.length)
                    m_Physics.SetCurrMaxSpeed(m_aSpeeds[iSpeed]);
            }
            if(m_bBreakPatrol)
                PatrolResume();
        } else
        {
            TryToLoadPath(waypoint);
            if(m_VehiclePath == null)
            {
                GameObject.CrashLog("Pojazd nie ma przypisanej sciezki patrolowej !!!\n");
                return;
            }
            m_bEditorAction = true;
            m_VehicleController = controller;
            SetVehicleParamsForPatrol();
            SetState("PatrolPathState");
            int iSpeed = m_VehiclePath.GetPoint(m_iCurrPatrolPoint).nFlags;
            if(iSpeed >= 0 && iSpeed <= m_aSpeeds.length)
                m_Physics.SetCurrMaxSpeed(m_aSpeeds[iSpeed]);
        }
    }

    public Pawn GetFirstOccupant(int nPassengerRole)
    {
        for(int i = 0; i < aSeatsInfo.size(); i++)
        {
            SeatInfo info = (SeatInfo)aSeatsInfo.get(i);
            if(info.GetRole() == nPassengerRole && info.IsOccupied())
                return info.GetOccupant();
        }

        return null;
    }

    public boolean DeleteIfNotRelevant()
    {
        return false;
    }

    public void OnCollisionFullInfoMove(ControlObject obj, Vector vPoint, Vector vNormal, Vector vMove)
    {
        if(m_bPhysicsActive)
            m_Physics.HandleCollision(obj, vPoint, vNormal, vMove);
    }

    public void Appear(ControlObject cDestinationObj)
    {
        if(bOnAppearShowWreckOnly)
        {
            ShowWreck();
            bOnAppearShowWreckOnly = false;
            StartFXSmokeUpdate();
        } else
        {
            super.Appear(cDestinationObj);
            boolean bWasPhysicsActiveBeforeDisappear = false;
            if(GetFirstOccupant(0) instanceof Player)
                bWasPhysicsActiveBeforeDisappear = true;
            ActivateVehicle(true, m_bIsGridIndependent, bWasPhysicsActiveBeforeDisappear);
        }
    }

    void CheckRadiuses()
    {
        if(m_VehiclePath != null)
        {
            for(int i = 0; i < m_VehiclePath.GetPointsNum(); i++)
                if(m_VehiclePath.GetPoint(i).fRadius == 0.0F)
                    m_VehiclePath.GetPoint(i).fRadius = 200F;

        }
    }

    void MakeVehicleNoise()
    {
        float fSpeed = m_Physics.m_fCurrSpeed;
        if(fSpeed > 1.0F)
        {
            float fSpeedCoef = Tools.InterpLinear(0.0F, m_Physics.GetMaxSpeed(), fSpeed);
            float fUpdateTime = fPredictionNoiseSecs * 0.5F - Math.max(0.0F, 1.0F - fSpeedCoef) * (fPredictionNoiseSecs * 0.5F - fMinMotionNoiseTime);
            float fTime = GetTime();
            if(fTime - m_fLastVehicleNoiseTime > fUpdateTime)
            {
                float fRadius = fSpeed * fPredictionNoiseSecs;
                if(fRadius < fMinMotionNoiseRadius)
                    fRadius = fMinMotionNoiseRadius;
                else
                if(fRadius > fMaxMotionNoiseRadius)
                    fRadius = fMaxMotionNoiseRadius;
                m_vNoisePos.Set(GetForwardVectorVolatile());
                m_vNoisePos.Mul(fRadius);
                m_vNoisePos.Add(GetPositionVectorVolatile());
                m_fLastVehicleNoiseTime = fTime;
                MakeNoiseOnPosition(m_vNoisePos, fRadius, 5);
                if(bNoiseVis)
                {
                    if(m_aVis == null)
                    {
                        m_aVis = new LaserPointer[_VIS_STEPS];
                        for(int i = 0; i < _VIS_STEPS; i++)
                        {
                            m_aVis[i] = Tools.CreateLaserPointer(GetModule(), "LaserBeamRed");
                            m_aVis[i].SetSize(3F);
                        }

                    }
                    if(m_aVis != null)
                    {
                        Vector vVisStart = new Vector(m_vNoisePos);
                        Vector vVisEnd = new Vector();
                        vVisStart.fY += 70F;
                        for(int i = 0; i < _VIS_STEPS; i++)
                        {
                            float fAngle = (6.283185F * (float)i) / (float)_VIS_STEPS;
                            vVisEnd.fX = (float)Math.sin(fAngle) * fRadius + vVisStart.fX;
                            vVisEnd.fZ = (float)Math.cos(fAngle) * fRadius + vVisStart.fZ;
                            vVisEnd.fY = vVisStart.fY;
                            m_aVis[i].PointFromTo(vVisStart, vVisEnd);
                        }

                    }
                }
            }
        }
    }

    public void SetMotionSpeedValue(int iMotionSpeed, float fNewSpeedValue)
    {
        if(iMotionSpeed >= 0 && iMotionSpeed < m_aSpeeds.length)
            m_aSpeeds[iMotionSpeed] = fNewSpeedValue;
    }

    void MsgRecvClientVehicleState()
    {
        MessageUnPackPosAndApply();
        MessageEnd();
    }

    void ForceStillState()
    {
        if(bOld)
            return;
        if((super.CurrentState instanceof DrivenState) || (super.CurrentState instanceof UncaredDriveState))
            super.SetState("StillState");
        EnableIncomingReplication(false);
        m_Physics.Clear();
    }

    public void PawnGotIn(SeatInfo info, Pawn pawn)
    {
        if(pawn.GetConflictSide() != EnumConflictSide._NEUTRAL)
            ChangeConflictSide(pawn.GetConflictSide());
        if(info.GetRole() == 0)
            GameObject.InvokeActionChain(aOnGotInDriver);
        else
        if(info.GetRole() == 1)
            GameObject.InvokeActionChain(aOnGotInPassenger);
        Pawn driver = GetFirstOccupant(0);
        if(info.GetRole() == 0)
        {
            m_bLocalPlayerDriver = driver != null && ((GameObject) (driver)).bNetIsOwner;
            if(super.Role == 4)
                EnableIncomingReplication(!m_bLocalPlayerDriver);
        }
        pawn.ClearFlag(256);
    }

    public void OnMessage()
    {
        switch(MessageGetId())
        {
        case 0: // '\0'
            GameObject.LogD(" MSG_CLIENT_RESPAWN\n");
            MsgRecvClientRespawn();
            break;

        case 1: // '\001'
            GameObject.LogD(" MSG_CLIENT_VEHICLE_STATE\n");
            MsgRecvClientVehicleState();
            break;

        case 2: // '\002'
            GameObject.LogD(" MSG_CLIENT_CANNOT_DRIVE\n");
            MsgRecvClientCannotDrive();
            break;

        case 3: // '\003'
            GameObject.LogD(" MSG_CLIENT_CRASH\n");
            MsgRecvClientCrash();
            break;

        case 4: // '\004'
            GameObject.LogD(" MSG_CLIENT_HIDE_WRECK\n");
            MsgRecvClientHideWreck();
            break;

        case 5: // '\005'
            MsgRecvServerCollision();
            break;

        default:
            MessageCancel();
            break;
        }
    }

    public void FinishDrive()
    {
        m_bEditorAction = false;
        RestoreVehicleParamsBeforePatrol();
        m_Physics.SetCurrMaxSpeed(m_Physics.GetMaxSpeed());
        SetState("UncaredDriveState");
    }

    void MsgSendClientCannotDrive()
    {
        MessageNew(2);
        MessageSend();
    }

    void MsgSendServerVehicleCollision(float fDamage)
    {
        MessageNew(5);
        MessagePackFloat(fDamage);
        MessagePackInt(GetNetId());
        MessageSend();
    }

    void SlideSound()
    {
        if(m_sSoundSlideName != null)
            PlaySound(m_sSoundSlideName);
    }

    int GetFreeSeatsNum()
    {
        int nNum = 0;
        for(int i = 0; i < aSeatsInfo.size(); i++)
        {
            SeatInfo info = (SeatInfo)aSeatsInfo.get(i);
            if(info.GetOccupant() == null && info.GetReserver() == null)
                nNum++;
        }

        return nNum;
    }

    Vehicle()
    {
        N_PHYSICS_UPDATES_PER_S = 20;
        PHYSICS_GRAIN = 0.0F;
        m_fObservedSightVAngle = 15F;
        m_fOverObservedHeight = 300F;
        m_fOverObservedBack = 800F;
        sBlobMaterial = "blobs.mat";
        fBlobMapSize = 220F;
        m_bSimulate = true;
        aSeatsInfo = new ArrayList();
        aOnGotInDriver = null;
        aOnGotInPassenger = null;
        aOnGetOutDriver = null;
        aOnGetOutPassenger = null;
        bExecutorAsPassenger = false;
        fMinHealthCoeffToDrive = 0.2F;
        aOnCantDrive = null;
        m_Physics = null;
        m_bPhysicsActive = false;
        m_bEngineOn = false;
        motion = null;
        fLastT = 0.0F;
        m_bCanDrive = true;
        nVehicleType = 1;
        fFuel = 100F;
        fFuelConsumption = 0.01F;
        m_fAllFrameTime = 0.0F;
        m_bVehicleInMovie = false;
        m_iCurrPatrolPoint = 0;
        m_iAddValue = 1;
        m_bDriveFinished = false;
        m_bBreakPatrol = false;
        m_bIsPatrolling = false;
        m_VehiclePath = null;
        m_sSoundStartName = null;
        m_sSoundLoopName = null;
        m_fSoundLoopMin = 1000F;
        m_fSoundLoopMax = 5000F;
        m_sSoundStopName = null;
        m_sSoundBrakeName = null;
        m_sSoundAccelName = null;
        m_sSoundHitName = null;
        m_sSoundSlideName = null;
        m_nSoundLoopId = 0;
        m_bPlayEngineStartStopSound = true;
        m_fMinFreq = 1.0F;
        m_fMaxFreq = 1.1F;
        m_fMaxFreqBack = 1.1F;
        m_bSoundsStarted = false;
        m_aSpeeds = null;
        m_bUseMotionSpeed = true;
        m_bEditorAction = false;
        m_VehicleController = null;
        sBlowUpFX = "FXBlowBarrel";
        sBlowUpSound = "Data/Sounds/Weapon/GrenadeExplosion";
        fBlowUpShakeStrength = 0.0F;
        fBlowUpShakeDistMin = 0.0F;
        fBlowUpShakeDistMax = 0.0F;
        m_fOccupantsDamageMul = 0.25F;
        m_fSingleOccupantsDamageMul = 0.25F;
        m_fNetOccupantsDamageMul = 0.0F;
        fFXSmokeUpdateTime = 0.5F;
        sFXSmokeName = "Smoke1";
        bSpawnSmokeFX = true;
        METHOD_UpdateSmokeFX = 0;
        m_bSmokeSpawned = false;
        m_fAttenuation = 0.92F;
        m_fForceFactor = 150F;
        m_fAmplitudeCoeff = 0.3F;
        m_iStampSize = -1;
        m_cPod = null;
        m_bLocalPlayerDriver = false;
        m_bMakeVehicleNoiseInMovie = false;
        sVehicleProfilingPage = "Vehicle Profiling";
        m_vFXDir = new Vector(Vector.Up);
        m_vFXParticlesDir = new Vector(Vector.Up);
        m_vPositionModifier = new Vector(Vector.Zero);
        m_sWreckMeshName = null;
        m_Wreck = null;
        m_bWreckVisible = false;
        aOnCollisionWithPlayer = null;
        _CORRECTION = 150F;
        _GET_OUT_TOLERANCE = 0.2F;
        m_fDownTestVectorLen = -300F;
        m_bIsGridIndependent = false;
        bOnAppearShowWreckOnly = false;
        m_TempObjects = new ArrayList();
        m_BoolTab = new boolean[5];
        m_fTestGranularity = 0.0F;
        fMinMotionNoiseRadius = 400F;
        fMaxMotionNoiseRadius = 3000F;
        fPredictionNoiseSecs = 2.0F;
        fMinMotionNoiseTime = 0.2F;
        m_fLastVehicleNoiseTime = 0.0F;
        m_vNoisePos = new Vector();
        m_aVis = null;
        _VIS_STEPS = 100;
        bNoiseVis = false;
        m_vLastPos = null;
        m_vLastDir = null;
        m_bValuesSetForPatrol = false;
        m_bModuleNet = false;
        m_fCurrDirAngle = 0.0F;
        m_fCurrSpeed = 0.0F;
        m_fMoveSpeed = 0.0F;
        m_iAcc = 0;
        m_fTurn = 0.0F;
        bOld = false;
        m_nRespawnCnt = 0;
        m_bGameLoading = false;
        m_nSoundLoopIdSG = 0;
        m_vActuallyUp = new Vector();
        m_vRenderUp = new Vector();
        m_bOnRenderUp = false;
        super.fHealth = 2000F;
        m_sSoundAccelName = "Data/Sounds/Vehicles/VehicleAccel";
        m_sSoundBrakeName = "Data/Sounds/Vehicles/VehicleBrake";
        m_sSoundHitName = "Data/Sounds/Vehicles/VehicleHit";
        m_sSoundSlideName = "Data/Sounds/Vehicles/VehicleSlide";
        m_sSoundStartName = "Data/Sounds/Vehicles/JeepEngineStart";
        m_sSoundLoopName = "Data/Sounds/Vehicles/JeepEngineLoop";
        m_sSoundStopName = "Data/Sounds/Vehicles/JeepEngineStop";
        m_fMinFreq = 0.6F;
        m_fMaxFreq = 1.3F;
        m_fMaxFreqBack = 1.2F;
        super.bIsActiveTarget = true;
        super.bIsAITarget = true;
    }

    public void Enable()
    {
        super.Enable();
        SetCanGetOut(true);
    }

    boolean TryToCallPointHandler()
    {
        String sText = m_VehiclePath.GetPoint(m_iCurrPatrolPoint).sTextField;
        if(sText == null || sText.equals(""))
            return false;
        StringTokenizer cItemsIter = new StringTokenizer(sText, " ,", false);
        if(!cItemsIter.hasMoreTokens())
            return false;
        String s = cItemsIter.nextToken();
        if(!GameObject.TextToUpperCase(s).equals("RANDOMWAIT"))
        {
            CallMethodIn(s, 0.0F);
            return true;
        }
        if(!cItemsIter.hasMoreTokens())
        {
            GameObject.CrashLog("Bledna nazwa stringa dla punktu w sciezce:" + m_VehiclePath.GetPathName() + "\n");
            return false;
        }
        float f1;
        try
        {
            f1 = Float.valueOf(cItemsIter.nextToken()).floatValue();
        }
        catch(NumberFormatException e)
        {
            GameObject.CrashLog("Bledny parametr dla stringa dla punktu w sciezce:" + m_VehiclePath.GetPathName() + "\n");
            return false;
        }
        if(!cItemsIter.hasMoreTokens())
        {
            GameObject.CrashLog("Bledny parametr dla stringa dla punktu w sciezce:" + m_VehiclePath.GetPathName() + "\n");
            return false;
        }
        float f2;
        try
        {
            f2 = Float.valueOf(cItemsIter.nextToken()).floatValue();
        }
        catch(NumberFormatException e)
        {
            GameObject.CrashLog("Bledny parametr dla stringa dla punktu w sciezce:" + m_VehiclePath.GetPathName() + "\n");
            return false;
        }
        if(f2 < f1)
        {
            return false;
        } else
        {
            PatrolBreak();
            DisableCallMethod("PatrolResume");
            CallMethodIn("PatrolResume", GameObject.RandomFloat(f1, f2));
            return true;
        }
    }

    void MsgRecvClientRespawn()
    {
        MessageUnPackPosAndApply();
        boolean bOnLevelRestart = MessageUnPackBoolean();
        MessageEnd();
        Respawn(bOnLevelRestart);
    }

    void CreateWreck()
    {
        if(m_Wreck != null)
            return;
        if(m_sWreckMeshName == null)
        {
            return;
        } else
        {
            m_Wreck = (VehicleWreck)CreateObject("VehicleWreck");
            m_Wreck.m_cOwner = this;
            m_Wreck.LoadMesh(m_sWreckMeshName);
            m_Wreck.SetFlag(46);
            m_Wreck.ClearFlag(1);
            m_Wreck.ClearFlag(0x1000000);
            m_Wreck.SetCollType(2);
            m_Wreck.SetCollHandler(0);
            m_Wreck.SetTraceCollType(5);
            m_Wreck.SetLighting(true);
            m_Wreck.SetFlag(256);
            m_Wreck.EnableRendering(false);
            return;
        }
    }

    void MsgSendClientCrash()
    {
        GameObject.LogD("\n");
        MessageNew(3);
        MessageSend();
    }

    public void PawnGotOut(SeatInfo info, Pawn pawn)
    {
        if(GetAllAliveOccupantsNum() == 0)
            ChangeConflictSide(EnumConflictSide._NEUTRAL);
        GameObject.InvokeActionChain(info.GetRole() != 0 ? aOnGetOutPassenger : aOnGetOutDriver);
        if(info.GetRole() == 0)
        {
            StopSounds();
            m_bLocalPlayerDriver = false;
            if(super.Role == 4)
                EnableIncomingReplication(false);
        }
        pawn.SetFlag(256);
    }

    void TextMessageDestroyed()
    {
        Pawn occupants[] = GetAllOccupants();
        if(occupants == null)
            return;
        for(int i = 0; i < occupants.length; i++)
            occupants[i].TextMessage("&VEHICLE_DESTROYED&");

    }

    Vector CanGetOutToPos(SeatInfo info, Vector vStartPos, Vector vDestPos)
    {
        if(GetTerrainType(vDestPos.fX, vDestPos.fZ) == 0)
            return null;
        Vector vMove = new Vector(vDestPos);
        vMove.Sub(vStartPos);
        vMove.fY = 0.0F;
        float fMoveLen = vMove.Len();
        Vector vOldOccupantPos = info.GetOccupant().GetPosition();
        info.GetOccupant().SetPositionWorld(vStartPos);
        info.GetOccupant().MoveByEllipsoid(vMove);
        if(vMove.Len() < fMoveLen * (1.0F - _GET_OUT_TOLERANCE))
        {
            info.GetOccupant().SetPositionWorld(vOldOccupantPos);
            return null;
        }
        Vector vStart = new Vector(vStartPos);
        vStart.Add(vMove);
        vMove = new Vector(0.0F, m_fDownTestVectorLen, 0.0F);
        info.GetOccupant().SetPositionWorld(vStart);
        if(info.GetOccupant().MoveByEllipsoid(vMove))
        {
            info.GetOccupant().SetPositionWorld(vOldOccupantPos);
            return null;
        } else
        {
            info.GetOccupant().SetPositionWorld(vOldOccupantPos);
            vStart.Add(vMove);
            return vStart;
        }
    }

    public void Disappear(ControlObject cDestinationObj)
    {
        if(m_bWreckVisible)
        {
            HideWreck();
            bOnAppearShowWreckOnly = true;
        } else
        {
            super.Disappear(cDestinationObj);
            m_bIsGridIndependent = IsGridIndependent();
            ActivateVehicle(false, m_bIsGridIndependent, false);
        }
    }

    void OnCreate()
    {
        super.OnCreate();
        super.bSG = true;
        SetLighting(true);
        super.fMaxHealth = super.fHealth;
        fLastT = GetTime();
        motion = new VehicleMotionState();
        N_PHYSICS_UPDATES_PER_S = 30;
        PHYSICS_GRAIN = 1.0F / (float)N_PHYSICS_UPDATES_PER_S;
        CreatePhysics();
        SetPhysicsType(0);
        SetFlag(8);
        SetFlag(1);
        SetFlag(32);
        ClearFlag(8192);
        SetCollHandler(1024);
        SetCollAction(16);
        SetCollFlags(4096);
        SetCollFlags(0x40000);
        SetCollFlags(0x1000000);
        SetCollFlags(0x8000000);
        ClearFlag(4);
        ClearFlag(2);
        if(m_Physics != null && m_bUseMotionSpeed)
        {
            m_Physics.m_Params._WHEEL_MOVE_SPEED_COEF = 1.0F;
            m_Physics.m_Params.SetMaxSpeed(m_aSpeeds[5]);
        }
        RegisterKeyRequest();
        m_bModuleNet = GetModule() instanceof ModuleNet;
        m_fOccupantsDamageMul = m_bModuleNet ? m_fNetOccupantsDamageMul : m_fSingleOccupantsDamageMul;
        m_fOldSlideValue = m_Physics.m_Params._SLIDE_SUPRESS;
        SetState("StillState");
        CallMethodIn("TryToAttachDriver", 0.0F);
        super.bExtendedExecutionMode = true;
        SetFlag(0x100000);
        METHOD_UpdateSmokeFX = RegisterCallMethod("UpdateSmokeFX");
        if(m_iStampSize > 0)
            UpdatePathMap(true, m_iStampSize, true);
        if(bInitProfiling)
        {
            if(PROFILE_GeneralA == 0)
                PROFILE_GeneralA = ProfileAdd(sVehicleProfilingPage, "GeneralA");
            if(PROFILE_GeneralB == 0)
                PROFILE_GeneralB = ProfileAdd(sVehicleProfilingPage, "GeneralB");
            if(PROFILE_GeneralC == 0)
                PROFILE_GeneralC = ProfileAdd(sVehicleProfilingPage, "GeneralC");
            bInitProfiling = false;
        }
        SetCorrectPosOnRender(true);
        super.m_fInterpolateSpeedOnMoveMul = 1.05F;
        if(m_Physics != null)
            m_Physics.AlignSpringsAndWheelsToTerrain();
    }

    void PatrolEnd()
    {
        RestoreVehicleParamsBeforePatrol();
        SetState("UncaredDriveState");
    }

    void SetVehiclePath(Path path)
    {
        m_VehiclePath = path;
        CheckRadiuses();
    }

    void PatrolStart()
    {
        if(m_VehiclePath == null)
            TryToLoadPath();
        if(m_VehiclePath == null)
        {
            GameObject.CrashLog("Pojazd nie ma przypisanej sciezki patrolowej !!!\n");
            return;
        } else
        {
            SetVehicleParamsForPatrol();
            SetState("PatrolPathState");
            return;
        }
    }

    void CheckCanDrive()
    {
        Pawn occupants[] = GetAllOccupants();
        boolean bPlayerInside = false;
        if(occupants != null)
        {
            for(int i = 0; i < occupants.length; i++)
            {
                if(!(occupants[i] instanceof Player))
                    continue;
                bPlayerInside = true;
                break;
            }

        }
        if(bPlayerInside || m_bModuleNet)
        {
            if(m_bCanDrive && super.fHealth > 0.0F && m_Physics != null && super.fHealth < super.fMaxHealth * fMinHealthCoeffToDrive)
                CannotDrive();
        } else
        {
            if(super.fHealth <= super.fMaxHealth * fMinHealthCoeffToDrive)
                StartFXSmokeUpdate();
            if(m_bCanDrive && super.fHealth <= 0.0F)
                CannotDrive();
        }
    }

    void AlreadyCannotDrive()
    {
        TextMessageAlreadyDestroyed();
        Pawn occupants[] = GetAllOccupants();
        if(occupants == null)
            return;
        for(int i = 0; i < occupants.length; i++)
            occupants[i].ActionGetOut();

    }

    public void OnFrame()
    {
        GlobalOnFrame();
    }

    void MsgRecvClientCannotDrive()
    {
        MessageEnd();
        CannotDrive();
    }

    public Pawn[] GetOccupants(int nPassengerRole)
    {
        int nOccupants = GetOccupantsNum(nPassengerRole);
        if(nOccupants == 0)
            return null;
        Pawn tab[] = new Pawn[nOccupants];
        int nNdx = 0;
        for(int i = 0; i < aSeatsInfo.size(); i++)
        {
            SeatInfo info = (SeatInfo)aSeatsInfo.get(i);
            if(info.GetRole() == nPassengerRole && info.IsOccupied())
            {
                tab[nNdx] = info.GetOccupant();
                nNdx++;
            }
        }

        return tab;
    }

    public boolean IsActive(ControlObject Activator)
    {
        if(!(Activator instanceof Pawn))
            return false;
        if(GetSeatOccupiedBy((Pawn)Activator) != null)
            return false;
        if(GetFirstFreeSeat(2) == null || super.fHealth <= 0.0F || !m_bCanDrive)
            return false;
        if(!super.bActiveTrigger)
            return false;
        SeatInfo seat = GetCurrentPointedSeat(Activator);
        return seat != null && seat.GetReserver() == null;
    }

    void UpdateSounds()
    {
        if(m_nSoundLoopId != 0 && m_Physics != null)
        {
            float fSpeedCoeff;
            if(m_Physics.m_fCurrSpeed >= 0.0F)
                fSpeedCoeff = m_Physics.m_fCurrSpeed / m_Physics.m_Params.GetMaxSpeed();
            else
                fSpeedCoeff = m_Physics.m_fCurrSpeed / m_Physics.m_Params._MIN_SPEED;
            if(fSpeedCoeff > 1.0F)
                fSpeedCoeff = 1.0F;
            if(fSpeedCoeff < 0.0F)
                fSpeedCoeff = 0.0F;
            float fFreq = m_fMinFreq + (m_fMaxFreq - m_fMinFreq) * fSpeedCoeff;
            SetSoundFreq(m_nSoundLoopId, fFreq);
        }
    }

    void TakeDamage(float fDamage, int nDamageType)
    {
        OnTakeDamage(fDamage, fDamage, null, null, null, 0, nDamageType);
    }

    public void GetRenderPosition(Vector vRenderPos, Vector vRenderDir, Vector vRenderRight)
    {
        if(m_bModuleNet && super.m_bCorrectPosOnRender)
        {
            if(m_bLocalPlayerDriver)
            {
                AdditionalSimulateOnRender(vRenderPos, vRenderDir, vRenderRight, null);
            } else
            {
                if(super.m_bInterpolateRenderPos && vRenderPos != null)
                {
                    GetPosition(vRenderPos);
                    InterpolateRenderPos(vRenderPos);
                }
                if(vRenderDir != null)
                    GetForwardVector(vRenderDir);
                if(vRenderRight != null)
                    GetRightVector(vRenderRight);
            }
        } else
        {
            super.GetRenderPosition(vRenderPos, vRenderDir, vRenderRight);
        }
    }

    public void DeleteAllSeatsInfos()
    {
        aSeatsInfo.clear();
    }

    void InitPhysicsParamsFromVehicle()
    {
        if(m_Physics == null)
        {
            GameObject.LogD(" m_Physics == null!!!!!!!!!!!\n");
            return;
        } else
        {
            m_Physics.InitParamsFromVehicle();
            return;
        }
    }

    public SeatInfo GetSeatReservedBy(Pawn actor)
    {
        for(int i = 0; i < aSeatsInfo.size(); i++)
        {
            SeatInfo info = (SeatInfo)aSeatsInfo.get(i);
            if(info.GetReserver() == actor)
                return info;
        }

        return null;
    }

    public void SetState(String sStateName)
    {
        if(super.CurrentState instanceof CrashedState)
        {
            return;
        } else
        {
            super.SetState(sStateName);
            return;
        }
    }

    public boolean IsArmed()
    {
        return false;
    }

    public void Simulate(boolean bDriver)
    {
        if(!m_bSimulate)
            return;
        byte iAcc = motion.iAcc;
        float fTurn = motion.fTurn;
        if(!m_bCanDrive)
        {
            iAcc = 0;
            fTurn = 0.0F;
        } else
        if(!m_bEngineOn)
            iAcc = 0;
        float fCurrentT = GetTime();
        float fdT = fCurrentT - fLastT;
        fLastT = fCurrentT;
        TurnOffPassengersCollisions();
        if(m_bModuleNet)
        {
            float fGranularity = GetModule().GetPhUpdateGranularity();
            if(m_fTestGranularity > 0.0F)
                fGranularity = m_fTestGranularity;
            if(bDriver && m_bLocalPlayerDriver)
            {
                for(; fdT >= fGranularity; fdT -= fGranularity)
                    m_Physics.Simulate(iAcc, fTurn, fGranularity);

                m_fCurrDirAngle = m_Physics.m_fCurrDirAngle;
                m_fCurrSpeed = m_Physics.m_fCurrSpeed;
                m_iAcc = iAcc;
                m_fTurn = fTurn;
            } else
            if(!bDriver && super.Role == 4)
            {
                for(; fdT >= fGranularity; fdT -= fGranularity)
                    m_Physics.Simulate((byte)0, 0.0F, fGranularity);

                m_fCurrDirAngle = m_Physics.m_fCurrDirAngle;
                m_fCurrSpeed = m_Physics.m_fCurrSpeed;
                m_iAcc = iAcc;
                m_fTurn = fTurn;
            } else
            {
                m_Physics.m_fCurrDirAngle = m_fCurrDirAngle;
                m_Physics.m_fCurrSpeed = m_fCurrSpeed;
                for(; fdT >= fGranularity; fdT -= fGranularity)
                    m_Physics.NetSimulate(fdT, super.Role == 4);

            }
            fLastT -= fdT;
            SetPhysicsLastUpdateTime(fLastT);
        } else
        {
            SetAllFramePeriod(fdT);
            for(float fTimePeriod = GetNextTimePeriod(); fTimePeriod > 0.0F; fTimePeriod = GetNextTimePeriod())
                m_Physics.Simulate(iAcc, fTurn, fTimePeriod);

        }
        TurnOnPassengersCollisions();
    }

    float GetCameraForceFactor()
    {
        return m_fForceFactor;
    }

    void MsgSendClientState()
    {
        MsgSendClientVehicleState();
    }

    void MsgSendClientVehicleState()
    {
        MessageNew(1);
        MessagePackPos();
        MessageSend();
    }

    void EnableBackLater(float fTime)
    {
        CallMethodIn("EnableBack", fTime);
    }

    void MessageUnPackPosAndApply()
    {
        Vector vUp = MessageUnPackVector();
        Vector vDir = MessageUnPackVector();
        Vector vPos = MessageUnPackVector();
        FromUpForwardPos(vUp, vDir, vPos);
        ResetInterpolatePosAndDir();
    }

    void OnPostRender()
    {
        if(super.m_bOnRenderPosition || super.m_bOnRenderDir || m_bOnRenderUp)
        {
            FromUpForwardPos(m_vActuallyUp, super.m_vActuallyDir, super.m_vActuallyPosition);
            super.m_bOnRenderPosition = false;
            super.m_bOnRenderDir = false;
            m_bOnRenderUp = false;
        }
    }

    public SeatInfo[] GetFreeSeats()
    {
        int nNum = GetFreeSeatsNum();
        if(nNum == 0)
            return null;
        SeatInfo tab[] = new SeatInfo[nNum];
        int nNdx = 0;
        for(int i = 0; i < aSeatsInfo.size(); i++)
        {
            SeatInfo info = (SeatInfo)aSeatsInfo.get(i);
            if(info.GetOccupant() == null && info.GetReserver() == null)
            {
                tab[nNdx] = info;
                nNdx++;
            }
        }

        return tab;
    }

    public void StartExecution(Actor executor)
    {
        if(!super.bExtendedExecutionMode)
        {
            Execute(executor);
            return;
        }
        Pawn pawn = null;
        if(executor instanceof Pawn)
            pawn = (Pawn)executor;
        else
            return;
        if(pawn.GetSeat().GetOccupant() == null)
        {
            if(pawn.GetSeat().GetReserver() == executor)
            {
                Vector vLocalStartPos = pawn.GetSeat().GetStartLocalPos();
                Vector vLocalStartDir = pawn.GetSeat().GetStartLocalDir();
                Vector vLocalEndPos = pawn.GetSeat().GetSeatLocalPos();
                Vector vLocalEndDir = pawn.GetSeat().GetSeatLocalDir();
                super.aExecutionSteps = (new ExecutionInfo[] {
                    new ExecutionInfo(3, 1, vLocalStartPos, vLocalStartDir), new ExecutionInfo(7, 0, vLocalEndPos, vLocalEndDir)
                });
                InitExecutionActions();
            }
        } else
        if(pawn.GetSeat().GetOccupant() == executor)
        {
            Vector vLocalStartPos = pawn.GetSeat().GetStartLocalPos();
            Vector vLocalStartDir = pawn.GetSeat().GetStartLocalDir();
            super.aExecutionSteps = (new ExecutionInfo[] {
                new ExecutionInfo(8, 0, vLocalStartPos, vLocalStartDir)
            });
            InitExecutionActions();
        }
        ExecutionInfo currentExecutionInfo = null;
        if(super.aExecutionSteps != null && super.aExecutionSteps.length > 0)
            currentExecutionInfo = GetFirstValidExecutionInfo(super.aExecutionSteps[0]);
        executor.TriggerObjectNotification(this, currentExecutionInfo);
    }

    void UpdateSmokeFX()
    {
        ExecuteFX(sFXSmokeName, GetPosition());
    }

    public void SetVehicleForMovie(boolean bIsInMovie, boolean bPlayEngineStartStopSound)
    {
        SetPlayEngineStartStopSound(bPlayEngineStartStopSound);
        m_bVehicleInMovie = bIsInMovie;
        if(bIsInMovie)
        {
            SetState("MovieSimulateState");
        } else
        {
            if(m_bPhysicsActive)
                SetPhysicsVehicleActive(false);
            SetState("StillState");
        }
        SetPlayEngineStartStopSound(true);
    }

    void DetachLoopSound()
    {
        if(m_nSoundLoopId != 0)
        {
            DetachSound(m_nSoundLoopId);
            m_nSoundLoopId = 0;
            m_bEngineOn = false;
        }
    }

    public void ActivateVehicle(boolean bActivate, boolean bGridIndependent, boolean bActivatePhysics)
    {
        if(bActivate)
        {
            if(m_iStampSize > 0 && !IsUpdatingPathMap())
                UpdatePathMap(true, m_iStampSize, true);
            if(bGridIndependent)
                ActivateOnModuleGridIndependent();
            else
                ActivateOnModule();
            if(m_bSmokeSpawned)
                UnfreezeCallMethod(METHOD_UpdateSmokeFX);
            fLastT = GetTime();
        } else
        {
            if(m_iStampSize > 0 && IsUpdatingPathMap())
                UpdatePathMap(false, m_iStampSize, true);
            if(m_bSmokeSpawned)
                FreezeCallMethod(METHOD_UpdateSmokeFX);
            DeactivateOnModuleAlways();
        }
        if(bActivate && bActivatePhysics)
            SetPhysicsVehicleActive(bActivate);
        else
            SetPhysicsVehicleActive(false);
    }

    public void OnAudioReinitialize()
    {
        if(m_nSoundLoopId != 0)
        {
            m_nSoundLoopId = 0;
            AttachLoopSound();
        }
    }

    String GetTip()
    {
        return "&GET_IN_VEHICLE&";
    }

    void ServerHideWreck()
    {
        HideWreck();
        if(super.Role == 4)
            MsgSendClientHideWreck();
    }

    void HideWreck()
    {
        if(m_Wreck == null)
        {
            return;
        } else
        {
            m_Wreck.DeactivateOnModuleAlways();
            m_Wreck.ClearFlag(1);
            m_Wreck.EnableRendering(false);
            m_bWreckVisible = false;
            StopFXSmokeUpdate();
            return;
        }
    }

    public void ReplicationInit()
    {
        sm_nVehicleMoveSet = NewReplicationSet("nativePosition;nativeDir;m_fCurrDirAngle;m_fCurrSpeed;m_iAcc;m_fTurn");
        sm_nVehicleHealthSet = NewReplicationSet("fHealth");
        SetNetPriority(2.0F);
        SetMinRelevantLevel(0.01F);
    }

    int GetSeatIndex(SeatInfo cSeat)
    {
        return aSeatsInfo.indexOf(cSeat);
    }

    SeatInfo GetSeatByIndex(int nIndex)
    {
        if(nIndex >= 0 && nIndex < aSeatsInfo.size())
            return (SeatInfo)aSeatsInfo.get(nIndex);
        else
            return null;
    }

    void MessagePackPos()
    {
        MessagePackVector(GetUpVector());
        MessagePackVector(GetForwardVector());
        MessagePackVector(GetPosition());
    }

    public void TurnOnPassengersCollisions()
    {
        for(int i = 0; i < m_TempObjects.size(); i++)
            if(m_BoolTab[i])
                ((ControlObject)m_TempObjects.get(i)).SetFlag(1);

    }

    void SetUpHudComponentToUpdate(HUDManager hud)
    {
        if(hud != null)
            hud.SetUniversalHUDActor(this, Text.Get("&HUD_VEHICLE_HEALTH&"), super.fMaxHealth, 0.0F);
    }

    void StopUpdatingHud(HUDManager hud)
    {
        DisableCallMethod("UpdateHUD");
        if(hud != null)
            hud.ClearUniversalHUDActor(this);
    }

    void ResetRespawnCnt()
    {
        m_nRespawnCnt = 0;
    }

    int GetRespawnCnt()
    {
        return m_nRespawnCnt;
    }

    void CreatePhysics()
    {
        m_Physics = new PhysicsVehicle(this);
        m_Physics.Init();
    }

    public void PatrolResume()
    {
        m_bBreakPatrol = false;
    }

    void OnCollisionWithPlayer()
    {
        GameObject.InvokeActionChain(aOnCollisionWithPlayer);
    }

    public Pawn[] GetAllOccupants()
    {
        int nOccupants = GetAllOccupantsNum();
        if(nOccupants == 0)
            return null;
        Pawn tab[] = new Pawn[nOccupants];
        int nNdx = 0;
        for(int i = 0; i < aSeatsInfo.size(); i++)
        {
            SeatInfo info = (SeatInfo)aSeatsInfo.get(i);
            if(info.IsOccupied())
            {
                tab[nNdx] = info.GetOccupant();
                nNdx++;
            }
        }

        return tab;
    }

    SeatInfo GetCurrentPointedSeat(ControlObject Activator)
    {
        if(!(Activator instanceof Pawn))
            return null;
        Pawn pawn = (Pawn)Activator;
        Vector vActivatorPos = Activator.GetPositionVectorVolatile();
        SeatInfo reservedSeat = GetSeatReservedBy(pawn);
        if(reservedSeat != null && vActivatorPos.Distance(reservedSeat.GetStartPos()) < reservedSeat.GetMoveInRadius())
            return reservedSeat;
        SeatInfo seats[] = GetFreeSeats();
        if(seats == null)
            return null;
        for(int i = 0; i < seats.length; i++)
            if(vActivatorPos.Distance(seats[i].GetStartPos()) < seats[i].GetMoveInRadius())
                return seats[i];

        return null;
    }

    void SetPhysicsVehicleActive(boolean bActive)
    {
        m_bPhysicsActive = bActive;
        if(m_bPhysicsActive)
        {
            StartSounds();
            InitPhysicsParamsFromVehicle();
        } else
        {
            StopSounds();
        }
    }

    void AdditionalSimulateOnRender(Vector vRenderPos, Vector vRenderDir, Vector vRenderRight, Vector vRenderUp)
    {
        float fDeltaTime = GetTime() - GetPhysicsLastUpdateTime();
        if(fDeltaTime > 0.0F && Math.abs(fDeltaTime) < 1.0F)
        {
            TurnOffPassengersCollisions();
            m_Physics.AdditionalSimulate(m_iAcc, m_fTurn, fDeltaTime, vRenderPos, vRenderDir, vRenderRight, vRenderUp);
            TurnOnPassengersCollisions();
        } else
        {
            GetPosition(vRenderPos);
            GetForwardVector(vRenderDir);
            GetRightVector(vRenderRight);
            GetUpVector(vRenderUp);
        }
    }

    public void SetAllFramePeriod(float fAllFrameTime)
    {
        m_fAllFrameTime = fAllFrameTime;
    }

    public float GetNextTimePeriod()
    {
        m_fAllFrameTime -= PHYSICS_GRAIN;
        if(m_fAllFrameTime >= 0.0F)
            return PHYSICS_GRAIN;
        if(m_fAllFrameTime > -PHYSICS_GRAIN)
            return m_fAllFrameTime + PHYSICS_GRAIN;
        else
            return 0.0F;
    }

    public Vector GetSpeed()
    {
        return new Vector(m_Physics.m_vMoveDir);
    }

    void SetPlayEngineStartStopSound(boolean bPlayEngineStartStopSound)
    {
        m_bPlayEngineStartStopSound = bPlayEngineStartStopSound;
    }

    void TextMessageAlreadyDestroyed()
    {
        Pawn occupants[] = GetAllOccupants();
        if(occupants == null)
            return;
        for(int i = 0; i < occupants.length; i++)
            occupants[i].TextMessage("&VEHICLE_ALREADY_DESTROYED&");

    }

    public void AddSeatInfo(SeatInfo info)
    {
        if(info != null)
            aSeatsInfo.add(info);
    }

    public void TryToAttachDriver()
    {
        ChromeActor driver = GetFirstOccupant(0);
        if(driver != null && (driver instanceof Player))
        {
            Pawn player = (Pawn)driver;
            player.cSeatInfo.Occupy(null);
            Execute(player);
        }
    }

    void SetVehicleParamsForPatrol()
    {
        if(m_bValuesSetForPatrol)
        {
            return;
        } else
        {
            m_bValuesSetForPatrol = true;
            m_fOldSlideValue = m_Physics.m_Params._SLIDE_SUPRESS;
            m_Physics.m_Params._SLIDE_SUPRESS = m_Physics.m_Params._SLIDE_COEF;
            m_fOldSlowDownValue = m_Physics.m_Params._SLOW_COEF;
            m_fOldAccelValue = m_Physics.m_Params._ACCELERATION_COEF;
            m_Physics.m_Params._ACCELERATION_COEF = 700F;
            m_fOldBrakeValue = m_Physics.m_Params._BRAKE_COEF;
            m_Physics.m_Params._BRAKE_COEF = 2500F;
            return;
        }
    }

    void RestoreVehicleParamsBeforePatrol()
    {
        if(!m_bValuesSetForPatrol)
        {
            return;
        } else
        {
            m_bValuesSetForPatrol = false;
            m_bIsPatrolling = false;
            m_Physics.m_Params._SLIDE_SUPRESS = m_fOldSlideValue;
            m_Physics.m_Params._SLOW_COEF = m_fOldSlowDownValue;
            m_Physics.m_Params._ACCELERATION_COEF = m_fOldAccelValue;
            m_Physics.m_Params._BRAKE_COEF = m_fOldBrakeValue;
            return;
        }
    }

    void EnableBack()
    {
        DisableCallMethod("EnableBack");
        if(m_Physics != null)
            m_Physics.EnableBack();
    }

    public Vector GetCheckedPosToGetOut(SeatInfo info)
    {
        if(info.GetOccupant() == null)
            return info.GetStartPos();
        int iFlags = GetFlags();
        ClearFlag(32);
        Vector vPos = CanGetOutToPos(info, info.GetSeatPos(), info.GetStartPos());
        if(vPos != null)
        {
            SetFlags(iFlags);
            return vPos;
        }
        Vector vExtents[] = {
            new Vector(), new Vector(), new Vector(), new Vector()
        };
        GetMeshExtents(vExtents[0], vExtents[1]);
        vExtents[2].Set(vExtents[0]);
        vExtents[2].fZ = (vExtents[1].fZ + vExtents[0].fZ) / 2.0F;
        vExtents[2].fX -= _CORRECTION;
        vExtents[3].Set(vExtents[1]);
        vExtents[3].fZ = vExtents[2].fZ;
        vExtents[3].fX += _CORRECTION;
        vExtents[0].fX = (vExtents[3].fX + vExtents[2].fX) / 2.0F;
        vExtents[0].fZ -= _CORRECTION;
        vExtents[1].fX = vExtents[0].fX;
        vExtents[1].fZ += _CORRECTION;
        for(int i = 0; i < vExtents.length; i++)
        {
            vExtents[i] = PointLocalToWorld(vExtents[i]);
            vExtents[i].fY = info.GetSeatPos().fY;
        }

        for(int i = 0; i < vExtents.length; i++)
        {
            vPos = CanGetOutToPos(info, info.GetSeatPos(), vExtents[i]);
            if(vPos != null)
            {
                SetFlags(iFlags);
                return vPos;
            }
        }

        SetFlags(iFlags);
        Vector vMin = new Vector();
        Vector vMax = new Vector();
        GetMeshExtentsInWorld(vMin, vMax);
        vPos = GetPosition();
        vPos.fY += Math.abs(vMax.fY - vMin.fY) + 10F;
        return vPos;
    }

    protected void SetCanGetOut(boolean bCanGetOut)
    {
        for(int i = 0; i < aSeatsInfo.size(); i++)
            ((SeatInfo)aSeatsInfo.get(i)).SetCanGetOut(bCanGetOut);

    }

    void OnDestinationPos(int iDestPointNum)
    {
        if(m_bEditorAction && m_VehicleController != null)
            m_VehicleController.Checkpoint();
        Pawn occupants[] = GetAllOccupants();
        if(occupants != null)
        {
            for(int i = 0; i < occupants.length; i++)
                if((occupants[i] instanceof NewAI) && ((NewAI)occupants[i]).GetController() != m_VehicleController)
                    ((NewAI)occupants[i]).GetController().Checkpoint();

        }
        m_iCurrPatrolPoint = iDestPointNum + m_iAddValue;
        if(m_iCurrPatrolPoint == m_VehiclePath.GetPointsNum())
        {
            if(m_VehiclePath.IsPathLooped())
                m_iCurrPatrolPoint = 0;
            else
            if(m_VehiclePath.IsPathOneWay())
            {
                m_bDriveFinished = true;
                motion.Stop();
                RestoreVehicleParamsBeforePatrol();
            } else
            if(m_VehiclePath.IsPathTwoWays())
            {
                m_iAddValue = -1;
                m_iCurrPatrolPoint = m_VehiclePath.GetPointsNum() - 2;
                if(m_iCurrPatrolPoint < 0)
                    m_iCurrPatrolPoint = 0;
            }
        } else
        if(m_iCurrPatrolPoint == 0)
        {
            m_iAddValue = 1;
            m_iCurrPatrolPoint = 1;
            if(m_VehiclePath.GetPointsNum() < 2)
                m_iCurrPatrolPoint = 0;
        }
    }

    void OnDestinationPos()
    {
        if(m_bEditorAction && m_VehicleController != null)
        {
            m_VehicleController.MovingEnd();
        } else
        {
            GameObject.CrashLog("Vehicle.OnDestinationPos().m_bEditorAction:" + m_bEditorAction + "\n");
            GameObject.CrashLog("Vehicle.OnDestinationPos().m_VehicleController:" + m_VehicleController + "\n");
        }
        Pawn occupants[] = GetAllOccupants();
        if(occupants != null)
        {
            for(int i = 0; i < occupants.length; i++)
                if((occupants[i] instanceof NewAI) && ((NewAI)occupants[i]).GetController() != m_VehicleController)
                    ((NewAI)occupants[i]).GetController().MovingEnd();

        }
    }

    public SeatInfo GetSeatOccupiedBy(Pawn actor)
    {
        for(int i = 0; i < aSeatsInfo.size(); i++)
        {
            SeatInfo info = (SeatInfo)aSeatsInfo.get(i);
            if(info.GetOccupant() == actor)
                return info;
        }

        return null;
    }

    void ShowWreck()
    {
        if(m_Wreck == null)
        {
            return;
        } else
        {
            m_Wreck.ActivateOnModule();
            m_Wreck.SetFlag(1);
            m_Wreck.EnableRendering(true);
            m_Wreck.FromUpForwardPos(Vector.Up, GetForwardVector(), GetPosition());
            m_bWreckVisible = true;
            return;
        }
    }

    void MsgSendClientHideWreck()
    {
        MessageNew(4);
        MessageSend();
    }

    void MsgRecvClientCrash()
    {
        MessageEnd();
        VehicleCrashed();
    }

    public void MultiplyMotionSpeedValue(int iMotionSpeed, float fSpeedValueMulitplier)
    {
        if(iMotionSpeed >= 0 && iMotionSpeed < m_aSpeeds.length)
            m_aSpeeds[iMotionSpeed] *= fSpeedValueMulitplier;
    }

    public void Execute(Actor executor)
    {
        super.Execute(executor);
        if(!(executor instanceof Pawn))
        {
            GameObject.CrashLog("[Vehicle.ActionExecute]: Vehicle can be executed only by Pawn\n");
            return;
        }
        Pawn pawn = (Pawn)executor;
        SeatInfo seat = GetCurrentPointedSeat(executor);
        if(seat == null)
        {
            GameObject.CrashLog("Vehicle.Execute(): seat == null \n");
            return;
        }
        pawn.PrepareToGetIn(seat);
        if(seat.GetReserver() == executor)
            pawn.GetIn(seat);
    }

    public void Execute(Actor executor, int iSeatType)
    {
        super.Execute(executor);
        if(!(executor instanceof Pawn))
        {
            GameObject.CrashLog("[Vehicle.ActionExecute]: Vehicle can be executed only by Pawn\n");
            return;
        }
        Pawn pawn = (Pawn)executor;
        SeatInfo seat = GetFirstFreeSeat(iSeatType);
        if(seat == null)
        {
            GameObject.CrashLog("Vehicle.Execute(): seat == null \n");
            return;
        }
        pawn.PrepareToGetIn(seat);
        if(seat.GetReserver() == executor)
            pawn.GetIn(seat);
    }

    static float RAD_TO_DEG = 57.29578F;
    int N_PHYSICS_UPDATES_PER_S;
    float PHYSICS_GRAIN;
    float m_fObservedSightVAngle;
    float m_fOverObservedHeight;
    float m_fOverObservedBack;
    String sBlobMaterial;
    float fBlobMapSize;
    boolean m_bSimulate;
    ArrayList aSeatsInfo;
    static float _GETOUT_DISTANCEDELTA = 50F;
    static float _GETOUT_ANGLEDELTA = 10F;
    public Action aOnGotInDriver[];
    public Action aOnGotInPassenger[];
    public Action aOnGetOutDriver[];
    public Action aOnGetOutPassenger[];
    boolean bExecutorAsPassenger;
    public float fMinHealthCoeffToDrive;
    static float _TIME_TO_GET_OUT_IF_VEHICLE_ALREADY_DESTROYED = 5F;
    public Action aOnCantDrive[];
    public PhysicsVehicle m_Physics;
    boolean m_bPhysicsActive;
    public boolean m_bEngineOn;
    VehicleMotionState motion;
    protected float fLastT;
    public boolean m_bCanDrive;
    public byte nVehicleType;
    public float fFuel;
    public float fFuelConsumption;
    public float m_fAllFrameTime;
    public boolean m_bVehicleInMovie;
    int m_iCurrPatrolPoint;
    int m_iAddValue;
    boolean m_bDriveFinished;
    boolean m_bBreakPatrol;
    boolean m_bIsPatrolling;
    Path m_VehiclePath;
    float m_fOldSlideValue;
    float m_fOldSlowDownValue;
    float m_fOldAccelValue;
    float m_fOldBrakeValue;
    static float _PATH_SLOW_VALUE = 5000F;
    public String m_sSoundStartName;
    public String m_sSoundLoopName;
    public float m_fSoundLoopMin;
    public float m_fSoundLoopMax;
    public String m_sSoundStopName;
    public String m_sSoundBrakeName;
    public String m_sSoundAccelName;
    public String m_sSoundHitName;
    public String m_sSoundSlideName;
    public int m_nSoundLoopId;
    boolean m_bPlayEngineStartStopSound;
    public float m_fMinFreq;
    public float m_fMaxFreq;
    public float m_fMaxFreqBack;
    boolean m_bSoundsStarted;
    float m_aSpeeds[] = {
        0, 210F, 630F, 1050F, 1575F, 2100F
    };
    boolean m_bUseMotionSpeed;
    boolean m_bEditorAction;
    IVehiclePassenger m_VehicleController;
    public String sBlowUpFX;
    public String sBlowUpSound;
    public float fBlowUpShakeStrength;
    public float fBlowUpShakeDistMin;
    public float fBlowUpShakeDistMax;
    float m_fOccupantsDamageMul;
    float m_fSingleOccupantsDamageMul;
    float m_fNetOccupantsDamageMul;
    public float fFXSmokeUpdateTime;
    public String sFXSmokeName;
    public boolean bSpawnSmokeFX;
    int METHOD_UpdateSmokeFX;
    boolean m_bSmokeSpawned;
    float m_fAttenuation;
    float m_fForceFactor;
    float m_fAmplitudeCoeff;
    int m_iStampSize;
    public VehiclePod m_cPod;
    boolean m_bLocalPlayerDriver;
    public boolean m_bMakeVehicleNoiseInMovie;
    String sVehicleProfilingPage;
    static boolean bInitProfiling = true;
    static int PROFILE_GeneralA = 0;
    static int PROFILE_GeneralB = 0;
    static int PROFILE_GeneralC = 0;
    Vector m_vFXDir;
    Vector m_vFXParticlesDir;
    Vector m_vPositionModifier;
    String m_sWreckMeshName;
    VehicleWreck m_Wreck;
    boolean m_bWreckVisible;
    public Action aOnCollisionWithPlayer[];
    float _CORRECTION;
    float _GET_OUT_TOLERANCE;
    float m_fDownTestVectorLen;
    boolean m_bIsGridIndependent;
    boolean bOnAppearShowWreckOnly;
    ArrayList m_TempObjects;
    boolean m_BoolTab[];
    float m_fTestGranularity;
    public float fMinMotionNoiseRadius;
    public float fMaxMotionNoiseRadius;
    public float fPredictionNoiseSecs;
    public float fMinMotionNoiseTime;
    private float m_fLastVehicleNoiseTime;
    private Vector m_vNoisePos;
    private LaserPointer m_aVis[];
    private int _VIS_STEPS;
    boolean bNoiseVis;
    Vector m_vLastPos;
    Vector m_vLastDir;
    boolean m_bValuesSetForPatrol;
    static final int MSG_CLIENT_RESPAWN = 0;
    static final int MSG_CLIENT_VEHICLE_STATE = 1;
    static final int MSG_CLIENT_CANNOT_DRIVE = 2;
    static final int MSG_CLIENT_CRASH = 3;
    static final int MSG_CLIENT_HIDE_WRECK = 4;
    static final int MSG_SERVER_COLLISION = 5;
    boolean m_bModuleNet;
    float m_fCurrDirAngle;
    float m_fCurrSpeed;
    float m_fMoveSpeed;
    byte m_iAcc;
    float m_fTurn;
    static int sm_nVehicleMoveSet = -1;
    static int sm_nVehicleHealthSet = -1;
    boolean bOld;
    private int m_nRespawnCnt;
    boolean m_bGameLoading;
    int m_nSoundLoopIdSG;
    Vector m_vActuallyUp;
    Vector m_vRenderUp;
    boolean m_bOnRenderUp;

}
