// Decompiled by Jad v1.5.8e. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) deadcode 
// Source File Name:   Walker.java

import java.util.Vector;

public class Walker extends Vehicle
{
    public class CrashedState extends Vehicle.CrashedState
    {

        public void SGUpdate()
        {
            FileChunk.Log("[Walker$CrashedState] : SGUpdate\n");
            SetPhysicsVehicleActive(false);
            HideHead();
            DeleteAttachedFXes();
            DisableCallMethods();
        }

        public void OnEnter()
        {
            SetPhysicsVehicleActive(false);
            if(m_sDieBlowFX != null)
            {
                ExecuteFX(m_sDieBlowFX, GetElementPos(m_nHorizRotateElem), Vector.Up);
                ExecuteParticleSystem(m_sDieBlowFX, GetElementPos(m_nHorizRotateElem), Vector.Up);
            }
            if(m_sDieBlowSound != null)
                PlaySound(m_sDieBlowSound);
            if(fBlowUpShakeStrength > 0.0F)
                ShakePlayersCamera(fBlowUpShakeStrength, fBlowUpShakeDistMin, fBlowUpShakeDistMax);
            HideHead();
            PlayAnimOnce(6);
            DeleteAttachedFXes();
            DisableCallMethods();
        }

        public CrashedState()
        {
        }
    }


    void OnAnimCycle(int nAnimId, int nCount)
    {
        DisableCallMethod(METHOD_PlayStepSound);
        if(nAnimId == m_nLastStepLoopAnimId)
        {
            PlayStepSound();
            CallMethodIn(METHOD_PlayStepSound, GetAnimLength(nAnimId) / 2.0F);
        }
    }

    void OnDestroy()
    {
        super.OnDestroy();
        m_aWeapons.Destroy();
    }

    public void OnAudioReinitialize()
    {
        m_nHeadRotateSoundID = -1;
    }

    void InitMesh()
    {
        m_nVertRotateElem = GetElementID(m_sVertRotateElem);
        m_nHorizRotateElem = GetElementID(m_sHorizRotateElem);
        m_nElemPointToLookAt = GetElementID(m_sMeshElementToLookAt);
        SetElementAnimType(m_nHorizRotateElem, (byte)3, false);
        SetElementAnimType(m_nVertRotateElem, (byte)3, false);
        SetAnimMorphTime(m_nHorizRotateElem, 0.3F, false);
        SetAnimMorphTime(m_nVertRotateElem, 0.3F, false);
        SetEllipsoidNoExtents(m_vEllipsoid.fX, m_vEllipsoid.fY, m_vEllipsoid.fZ);
    }

    Vector GetTargetPoint()
    {
        m_vTargetPoint.Set(m_fTargetX, m_fTargetY, m_fTargetZ);
        return m_vTargetPoint;
    }

    public void ReplicationInit()
    {
        super.ReplicationInit();
        sm_nWalkerState = NewReplicationSet("m_fHorizAngle;m_fVertAngle;m_bPrimaryWeaponFiring;m_bSecondaryWeaponFiring;m_fTargetX;m_fTargetY;m_fTargetZ");
    }

    void UnhideHead()
    {
        if(m_aHeadElements == null)
            return;
        for(int i = 0; i < m_aHeadElements.length; i++)
        {
            int nId = GetElementID(m_aHeadElements[i]);
            UnhideElement(nId);
            EnableCollisionsElement(nId, true);
        }

    }

    void MsgSendAnim(int nAnim, boolean bStepAnimation)
    {
        MessageNew(11);
        MessagePackInt(nAnim);
        MessagePackBoolean(bStepAnimation);
        MessageSend();
    }

    void PlayAnimLoop(int nAnim, boolean bStepAnimation)
    {
        if(super.Role == 4 || super.m_bLocalPlayerDriver)
            MsgSendAnim(nAnim, bStepAnimation);
        PlayAnim(m_aAnims[nAnim], -1);
        PlayAnimSound(nAnim);
        if(bStepAnimation)
        {
            m_nLastStepLoopAnimId = m_aAnims[nAnim];
            OnAnimCycle(m_nLastStepLoopAnimId, -1);
        } else
        {
            DisableCallMethod(METHOD_PlayStepSound);
            m_nLastStepLoopAnimId = -1;
        }
        DisableCallMethod("PlayAnimLater");
    }

    float GetMinVertAngle()
    {
        return m_fMinVAngle;
    }

    public void RotateHeadDo(float fHorizAngle, float fVertAngle)
    {
        RotateElementWithAnim(m_nVertRotateElem, Vector.Right, fVertAngle);
        RotateElementWithAnim(m_nHorizRotateElem, Vector.Up, fHorizAngle);
    }

    public void OnPostUpdate()
    {
        float fDelta = Math.abs(m_fHorizAngle - m_fLastHorizAngle) + Math.abs(m_fVertAngle - m_fLastVertAngle);
        if(fDelta > 0.0F)
        {
            RotateHeadDo(m_fHorizAngle, m_fVertAngle);
            if(fDelta > 3F)
                PlayHeadRotateSound(Math.max(GetAnimMorphTime(m_nHorizRotateElem), GetAnimMorphTime(m_nVertRotateElem)));
            m_fLastHorizAngle = m_fHorizAngle;
            m_fLastVertAngle = m_fVertAngle;
        }
        if(m_bPrimaryWeaponLastFiring != m_bPrimaryWeaponFiring)
        {
            SetFire(0, m_bPrimaryWeaponFiring);
            m_bPrimaryWeaponLastFiring = m_bPrimaryWeaponFiring;
        }
        if(m_bSecondaryWeaponLastFiring != m_bSecondaryWeaponFiring)
        {
            SetFire(1, m_bSecondaryWeaponFiring);
            m_bSecondaryWeaponLastFiring = m_bSecondaryWeaponFiring;
        }
    }

    void AttachLoopSound()
    {
        super.AttachLoopSound();
        super.m_bEngineOn = true;
    }

    void PlayStepSound()
    {
        if(m_sStepSound != null)
            PlaySound(m_sStepSound);
    }

    void PlayHeadRotateSound(float fTime)
    {
        if(m_nHeadRotateSoundID < 0)
        {
            if(m_sHeadLoopSound != null)
                m_nHeadRotateSoundID = AttachSound(m_sHeadLoopSound);
        } else
        {
            PlaySound(m_nHeadRotateSoundID);
        }
        DisableCallMethod(METHOD_StopHeadRotateSound);
        CallMethodIn(METHOD_StopHeadRotateSound, fTime);
    }

    void CreatePhysics()
    {
        super.m_Physics = m_cPhysicsWalker = new PhysicsWalker(this);
        super.m_Physics.Init();
        super.m_Physics.sWheelSmokeFX = null;
        super.m_Physics.bWheelSmokeFX = false;
        super.m_Physics.m_Params._TURNING_SPEED = 0.0F;
        super.m_Physics.m_Params._ROTATE_SPEED = m_fRotateSpeed;
        super.m_Physics.m_Params.SetMaxSpeed(m_fWalkSpeed);
        super.m_Physics.m_Params._MIN_SPEED_TO_COLLIDE = m_fWalkSpeed + 1.0F;
        super.m_Physics.m_Params._CURR_MAX_SPEED = m_fWalkSpeed;
        super.m_Physics.m_Params._MIN_SPEED = -m_fWalkSpeedBack;
        super.m_bUseMotionSpeed = false;
    }

    void MsgSendClientWeaponsInfo()
    {
        MessageNew(10);
        MessagePackInt(m_aWeapons.GetSize());
        for(int i = 0; i < m_aWeapons.GetSize(); i++)
        {
            WeaponWalker cWeapon = m_aWeapons.Get(i);
            GameObject.LogR("MsgSendClientWeaponsInfo " + cWeapon + " " + cWeapon.GetMode() + " " + cWeapon.GetWalkerElementBarrelExit() + "\n");
            MessagePackInt(cWeapon.GetWeapon().GetNetId());
            MessagePackInt(cWeapon.GetMode());
            MessagePackString(cWeapon.GetWalkerElementBarrelExit());
        }

        MessageSend();
    }

    void Respawn(boolean bOnLevelRestart)
    {
        super.Respawn(bOnLevelRestart);
        UnhideHead();
    }

    void ApplyNewWeapon(Weapon cWeapon, String sWalkerElementBarrelExit, int nMode)
    {
        GameObject.LogR("ApplyNewWeapon " + cWeapon + " " + sWalkerElementBarrelExit + " " + nMode + "\n");
        AttachChild(cWeapon, GetElementID(sWalkerElementBarrelExit));
        cWeapon.SetWalkerMode(this);
        m_aWeapons.Add(new WeaponWalker(cWeapon, nMode, sWalkerElementBarrelExit));
    }

    void PlayAnimLater(int nAnim, float fDelay)
    {
        m_nAnimToPlay = nAnim;
        DisableCallMethod("PlayAnimLater");
        CallMethodIn("PlayAnimLater", fDelay);
    }

    void PlayAnimLater()
    {
        DisableCallMethod("PlayAnimLater");
        PlayAnimOnce(m_nAnimToPlay);
    }

    public void PawnGotIn(SeatInfo info, Pawn pawn)
    {
        super.PawnGotIn(info, pawn);
        PlayAnimOnce(10);
        CallMethodIn(METHOD_EnableWalk, 2.0F);
        m_aWeapons.SetWeaponsOwner(pawn);
    }

    public void OnReplicateServer()
    {
        super.OnReplicateServer();
        if(super.bNetInit)
            MsgSendClientWeaponsInfo();
        Pawn driver = GetFirstOccupant(0);
        if(driver == null || !((GameObject) (driver)).bNetIsOwner)
            Replicate(sm_nWalkerState);
    }

    public void OnMessage()
    {
        switch(MessageGetId())
        {
        case 10: // '\n'
            GameObject.LogD(" MSG_WEAPONSINFO\n");
            MsgRecvClientWeaponsInfo();
            break;

        case 11: // '\013'
            GameObject.LogD(" MSG_ANIM\n");
            MsgRecvAnim();
            break;

        default:
            super.OnMessage();
            break;
        }
    }

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[Walker.SGSaveChunk]\n");
        FileChunk cFC = GameObject.NewChunk(1625, cFCParent);
        super.SGSaveChunk(cFC);
        m_cPhysicsWalker.SGSaveChunk(cFC);
        cFC.SaveObject(m_aWeapons);
        if(m_nHeadRotateSoundID > 0 && !IsSoundPlaying(m_nHeadRotateSoundID))
            cFC.SaveInt(-1);
        else
            cFC.SaveInt(m_nHeadRotateSoundID);
        cFC.SaveFloat(m_fWalkSpeed);
        cFC.SaveFloat(m_fWalkSpeedBack);
        cFC.SaveFloat(m_fRotateSpeed);
        cFC.SaveFloat(m_fWalkAnimSpeed);
        cFC.SaveFloat(m_fWalkAnimSpeedMul);
        cFC.delete();
    }

    void CheckWeaponsToApply()
    {
        for(int i = 0; i < m_aWeaponsToApply.size(); i++)
        {
            boolean bRemove = true;
            if(m_aWeaponsToApply.elementAt(i) instanceof WeaponWalkerInfo)
            {
                WeaponWalkerInfo cInfo = (WeaponWalkerInfo)m_aWeaponsToApply.elementAt(i);
                Weapon cWeapon = GetWeaponByNetId(cInfo.GetNetId());
                if(cWeapon != null)
                    ApplyNewWeapon(cWeapon, cInfo.GetWalkerElementBarrelExit(), cInfo.GetMode());
                else
                    bRemove = false;
            }
            if(bRemove)
            {
                m_aWeaponsToApply.removeElementAt(i);
                i--;
            }
        }

        if(m_aWeaponsToApply.size() <= 0)
            DisableCallMethod(METHOD_CheckWeaponsToApply);
    }

    public void SGLoadChunk(FileChunk cParentFC)
    {
        FileChunk.Log("[Walker.SGLoadChunk]\n");
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        if(cFC.GetID() == 1625)
        {
            super.SGLoadChunk(cFC);
            m_cPhysicsWalker.SGLoadChunk(cFC);
            m_aWeapons = (WeaponWalkerList)cFC.LoadObject(m_aWeapons, this);
            m_nHeadRotateSoundIDSG = cFC.LoadInt();
            m_fWalkSpeed = cFC.LoadFloat();
            m_fWalkSpeedBack = cFC.LoadFloat();
            m_fRotateSpeed = cFC.LoadFloat();
            m_fWalkAnimSpeed = cFC.LoadFloat();
            m_fWalkAnimSpeedMul = cFC.LoadFloat();
        }
        cFC.delete();
    }

    float GetMaxHorizAngle()
    {
        return m_fMaxHAngle;
    }

    void InitAnimations()
    {
        String sRootElementName = "";
        m_aAnims[0] = GetAnimID(sRootElementName, "normal");
        m_aAnims[1] = GetAnimID(sRootElementName, "walk");
        m_aAnims[2] = GetAnimID(sRootElementName, "walk_back");
        m_aAnims[3] = GetAnimID(sRootElementName, "rotate_left");
        m_aAnims[4] = GetAnimID(sRootElementName, "rotate_right");
        m_aAnims[5] = GetAnimID(sRootElementName, "normal-standby");
        m_aAnims[6] = GetAnimID(sRootElementName, "Standby");
        m_aAnims[7] = GetAnimID(sRootElementName, "standby-standby_open");
        m_aAnims[8] = GetAnimID(sRootElementName, "standby_open");
        m_aAnims[9] = GetAnimID(sRootElementName, "Standby_open-standby");
        m_aAnims[10] = GetAnimID(sRootElementName, "Wakeup");
        m_aAnims[11] = GetAnimID(sRootElementName, "normal-up");
        m_aAnims[12] = GetAnimID(sRootElementName, "up");
        m_aAnims[13] = GetAnimID(sRootElementName, "up-normal");
        m_aAnims[14] = GetAnimID(sRootElementName, "normal-down");
        m_aAnims[15] = GetAnimID(sRootElementName, "down");
        m_aAnims[16] = GetAnimID(sRootElementName, "down-normal");
        CalcWalkAnimSpeed("Walker R Foot", "Walker L Foot");
        SetFrame(m_aAnims[6], GetFirstFrame(m_aAnims[6]), -1);
        SetAnimMorphTime(0.5F);
    }

    void DisableWalk()
    {
        DisableCallMethod(METHOD_EnableWalk);
        m_cPhysicsWalker.EnableWalk(false);
    }

    void StopHeadRotateSound()
    {
        if(m_nHeadRotateSoundID > 0)
            StopSound(m_nHeadRotateSoundID);
    }

    void PassengerIsDead()
    {
    }

    Walker()
    {
        m_aAnims = new int[17];
        m_cPhysicsWalker = null;
        m_aWeapons = new WeaponWalkerList(this);
        m_sVertRotateElem = "Walker Neck";
        m_nVertRotateElem = -1;
        m_sHorizRotateElem = "Walker Head";
        m_nHorizRotateElem = -1;
        m_sMeshElementToLookAt = "Walker Cockpit";
        m_nElemPointToLookAt = -1;
        m_vEllipsoid = new Vector(180F, 450F, 225F);
        m_aWalkerAnimsSounds = null;
        m_sStepSound = null;
        m_sHeadLoopSound = null;
        m_nHeadRotateSoundID = -1;
        m_fMaxHAngle = 15F;
        m_fMaxVAngle = 20F;
        m_fMinVAngle = -10F;
        METHOD_EnableWalk = 0;
        METHOD_StopHeadRotateSound = 0;
        METHOD_StopGunRotateSound = 0;
        METHOD_PlayStepSound = 0;
        METHOD_CheckWeaponsToApply = 0;
        m_sDieBlowFX = "FXBlowWalker";
        m_sDieBlowSound = "Data/Sounds/Explosion/WalkerDieExplosion.wav";
        m_aHeadElements = null;
        m_fWalkSpeed = 210F;
        m_fWalkSpeedBack = 130F;
        m_fRotateSpeed = 30F;
        m_fWalkAnimSpeed = 1.0F;
        m_fWalkAnimSpeedMul = 1.0F;
        m_nAnimToPlay = -1;
        m_nLastStepLoopAnimId = -1;
        m_vTargetPoint = new Vector();
        m_fTargetX = 0.0F;
        m_fTargetY = 0.0F;
        m_fTargetZ = 0.0F;
        m_fMinVertHeadAngle = -25F;
        m_fMaxVertHeadAngle = 16F;
        m_fMaxHorizHeadAngle = 40F;
        m_fHorizVertAddAngle = -20F;
        m_fLastHorizAngle = 0.0F;
        m_fLastVertAngle = 0.0F;
        m_fHorizAngle = 0.0F;
        m_fVertAngle = 0.0F;
        fVertMul = 0.5F;
        _GET_OUT_DOWN_CORRECTION = -200F;
        m_nHeadRotateSoundIDSG = -1;
        m_aWeaponsToApply = new Vector();
        m_bPrimaryWeaponFiring = false;
        m_bSecondaryWeaponFiring = false;
        m_bPrimaryWeaponLastFiring = false;
        m_bSecondaryWeaponLastFiring = false;
        super.MeshName = "Data/Meshes/Ai/Walker_w.3da";
        super.fHealth = super.fMaxHealth = 3500F;
        super.bForceWholeObjectCollision = true;
        super.m_sSoundStartName = null;
        super.m_sSoundLoopName = null;
        super.m_sSoundStopName = null;
        super.m_sSoundAccelName = null;
        super.m_sSoundBrakeName = null;
        super.m_sSoundSlideName = null;
    }

    public boolean IsArmed()
    {
        return true;
    }

    void PlayAnimSound(int nAnim)
    {
        if(m_aWalkerAnimsSounds != null && m_aWalkerAnimsSounds[nAnim] != null)
            PlaySound(m_aWalkerAnimsSounds[nAnim]);
    }

    public Vector GetPointToLookAt(int nPoint)
    {
        return GetElementPos(m_nElemPointToLookAt);
    }

    public void SGUpdate()
    {
        FileChunk.Log("[Walker.SGUpdate]\n");
        super.SGUpdate();
        if(m_nHeadRotateSoundID > 0)
        {
            DetachSound(m_nHeadRotateSoundID);
            m_nHeadRotateSoundID = -1;
        }
        if(m_nHeadRotateSoundIDSG > 0)
        {
            FileChunk.Log("[Walker.SGUpdate] HeadLoopSound attached! \n");
            m_nHeadRotateSoundID = AttachSound(m_sHeadLoopSound);
        }
    }

    void SetFire(int nMode, boolean bFire)
    {
        m_aWeapons.SetFire(nMode, bFire);
    }

    public Vector GetCheckedPosToGetOut(SeatInfo info)
    {
        if(info.GetOccupant() == null)
            return info.GetStartPos();
        int iVehicleFlags = GetFlags();
        ClearFlag(32);
        int iPassengerFlags = GetFlags();
        info.GetOccupant().ClearFlag(32);
        Vector vPos = null;
        Vector vExtents[] = {
            new Vector(), new Vector(), new Vector(), new Vector()
        };
        GetMeshExtents(vExtents[1], vExtents[0]);
        vExtents[2].Set(vExtents[1]);
        vExtents[2].fZ = (vExtents[0].fZ + vExtents[1].fZ) / 2.0F;
        vExtents[2].fX -= super._CORRECTION;
        vExtents[3].Set(vExtents[0]);
        vExtents[3].fZ = vExtents[2].fZ;
        vExtents[3].fX += super._CORRECTION;
        vExtents[1].fX = (vExtents[3].fX + vExtents[2].fX) / 2.0F;
        vExtents[1].fZ -= super._CORRECTION;
        vExtents[0].fX = vExtents[1].fX;
        vExtents[0].fZ += super._CORRECTION;
        for(int i = 0; i < vExtents.length; i++)
        {
            vExtents[i] = PointLocalToWorld(vExtents[i]);
            vExtents[i].fY = info.GetSeatPos().fY + _GET_OUT_DOWN_CORRECTION;
        }

        Vector vFromPos = info.GetSeatPos();
        vFromPos.fY += _GET_OUT_DOWN_CORRECTION;
        for(int i = 0; i < vExtents.length; i++)
        {
            vPos = CanGetOutToPos(info, vFromPos, vExtents[i]);
            if(vPos != null)
            {
                SetFlags(iVehicleFlags);
                info.GetOccupant().SetFlags(iPassengerFlags);
                return vPos;
            }
        }

        SetFlags(iVehicleFlags);
        info.GetOccupant().SetFlags(iPassengerFlags);
        Vector vMin = new Vector();
        Vector vMax = new Vector();
        GetMeshExtentsInWorld(vMin, vMax);
        vPos = GetPosition();
        vPos.fY += Math.abs(vMax.fY - vMin.fY) + 10F;
        return vPos;
    }

    public void PawnGotOut(SeatInfo info, Pawn pawn)
    {
        super.PawnGotOut(info, pawn);
        m_aWeapons.ForceStopFire();
        m_aWeapons.SetWeaponsOwner(null);
        DisableWalk();
        RotateHead(0.0F, 0.0F);
        PlayAnimOnce(5);
    }

    void HideHead()
    {
        if(m_aHeadElements == null)
            return;
        for(int i = 0; i < m_aHeadElements.length; i++)
        {
            int nId = GetElementID(m_aHeadElements[i]);
            HideElement(nId);
            EnableCollisionsElement(nId, false);
        }

    }

    public void RotateHead(float fHorizAngle, float fVertAngle)
    {
        fVertAngle *= fVertMul;
        fHorizAngle = MathUtils.crop(fHorizAngle, -m_fMaxHorizHeadAngle, m_fMaxHorizHeadAngle);
        fVertAngle = MathUtils.crop(fVertAngle, m_fMinVertHeadAngle, m_fMaxVertHeadAngle);
        m_fHorizAngle = fHorizAngle;
        m_fVertAngle = fVertAngle;
    }

    void DriverIsDead()
    {
    }

    void SpeedChanged()
    {
        super.m_Physics.m_Params._ROTATE_SPEED = m_fRotateSpeed;
        super.m_Physics.m_Params.SetMaxSpeed(m_fWalkSpeed);
        super.m_Physics.m_Params._MIN_SPEED_TO_COLLIDE = m_fWalkSpeed + 1.0F;
        super.m_Physics.m_Params._CURR_MAX_SPEED = m_fWalkSpeed;
        super.m_Physics.m_Params._MIN_SPEED = -m_fWalkSpeedBack;
        UpdateWalkAnimsSpeed();
    }

    void MsgRecvAnim()
    {
        int nAnim = MessageUnPackInt();
        boolean bStep = MessageUnPackBoolean();
        MessageEnd();
        if(!super.m_bLocalPlayerDriver && m_cPhysicsWalker.IsWalkEnabled())
            PlayAnimLoop(nAnim, bStep);
    }

    float GetMainGunAccuracy()
    {
        if(m_aWeapons != null)
        {
            for(int i = 0; i < m_aWeapons.GetSize(); i++)
            {
                WeaponWalker cW = m_aWeapons.Get(i);
                if(cW.GetMode() == 0)
                    return cW.m_cWeapon.fBaseAcc;
            }

            return 1.0F;
        } else
        {
            return 0.0F;
        }
    }

    void SetWeaponFiring(int nMode, boolean bFiring)
    {
        if(nMode == 0)
            m_bPrimaryWeaponFiring = bFiring;
        else
            m_bSecondaryWeaponFiring = bFiring;
    }

    float GetMaxVertAngle()
    {
        return m_fMaxVAngle;
    }

    void CreateWeapons()
    {
    }

    void PlayAnimOnce(int nAnim)
    {
        PlayAnim(m_aAnims[nAnim], 1);
        PlayAnimSound(nAnim);
        DisableCallMethod(METHOD_PlayStepSound);
        DisableCallMethod("PlayAnimLater");
    }

    void EnableWalk()
    {
        m_cPhysicsWalker.EnableWalk(true);
    }

    void OnCreate()
    {
        METHOD_EnableWalk = RegisterCallMethod("EnableWalk");
        METHOD_StopHeadRotateSound = RegisterCallMethod("StopHeadRotateSound");
        METHOD_StopGunRotateSound = RegisterCallMethod("StopGunRotateSound");
        METHOD_PlayStepSound = RegisterCallMethod("PlayStepSound");
        METHOD_CheckWeaponsToApply = RegisterCallMethod("CheckWeaponsToApply");
        super.bSG = true;
        super.OnCreate();
        if(super.m_Physics != null)
            UpdatePathMap(true, 7);
        SetFlag(256);
        SetBlobMaterial(super.sBlobMaterial);
        SetBlobMapSize(super.fBlobMapSize);
        SetTraceCollType(5);
        SetCollType(2);
        ClearFlag(4);
        SetFlag(264);
        CreateWeapons();
        InitAnimations();
        InitMesh();
        super.m_fDownTestVectorLen = -500F;
        SetMaxClimbAngle(60F);
    }

    void DetachLoopSound()
    {
        super.DetachLoopSound();
        super.m_bEngineOn = false;
    }

    protected void CalcWalkAnimSpeed(String sFoot1, String sFoot2)
    {
        int nFoot1 = GetElementID(sFoot1);
        int nFoot2 = GetElementID(sFoot2);
        int nAnimForwardId = m_aAnims[1];
        SetFrame(nAnimForwardId, GetFirstFrame(nAnimForwardId), -1);
        Vector vDist = GetElementPos(nFoot1);
        vDist.Sub(GetElementPos(nFoot2));
        vDist = VectorWorldToLocal(vDist);
        float fDist = Math.abs(vDist.fZ);
        m_fWalkAnimSpeed = (2.0F * fDist) / (GetAnimLength(nAnimForwardId) * GetAnimFreq(nAnimForwardId));
        UpdateWalkAnimsSpeed();
    }

    void UpdateWalkAnimsSpeed()
    {
        SetAnimFreq(m_aAnims[1], (m_fWalkAnimSpeedMul * m_fWalkSpeed) / m_fWalkAnimSpeed);
        SetAnimFreq(m_aAnims[2], (m_fWalkAnimSpeedMul * m_fWalkSpeedBack) / m_fWalkAnimSpeed);
    }

    public void SetTargetPoint(Vector vTarget)
    {
        m_vTargetPoint.Set(vTarget);
        m_fTargetX = vTarget.fX;
        m_fTargetY = vTarget.fY;
        m_fTargetZ = vTarget.fZ;
    }

    public void OnReplicateClient()
    {
        super.OnReplicateClient();
        if(super.m_bLocalPlayerDriver)
            Replicate(sm_nWalkerState);
    }

    void MsgRecvClientWeaponsInfo()
    {
        int nCnt = MessageUnPackInt();
        for(int i = 0; i < nCnt; i++)
        {
            int nNetId = MessageUnPackInt();
            int nMode = MessageUnPackInt();
            String sElement = MessageUnPackString();
            m_aWeaponsToApply.addElement(new WeaponWalkerInfo(nNetId, nMode, sElement));
            GameObject.LogR("MsgRecvClientWeaponsInfo " + nNetId + " " + nMode + " " + sElement + "\n");
        }

        MessageEnd();
        CallMethodEvery(METHOD_CheckWeaponsToApply, 1.0F);
    }

    void CreateNewWeapon(Class cWeaponClass, String sWalkerElementBarrelExit, int nMode)
    {
        if(cWeaponClass != null && super.Role == 4)
        {
            Weapon cWeapon = (Weapon)CreateObject(cWeaponClass.getName());
            ApplyNewWeapon(cWeapon, sWalkerElementBarrelExit, nMode);
        }
    }

    public static final int A_STAND = 0;
    public static final int A_FORWARD = 1;
    public static final int A_BACKWARD = 2;
    public static final int A_ROTATE_LEFT = 3;
    public static final int A_ROTATE_RIGHT = 4;
    public static final int A_NORMAL2STANDBY = 5;
    public static final int A_STANDBY = 6;
    public static final int A_STANDBY2STANDBY_OPEN = 7;
    public static final int A_STANDBY_OPEN = 8;
    public static final int A_STANDBY_OPEN2STANDBY = 9;
    public static final int A_WAKEUP = 10;
    public static final int A_NORMAL2UP = 11;
    public static final int A_UP = 12;
    public static final int A_UP2NORMAL = 13;
    public static final int A_NORMAL2DOWN = 14;
    public static final int A_DOWN = 15;
    public static final int A_DOWN2NORMAL = 16;
    public static final int A_CNT = 17;
    protected int m_aAnims[];
    PhysicsWalker m_cPhysicsWalker;
    WeaponWalkerList m_aWeapons;
    String m_sVertRotateElem;
    int m_nVertRotateElem;
    String m_sHorizRotateElem;
    int m_nHorizRotateElem;
    String m_sMeshElementToLookAt;
    int m_nElemPointToLookAt;
    Vector m_vEllipsoid;
    String m_aWalkerAnimsSounds[];
    String m_sStepSound;
    String m_sHeadLoopSound;
    protected int m_nHeadRotateSoundID;
    float m_fMaxHAngle;
    float m_fMaxVAngle;
    float m_fMinVAngle;
    int METHOD_EnableWalk;
    int METHOD_StopHeadRotateSound;
    int METHOD_StopGunRotateSound;
    int METHOD_PlayStepSound;
    int METHOD_CheckWeaponsToApply;
    String m_sDieBlowFX;
    String m_sDieBlowSound;
    String m_aHeadElements[];
    float m_fWalkSpeed;
    float m_fWalkSpeedBack;
    float m_fRotateSpeed;
    float m_fWalkAnimSpeed;
    float m_fWalkAnimSpeedMul;
    int m_nAnimToPlay;
    int m_nLastStepLoopAnimId;
    Vector m_vTargetPoint;
    float m_fTargetX;
    float m_fTargetY;
    float m_fTargetZ;
    public float m_fMinVertHeadAngle;
    public float m_fMaxVertHeadAngle;
    public float m_fMaxHorizHeadAngle;
    public float m_fHorizVertAddAngle;
    float m_fLastHorizAngle;
    float m_fLastVertAngle;
    float m_fHorizAngle;
    float m_fVertAngle;
    float fVertMul;
    float _GET_OUT_DOWN_CORRECTION;
    int m_nHeadRotateSoundIDSG;
    static int sm_nWalkerState = -1;
    static final int MSG_WEAPONSINFO = 10;
    static final int MSG_ANIM = 11;
    Vector m_aWeaponsToApply;
    boolean m_bPrimaryWeaponFiring;
    boolean m_bSecondaryWeaponFiring;
    boolean m_bPrimaryWeaponLastFiring;
    boolean m_bSecondaryWeaponLastFiring;

}
